# KrylovKit.jl

A Julia package collecting a number of Krylov-based algorithms for linear problems, singular
value and eigenvalue problems and the application of functions of linear maps or operators
to vectors.

| **Documentation** | **Build Status** | **Digital Object Idenitifier** | **License** |
|:-----------------:|:----------------:|:---------------:|:-----------:|
| [![][docs-stable-img]][docs-stable-url] [![][docs-dev-img]][docs-dev-url] | [![][aqua-img]][aqua-url] [![CI][github-img]][github-url] [![][codecov-img]][codecov-url] | [![DOI][doi-img]][doi-url] | [![license][license-img]][license-url] |

[docs-dev-img]: https://img.shields.io/badge/docs-dev-blue.svg
[docs-dev-url]: https://jutho.github.io/KrylovKit.jl/latest

[docs-stable-img]: https://img.shields.io/badge/docs-stable-blue.svg
[docs-stable-url]: https://jutho.github.io/KrylovKit.jl/stable

[github-img]: https://github.com/Jutho/KrylovKit.jl/workflows/CI/badge.svg
[github-url]: https://github.com/Jutho/KrylovKit.jl/actions?query=workflow%3ACI

[aqua-img]: https://raw.githubusercontent.com/JuliaTesting/Aqua.jl/master/badge.svg
[aqua-url]: https://github.com/JuliaTesting/Aqua.jl

[codecov-img]: https://codecov.io/gh/Jutho/KrylovKit.jl/branch/master/graph/badge.svg
[codecov-url]: https://codecov.io/gh/Jutho/KrylovKit.jl

[license-img]: http://img.shields.io/badge/license-MIT-brightgreen.svg?style=flat
[license-url]: LICENSE.md

[doi-img]: https://zenodo.org/badge/DOI/10.5281/zenodo.10622234.svg
[doi-url]: https://doi.org/10.5281/zenodo.10622234

## Release notes for the latest version

### v0.9
KrylovKit v0.9 adds two new sets of functionality:
* The function `lssolve` can be used to solve linear least squares problems, i.e. problems of the form `x = argmin(norm(A*x - b))` 
  for a given linear map `A` and vector `b`. Currently, only one algorithm is implemented, namely the LSMR algorithm
  of Fong and Saunders.
* There are now new functions `reallinsolve` and `realeigsolve` (and `reallssolve` since v0.9.4), which are useful when 
  using vectors with complex arithmetic, but where the linear map (implemented as a function `f`) acts as a real linear map,
  meaning that it only satisfies `f(α*x) = α*f(x)` when `α` is a real number. This occurs for example when computing the
  Jacobian of a complex function that is not holomorphic, e.g. in the context of automatic differentation. This is implemented
  by simply wrapping the vector as `RealVec`, which is a specific `InnerProductVec` type where the redefined inner product
  forgets about the imaginary part of the original `inner` function, thereby effectively treating the vector as living in a
  real vector space. Furthermore, in this setting, only real linear combinations of vectors are allowed, so that for the
  case of `eigsolve`, only real eigenvalues and eigenvectors are computed. An error will be thrown if the requested list
  of eigenvalues contains complex eigenvalues.

In addition, the following is technically a breaking change:
* The verbosity system, the different verbosity levels and the output formatting have been redesigned (both in the primal methods
  and the rrules). The default verbosity level is now `WARN_LEVEL`, which means that warnings will be printed by default, but all other output
  (info messages) are suppressed. Before, the default verbosity was such that all output (including warnings) were suppressed.

## Overview
KrylovKit.jl accepts general functions or callable objects as linear maps, and general Julia
objects with vector like behavior (as defined in the docs) as vectors.

The high level interface of KrylovKit is provided by the following functions:
*   `linsolve`: solve linear systems
*   `lssolve`: solve least squares problems
*   `eigsolve`: find a few eigenvalues and corresponding eigenvectors
*   `geneigsolve`: find a few generalized eigenvalues and corresponding vectors
*   `svdsolve`: find a few singular values and corresponding left and right singular vectors
*   `exponentiate`: apply the exponential of a linear map to a vector
*   `expintegrator`: [exponential integrator](https://en.wikipedia.org/wiki/Exponential_integrator)
    for a linear non-homogeneous ODE, computes a linear combination of the `ϕⱼ` functions which generalize `ϕ₀(z) = exp(z)`.

## Installation
`KrylovKit.jl` can be installed with the Julia package manager.
From the Julia REPL, type `]` to enter the Pkg REPL mode and run:
```
pkg> add KrylovKit
```

Or, equivalently, via the `Pkg` API:
```julia
julia> import Pkg; Pkg.add("KrylovKit.jl")
```

## Documentation

-   [**STABLE**][docs-stable-url] - **documentation of the most recently tagged version.**
-   [**DEVEL**][docs-dev-url] - *documentation of the in-development version.*

## Project Status

The package is tested against Julia `1.6`, the long-term stable release (1.10), the current stable release as well
as nightly builds of the Julia `master` branch on Linux, macOS, and Windows 64-bit architecture and with `1` and `4` threads.

## Questions and Contributions

Contributions are very welcome, as are feature requests and suggestions. Please open an [issue][issues-url] if you encounter any problems.

[issues-url]: https://github.com/Jutho/KrylovKit.jl/issues

"""
    geneigsolve((A::AbstractMatrix, B::AbstractMatrix), [howmany = 1, which = :LM,
                                    T = promote_type(eltype(A), eltype(B))]; kwargs...)
    geneigsolve(f, n::Int, [howmany = 1, which = :LM, T = Float64]; kwargs...)
    geneigsolve(f, x₀, [howmany = 1, which = :LM]; kwargs...)
    # expert version:
    geneigsolve(f, x₀, howmany, which, algorithm)

Compute at least `howmany` generalized eigenvalues ``λ`` and generalized eigenvectors
``x`` of the form ``(A - λB)x = 0``, where `A` and `B` are either instances of
`AbstractMatrix`, or some function that implements the matrix vector product. In case
functions are used, one could either specify the action of `A` and `B` via a tuple of two
functions (or a function and an `AbstractMatrix`), or one could use a single function that
takes a single argument `x` and returns two results, corresponding to `A*x` and `B*x`.
Return the computed eigenvalues, eigenvectors and a `ConvergenceInfo` structure.

### Arguments:

The first argument is either a tuple of two linear maps, so a function or an `AbstractMatrix`
for either of them, representing the action of `A` and `B`. Alternatively, a single function
can be used that takes a single argument `x` and returns the equivalent of `(A*x, B*x)` as
result. This latter form is compatible with the `do` block syntax of Julia. If an
`AbstractMatrix` is used for either `A` or `B`, a starting vector `x₀` does not need to be
provided, it is then chosen as `rand(T, size(A,1))` if `A` is an `AbstractMatrix` (or
similarly if only `B` is an `AbstractMatrix`). Here `T = promote_type(eltype(A), eltype(B))`
if both `A` and `B` are instances of `AbstractMatrix`, or just the `eltype` of whichever is
an `AbstractMatrix`. If both `A` and `B` are encoded more generally as a callable function
or method, the best approach is to provide an explicit starting guess `x₀`. Note that `x₀`
does not need to be of type `AbstractVector`, any type that behaves as a vector and supports
the required methods (see KrylovKit docs) is accepted. If instead of `x₀` an integer `n` is
specified, it is assumed that `x₀` is a regular vector and it is initialized to `rand(T,n)`,
where the default value of `T` is `Float64`, unless specified differently.

The next arguments are optional, but should typically be specified. `howmany` specifies how
many eigenvalues should be computed; `which` specifies which eigenvalues should be
targeted. Valid specifications of `which` are given by

  - `:LM`: eigenvalues of largest magnitude
  - `:LR`: eigenvalues with largest (most positive) real part
  - `:SR`: eigenvalues with smallest (most negative) real part
  - `:LI`: eigenvalues with largest (most positive) imaginary part, only if `T <: Complex`
  - `:SI`: eigenvalues with smallest (most negative) imaginary part, only if `T <: Complex`
  - [`EigSorter(f; rev = false)`](@ref): eigenvalues `λ` that appear first (or last if
    `rev == true`) when sorted by `f(λ)`

!!! note "Note about selecting `which` eigenvalues"

    Krylov methods work well for extremal eigenvalues, i.e. eigenvalues on the periphery of
    the spectrum of the linear map. Even with `ClosestTo`, no shift and invert is performed.
    This is useful if, e.g., you know the spectrum to be within the unit circle in the
    complex plane, and want to target the eigenvalues closest to the value `λ = 1`.

The argument `T` acts as a hint in which `Number` type the computation should be performed,
but is not restrictive. If the linear map automatically produces complex values, complex
arithmetic will be used even though `T<:Real` was specified.

### Return values:

The return value is always of the form `vals, vecs, info = geneigsolve(...)` with

  - `vals`: a `Vector` containing the eigenvalues, of length at least `howmany`, but could
    be longer if more eigenvalues were converged at the same cost.

  - `vecs`: a `Vector` of corresponding eigenvectors, of the same length as `vals`.
    Note that eigenvectors are not returned as a matrix, as the linear map could act on any
    custom Julia type with vector like behavior, i.e. the elements of the list `vecs` are
    objects that are typically similar to the starting guess `x₀`, up to a possibly
    different `eltype`. When the linear map is a simple `AbstractMatrix`, `vecs` will be
    `Vector{Vector{<:Number}}`.
  - `info`: an object of type [`ConvergenceInfo`], which has the following fields

      + `info.converged::Int`: indicates how many eigenvalues and eigenvectors were actually
        converged to the specified tolerance `tol` (see below under keyword arguments)
      + `info.residual::Vector`: a list of the same length as `vals` containing the
        residuals `info.residual[i] = f(vecs[i]) - vals[i] * vecs[i]`
      + `info.normres::Vector{<:Real}`: list of the same length as `vals` containing the
        norm of the residual `info.normres[i] = norm(info.residual[i])`
      + `info.numops::Int`: number of times the linear map was applied, i.e. number of times
        `f` was called, or a vector was multiplied with `A`
      + `info.numiter::Int`: number of times the Krylov subspace was restarted (see below)

!!! warning "Check for convergence"

    No warning is printed if not all requested eigenvalues were converged, so always check
    if `info.converged >= howmany`.

### Keyword arguments:

Keyword arguments and their default values are given by:

  - `verbosity::Int = SILENT_LEVEL`: verbosity level, i.e. 
    - SILENT_LEVEL (suppress all messages)
    - WARN_LEVEL (only warnings)
    - STARTSTOP_LEVEL (one message with convergence info at the end)
    - EACHITERATION_LEVEL (progress info after every iteration)
  - `tol::Real`: the requested accuracy, relative to the 2-norm of the corresponding
    eigenvectors, i.e. convergence is achieved if `norm((A - λB)x) < tol * norm(x)`. Because
    eigenvectors are now normalised such that `dot(x, B*x) = 1`, `norm(x)` is not
    automatically one. If you work in e.g. single precision (`Float32`), you should
    definitely change the default value.
  - `krylovdim::Integer`: the maximum dimension of the Krylov subspace that will be
    constructed. Note that the dimension of the vector space is not known or checked, e.g.
    `x₀` should not necessarily support the `Base.length` function. If you know the actual
    problem dimension is smaller than the default value, it is useful to reduce the value
    of `krylovdim`, though in principle this should be detected.
  - `maxiter::Integer`: the number of times the Krylov subspace can be rebuilt; see below
    for further details on the algorithms.
  - `orth::Orthogonalizer`: the orthogonalization method to be used, see
    [`Orthogonalizer`](@ref)
  - `issymmetric::Bool`: if both linear maps `A` and `B` are symmetric, only meaningful if
    `T<:Real`
  - `ishermitian::Bool`: if both linear maps `A` and `B` are hermitian
  - `isposdef::Bool`: if the linear map `B` is positive definite
    
The default values are given by `tol = KrylovDefaults.tol`,
`krylovdim = KrylovDefaults.krylovdim`, `maxiter = KrylovDefaults.maxiter`,
`orth = KrylovDefaults.orth`; see [`KrylovDefaults`](@ref) for details.

The default value for the last three parameters depends on the method. If an
`AbstractMatrix` is used, `issymmetric`, `ishermitian` and `isposdef` are checked for that
matrix, otherwise the default values are `issymmetric = false` and
`ishermitian = T <: Real && issymmetric`. When values are provided, no checks will be
performed even in the matrix case.

### Algorithm

The last method, without default values and keyword arguments, is the one that is finally
called, and can also be used directly. Here the algorithm is specified, though currently
only [`GolubYe`](@ref) is available. The Golub-Ye algorithm is an algorithm for solving
hermitian (symmetric) generalized eigenvalue problems `A x = λ B x` with positive definite
`B`, without the need for inverting `B`. It builds a Krylov subspace of size `krylovdim`
starting from an estimate `x` by acting with `(A - ρ(x) B)`, where 
`ρ(x) = dot(x, A*x)/ dot(x, B*x)`, and employing the Lanczos algorithm. This process is
repeated at most `maxiter` times. In every iteration `k>1`, the subspace will also be
expanded to size `krylovdim+1` by adding ``x_k - x_{k-1}``, which is known as the LOPCG
correction and was suggested by Money and Ye. With `krylovdim = 2`, this algorithm becomes
equivalent to `LOPCG`.

!!! warning "Restriction to symmetric definite generalized eigenvalue problems"

    While the only algorithm so far is restricted to symmetric/hermitian generalized
    eigenvalue problems with positive definite `B`, this is not reflected in the default
    values for the keyword arguments `issymmetric` or `ishermitian` and `isposdef`. Make
    sure to set these to true to understand the implications of using this algorithm.
"""
function geneigsolve end

function geneigsolve(
        AB::Tuple{AbstractMatrix, AbstractMatrix},
        howmany::Int = 1,
        which::Selector = :LM,
        T = promote_type(eltype.(AB)...);
        kwargs...
    )
    if !(size(AB[1], 1) == size(AB[1], 2) == size(AB[2], 1) == size(AB[2], 2))
        throw(DimensionMismatch("Matrices `A` and `B` should be square and have matching size"))
    end
    x₀ = Random.rand!(similar(AB[1], T, size(AB[1], 1)))
    return geneigsolve(AB, x₀, howmany::Int, which; kwargs...)
end
function geneigsolve(
        AB::Tuple{Any, AbstractMatrix},
        howmany::Int = 1,
        which::Selector = :LM,
        T = eltype(AB[2]);
        kwargs...
    )
    x₀ = Random.rand!(similar(AB[2], T, size(AB[2], 1)))
    return geneigsolve(AB, x₀, howmany, which; kwargs...)
end
function geneigsolve(
        AB::Tuple{AbstractMatrix, Any},
        howmany::Int = 1,
        which::Selector = :LM,
        T = eltype(AB[1]);
        kwargs...
    )
    x₀ = Random.rand!(similar(AB[1], T, size(AB[1], 1)))
    return geneigsolve(AB, x₀, howmany, which; kwargs...)
end

function geneigsolve(
        f, n::Int, howmany::Int = 1, which::Selector = :LM, T::Type = Float64;
        kwargs...
    )
    return geneigsolve(f, rand(T, n), howmany, which; kwargs...)
end

function geneigsolve(f, x₀, howmany::Int = 1, which::Selector = :LM; kwargs...)
    T = genapply_scalartype(f, x₀)
    alg = geneigselector(f, T; kwargs...)
    if alg isa GolubYe && (which == :LI || which == :SI)
        error("Eigenvalue selector which = $which invalid: real eigenvalues expected with Lanczos algorithm")
    end
    return geneigsolve(f, x₀, howmany, which, alg)
end

function geneigselector(
        AB::Tuple{AbstractMatrix, AbstractMatrix}, T::Type;
        issymmetric = (T <: Real && all(LinearAlgebra.issymmetric, AB)),
        ishermitian = issymmetric || all(LinearAlgebra.ishermitian, AB),
        isposdef = ishermitian && LinearAlgebra.isposdef(AB[2]),
        kwargs...
    )
    if (issymmetric || ishermitian) && isposdef
        return GolubYe(; kwargs...)
    else
        throw(ArgumentError("Only symmetric or hermitian generalized eigenvalue problems with positive definite `B` matrix are currently supported."))
    end
end
function geneigselector(
        f, T::Type;
        issymmetric = false,
        ishermitian = issymmetric,
        isposdef = false,
        kwargs...
    )
    if (issymmetric || ishermitian) && isposdef
        return GolubYe(; kwargs...)
    else
        throw(ArgumentError("Only symmetric or hermitian generalized eigenvalue problems with positive definite `B` matrix are currently supported."))
    end
end

"""
    mutable struct GKLFactorization{TU,TV,S<:Real}

Structure to store a Golub-Kahan-Lanczos (GKL) bidiagonal factorization of a linear map `A`
of the form

```julia
A * V = U * B + r * b'
A' * U = V * B'
```

For a given GKL factorization `fact` of length `k = length(fact)`, the two bases `U` and `V`
are obtained via [`basis(fact, Val(:U))`](@ref basis) and `basis(fact, Val(:V))`. Here,
`U` and `V` are instances of [`OrthonormalBasis{T}`](@ref Basis), with also
`length(U) == length(V) == k` and where `T` denotes the type of vector like objects used in
the problem. The Rayleigh quotient `B` is obtained as [`rayleighquotient(fact)`](@ref) and
is of type `Bidiagonal{S<:Number}` with `size(B) == (k,k)`. The residual `r` is
obtained as [`residual(fact)`](@ref) and is of type `T`. One can also query
[`normres(fact)`](@ref) to obtain `norm(r)`, the norm of the residual. The vector `b` has no
dedicated name but can be obtained via [`rayleighextension(fact)`](@ref). It takes the
default value ``e_k``, i.e. the unit vector of all zeros and a one in the last entry, which
is represented using [`SimpleBasisVector`](@ref).

A GKL factorization `fact` can be destructured as `U, V, B, r, nr, b = fact` with
`nr = norm(r)`.

`GKLFactorization` is mutable because it can [`expand!`](@ref) or [`shrink!`](@ref).
See also [`GKLIterator`](@ref) for an iterator that constructs a progressively expanding
GKL factorizations of a given linear map and a starting vector `u₀`.
"""
mutable struct GKLFactorization{TU, TV, S <: Real}
    k::Int # current Krylov dimension
    U::OrthonormalBasis{TU} # basis of length k
    V::OrthonormalBasis{TV} # basis of length k
    αs::Vector{S}
    βs::Vector{S}
    r::TU
end

Base.length(F::GKLFactorization) = F.k
Base.sizehint!(F::GKLFactorization, n) = begin
    sizehint!(F.U, n)
    sizehint!(F.V, n)
    sizehint!(F.αs, n)
    sizehint!(F.βs, n)
    return F
end
Base.eltype(F::GKLFactorization) = eltype(typeof(F))
Base.eltype(::Type{<:GKLFactorization{<:Any, <:Any, S}}) where {S} = S

# iteration for destructuring into components
Base.iterate(F::GKLFactorization) = (basis(F, Val(:U)), Val(:V))
Base.iterate(F::GKLFactorization, ::Val{:V}) = (basis(F, Val(:V)), Val(:rayleighquotient))
function Base.iterate(F::GKLFactorization, ::Val{:rayleighquotient})
    return (rayleighquotient(F), Val(:residual))
end
Base.iterate(F::GKLFactorization, ::Val{:residual}) = (residual(F), Val(:normres))
Base.iterate(F::GKLFactorization, ::Val{:normres}) = (normres(F), Val(:rayleighextension))
function Base.iterate(F::GKLFactorization, ::Val{:rayleighextension})
    return (rayleighextension(F), Val(:done))
end
Base.iterate(F::GKLFactorization, ::Val{:done}) = nothing

"""
        basis(fact::GKLFactorization, ::Val{which})

Return the list of basis vectors of a [`GKLFactorization`](@ref), where `which` should take
the value `:U` or `:V` and indicates which set of basis vectors (in the domain or in the
codomain of the corresponding linear map) should be returned. The return type is an
`OrthonormalBasis{T}`, where `T` represents the type of the vectors used by the problem.
"""
function basis(F::GKLFactorization, ::Val{UV}) where {UV}
    length(F.U) == F.k || error("Not keeping vectors during GKL bidiagonalization")
    UV == :U || UV == :V || error("invalid flag for specifying basis")
    return UV == :U ? F.U : F.V
end
function rayleighquotient(F::GKLFactorization)
    return Bidiagonal(view(F.αs, 1:(F.k)), view(F.βs, 1:(F.k - 1)), :L)
end
residual(F::GKLFactorization) = F.r
@inbounds normres(F::GKLFactorization) = F.βs[F.k]
rayleighextension(F::GKLFactorization) = SimpleBasisVector(F.k, F.k)

# GKL iteration for constructing the orthonormal basis of a Krylov subspace.
"""
    struct GKLIterator{F,TU,O<:Orthogonalizer}
    GKLIterator(f, u₀, [orth::Orthogonalizer = KrylovDefaults.orth, keepvecs::Bool = true])

Iterator that takes a general linear map `f::F` and an initial vector `u₀::TU` and generates
an expanding `GKLFactorization` thereof. In particular, `GKLIterator` implements the
[Golub-Kahan-Lanczos bidiagonalization procedure](http://www.netlib.org/utk/people/JackDongarra/etemplates/node198.html).
Note, however, that this implementation starts from a vector `u₀` in the codomain of the
linear map `f`, which will end up (after normalisation) as the first column of `U`.

The argument `f` can be a matrix, a tuple of two functions where the first represents the
normal action and the second the adjoint action, or a function accepting two arguments,
where the first argument is the vector to which the linear map needs to be applied, and the
second argument is either `Val(false)` for the normal action and `Val(true)` for the adjoint
action. Note that the flag is thus a `Val` type to allow for type stability in cases where
the vectors in the domain and the codomain of the linear map have a different type.

The optional argument `orth` specifies which [`Orthogonalizer`](@ref) to be used. The
default value in [`KrylovDefaults`](@ref) is to use [`ModifiedGramSchmidtIR`](@ref), which
possibly uses reorthogonalization steps.

When iterating over an instance of `GKLIterator`, the values being generated are
instances `fact` of [`GKLFactorization`](@ref), which can be immediately destructured into a
[`basis(fact, Val(:U))`](@ref), [`basis(fact, Val(:V))`](@ref), [`rayleighquotient`](@ref),
[`residual`](@ref), [`normres`](@ref) and [`rayleighextension`](@ref), for example as

```julia
for (U, V, B, r, nr, b) in GKLIterator(f, u₀)
    # do something
    nr < tol && break # a typical stopping criterion
end
```

Since the iterator does not know the dimension of the underlying vector space of
objects of type `T`, it keeps expanding the Krylov subspace until the residual norm `nr`
falls below machine precision `eps(typeof(nr))`.

The internal state of `GKLIterator` is the same as the return value, i.e. the corresponding
`GKLFactorization`. However, as Julia's Base iteration interface (using `Base.iterate`)
requires that the state is not mutated, a `deepcopy` is produced upon every next iteration
step.

Instead, you can also mutate the `GKLFactorization` in place, using the following
interface, e.g. for the same example above

```julia
iterator = GKLIterator(f, u₀)
factorization = initialize(iterator)
while normres(factorization) > tol
    expand!(iterator, factorization)
    U, V, B, r, nr, b = factorization
    # do something
end
```

Here, [`initialize(::GKLIterator)`](@ref) produces the first GKL factorization of length 1,
and `expand!(::GKLIterator, ::GKLFactorization)`(@ref) expands the factorization in place.
See also [`initialize!(::GKLIterator, ::GKLFactorization)`](@ref) to initialize in an
already existing factorization (most information will be discarded) and
[`shrink!(::GKLIterator, k)`](@ref) to shrink an existing factorization down to length `k`.
"""
struct GKLIterator{F, TU, O <: Orthogonalizer}
    operator::F
    u₀::TU
    orth::O
    keepvecs::Bool
    function GKLIterator{F, TU, O}(
            operator::F, u₀::TU, orth::O, keepvecs::Bool
        ) where {F, TU, O <: Orthogonalizer}
        if !keepvecs && isa(orth, Reorthogonalizer)
            error("Cannot use reorthogonalization without keeping all Krylov vectors")
        end
        return new{F, TU, O}(operator, u₀, orth, keepvecs)
    end
end
function GKLIterator(
        operator::F, u₀::TU, orth::O = KrylovDefaults.orth, keepvecs::Bool = true
    ) where {F, TU, O <: Orthogonalizer}
    return GKLIterator{F, TU, O}(operator, u₀, orth, keepvecs)
end

Base.IteratorSize(::Type{<:GKLIterator}) = Base.SizeUnknown()
Base.IteratorEltype(::Type{<:GKLIterator}) = Base.EltypeUnknown()

function Base.iterate(iter::GKLIterator)
    state = initialize(iter)
    return state, state
end
function Base.iterate(iter::GKLIterator, state::GKLFactorization)
    nr = normres(state)
    if nr < eps(typeof(nr))
        return nothing
    else
        state = expand!(iter, deepcopy(state))
        return state, state
    end
end

function initialize(iter::GKLIterator; verbosity::Int = KrylovDefaults.verbosity[])
    # initialize without using eltype
    u₀ = iter.u₀
    β₀ = norm(u₀)
    iszero(β₀) && throw(ArgumentError("initial vector should not have norm zero"))
    v₀ = apply_adjoint(iter.operator, u₀)
    α = norm(v₀) / β₀
    Av₀ = apply_normal(iter.operator, v₀) # apply operator
    α² = inner(u₀, Av₀) / β₀^2
    α² ≈ α * α || throw(ArgumentError("operator and its adjoint are not compatible"))
    T = typeof(α²) # scalar type of the Rayleigh quotient

    # these lines determines the vector types that we will henceforth use
    u = scale(u₀, one(T) / β₀)
    v = scale(v₀, one(T) / (α * β₀))
    if typeof(Av₀) == typeof(u)
        r = scale!!(Av₀, 1 / (α * β₀))
    else
        r = scale!!(zerovector(u), Av₀, 1 / (α * β₀))
    end
    r = add!!(r, u, -α)
    β = norm(r)

    U = OrthonormalBasis([u])
    V = OrthonormalBasis([v])
    S = real(T)
    αs = S[α]
    βs = S[β]
    if verbosity > EACHITERATION_LEVEL
        @info "GKL initiation at dimension 1: subspace normres = $(normres2string(β))"
    end
    return GKLFactorization(1, U, V, αs, βs, r)
end
function initialize!(
        iter::GKLIterator, state::GKLFactorization;
        verbosity::Int = KrylovDefaults.verbosity[]
    )
    U = state.U
    while length(U) > 1
        pop!(U)
    end
    V = empty!(state.V)
    αs = empty!(state.αs)
    βs = empty!(state.βs)

    u = scale!!(U[1], iter.u₀, 1 / norm(iter.u₀))
    v = apply_adjoint(iter.operator, u)
    α = norm(v)
    v = scale!!(v, inv(α))
    r = apply_normal(iter.operator, v)
    r = add!!(r, u, -α)
    β = norm(r)

    state.k = 1
    push!(V, v)
    push!(αs, α)
    push!(βs, β)
    state.r = r
    if verbosity > EACHITERATION_LEVEL
        @info "GKL initiation at dimension 1: subspace normres = $(normres2string(β))"
    end
    return state
end
function expand!(
        iter::GKLIterator, state::GKLFactorization;
        verbosity::Int = KrylovDefaults.verbosity[]
    )
    βold = normres(state)
    U = state.U
    V = state.V
    r = state.r
    U = push!(U, scale!!(r, 1 / βold))
    v, r, α, β = gklrecurrence(iter.operator, U, V, βold, iter.orth)

    push!(V, v)
    push!(state.αs, α)
    push!(state.βs, β)

    #!iter.keepvecs && popfirst!(state.V) # remove oldest V if not keepvecs

    state.k += 1
    state.r = r
    if verbosity > EACHITERATION_LEVEL
        @info "GKL expension to dimension $(state.k): subspace normres = $(normres2string(β))"
    end
    return state
end
function shrink!(state::GKLFactorization, k; verbosity::Int = KrylovDefaults.verbosity[])
    length(state) == length(state.V) ||
        error("we cannot shrink GKLFactorization without keeping vectors")
    length(state) <= k && return state
    U = state.U
    V = state.V
    while length(V) > k + 1
        pop!(U)
        pop!(V)
    end
    pop!(V)
    r = pop!(U)
    resize!(state.αs, k)
    resize!(state.βs, k)
    state.k = k
    β = normres(state)
    if verbosity > EACHITERATION_LEVEL
        @info "GKL reduction to dimension $k: subspace normres = $(normres2string(β))"
    end
    state.r = scale!!(r, β)
    return state
end

# Golub-Kahan-Lanczos recurrence relation
function gklrecurrence(
        operator, U::OrthonormalBasis, V::OrthonormalBasis, β, orth::Union{ClassicalGramSchmidt, ModifiedGramSchmidt}
    )
    u = U[end]
    v = apply_adjoint(operator, u)
    v = add!!(v, V[end], -β)
    α = norm(v)
    v = scale!!(v, inv(α))

    r = apply_normal(operator, v)
    r = add!!(r, u, -α)
    β = norm(r)
    return v, r, α, β
end
function gklrecurrence(
        operator, U::OrthonormalBasis, V::OrthonormalBasis, β, orth::ClassicalGramSchmidt2
    )
    u = U[end]
    v = apply_adjoint(operator, u)
    v = add!!(v, V[end], -β) # not necessary if we definitely reorthogonalize next step and previous step
    # v, = orthogonalize!(v, V, ClassicalGramSchmidt())
    α = norm(v)
    v = scale!!(v, inv(α))

    r = apply_normal(operator, v)
    r = add!!(r, u, -α)
    r, = orthogonalize!!(r, U, ClassicalGramSchmidt())
    β = norm(r)
    return v, r, α, β
end
function gklrecurrence(
        operator, U::OrthonormalBasis, V::OrthonormalBasis, β, orth::ModifiedGramSchmidt2
    )
    u = U[end]
    v = apply_adjoint(operator, u)
    v = add!!(v, V[end], -β)
    for q in V
        # it is claimed that this is not necessary if we definitely
        # reorthogonalize next step and previous step, but some of
        # my experiments show that this does make a significant difference
        v, = orthogonalize!!(v, q, ModifiedGramSchmidt())
    end
    α = norm(v)
    v = scale!!(v, inv(α))

    r = apply_normal(operator, v)
    r = add!!(r, u, -α)
    for q in U
        r, = orthogonalize!!(r, q, ModifiedGramSchmidt())
    end
    β = norm(r)
    return v, r, α, β
end
function gklrecurrence(
        operator, U::OrthonormalBasis, V::OrthonormalBasis, β, orth::ClassicalGramSchmidtIR
    )
    u = U[end]
    v = apply_adjoint(operator, u)
    v = add!!(v, V[end], -β)
    α = norm(v)
    nold = sqrt(abs2(α) + abs2(β))
    while α < orth.η * nold
        nold = α
        v, = orthogonalize!!(v, V, ClassicalGramSchmidt())
        α = norm(v)
    end
    v = scale!!(v, inv(α))

    r = apply_normal(operator, v)
    r = add!!(r, u, -α)
    β = norm(r)
    nold = sqrt(abs2(α) + abs2(β))
    while eps(one(β)) < β < orth.η * nold
        nold = β
        r, = orthogonalize!!(r, U, ClassicalGramSchmidt())
        β = norm(r)
    end

    return v, r, α, β
end
function gklrecurrence(
        operator, U::OrthonormalBasis, V::OrthonormalBasis, β, orth::ModifiedGramSchmidtIR
    )
    u = U[end]
    v = apply_adjoint(operator, u)
    v = add!!(v, V[end], -β)
    α = norm(v)
    nold = sqrt(abs2(α) + abs2(β))
    while eps(one(α)) < α < orth.η * nold
        nold = α
        for q in V
            v, = orthogonalize!!(v, q, ModifiedGramSchmidt())
        end
        α = norm(v)
    end
    v = scale!!(v, inv(α))

    r = apply_normal(operator, v)
    r = add!!(r, u, -α)
    β = norm(r)
    nold = sqrt(abs2(α) + abs2(β))
    while eps(one(β)) < β < orth.η * nold
        nold = β
        for q in U
            r, = orthogonalize!!(r, q, ModifiedGramSchmidt())
        end
        β = norm(r)
    end

    return v, r, α, β
end

"""
    mutable struct LanczosFactorization{T,S<:Real} <: KrylovFactorization{T,S}

Structure to store a Lanczos factorization of a real symmetric or complex hermitian linear
map `A` of the form

```julia
A * V = V * B + r * b'
```

For a given Lanczos factorization `fact` of length `k = length(fact)`, the basis `V` is
obtained via [`basis(fact)`](@ref basis) and is an instance of [`OrthonormalBasis{T}`](@ref
Basis), with also `length(V) == k` and where `T` denotes the type of vector like objects
used in the problem. The Rayleigh quotient `B` is obtained as
[`rayleighquotient(fact)`](@ref) and is of type `SymTridiagonal{S<:Real}` with `size(B) ==
(k,k)`. The residual `r` is obtained as [`residual(fact)`](@ref) and is of type `T`. One can
also query [`normres(fact)`](@ref) to obtain `norm(r)`, the norm of the residual. The vector
`b` has no dedicated name but can be obtained via [`rayleighextension(fact)`](@ref). It
takes the default value ``e_k``, i.e. the unit vector of all zeros and a one in the last
entry, which is represented using [`SimpleBasisVector`](@ref).

A Lanczos factorization `fact` can be destructured as `V, B, r, nr, b = fact` with
`nr = norm(r)`.

`LanczosFactorization` is mutable because it can [`expand!`](@ref) or [`shrink!`](@ref).
See also [`LanczosIterator`](@ref) for an iterator that constructs a progressively expanding
Lanczos factorizations of a given linear map and a starting vector. See
[`ArnoldiFactorization`](@ref) and [`ArnoldiIterator`](@ref) for a Krylov factorization that
works for general (non-symmetric) linear maps.
"""
mutable struct LanczosFactorization{T, S <: Real} <: KrylovFactorization{T, S}
    k::Int # current Krylov dimension
    V::OrthonormalBasis{T} # basis of length k
    αs::Vector{S}
    βs::Vector{S}
    r::T
end

Base.length(F::LanczosFactorization) = F.k
Base.sizehint!(F::LanczosFactorization, n) = begin
    sizehint!(F.V, n)
    sizehint!(F.αs, n)
    sizehint!(F.βs, n)
    return F
end
Base.eltype(F::LanczosFactorization) = eltype(typeof(F))
Base.eltype(::Type{<:LanczosFactorization{<:Any, S}}) where {S} = S

function basis(F::LanczosFactorization)
    return length(F.V) == F.k ? F.V :
        error("Not keeping vectors during Lanczos factorization")
end
function rayleighquotient(F::LanczosFactorization)
    return SymTridiagonal(view(F.αs, 1:(F.k)), view(F.βs, 1:(F.k - 1)))
end
residual(F::LanczosFactorization) = F.r
@inbounds normres(F::LanczosFactorization) = F.βs[F.k]
rayleighextension(F::LanczosFactorization) = SimpleBasisVector(F.k, F.k)

# Lanczos iteration for constructing the orthonormal basis of a Krylov subspace.
"""
    struct LanczosIterator{F,T,O<:Orthogonalizer} <: KrylovIterator{F,T}
    LanczosIterator(f, v₀, [orth::Orthogonalizer = KrylovDefaults.orth, keepvecs::Bool = true])

Iterator that takes a linear map `f::F` (supposed to be real symmetric or complex hermitian)
and an initial vector `v₀::T` and generates an expanding `LanczosFactorization` thereof. In
particular, `LanczosIterator` uses the
[Lanczos iteration](https://en.wikipedia.org/wiki/Lanczos_algorithm) scheme to build a
successively expanding Lanczos factorization. While `f` cannot be tested to be symmetric or
hermitian directly when the linear map is encoded as a general callable object or function,
it is tested whether the imaginary part of `inner(v, f(v))` is sufficiently small to be
neglected.

The argument `f` can be a matrix, or a function accepting a single argument `v`, so that
`f(v)` implements the action of the linear map on the vector `v`.

The optional argument `orth` specifies which [`Orthogonalizer`](@ref) to be used. The
default value in [`KrylovDefaults`](@ref) is to use [`ModifiedGramSchmidtIR`](@ref), which
possibly uses reorthogonalization steps. One can use to discard the old vectors that span
the Krylov subspace by setting the final argument `keepvecs` to `false`. This, however, is
only possible if an `orth` algorithm is used that does not rely on reorthogonalization, such
as `ClassicalGramSchmidt()` or `ModifiedGramSchmidt()`. In that case, the iterator strictly
uses the Lanczos three-term recurrence relation.

When iterating over an instance of `LanczosIterator`, the values being generated are
instances of [`LanczosFactorization`](@ref), which can be immediately destructured into a
[`basis`](@ref), [`rayleighquotient`](@ref), [`residual`](@ref), [`normres`](@ref) and
[`rayleighextension`](@ref), for example as

```julia
for (V, B, r, nr, b) in LanczosIterator(f, v₀)
    # do something
    nr < tol && break # a typical stopping criterion
end
```

Note, however, that if `keepvecs=false` in `LanczosIterator`, the basis `V` cannot be
extracted.

Since the iterator does not know the dimension of the underlying vector space of
objects of type `T`, it keeps expanding the Krylov subspace until the residual norm `nr`
falls below machine precision `eps(typeof(nr))`.

The internal state of `LanczosIterator` is the same as the return value, i.e. the
corresponding `LanczosFactorization`. However, as Julia's Base iteration interface (using
`Base.iterate`) requires that the state is not mutated, a `deepcopy` is produced upon every
next iteration step.

Instead, you can also mutate the `KrylovFactorization` in place, using the following
interface, e.g. for the same example above

```julia
iterator = LanczosIterator(f, v₀)
factorization = initialize(iterator)
while normres(factorization) > tol
    expand!(iterator, factorization)
    V, B, r, nr, b = factorization
    # do something
end
```

Here, [`initialize(::KrylovIterator)`](@ref) produces the first Krylov factorization of
length 1, and [`expand!(iter::KrylovIterator, fact::KrylovFactorization)`](@ref) expands the
factorization in place. See also [`initialize!(::KrylovIterator,
::KrylovFactorization)`](@ref) to initialize in an already existing factorization (most
information will be discarded) and [`shrink!(::KrylovFactorization, k)`](@ref) to shrink an
existing factorization down to length `k`.
"""
struct LanczosIterator{F, T, O <: Orthogonalizer} <: KrylovIterator{F, T}
    operator::F
    x₀::T
    orth::O
    keepvecs::Bool
    function LanczosIterator{F, T, O}(
            operator::F,
            x₀::T,
            orth::O,
            keepvecs::Bool
        ) where {F, T, O <: Orthogonalizer}
        if !keepvecs && isa(orth, Reorthogonalizer)
            error("Cannot use reorthogonalization without keeping all Krylov vectors")
        end
        return new{F, T, O}(operator, x₀, orth, keepvecs)
    end
end
function LanczosIterator(
        operator::F,
        x₀::T,
        orth::O = KrylovDefaults.orth,
        keepvecs::Bool = true
    ) where {F, T, O <: Orthogonalizer}
    return LanczosIterator{F, T, O}(operator, x₀, orth, keepvecs)
end

Base.IteratorSize(::Type{<:LanczosIterator}) = Base.SizeUnknown()
Base.IteratorEltype(::Type{<:LanczosIterator}) = Base.EltypeUnknown()

function Base.iterate(iter::LanczosIterator)
    state = initialize(iter)
    return state, state
end
function Base.iterate(iter::LanczosIterator, state::LanczosFactorization)
    nr = normres(state)
    if nr < eps(typeof(nr))
        return nothing
    else
        state = expand!(iter, deepcopy(state))
        return state, state
    end
end

function warn_nonhermitian(α, β₁, β₂)
    n = hypot(α, β₁, β₂)
    if abs(imag(α)) / n > eps(one(n))^(2 / 5)
        @warn "ignoring imaginary component $(imag(α)) from total weight $n: operator might not be hermitian?" α β₁ β₂
    end
    return nothing
end

function initialize(iter::LanczosIterator; verbosity::Int = KrylovDefaults.verbosity[])
    # initialize without using eltype
    x₀ = iter.x₀
    β₀ = norm(x₀)
    iszero(β₀) && throw(ArgumentError("initial vector should not have norm zero"))
    Ax₀ = apply(iter.operator, x₀)
    α = inner(x₀, Ax₀) / (β₀ * β₀)
    T = typeof(α) # scalar type of the Rayleigh quotient
    # this line determines the vector type that we will henceforth use
    # vector scalar type can be different from `T`, e.g. for real inner products
    v = add!!(scale(Ax₀, zero(α)), x₀, 1 / β₀)
    if typeof(Ax₀) != typeof(v)
        r = add!!(zerovector(v), Ax₀, 1 / β₀)
    else
        r = scale!!(Ax₀, 1 / β₀)
    end
    βold = norm(r)
    r = add!!(r, v, -α) # should we use real(α) here?
    β = norm(r)
    # possibly reorthogonalize
    if iter.orth isa Union{ClassicalGramSchmidt2, ModifiedGramSchmidt2}
        dα = inner(v, r)
        α += dα
        r = add!!(r, v, -dα) # should we use real(dα) here?
        β = norm(r)
    elseif iter.orth isa Union{ClassicalGramSchmidtIR, ModifiedGramSchmidtIR}
        while eps(one(β)) < β < iter.orth.η * βold
            βold = β
            dα = inner(v, r)
            α += dα
            r = add!!(r, v, -dα) # should we use real(dα) here?
            β = norm(r)
        end
    end
    verbosity >= WARN_LEVEL && warn_nonhermitian(α, zero(β), β)
    V = OrthonormalBasis([v])
    αs = [real(α)]
    βs = [β]
    if verbosity > EACHITERATION_LEVEL
        @info "Lanczos initiation at dimension 1: subspace normres = $(normres2string(β))"
    end
    return LanczosFactorization(1, V, αs, βs, r)
end
function initialize!(
        iter::LanczosIterator, state::LanczosFactorization;
        verbosity::Int = KrylovDefaults.verbosity[]
    )
    x₀ = iter.x₀
    V = state.V
    while length(V) > 1
        pop!(V)
    end
    αs = empty!(state.αs)
    βs = empty!(state.βs)

    V[1] = scale!!(V[1], x₀, 1 / norm(x₀))
    w = apply(iter.operator, V[1])
    r, α = orthogonalize!!(w, V[1], iter.orth)
    β = norm(r)
    verbosity >= WARN_LEVEL && warn_nonhermitian(α, zero(β), β)

    state.k = 1
    push!(αs, real(α))
    push!(βs, β)
    state.r = r
    if verbosity > EACHITERATION_LEVEL
        @info "Lanczos initiation at dimension 1: subspace normres = $(normres2string(β))"
    end
    return state
end
function expand!(
        iter::LanczosIterator, state::LanczosFactorization;
        verbosity::Int = KrylovDefaults.verbosity[]
    )
    βold = normres(state)
    V = state.V
    r = state.r
    V = push!(V, scale!!(r, 1 / βold))
    r, α, β = lanczosrecurrence(iter.operator, V, βold, iter.orth)
    verbosity >= WARN_LEVEL && warn_nonhermitian(α, βold, β)

    αs = push!(state.αs, real(α))
    βs = push!(state.βs, β)

    !iter.keepvecs && popfirst!(state.V) # remove oldest V if not keepvecs

    state.k += 1
    state.r = r
    if verbosity > EACHITERATION_LEVEL
        @info "Lanczos expansion to dimension $(state.k): subspace normres = $(normres2string(β))"
    end
    return state
end
function shrink!(state::LanczosFactorization, k; verbosity::Int = KrylovDefaults.verbosity[])
    length(state) == length(state.V) ||
        error("we cannot shrink LanczosFactorization without keeping Lanczos vectors")
    length(state) <= k && return state
    V = state.V
    while length(V) > k + 1
        pop!(V)
    end
    r = pop!(V)
    resize!(state.αs, k)
    resize!(state.βs, k)
    state.k = k
    β = normres(state)
    if verbosity > EACHITERATION_LEVEL
        @info "Lanczos reduction to dimension $k: subspace normres = $(normres2string(β))"
    end
    state.r = scale!!(r, β)
    return state
end

# Exploit hermiticity to "simplify" orthonormalization process:
# Lanczos three-term recurrence relation
function lanczosrecurrence(operator, V::OrthonormalBasis, β, orth::ClassicalGramSchmidt)
    v = V[end]
    w = apply(operator, v)
    α = inner(v, w)
    w = add!!(w, V[end - 1], -β)
    w = add!!(w, v, -α)
    β = norm(w)
    return w, α, β
end
function lanczosrecurrence(operator, V::OrthonormalBasis, β, orth::ModifiedGramSchmidt)
    v = V[end]
    w = apply(operator, v)
    w = add!!(w, V[end - 1], -β)
    α = inner(v, w)
    w = add!!(w, v, -α)
    β = norm(w)
    return w, α, β
end
function lanczosrecurrence(operator, V::OrthonormalBasis, β, orth::ClassicalGramSchmidt2)
    v = V[end]
    w = apply(operator, v)
    α = inner(v, w)
    w = add!!(w, V[end - 1], -β)
    w = add!!(w, v, -α)

    w, s = orthogonalize!!(w, V, ClassicalGramSchmidt())
    α += s[end]
    β = norm(w)
    return w, α, β
end
function lanczosrecurrence(operator, V::OrthonormalBasis, β, orth::ModifiedGramSchmidt2)
    v = V[end]
    w = apply(operator, v)
    w = add!!(w, V[end - 1], -β)
    w, α = orthogonalize!!(w, v, ModifiedGramSchmidt())

    s = α
    for q in V
        w, s = orthogonalize!!(w, q, ModifiedGramSchmidt())
    end
    α += s
    β = norm(w)
    return w, α, β
end
function lanczosrecurrence(operator, V::OrthonormalBasis, β, orth::ClassicalGramSchmidtIR)
    v = V[end]
    w = apply(operator, v)
    α = inner(v, w)
    w = add!!(w, V[end - 1], -β)
    w = add!!(w, v, -α)

    ab2 = abs2(α) + abs2(β)
    β = norm(w)
    nold = sqrt(abs2(β) + ab2)
    while eps(one(β)) < β < orth.η * nold
        nold = β
        w, s = orthogonalize!!(w, V, ClassicalGramSchmidt())
        α += s[end]
        β = norm(w)
    end
    return w, α, β
end
function lanczosrecurrence(operator, V::OrthonormalBasis, β, orth::ModifiedGramSchmidtIR)
    v = V[end]
    w = apply(operator, v)
    w = add!!(w, V[end - 1], -β)

    w, α = orthogonalize!!(w, v, ModifiedGramSchmidt())
    ab2 = abs2(α) + abs2(β)
    β = norm(w)
    nold = sqrt(abs2(β) + ab2)
    while eps(one(β)) < β < orth.η * nold
        nold = β
        s = zero(α)
        for q in V
            w, s = orthogonalize!!(w, q, ModifiedGramSchmidt())
        end
        α += s
        β = norm(w)
    end
    return w, α, β
end

"""
    function expintegrator(A, t::Number, u₀, u₁, …; kwargs...)
    function expintegrator(A, t::Number, (u₀, u₁, …); kwargs...)
    function expintegrator(A, t::Number, (u₀, u₁, …), algorithm)

Compute ``y = ϕ₀(t*A)*u₀ + t*ϕ₁(t*A)*u₁ + t^2*ϕ₂(t*A)*u₂ + …``, where `A` is a general
linear map, i.e. a `AbstractMatrix` or just a general function or callable object and `u₀`,
`u₁` are of any Julia type with vector like behavior. Here, ``ϕ₀(z) = exp(z)`` and
``ϕⱼ₊₁ = (ϕⱼ(z) - 1/j!)/z``. In particular, ``y = x(t)`` represents the solution of the ODE
``ẋ(t) = A*x(t) + ∑ⱼ t^j/j! uⱼ₊₁`` with ``x(0) = u₀``.

!!! note

    When there are only input vectors `u₀` and `u₁`, `t` can equal `Inf`, in which the
    algorithm tries to evolve all the way to the fixed point `y = - A \\ u₁ + P₀ u₀` with
    `P₀` the projector onto the eigenspace of eigenvalue zero (if any) of `A`. If `A` has
    any eigenvalues with real part larger than zero, however, the solution to the ODE will
    diverge, i.e. the fixed point is not stable.

### Arguments:

The linear map `A` can be an `AbstractMatrix` (dense or sparse) or a general function or
callable object that implements the action of the linear map on a vector. If `A` is an
`AbstractMatrix`, `x` is expected to be an `AbstractVector`, otherwise `x` can be of any
type that behaves as a vector and supports the required methods (see KrylovKit docs).

The time parameter `t` can be real or complex, and it is better to choose `t` e.g. imaginary
and `A` hermitian, then to absorb the imaginary unit in an antihermitian `A`. For the
former, the Lanczos scheme is used to built a Krylov subspace, in which an approximation to
the exponential action of the linear map is obtained. The arguments `u₀`, `u₁`, … can be
of any type and should be in the domain of `A`.

### Return values:

The return value is always of the form `y, info = expintegrator(...)` with

  - `y`: the result of the computation, i.e.
    ``y = ϕ₀(t*A)*u₀ + t*ϕ₁(t*A)*u₁ + t^2*ϕ₂(t*A)*u₂ + …``

  - `info`: an object of type [`ConvergenceInfo`], which has the following fields

      + `info.converged::Int`: 0 or 1 if the solution `y` at time `t` was found with an
        error below the requested tolerance per unit time, i.e. if `info.normres <= tol * abs(t)`
      + `info.residual::Nothing`: value `nothing`, there is no concept of a residual in
        this case
      + `info.normres::Real`: a (rough) estimate of the total error accumulated in the
        solution
      + `info.numops::Int`: number of times the linear map was applied, i.e. number of times
        `f` was called, or a vector was multiplied with `A`
      + `info.numiter::Int`: number of times the Krylov subspace was restarted (see below)

### Keyword arguments:

Keyword arguments and their default values are given by:

  - `verbosity::Int = SILENT_LEVEL`: verbosity level, i.e. 
    - SILENT_LEVEL (suppress all messages)
    - WARN_LEVEL (only warnings)
    - STARTSTOP_LEVEL (one message with convergence info at the end)
    - EACHITERATION_LEVEL (progress info after every iteration)
    - EACHITERATION_LEVEL+ (all of the above and additional information about the Lanczos or Arnoldi iteration)
  - `krylovdim = 30`: the maximum dimension of the Krylov subspace that will be constructed.
    Note that the dimension of the vector space is not known or checked, e.g. `x₀` should
    not necessarily support the `Base.length` function. If you know the actual problem
    dimension is smaller than the default value, it is useful to reduce the value of
    `krylovdim`, though in principle this should be detected.
  - `tol = 1e-12`: the requested accuracy per unit time, i.e. if you want a certain
    precision `ϵ` on the final result, set `tol = ϵ/abs(t)`. If you work in e.g. single
    precision (`Float32`), you should definitely change the default value.
  - `maxiter::Int = 100`: the number of times the Krylov subspace can be rebuilt; see below
    for further details on the algorithms.
  - `issymmetric`: if the linear map is symmetric, only meaningful if `T<:Real`
  - `ishermitian`: if the linear map is hermitian
    The default value for the last two depends on the method. If an `AbstractMatrix` is
    used, `issymmetric` and `ishermitian` are checked for that matrix, otherwise the default
    values are `issymmetric = false` and `ishermitian = T <: Real && issymmetric`.
  - `eager::Bool = false`: if true, eagerly try to compute the result after every expansion
    of the Krylov subspace to test for convergence, otherwise wait until the Krylov subspace
    as dimension `krylovdim`. This can result in a faster return, for example if the total
    time for the evolution is quite small, but also has some overhead, as more computations
    are performed after every expansion step.

### Algorithm

The last method, without keyword arguments and the different vectors `u₀`, `u₁`, … in a
tuple, is the one that is finally called, and can also be used directly. Here, one
specifies the algorithm explicitly as either [`Lanczos`](@ref), for real symmetric or
complex hermitian linear maps, or [`Arnoldi`](@ref), for general linear maps. Note that
these names refer to the process for building the Krylov subspace, and that one can still
use complex time steps in combination with e.g. a real symmetric map.
"""
function expintegrator end

function expintegrator(A, t::Number, u₀, us...; kwargs...)
    Ts = typeof.(inner.((u₀, us...), (u₀,)))
    T = promote_type(typeof(t), Ts...)
    alg = eigselector(A, T; kwargs...)
    return expintegrator(A, t, (u₀, us...), alg)
end

function expintegrator(A, t::Number, u::Tuple, alg::Union{Lanczos, Arnoldi})
    length(u) == 1 && return expintegrator(A, t, (u[1], zerovector(u[1])), alg)

    p = length(u) - 1

    # process initial vector and determine result type
    u₀ = first(u)
    β₀ = norm(u₀)
    Au₀ = apply(A, u₀) # used to determine return type
    numops = 1
    T = promote_type(typeof(t), (typeof.(inner.(u, (Au₀,))))...)
    S = real(T)
    w₀ = scale(u₀, one(T))

    # maxiter, krylovdim and related allocations
    maxiter = alg.maxiter
    @assert maxiter >= 1
    krylovdim = alg.krylovdim
    K = krylovdim
    HH = zeros(T, (krylovdim + p + 1, krylovdim + p + 1))

    # time step parameters
    η::S = alg.tol # tol is per unit time
    totalerr = zero(η)
    sgn = sign(t)
    τ::S = abs(t)
    if isfinite(τ)
        Δτ = τ  # don't try any clever initial guesses, rely on correction mechanism
        Δτmin = τ / alg.maxiter
        maxerr = τ * η
    else
        Δτ = oneunit(S)
        Δτmin = zero(S)
        maxerr = η
    end
    totaltimestring = @sprintf("%.2e", τ)

    # safety factors
    δ::S = 1.2
    γ::S = 0.8

    # initial vectors
    τ₀ = zero(τ)
    w = Vector{typeof(w₀)}(undef, p + 1)
    w[1] = w₀
    # reuse the result of apply computed earlier:
    w[2] = scale!!(zerovector(w₀), Au₀, one(T))
    for j in 1:p
        if j > 1
            w[j + 1] = apply(A, w[j])
            numops += 1
        end
        lfac = 1
        for l in 0:(p - j)
            w[j + 1] = add!!(w[j + 1], u[j + l + 1], (sgn * τ₀)^l / lfac)
            lfac *= l + 1
        end
    end
    v = zerovector(w₀)
    β = norm(w[p + 1])
    if β < η && p == 1
        if alg.verbosity >= STARTSTOP_LEVEL
            @info "expintegrate finished after 0 iterations, converged to fixed point up to error = $(normres2string(β))"
        end
        return w₀, ConvergenceInfo(1, nothing, β, 0, numops)
    end
    v = scale!!(v, w[p + 1], 1 / β)

    # initialize iterator
    if alg isa Lanczos
        iter = LanczosIterator(A, w[p + 1], alg.orth)
    else
        iter = ArnoldiIterator(A, w[p + 1], alg.orth)
    end
    fact = initialize(iter; verbosity = alg.verbosity)
    numops += 1
    sizehint!(fact, krylovdim)

    # start outer iteration loop
    numiter = 1
    while true
        K = length(fact)
        V = basis(fact)

        if K == krylovdim
            if numiter < maxiter
                Δτ = min(Δτ, τ - τ₀)
                if isfinite(τ) # try to adapt minimal time step
                    Δτmin = (τ - τ₀) / (maxiter - numiter + 1)
                end
            else
                Δτ = τ - τ₀
            end

            # Small matrix exponential and error estimation
            H = fill!(view(HH, 1:(K + p + 1), 1:(K + p + 1)), zero(T))
            mul!(view(H, 1:K, 1:K), rayleighquotient(fact), sgn * Δτ)
            H[1, K + 1] = 1
            for i in 1:p
                H[K + i, K + i + 1] = 1
            end
            expH = exp(H) # LinearAlgebra.exp! is type unstable for SubArray instances
            ϵ = abs(Δτ^p * β * normres(fact) * expH[K, K + p + 1])
            ω = ϵ / (Δτ * η)

            q::S = K / 2
            while numiter < maxiter && ω >= one(ω) && Δτ > Δτmin
                ϵ_prev = ϵ
                Δτ_prev = Δτ
                Δτ = max(Δτ * (γ / ω)^(1 / (q + 1)), Δτmin)
                H = fill!(view(HH, 1:(K + p + 1), 1:(K + p + 1)), zero(T))
                mul!(view(H, 1:K, 1:K), rayleighquotient(fact), sgn * Δτ)
                H[1, K + 1] = 1
                for i in 1:p
                    H[K + i, K + i + 1] = 1
                end
                expH = exp(H) # LinearAlgebra.exp! is type unstable for SubArray instances
                ϵ = abs(Δτ^p * β * normres(fact) * expH[K, K + p + 1])
                ω = ϵ / (Δτ * η)
                q = max(zero(q), log(ϵ / ϵ_prev) / log(Δτ / Δτ_prev) - 1)
            end

            # take time step
            τ₀ = numiter < maxiter ? τ₀ + Δτ : τ # to avoid floating point errors
            totalerr += ϵ
            jfac = 1
            for j in 1:(p - 1)
                w₀ = add!!(w₀, w[j + 1], (sgn * Δτ)^j / jfac)
                jfac *= (j + 1)
            end
            w[p + 1] = unproject!!(w[p + 1], basis(fact), view(expH, 1:K, K + p))
            # add first correction
            w[p + 1] = add!!(w[p + 1], residual(fact), expH[K, K + p + 1])
            w₀ = add!!(w₀, w[p + 1], β * (sgn * Δτ)^p)
            w[1] = w₀

            # increase time step for next iteration:
            if ω < γ
                Δτ *= (γ / ω)^(1 / (q + 1))
            end
        elseif normres(fact) <= ((τ - τ₀) * η) || alg.eager
            # Small matrix exponential and error estimation
            H = fill!(view(HH, 1:(K + p + 1), 1:(K + p + 1)), zero(T))
            mul!(view(H, 1:K, 1:K), rayleighquotient(fact), sgn * (τ - τ₀))
            H[1, K + 1] = 1
            for i in 1:p
                H[K + i, K + i + 1] = 1
            end
            expH = exp(H) # LinearAlgebra.exp! is type unstable for SubArray instances
            ϵ = abs((τ - τ₀)^p * β * normres(fact) * expH[K, K + p + 1])
            ω = ϵ / ((τ - τ₀) * η)
            if ω < one(ω)
                # take time step
                totalerr += ϵ
                jfac = 1
                for j in 1:(p - 1)
                    w₀ = add!!(w₀, w[j + 1], (sgn * (τ - τ₀))^j / jfac)
                    jfac *= (j + 1)
                end
                w[p + 1] = unproject!!(w[p + 1], basis(fact), view(expH, 1:K, K + p))
                # add first correction
                w[p + 1] = add!!(w[p + 1], residual(fact), expH[K, K + p + 1])
                w₀ = add!!(w₀, w[p + 1], β * (sgn * (τ - τ₀))^p)
                w[1] = w₀
                τ₀ = τ
            end
        end
        if τ₀ >= τ
            if totalerr <= maxerr
                if alg.verbosity >= STARTSTOP_LEVEL
                    @info """expintegrate finished after $numiter iterations:
                    * total error = $(normres2string(totalerr))
                    * number of operations = $numops"""
                end
                return w₀, ConvergenceInfo(1, nothing, totalerr, numiter, numops)
            else
                if alg.verbosity >= WARN_LEVEL
                    @warn """expintegrate did not reach sufficiently small error after $numiter iterations:
                    * total error = $(normres2string(totalerr))
                    * number of operations = $numops"""
                end
                return w₀, ConvergenceInfo(0, nothing, totalerr, numiter, numops)
            end
        end
        if K < krylovdim
            fact = expand!(iter, fact; verbosity = alg.verbosity)
            numops += 1
        else
            for j in 1:p
                w[j + 1] = apply(A, w[j])
                numops += 1
                lfac = 1
                for l in 0:(p - j)
                    w[j + 1] = add!!(w[j + 1], u[j + l + 1], (sgn * τ₀)^l / lfac)
                    lfac *= l + 1
                end
            end
            β = norm(w[p + 1])
            if β < η && p == 1 # w₀ is fixed point of ODE
                if alg.verbosity >= STARTSTOP_LEVEL
                    @info "expintegrate finished after $numiter iterations, converged to fixed point up to error = $(normres2string(totalerr))"
                end
                return w₀, ConvergenceInfo(1, nothing, β, numiter, numops)
            end
            v = scale!!(v, w[p + 1], 1 / β)

            if alg.verbosity >= EACHITERATION_LEVEL
                timestring = @sprintf("%.2e", τ₀)
                @info "expintegrate in iteration $numiter: reached time $timestring of $totaltimestring, total error = $(normres2string(totalerr))"
            end

            if alg isa Lanczos
                iter = LanczosIterator(A, w[p + 1], alg.orth)
            else
                iter = ArnoldiIterator(A, w[p + 1], alg.orth)
            end
            fact = initialize!(iter, fact; verbosity = alg.verbosity)
            numops += 1
            numiter += 1
        end
    end
    return
end

# Definition of an orthonormal basis
"""
    OrthonormalBasis{T} <: Basis{T}

A list of vector like objects of type `T` that are mutually orthogonal and normalized to
one, representing an orthonormal basis for some subspace (typically a Krylov subspace). See
also [`Basis`](@ref)

Orthonormality of the vectors contained in an instance `b` of `OrthonormalBasis`
(i.e. `all(inner(b[i],b[j]) == I[i,j] for i=1:length(b), j=1:length(b))`) is not checked when
elements are added; it is up to the algorithm that constructs `b` to guarantee
orthonormality.

One can easily orthogonalize or orthonormalize a given vector `v` with respect to a
`b::OrthonormalBasis` using the functions
[`w, = orthogonalize(v,b,...)`](@ref orthogonalize) or
[`w, = orthonormalize(v,b,...)`](@ref orthonormalize). The resulting vector `w` of the
latter can then be added to `b` using `push!(b, w)`. Note that in place versions
[`orthogonalize!!(v, b, ...)`](@ref orthogonalize) or
[`orthonormalize!!(v, b, ...)`](@ref orthonormalize) are also available.

Finally, a linear combination of the vectors in `b::OrthonormalBasis` can be obtained by
multiplying `b` with a `Vector{<:Number}` using `*` or `mul!` (if the output vector is
already allocated).
"""
struct OrthonormalBasis{T} <: Basis{T}
    basis::Vector{T}
end
OrthonormalBasis{T}() where {T} = OrthonormalBasis{T}(Vector{T}(undef, 0))

# Iterator methods for OrthonormalBasis
Base.IteratorSize(::Type{<:OrthonormalBasis}) = Base.HasLength()
Base.IteratorEltype(::Type{<:OrthonormalBasis}) = Base.HasEltype()

Base.length(b::OrthonormalBasis) = length(b.basis)
Base.eltype(b::OrthonormalBasis{T}) where {T} = T

Base.iterate(b::OrthonormalBasis) = Base.iterate(b.basis)
Base.iterate(b::OrthonormalBasis, state) = Base.iterate(b.basis, state)

Base.getindex(b::OrthonormalBasis, i) = getindex(b.basis, i)
Base.setindex!(b::OrthonormalBasis, i, q) = setindex!(b.basis, i, q)
Base.firstindex(b::OrthonormalBasis) = firstindex(b.basis)
Base.lastindex(b::OrthonormalBasis) = lastindex(b.basis)

Base.first(b::OrthonormalBasis) = first(b.basis)
Base.last(b::OrthonormalBasis) = last(b.basis)

Base.popfirst!(b::OrthonormalBasis) = popfirst!(b.basis)
Base.pop!(b::OrthonormalBasis) = pop!(b.basis)
Base.push!(b::OrthonormalBasis{T}, q::T) where {T} = (push!(b.basis, q); return b)
Base.empty!(b::OrthonormalBasis) = (empty!(b.basis); return b)
Base.sizehint!(b::OrthonormalBasis, k::Int) = (sizehint!(b.basis, k); return b)
Base.resize!(b::OrthonormalBasis, k::Int) = (resize!(b.basis, k); return b)

# Multiplication methods with OrthonormalBasis
function Base.:*(b::OrthonormalBasis, x::AbstractVector)
    y = zerovector(first(b), promote_type(scalartype(x), scalartype(first(b))))
    return unproject!!(y, b, x)
end

const BLOCKSIZE = 4096

# helper function to determine if a multithreaded approach should be used
# this uses functionality beyond VectorInterface, but can be faster
_use_multithreaded_array_kernel(y) = _use_multithreaded_array_kernel(typeof(y))
_use_multithreaded_array_kernel(::Type) = false
function _use_multithreaded_array_kernel(::Type{<:Array{T}}) where {T <: Number}
    return isbitstype(T) && get_num_threads() > 1
end
function _use_multithreaded_array_kernel(::Type{<:OrthonormalBasis{T}}) where {T}
    return _use_multithreaded_array_kernel(T)
end

"""
    project!!(y::AbstractVector, b::OrthonormalBasis, x,
        [α::Number = 1, β::Number = 0, r = Base.OneTo(length(b))])

For a given orthonormal basis `b`, compute the expansion coefficients `y` resulting from
projecting the vector `x` onto the subspace spanned by `b`; more specifically this computes

```
    y[j] = β*y[j] + α * inner(b[r[j]], x)
```

for all ``j ∈ r``.
"""
function project!!(
        y::AbstractVector, b::OrthonormalBasis, x,
        α::Number = true, β::Number = false, r = Base.OneTo(length(b))
    )
    # no specialized routine for IndexLinear x because reduction dimension is large dimension
    length(y) == length(r) || throw(DimensionMismatch())
    if get_num_threads() > 1
        @sync for J in splitrange(1:length(r), get_num_threads())
            Threads.@spawn for j in $J
                @inbounds begin
                    if β == 0
                        y[j] = α * inner(b[r[j]], x)
                    else
                        y[j] = β * y[j] + α * inner(b[r[j]], x)
                    end
                end
            end
        end
    else
        for j in 1:length(r)
            @inbounds begin
                if β == 0
                    y[j] = α * inner(b[r[j]], x)
                else
                    y[j] = β * y[j] + α * inner(b[r[j]], x)
                end
            end
        end
    end
    return y
end

"""
    unproject!!(y, b::OrthonormalBasis, x::AbstractVector,
        [α::Number = 1, β::Number = 0, r = Base.OneTo(length(b))])

For a given orthonormal basis `b`, reconstruct the vector-like object `y` that is defined by
expansion coefficients with respect to the basis vectors in `b` in `x`; more specifically
this computes

```
    y = β*y + α * sum(b[r[i]]*x[i] for i = 1:length(r))
```
"""
function unproject!!(
        y, b::OrthonormalBasis, x::AbstractVector,
        α::Number = true, β::Number = false, r = Base.OneTo(length(b))
    )
    if _use_multithreaded_array_kernel(y)
        return unproject_linear_multithreaded!(y, b, x, α, β, r)
    end
    # general case: using only vector operations, i.e. axpy! (similar to BLAS level 1)
    length(x) == length(r) || throw(DimensionMismatch())
    if β == 0
        y = scale!!(y, false) # should be hard zero
    elseif β != 1
        y = scale!!(y, β)
    end
    @inbounds for (i, ri) in enumerate(r)
        y = add!!(y, b[ri], α * x[i])
    end
    return y
end
function unproject_linear_multithreaded!(
        y::AbstractArray, b::OrthonormalBasis{<:AbstractArray}, x::AbstractVector,
        α::Number = true, β::Number = false, r = Base.OneTo(length(b))
    )
    # multi-threaded implementation, similar to BLAS level 2 matrix vector multiplication
    m = length(y)
    n = length(r)
    length(x) == n || throw(DimensionMismatch())
    for rj in r
        length(b[rj]) == m || throw(DimensionMismatch())
    end
    if n == 0
        return β == 1 ? y : β == 0 ? zerovector!(y) : scale!(y, β)
    end
    let m = m, n = n, y = y, x = x, b = b, blocksize = prevpow(2, div(BLOCKSIZE, n))
        @sync for II in splitrange(1:blocksize:m, get_num_threads())
            Threads.@spawn for I in $II
                unproject_linear_kernel!(y, b, x, I:min(I + blocksize - 1, m), α, β, r)
            end
        end
    end
    return y
end
function unproject_linear_kernel!(
        y::AbstractArray, b::OrthonormalBasis{<:AbstractArray}, x::AbstractVector,
        I, α::Number, β::Number, r
    )
    return @inbounds begin
        if β == 0
            @simd for i in I
                y[i] = zero(y[i])
            end
        elseif β != 1
            @simd for i in I
                y[i] *= β
            end
        end
        for (j, rj) in enumerate(r)
            xj = x[j] * α
            Vj = b[rj]
            @simd for i in I
                y[i] += Vj[i] * xj
            end
        end
    end
end

"""
    rank1update!(b::OrthonormalBasis, y, x::AbstractVector,
        [α::Number = 1, β::Number = 1, r = Base.OneTo(length(b))])

Perform a rank 1 update of a basis `b`, i.e. update the basis vectors as

```
    b[r[i]] = β*b[r[i]] + α * y * conj(x[i])
```

It is the user's responsibility to make sure that the result is still an orthonormal basis.
"""
@fastmath function rank1update!(
        b::OrthonormalBasis, y, x::AbstractVector,
        α::Number = true, β::Number = true, r = Base.OneTo(length(b))
    )
    if _use_multithreaded_array_kernel(y)
        return rank1update_linear_multithreaded!(b, y, x, α, β, r)
    end
    # general case: using only vector operations, i.e. axpy! (similar to BLAS level 1)
    length(x) == length(r) || throw(DimensionMismatch())
    @inbounds for (i, ri) in enumerate(r)
        if β == 1
            b[ri] = add!!(b[ri], y, α * conj(x[i]))
        elseif β == 0
            b[ri] = scale!!(b[ri], y, α * conj(x[i]))
        else
            b[ri] = add!!(b[ri], y, α * conj(x[i]), β)
        end
    end
    return b
end
@fastmath function rank1update_linear_multithreaded!(
        b::OrthonormalBasis{<:AbstractArray}, y::AbstractArray, x::AbstractVector,
        α::Number, β::Number, r
    )
    # multi-threaded implementation, similar to BLAS level 2 matrix vector multiplication
    m = length(y)
    n = length(r)
    length(x) == n || throw(DimensionMismatch())
    for rj in r
        length(b[rj]) == m || throw(DimensionMismatch())
    end
    if n == 0
        return b
    end
    let m = m, n = n, y = y, x = x, b = b, blocksize = prevpow(2, div(BLOCKSIZE, n))
        @sync for II in splitrange(1:blocksize:m, get_num_threads())
            Threads.@spawn for I in $II
                @inbounds begin
                    for (j, rj) in enumerate(r)
                        xj = α * conj(x[j])
                        Vj = b[rj]
                        if β == 0
                            @simd for i in I:min(I + blocksize - 1, m)
                                Vj[i] = zero(Vj[i])
                            end
                        elseif β != 1
                            @simd for i in I:min(I + blocksize - 1, m)
                                Vj[i] *= β
                            end
                        end
                        if I + blocksize - 1 <= m
                            @simd for i in Base.OneTo(blocksize)
                                Vj[I - 1 + i] += y[I - 1 + i] * xj
                            end
                        else
                            @simd for i in I:m
                                Vj[i] += y[i] * xj
                            end
                        end
                    end
                end
            end
        end
    end
    return b
end

"""
    basistransform!(b::OrthonormalBasis, U::AbstractMatrix)

Transform the orthonormal basis `b` by the matrix `U`. For `b` an orthonormal basis,
the matrix `U` should be real orthogonal or complex unitary; it is up to the user to ensure
this condition is satisfied. The new basis vectors are given by

```
    b[j] ← b[i] * U[i,j]
```

and are stored in `b`, so the old basis vectors are thrown away. Note that, by definition,
the subspace spanned by these basis vectors is exactly the same.
"""
function basistransform!(b::OrthonormalBasis{T}, U::AbstractMatrix) where {T} # U should be unitary or isometric
    if _use_multithreaded_array_kernel(b)
        return basistransform_linear_multithreaded!(b, U)
    end
    m, n = size(U)
    m == length(b) || throw(DimensionMismatch())

    let b2 = [zerovector(b[1]) for j in 1:n]
        if get_num_threads() > 1
            @sync for J in splitrange(1:n, get_num_threads())
                Threads.@spawn for j in $J
                    b2[j] = scale!!(b2[j], b[1], U[1, j])
                    for i in 2:m
                        b2[j] = add!!(b2[j], b[i], U[i, j])
                    end
                end
            end
        else
            for j in 1:n
                b2[j] = scale!!(b2[j], b[1], U[1, j])
                for i in 2:m
                    b2[j] = add!!(b2[j], b[i], U[i, j])
                end
            end
        end
        for j in 1:n
            b[j] = b2[j]
        end
    end
    return b
end

function basistransform_linear_multithreaded!(
        b::OrthonormalBasis{<:AbstractArray}, U::AbstractMatrix
    ) # U should be unitary or isometric
    m, n = size(U)
    m == length(b) || throw(DimensionMismatch())
    K = length(b[1])

    blocksize = prevpow(2, div(BLOCKSIZE, m))
    let b2 = [similar(b[1]) for j in 1:n], K = K, m = m, n = n
        @sync for II in splitrange(1:blocksize:K, get_num_threads())
            Threads.@spawn for I in $II
                @inbounds for j in 1:n
                    b2j = b2[j]
                    @simd for i in I:min(I + blocksize - 1, K)
                        b2j[i] = zero(b2j[i])
                    end
                    for k in 1:m
                        bk = b[k]
                        Ukj = U[k, j]
                        @simd for i in I:min(I + blocksize - 1, K)
                            b2j[i] += bk[i] * Ukj
                        end
                    end
                end
            end
        end
        for j in 1:n
            b[j] = b2[j]
        end
    end
    return b
end

# function basistransform2!(b::OrthonormalBasis, U::AbstractMatrix) # U should be unitary or isometric
#     m, n = size(U)
#     m == length(b) || throw(DimensionMismatch())
#
#     # apply basis transform via householder reflections
#     for j = 1:size(U,2)
#         h, ν = householder(U, j:m, j)
#         lmul!(h, view(U, :, j+1:n))
#         rmul!(b, h')
#     end
#     return b
# end

# Orthogonalization of a vector against a given OrthonormalBasis
orthogonalize(v, args...) = orthogonalize!!(scale(v, true), args...)

function orthogonalize!!(v::T, b::OrthonormalBasis{T}, alg::Orthogonalizer) where {T}
    S = promote_type(scalartype(v), scalartype(T))
    c = Vector{S}(undef, length(b))
    return orthogonalize!!(v, b, c, alg)
end

function orthogonalize!!(
        v::T, b::OrthonormalBasis{T}, x::AbstractVector, ::ClassicalGramSchmidt
    ) where {T}
    x = project!!(x, b, v)
    v = unproject!!(v, b, x, -1, 1)
    return (v, x)
end
function reorthogonalize!!(
        v::T, b::OrthonormalBasis{T}, x::AbstractVector, ::ClassicalGramSchmidt
    ) where {T}
    s = similar(x) ## EXTRA ALLOCATION
    s = project!!(s, b, v)
    v = unproject!!(v, b, s, -1, 1)
    x .+= s
    return (v, x)
end
function orthogonalize!!(
        v::T, b::OrthonormalBasis{T}, x::AbstractVector, ::ClassicalGramSchmidt2
    ) where {T}
    (v, x) = orthogonalize!!(v, b, x, ClassicalGramSchmidt())
    return reorthogonalize!!(v, b, x, ClassicalGramSchmidt())
end
function orthogonalize!!(
        v::T, b::OrthonormalBasis{T}, x::AbstractVector, alg::ClassicalGramSchmidtIR
    ) where {T}
    nold = norm(v)
    (v, x) = orthogonalize!!(v, b, x, ClassicalGramSchmidt())
    nnew = norm(v)
    while eps(one(nnew)) < nnew < alg.η * nold
        nold = nnew
        (v, x) = reorthogonalize!!(v, b, x, ClassicalGramSchmidt())
        nnew = norm(v)
    end
    return (v, x)
end

function orthogonalize!!(
        v::T, b::OrthonormalBasis{T}, x::AbstractVector, ::ModifiedGramSchmidt
    ) where {T}
    for (i, q) in enumerate(b)
        s = inner(q, v)
        v = add!!(v, q, -s)
        x[i] = s
    end
    return (v, x)
end
function reorthogonalize!!(
        v::T, b::OrthonormalBasis{T}, x::AbstractVector, ::ModifiedGramSchmidt
    ) where {T}
    for (i, q) in enumerate(b)
        s = inner(q, v)
        v = add!!(v, q, -s)
        x[i] += s
    end
    return (v, x)
end
function orthogonalize!!(
        v::T, b::OrthonormalBasis{T}, x::AbstractVector, ::ModifiedGramSchmidt2
    ) where {T}
    (v, x) = orthogonalize!!(v, b, x, ModifiedGramSchmidt())
    return reorthogonalize!!(v, b, x, ModifiedGramSchmidt())
end
function orthogonalize!!(
        v::T, b::OrthonormalBasis{T}, x::AbstractVector, alg::ModifiedGramSchmidtIR
    ) where {T}
    nold = norm(v)
    (v, x) = orthogonalize!!(v, b, x, ModifiedGramSchmidt())
    nnew = norm(v)
    while eps(one(nnew)) < nnew < alg.η * nold
        nold = nnew
        (v, x) = reorthogonalize!!(v, b, x, ModifiedGramSchmidt())
        nnew = norm(v)
    end
    return (v, x)
end

# Orthogonalization of a vector against a given normalized vector
orthogonalize!!(v::T, q::T, alg::Orthogonalizer) where {T} = _orthogonalize!!(v, q, alg)
# avoid method ambiguity on Julia 1.0 according to Aqua.jl

function _orthogonalize!!(
        v::T, q::T, alg::Union{ClassicalGramSchmidt, ModifiedGramSchmidt}
    ) where {T}
    s = inner(q, v)
    v = add!!(v, q, -s)
    return (v, s)
end
function _orthogonalize!!(
        v::T, q::T, alg::Union{ClassicalGramSchmidt2, ModifiedGramSchmidt2}
    ) where {T}
    s = inner(q, v)
    v = add!!(v, q, -s)
    ds = inner(q, v)
    v = add!!(v, q, -ds)
    return (v, s + ds)
end
function _orthogonalize!!(
        v::T, q::T, alg::Union{ClassicalGramSchmidtIR, ModifiedGramSchmidtIR}
    ) where {T}
    nold = norm(v)
    s = inner(q, v)
    v = add!!(v, q, -s)
    nnew = norm(v)
    while eps(one(nnew)) < nnew < alg.η * nold
        nold = nnew
        ds = inner(q, v)
        v = add!!(v, q, -ds)
        s += ds
        nnew = norm(v)
    end
    return (v, s)
end

"""
    orthogonalize(v, b::OrthonormalBasis, [x::AbstractVector,] alg::Orthogonalizer]) -> w, x
    orthogonalize!!(v, b::OrthonormalBasis, [x::AbstractVector,] alg::Orthogonalizer]) -> w, x

    orthogonalize(v, q, algorithm::Orthogonalizer]) -> w, s
    orthogonalize!!(v, q, algorithm::Orthogonalizer]) -> w, s

Orthogonalize vector `v` against all the vectors in the orthonormal basis `b` using the
orthogonalization algorithm `alg` of type [`Orthogonalizer`](@ref), and return the resulting
vector `w` and the overlap coefficients `x` of `v` with the basis vectors in `b`.

In case of `orthogonalize!`, the vector `v` is mutated in place. In both functions, storage
for the overlap coefficients `x` can be provided as optional argument `x::AbstractVector`
with `length(x) >= length(b)`.

One can also orthogonalize `v` against a given vector `q` (assumed to be normalized), in
which case the orthogonal vector `w` and the inner product `s` between `v` and `q` are
returned.

Note that `w` is not normalized, see also [`orthonormalize`](@ref).

For more information on possible orthogonalization algorithms, see [`Orthogonalizer`](@ref)
and its concrete subtypes [`ClassicalGramSchmidt`](@ref), [`ModifiedGramSchmidt`](@ref),
[`ClassicalGramSchmidt2`](@ref), [`ModifiedGramSchmidt2`](@ref),
[`ClassicalGramSchmidtIR`](@ref) and [`ModifiedGramSchmidtIR`](@ref).
"""
orthogonalize, orthogonalize!!

# Orthonormalization: orthogonalization and normalization
orthonormalize(v, args...) = orthonormalize!!(scale(v, VectorInterface.One()), args...)

function orthonormalize!!(v, args...)
    out = orthogonalize!!(v, args...) # out[1] === v
    β = norm(v)
    v = scale!!(v, inv(β))
    return tuple(v, β, Base.tail(out)...)
end

"""
    orthonormalize(v, b::OrthonormalBasis, [x::AbstractVector,] alg::Orthogonalizer]) -> w, β, x
    orthonormalize!!(v, b::OrthonormalBasis, [x::AbstractVector,] alg::Orthogonalizer]) -> w, β, x

    orthonormalize(v, q, algorithm::Orthogonalizer]) -> w, β, s
    orthonormalize!!(v, q, algorithm::Orthogonalizer]) -> w, β, s

Orthonormalize vector `v` against all the vectors in the orthonormal basis `b` using the
orthogonalization algorithm `alg` of type [`Orthogonalizer`](@ref), and return the resulting
vector `w` (of norm 1), its norm `β` after orthogonalizing and the overlap coefficients `x`
of `v` with the basis vectors in `b`, such that `v = β * w + b * x`.

In case of `orthogonalize!`, the vector `v` is mutated in place. In both functions, storage
for the overlap coefficients `x` can be provided as optional argument `x::AbstractVector`
with `length(x) >= length(b)`.

One can also orthonormalize `v` against a given vector `q` (assumed to be normalized), in
which case the orthonormal vector `w`, its norm `β` before normalizing and the inner product
`s` between `v` and `q` are returned.

See [`orthogonalize`](@ref) if `w` does not need to be normalized.

For more information on possible orthogonalization algorithms, see [`Orthogonalizer`](@ref)
and its concrete subtypes [`ClassicalGramSchmidt`](@ref), [`ModifiedGramSchmidt`](@ref),
[`ClassicalGramSchmidt2`](@ref), [`ModifiedGramSchmidt2`](@ref),
[`ClassicalGramSchmidtIR`](@ref) and [`ModifiedGramSchmidtIR`](@ref).
"""
orthonormalize, orthonormalize!!

"""
    eigsolve(A::AbstractMatrix, [x₀, howmany = 1, which = :LM, T = eltype(A)]; kwargs...)
    eigsolve(f, n::Int, [howmany = 1, which = :LM, T = Float64]; kwargs...)
    eigsolve(f, x₀, [howmany = 1, which = :LM]; kwargs...)
    # expert version:
    eigsolve(f, x₀, howmany, which, algorithm; alg_rrule=...)

    # block version:
    eigsolve(f, x₀::Block, [howmany = 1, which = :LM]; kwargs...)
    # expert block version:
    eigsolve(f, x₀::Block, howmany, which, algorithm; alg_rrule=...)

Compute at least `howmany` eigenvalues from the linear map encoded in the matrix `A` or by
the function `f`. Return eigenvalues, eigenvectors and a `ConvergenceInfo` structure.

### Arguments:

The linear map can be an `AbstractMatrix` (dense or sparse) or a general function or
callable object. If an `AbstractMatrix` is used, a starting vector `x₀` does not need to be
provided, it is then chosen as `rand(T, size(A, 1))`. If the linear map is encoded more
generally as a a callable function or method, the best approach is to provide an explicit
starting guess `x₀`. Note that `x₀` does not need to be of type `AbstractVector`; any type
that behaves as a vector and supports the required methods (see KrylovKit docs) is accepted.
If instead of `x₀` an integer `n` is specified, it is assumed that `x₀` is a regular vector
and it is initialized to `rand(T, n)`, where the default value of `T` is `Float64`, unless
specified differently.

The next arguments are optional, but should typically be specified. `howmany` specifies how
many eigenvalues should be computed; `which` specifies which eigenvalues should be
targeted. Valid specifications of `which` are given by

  - `:LM`: eigenvalues of largest magnitude
  - `:LR`: eigenvalues with largest (most positive) real part
  - `:SR`: eigenvalues with smallest (most negative) real part
  - `:LI`: eigenvalues with largest (most positive) imaginary part, only if `T <: Complex`
  - `:SI`: eigenvalues with smallest (most negative) imaginary part, only if `T <: Complex`
  - [`EigSorter(f; rev = false)`](@ref): eigenvalues `λ` that appear first (or last if
    `rev == true`) when sorted by `f(λ)`

!!! note "Note about selecting `which` eigenvalues"

    Krylov methods work well for extremal eigenvalues, i.e. eigenvalues on the periphery of
    the spectrum of the linear map. All of the valid `Symbol`s for `which` have this
    property, but could also be specified using `EigSorter`, e.g. `:LM` is equivalent to
    `Eigsorter(abs; rev = true)`. Note that smallest magnitude sorting is obtained using
    e.g. `EigSorter(abs; rev = false)`, but since no (shift-and)-invert is used, this will
    only be successful if you somehow know that eigenvalues close to zero are also close
    to the periphery of the spectrum.

!!! warning "Repeated eigenvalues"

    From a theoretical point of view, Krylov methods can at most find a single eigenvector
    associated with a targetted eigenvalue, even if the latter is repeated, i.e. the
    eigenvalue has multiple linearly independent eigenvectors or thus an eigenspace
    with dimension (geometric multiplicity) larger than one. In the case of such
    a repeated eigenvalue, the specific eigenvector that is returned is determined by the
    starting vector `x₀`. For large problems, this turns out to be less of an issue in
    practice, as often a second linearly independent eigenvector is generated out of the
    numerical noise resulting from the orthogonalisation steps in the Lanczos or Arnoldi
    iteration. Nonetheless, it is important to take this into account and to try not to
    depend on this potentially fragile behaviour, especially for smaller problems.
    The [`BlockLanczos`](@ref) method has been implemented to compute repeated
    eigenvalues and their corresponding eigenvectors more reliably. Given a starting block `x₀`
    with length `p`, which is the number of vectors in `x₀`, the method can at most simultaneously
    determine `p`-fold repeated eigenvalues and their associated eigenvectors.

The argument `T` acts as a hint in which `Number` type the computation should be performed,
but is not restrictive. If the linear map automatically produces complex values, complex
arithmetic will be used even though `T<:Real` was specified. However, if the linear map and
initial guess are real, approximate eigenvalues will be searched for using a partial Schur
factorization, which implies that complex conjugate eigenvalues come in pairs and cannot
be split. It is then illegal to choose `which` in a way that would treat `λ` and `conj(λ)`
differently, i.e. `:LI` and `:SI` are invalid, as well as any `EigSorter` that would lead
to `by(λ) != by(conj(λ))`.

### Return values:

The return value is always of the form `vals, vecs, info = eigsolve(...)` with

  - `vals`: a `Vector` containing the eigenvalues, of length at least `howmany`, but could
    be longer if more eigenvalues were converged at the same cost. Eigenvalues will be real
    if [`Lanczos`](@ref) or [`BlockLanczos`](@ref) was used and complex if [`Arnoldi`](@ref) was used (see below).
  - `vecs`: a `Vector` of corresponding eigenvectors, of the same length as `vals`. Note
    that eigenvectors are not returned as a matrix, as the linear map could act on any
    custom Julia type with vector like behavior, i.e. the elements of the list `vecs` are
    objects that are typically similar to the starting guess `x₀`, up to a possibly
    different `eltype`. In particular  for a general matrix (i.e. with `Arnoldi`) the
    eigenvectors are generally complex and are therefore always returned in a complex
    number format. When the linear map is a simple `AbstractMatrix`, `vecs` will be
    `Vector{Vector{<:Number}}`.
  - `info`: an object of type [`ConvergenceInfo`], which has the following fields

      + `info.converged::Int`: indicates how many eigenvalues and eigenvectors were actually
        converged to the specified tolerance `tol` (see below under keyword arguments)
      + `info.residual::Vector`: a list of the same length as `vals` containing the
        residuals `info.residual[i] = f(vecs[i]) - vals[i] * vecs[i]`
      + `info.normres::Vector{<:Real}`: list of the same length as `vals` containing the
        norm of the residual `info.normres[i] = norm(info.residual[i])`
      + `info.numops::Int`: number of times the linear map was applied, i.e. number of times
        `f` was called, or a vector was multiplied with `A`
      + `info.numiter::Int`: number of times the Krylov subspace was restarted (see below)

!!! warning "Check for convergence"

    No warning is printed if not all requested eigenvalues were converged, so always check
    if `info.converged >= howmany`.

### Keyword arguments:

Keyword arguments and their default values are given by:

  - `verbosity::Int = SILENT_LEVEL`: verbosity level, i.e. 
    - SILENT_LEVEL (suppress all messages)
    - WARN_LEVEL (only warnings)
    - STARTSTOP_LEVEL (one message with convergence info at the end)
    - EACHITERATION_LEVEL (progress info after every iteration)
    - EACHITERATION_LEVEL+ (all of the above and additional information about the Lanczos, BlockLanczos, or Arnoldi iteration)
  - `tol::Real`: the requested accuracy (corresponding to the 2-norm of the residual for
    Schur vectors, not the eigenvectors). If you work in e.g. single precision (`Float32`),
    you should definitely change the default value.
  - `krylovdim::Integer`: the maximum dimension of the Krylov subspace that will be
    constructed. Note that the dimension of the vector space is not known or checked, e.g.
    `x₀` should not necessarily support the `Base.length` function. If you know the actual
    problem dimension is smaller than the default value, it is useful to reduce the value of
    `krylovdim`, though in principle this should be detected.
  - `maxiter::Integer`: the number of times the Krylov subspace can be rebuilt; see below
    for further details on the algorithms.
  - `orth::Orthogonalizer`: the orthogonalization method to be used, see
    [`Orthogonalizer`](@ref)
  - `issymmetric::Bool`: if the linear map is symmetric, only meaningful if `T<:Real`
  - `ishermitian::Bool`: if the linear map is hermitian
  - `eager::Bool = false`: if true, eagerly compute the eigenvalue or Schur decomposition
    after every expansion of the Krylov subspace to test for convergence, otherwise wait
    until the Krylov subspace has dimension `krylovdim`. This can result in a faster return,
    for example if the initial guess is very good, but also has some overhead, as many more
    dense Schur factorizations need to be computed.

The default values are given by `tol = KrylovDefaults.tol`,
`krylovdim = KrylovDefaults.krylovdim`, `maxiter = KrylovDefaults.maxiter`,
`orth = KrylovDefaults.orth`; see [`KrylovDefaults`](@ref) for details.

The default value for the last two parameters depends on the method. If an `AbstractMatrix`
is used, `issymmetric` and `ishermitian` are checked for that matrix, otherwise the default
values are `issymmetric = false` and `ishermitian = T <: Real && issymmetric`. When values
for the keyword arguments are provided, no checks will be performed even in the matrix case.

The final keyword argument `alg_rrule` is relevant only when `eigsolve` is used in a setting
where reverse-mode automatic differentation will be used. A custom `ChainRulesCore.rrule` is
defined for `eigsolve`, which can be evaluated using different algorithms that can be specified
via `alg_rrule`. A suitable default is chosen, so this keyword argument should only be used
when this default choice is failing or not performing efficiently. Check the documentation for
more information on the possible values for `alg_rrule` and their implications on the algorithm
being used.

### Algorithm

The final (expert) method, without default values and keyword arguments, is the one that is
finally called, and can also be used directly. Here, one specifies the algorithm explicitly
as either [`Lanczos`](@ref) or [`BlockLanczos`](@ref), for real symmetric or complex hermitian problems, or
[`Arnoldi`](@ref), for general problems. Note that these names refer to the process for
building the Krylov subspace, but the actual algorithm is an implementation of the
Krylov-Schur algorithm, which can dynamically shrink and grow the Krylov subspace, i.e. the
restarts are so-called thick restarts where a part of the current Krylov subspace is kept.

!!! note "Note about convergence"

    In case of a general problem, where the `Arnoldi` method is used, convergence of an
    eigenvalue is not based on the norm of the residual `norm(f(vecs[i]) - vals[i]*vecs[i])`
    for the eigenvector but rather on the norm of the residual for the corresponding Schur
    vectors.

    See also [`schursolve`](@ref) if you want to use the partial Schur decomposition
    directly, or if you are not interested in computing the eigenvectors, and want to work
    in real arithmetic all the way true (if the linear map and starting guess are real).
    If you have knowledge that all requested eigenvalues of a real problem will be real,
    and thus also their associated eigenvectors, you can also use [`realeigsolve`](@ref).
"""
function eigsolve end

"""
    EigSorter(by; rev = false)

A simple `struct` to be used in combination with [`eigsolve`](@ref) or [`schursolve`](@ref)
to indicate which eigenvalues need to be targeted, namely those that appear first when
sorted by `by` and possibly in reverse order if `rev == true`.
"""
struct EigSorter{F}
    by::F
    rev::Bool
end
EigSorter(f::F; rev = false) where {F} = EigSorter{F}(f, rev)

const Selector = Union{Symbol, EigSorter}

function eigsolve(
        A::AbstractMatrix, howmany::Int = 1, which::Selector = :LM, T::Type = eltype(A);
        kwargs...
    )
    x₀ = Random.rand!(similar(A, T, size(A, 1)))
    return eigsolve(A, x₀, howmany, which; kwargs...)
end

function eigsolve(
        f, n::Int, howmany::Int = 1, which::Selector = :LM, T::Type = Float64;
        kwargs...
    )
    return eigsolve(f, rand(T, n), howmany, which; kwargs...)
end
function eigsolve(f, x₀, howmany::Int = 1, which::Selector = :LM; kwargs...)
    T = apply_scalartype(f, x₀)
    alg = eigselector(f, T; Tx = typeof(x₀), kwargs...)
    checkwhich(which) || error("Unknown eigenvalue selector: which = $which")
    if alg isa Lanczos || alg isa BlockLanczos
        if which == :LI || which == :SI
            error("Eigenvalue selector which = $which invalid: real eigenvalues expected with Lanczos and BlockLanczos algorithms")
        end
    elseif T <: Real
        by, rev = eigsort(which)
        if by(+im) != by(-im)
            error("Eigenvalue selector which = $which invalid because it does not treat
            `λ` and `conj(λ)` equally: work in complex arithmetic by providing a complex starting vector `x₀`")
        end
    end
    if haskey(kwargs, :alg_rrule)
        alg_rrule = kwargs[:alg_rrule]
    else
        alg_rrule = Arnoldi(;
            tol = alg.tol,
            krylovdim = alg.krylovdim,
            maxiter = alg.maxiter,
            eager = alg.eager,
            orth = alg.orth
        )
    end
    return eigsolve(f, x₀, howmany, which, alg; alg_rrule = alg_rrule)
end

function eigselector(
        f, T::Type;
        Tx::Type = Nothing,
        issymmetric::Bool = false,
        ishermitian::Bool = issymmetric && (T <: Real),
        krylovdim::Int = Tx <: Block ? KrylovDefaults.blockkrylovdim[] : KrylovDefaults.krylovdim[],
        maxiter::Int = KrylovDefaults.maxiter[],
        tol::Real = KrylovDefaults.tol[],
        qr_tol::Real = KrylovDefaults.tol[],
        orth::Orthogonalizer = KrylovDefaults.orth,
        eager::Bool = false,
        verbosity::Int = KrylovDefaults.verbosity[],
        alg_rrule = nothing
    )
    if Tx <: Block
        !(issymmetric || ishermitian) &&
            error("BlockLanczos requires a symmetric or hermitian linear map. A BlockArnoldi method has not yet been implemented but will be in the future")
        return BlockLanczos(;
            krylovdim = krylovdim,
            maxiter = maxiter,
            tol = tol,
            qr_tol = qr_tol,
            orth = orth,
            eager = eager,
            verbosity = verbosity
        )
    elseif (T <: Real && issymmetric) || ishermitian
        return Lanczos(;
            krylovdim = krylovdim,
            maxiter = maxiter,
            tol = tol,
            orth = orth,
            eager = eager,
            verbosity = verbosity
        )
    else
        return Arnoldi(;
            krylovdim = krylovdim,
            maxiter = maxiter,
            tol = tol,
            orth = orth,
            eager = eager,
            verbosity = verbosity
        )
    end
end
function eigselector(
        A::AbstractMatrix, T::Type;
        Tx::Type = Nothing,
        issymmetric::Bool = (T <: Real && LinearAlgebra.issymmetric(A)),
        ishermitian::Bool = issymmetric || LinearAlgebra.ishermitian(A),
        krylovdim::Int = Tx <: Block ? KrylovDefaults.blockkrylovdim[] : KrylovDefaults.krylovdim[],
        maxiter::Int = KrylovDefaults.maxiter[],
        tol::Real = KrylovDefaults.tol[],
        qr_tol::Real = KrylovDefaults.tol[],
        orth::Orthogonalizer = KrylovDefaults.orth,
        eager::Bool = false,
        verbosity::Int = KrylovDefaults.verbosity[],
        alg_rrule = nothing
    )
    if Tx <: Block
        !(issymmetric || ishermitian) &&
            error("BlockLanczos requires a symmetric or hermitian linear map. A BlockArnoldi method has not yet been implemented but will be in the future")
        return BlockLanczos(;
            krylovdim = krylovdim,
            maxiter = maxiter,
            tol = tol,
            qr_tol = qr_tol,
            orth = orth,
            eager = eager,
            verbosity = verbosity
        )
    elseif (T <: Real && issymmetric) || ishermitian
        return Lanczos(;
            krylovdim = krylovdim,
            maxiter = maxiter,
            tol = tol,
            orth = orth,
            eager = eager,
            verbosity = verbosity
        )
    else
        return Arnoldi(;
            krylovdim = krylovdim,
            maxiter = maxiter,
            tol = tol,
            orth = orth,
            eager = eager,
            verbosity = verbosity
        )
    end
end

checkwhich(::EigSorter) = true
checkwhich(s::Symbol) = s in (:LM, :LR, :SR, :LI, :SI)

eigsort(s::EigSorter) = s.by, s.rev
function eigsort(which::Symbol)
    if which == :LM
        by = abs
        rev = true
    elseif which == :LR
        by = real
        rev = true
    elseif which == :SR
        by = real
        rev = false
    elseif which == :LI
        by = imag
        rev = true
    elseif which == :SI
        by = imag
        rev = false
    else
        error("invalid specification of which eigenvalues to target: which = $which")
    end
    return by, rev
end

Base.@deprecate(RecursiveVec(args...), tuple(args...))

Base.@deprecate(basis(F::GKLFactorization, which::Symbol), basis(F, Val(which)))

import LinearAlgebra: mul!
Base.@deprecate(mul!(y, b::OrthonormalBasis, x::AbstractVector), unproject!!(y, b, x))

"""
    struct PackedHessenberg{T,V<:AbstractVector{T}} <: AbstractMatrix{T}
        data::V
        n::Int
    end

A custom struct to store a Hessenberg matrix in a packed format (without zeros). Hereto, the
non-zero entries are stored sequentially in vector `data` of length `n(n+1)/2`.
"""
struct PackedHessenberg{T, V <: AbstractVector{T}} <: AbstractMatrix{T}
    data::V
    n::Int
    function PackedHessenberg{T, V}(data::V, n::Int) where {T, V <: AbstractVector{T}}
        @assert length(data) >= ((n * n + 3 * n - 2) >> 1)
        return new{T, V}(data, n)
    end
end
function PackedHessenberg(data::AbstractVector, n::Int)
    return PackedHessenberg{eltype(data), typeof(data)}(data, n)
end
Base.size(A::PackedHessenberg) = (A.n, A.n)

function Base.replace_in_print_matrix(
        A::PackedHessenberg,
        i::Integer,
        j::Integer,
        s::AbstractString
    )
    return i <= j + 1 ? s : Base.replace_with_centered_mark(s)
end

function Base.getindex(A::PackedHessenberg{T}, i::Integer, j::Integer) where {T}
    @boundscheck checkbounds(A, i, j)
    if i > j + 1
        return zero(T)
    else
        return A.data[((j * j + j - 2) >> 1) + i]
    end
end
function Base.setindex!(A::PackedHessenberg{T}, v, i::Integer, j::Integer) where {T}
    @boundscheck checkbounds(A, i, j)
    if i > j + 1 && !iszero(v)
        throw(ReadOnlyMemoryError())
    else
        A.data[((j * j + j - 2) >> 1) + i] = v
    end
    return v
end

Base.IndexStyle(::Type{<:PackedHessenberg}) = Base.IndexCartesian()

# TODO: add more methods from the AbstractArray interface

module LinsolveAD
using KrylovKit, LinearAlgebra
using Random, Test, TestExtras
using ChainRulesCore, ChainRulesTestUtils, Zygote, FiniteDifferences
using ..TestSetup

fdm = ChainRulesTestUtils._fdm
n = 10
N = 30

function build_mat_example(A, b, x, alg, alg_rrule)
    Avec, A_fromvec = to_vec(A)
    bvec, b_fromvec = to_vec(b)
    xvec, x_fromvec = to_vec(x)
    T = eltype(A)

    function mat_example(Av, bv, xv)
        Ã = A_fromvec(Av)
        b̃ = b_fromvec(bv)
        x̃ = x_fromvec(xv)
        x, info = linsolve(Ã, b̃, x̃, alg; alg_rrule = alg_rrule)
        info.converged == 0 &&
            println("linsolve did not converge: normres = ", info.normres)
        xv, = to_vec(x)
        return xv
    end
    function mat_example_fun(Av, bv, xv)
        Ã = A_fromvec(Av)
        b̃ = b_fromvec(bv)
        x̃ = x_fromvec(xv)
        f = x -> Ã * x
        x, info = linsolve(f, b̃, x̃, alg; alg_rrule = alg_rrule)
        info.converged == 0 &&
            println("linsolve did not converge: normres = ", info.normres)
        xv, = to_vec(x)
        return xv
    end
    return mat_example, mat_example_fun, Avec, bvec, xvec
end

function testfun(A, x, c, d)
    return A * x + c * dot(d, x)
end
testfunthunk(A, x, c, d) = testfun(A, x, c, d)
function ChainRulesCore.rrule(
        config::RuleConfig{>:HasReverseMode}, ::typeof(testfunthunk),
        args...
    )
    y = testfunthunk(args...)
    function thunkedpb(dy)
        pb = rrule_via_ad(config, testfun, args...)[2]
        return map(z -> @thunk(z), pb(dy))
    end
    return y, thunkedpb
end

function build_fun_example(A, b, c, d, e, f, alg, alg_rrule)
    Avec, matfromvec = to_vec(A)
    bvec, vecfromvec = to_vec(b)
    cvec, = to_vec(c)
    dvec, = to_vec(d)
    evec, scalarfromvec = to_vec(e)
    fvec, = to_vec(f)

    function fun_example(Av, bv, cv, dv, ev, fv)
        Ã = matfromvec(Av)
        b̃ = vecfromvec(bv)
        c̃ = vecfromvec(cv)
        d̃ = vecfromvec(dv)
        ẽ = scalarfromvec(ev)
        f̃ = scalarfromvec(fv)

        x, info = linsolve(b̃, zero(b̃), alg, ẽ, f̃; alg_rrule = alg_rrule) do y
            return testfunthunk(Ã, y, c̃, d̃)
        end
        # info.converged > 0 || @warn "not converged"
        xv, = to_vec(x)
        return xv
    end
    return fun_example, Avec, bvec, cvec, dvec, evec, fvec
end

@testset "Small linsolve AD test with eltype=$T" for T in (
        Float32, Float64, ComplexF32,
        ComplexF64,
    )
    A = 2 * (rand(T, (n, n)) .- one(T) / 2)
    b = 2 * (rand(T, n) .- one(T) / 2)
    b /= norm(b)
    x = 2 * (rand(T, n) .- one(T) / 2)

    condA = cond(A)
    tol = tolerance(T) #condA * (T <: Real ? eps(T) : 4 * eps(real(T)))
    alg = GMRES(; tol = tol, krylovdim = n, maxiter = 1)

    config = Zygote.ZygoteRuleConfig()
    _, pb = ChainRulesCore.rrule(config, linsolve, A, b, x, alg, 0, 1; alg_rrule = alg)
    @constinferred pb((ZeroTangent(), NoTangent()))
    @constinferred pb((rand(T, n), NoTangent()))

    mat_example, mat_example_fun, Avec, bvec, xvec = build_mat_example(A, b, x, alg, alg)
    (JA, Jb, Jx) = FiniteDifferences.jacobian(fdm, mat_example, Avec, bvec, xvec)
    (JA1, Jb1, Jx1) = Zygote.jacobian(mat_example, Avec, bvec, xvec)
    (JA2, Jb2, Jx2) = Zygote.jacobian(mat_example_fun, Avec, bvec, xvec)

    @test isapprox(JA, JA1; rtol = condA * sqrt(eps(real(T))))
    @test all(isapprox.(JA1, JA2; atol = n * eps(real(T))))
    # factor 2 is minimally necessary for complex case, but 3 is more robust
    @test norm(Jx, Inf) < condA * sqrt(eps(real(T)))
    @test all(iszero, Jx1)
end

@testset "Large linsolve AD test with eltype=$T" for T in (Float64, ComplexF64)
    A = rand(T, (N, N)) .- one(T) / 2
    A = I - (9 // 10) * A / maximum(abs, eigvals(A))
    b = 2 * (rand(T, N) .- one(T) / 2)
    c = 2 * (rand(T, N) .- one(T) / 2)
    d = 2 * (rand(T, N) .- one(T) / 2)
    e = rand(T)
    f = rand(T)

    # mix algorithms]
    tol = tolerance(T) # N^2 * eps(real(T))
    alg1 = GMRES(; tol = tol, krylovdim = 20)
    alg2 = BiCGStab(; tol = tol, maxiter = 100) # BiCGStab seems to require slightly smaller tolerance for tests to work
    for (alg, alg_rrule) in ((alg1, alg2), (alg2, alg1))
        #! format: off
        fun_example, Avec, bvec, cvec, dvec, evec, fvec =
            build_fun_example(A, b, c, d, e, f, alg, alg_rrule)
        #! format: on

        (JA, Jb, Jc, Jd, Je, Jf) = FiniteDifferences.jacobian(
            fdm, fun_example,
            Avec, bvec, cvec, dvec, evec,
            fvec
        )
        (JA′, Jb′, Jc′, Jd′, Je′, Jf′) = Zygote.jacobian(
            fun_example, Avec, bvec, cvec,
            dvec, evec, fvec
        )
        rtol = 2 * cond(A + c * d') * sqrt(eps(real(T)))
        @test isapprox(JA, JA′; rtol = rtol)
        @test isapprox(Jb, Jb′; rtol = rtol)
        @test isapprox(Jc, Jc′; rtol = rtol)
        @test isapprox(Jd, Jd′; rtol = rtol)
        @test isapprox(Je, Je′; rtol = rtol)
        @test isapprox(Jf, Jf′; rtol = rtol)
    end
end
end

"""
    lssolve(A::AbstractMatrix, b::AbstractVector, [λ::Real = 0]; kwargs...)
    lssolve(f, b, [λ = 0]; kwargs...)
    # expert version:
    lssolve(f, b, algorithm, [λ = 0])

Compute a least squares solution `x` to the problem `A * x ≈ b` or `f(x) ≈ b` where `f`
encodes a linear map, i.e. a solution `x` that minimizes `norm(b - f(x))`.
Return the approximate solution `x` and a `ConvergenceInfo` structure.

### Arguments:

The linear map can be an `AbstractMatrix` (dense or sparse) or a general function or
callable object. Since both the action of the linear map and its adjoint are required in
order to solve the least squares problem, `f` can either be a tuple of two callable objects
(each accepting a single argument), representing the linear map and its adjoint respectively, 
or, `f` can be a single callable object that accepts two input arguments, where the second
argument is a flag of type `Val{true}` or `Val{false}` that indicates whether the adjoint or
the normal action of the linear map needs to be computed. The latter form still combines
well with the `do` block syntax of Julia, as in

```julia
x, info = lssolve(b; kwargs...) do x, flag
    if flag === Val(true)
        # y = compute action of adjoint map on x
    else
        # y = compute action of linear map on x
    end
    return y
end
```

If the linear map `A` or `f` has a nontrivial nullspace, so different minimisers exist, the
solution being returned is such that `norm(x)` is minimal. Alternatively, the problem can
be providing a nonzero value for the optional argument `λ`, representing a scalar so 
that the minimisation problem `norm(b - A * x)^2 + λ * norm(x)^2` is solved instead.

!!! info "Starting guess"
    Note that `lssolve` does not allow to specify an starting guess `x₀` for the solution. The
    starting guess is always assumed to be the zero vector in the domain of the linear map, which
    is found by applying the adjoint action of the linear map to `b` and applying `zerovector`
    to the result. Given a good initial guess `x₀`, the user can call `lssolve` with a modified
    right hand side `b - f(x₀)` and add `x₀` to the solution returned by `lssolve`. The
    resulting vector `x` is a least squares solution to the original problem, but such that 
    `norm(x - x₀)` is minimal or `norm(b - A * x)^2 + λ * norm(x-x₀)^2` is minimised instead

### Return values:

The return value is always of the form `x, info = lssolve(...)` with

  - `x`: the least squares solution to the problem, as defined above 

  - `info`: an object of type [`ConvergenceInfo`], which has the following fields

      + `info.converged::Int`: takes value 0 or 1 depending on whether the solution was
        converged up to the requested tolerance
      + `info.residual`: residual `b - A*x` of the approximate solution `x`
      + `info.normres::Real`: norm of the residual of the normal equations,
        i.e. the quantity `norm(A'*(b - A*x) - λ^2 * x)` that needs to be smaller
        than the requested tolerance `tol` in order to have a converged solution
      + `info.numops::Int`: total number of times that the linear map was applied, i.e. the
        number of times that `f` was called, or a vector was multiplied with `A` or `A'`
      + `info.numiter::Int`: total number of iterations of the algorithm

!!! warning "Check for convergence"

    No warning is printed if no converged solution was found, so always check if
    `info.converged == 1`.

### Keyword arguments:

Keyword arguments are given by:

  - `verbosity::Int = SILENT_LEVEL`: verbosity level, i.e. 
    - SILENT_LEVEL (suppress all messages)
    - WARN_LEVEL (only warnings)
    - STARTSTOP_LEVEL (information at the beginning and end)
    - EACHITERATION_LEVEL (progress info after every iteration)
  - `atol::Real`: the requested accuracy, i.e. absolute tolerance, on the norm of the
    residual.
  - `rtol::Real`: the requested accuracy on the norm of the residual, relative to the norm
    of the right hand side `b`.
  - `tol::Real`: the requested accuracy on the norm of the residual that is actually used by
    the algorithm; it defaults to `max(atol, rtol*norm(b))`. So either use `atol` and `rtol`
    or directly use `tol` (in which case the value of `atol` and `rtol` will be ignored).
  - `maxiter::Integer`: the number of iterations of the algorithm. Every iteration involves
    one application of the linear map and one application of the adjoint of the linear map.

The default values are given by `atol = KrylovDefaults.tol`, `rtol = KrylovDefaults.tol`,
`tol = max(atol, rtol*norm(b))`, `maxiter = KrylovDefaults.maxiter`;
see [`KrylovDefaults`](@ref) for details.

### Algorithms

The final (expert) method, without default values and keyword arguments, is the one that is
finally called, and can also be used directly. Here, one specifies the algorithm explicitly.
Currently, only [`LSMR`](@ref) is available and thus selected.
"""
function lssolve end

function lssolve(
        f, b, λ::Real = 0;
        rtol::Real = KrylovDefaults.tol[],
        atol::Real = KrylovDefaults.tol[],
        tol::Real = max(atol, rtol * norm(b)),
        kwargs...
    )
    alg = LSMR(; tol = tol, kwargs...)
    return lssolve(f, b, alg, λ)
end

"""
    reallssolve(f, b, algorithm, [λ::Real = 0])

Compute a least squares solution `x` to the problem `f(x) ≈ b` where `f`
encodes a real linear map, i.e. a solution `x` that minimizes `norm(b - f(x))`.
Return the approximate solution `x` and a `ConvergenceInfo` structure.

!!! note "Note about real linear maps"

    A function `f` is said to implement a real linear map if it satisfies 
    `f(add(x,y)) = add(f(x), f(y)` and `f(scale(x, α)) = scale(f(x), α)` for vectors `x`
    and `y` and scalars `α::Real`. Note that this is possible even when the vectors are
    represented using complex arithmetic. For example, the map `f=x-> x + conj(x)`
    represents a real linear map that is not (complex) linear, as it does not satisfy
    `f(scale(x, α)) = scale(f(x), α)` for complex scalars `α`. Note that complex linear
    maps are always real linear maps and thus can be used in this context, though in that
    case `lssolve` and `reallssolve` target the same solution. However, they still compute
    that solution using different arithmetic, and in that case `lssolve` might be more
    efficient.

    To interpret the vectors `x` and `y` as elements from a real vector space, the standard
    inner product defined on them will be replaced with `real(inner(x,y))`. This has no
    effect if the vectors `x` and `y` were represented using real arithmetic to begin with,
    and allows to seemlessly use complex vectors as well.

### Arguments:

The real linear map will typically be a function or callable object, as a matrix can only
represent a complex linear map and can thus simply be used in combination with `lssolve`. 
Since both the action of the  map and its adjoint are required in order to solve the least
squares problem, `f` can either be a tuple of two callable objects (each accepting a single
argument), representing the linear map and its adjoint respectively, or, `f` can be a single
callable object that accepts two input arguments, where the second argument is a flag of 
type `Val{true}` or `Val{false}` that indicates whether the adjoint or the normal action of 
the real linear map needs to be computed. The latter form still combines well with the `do`
block syntax of Julia, as in

```julia
x, info = reallssolve(b; kwargs...) do x, flag
    if flag === Val(true)
        # y = compute action of adjoint map on x
    else
        # y = compute action of linear map on x
    end
    return y
end
```

If the real linear map `A` or `f` has a nontrivial nullspace, so different minimisers exist,
the solution being returned is such that `norm(x)` is minimal. Alternatively, the problem
can be providing a nonzero value for the optional argument `λ`, representing a scalar so 
that the minimisation problem `norm(b - A * x)^2 + λ * norm(x)^2` is solved instead.

### Return values:

The return value is always of the form `x, info = reallssolve(...)` with

  - `x`: the least squares solution to the problem, as defined above 

  - `info`: an object of type [`ConvergenceInfo`], which has the following fields

      + `info.converged::Int`: takes value 0 or 1 depending on whether the solution was
        converged up to the requested tolerance
      + `info.residual`: residual `b - A*x` of the approximate solution `x`
      + `info.normres::Real`: norm of the residual of the normal equations,
        i.e. the quantity `norm(A'*(b - A*x) - λ^2 * x)` that needs to be smaller
        than the requested tolerance `tol` in order to have a converged solution
      + `info.numops::Int`: total number of times that the linear map was applied, i.e. the
        number of times that `f` was called, or a vector was multiplied with `A` or `A'`
      + `info.numiter::Int`: total number of iterations of the algorithm


### Algorithms

The final (expert) method, without default values and keyword arguments, is the one that is
finally called, and can also be used directly. Here, one specifies the algorithm explicitly.
Currently, only [`LSMR`](@ref) is available and thus selected.
"""
function reallssolve(f, b, alg, λ::Real = 0)
    x, info = lssolve(f, RealVec(b), alg, λ)
    newinfo = ConvergenceInfo(
        info.converged, info.residual[], info.normres, info.numiter,
        info.numops
    )
    return x[], newinfo
end

@testset "BiArnoldi - eigsolve full ($mode)" for mode in (:vector, :inplace, :outplace)
    scalartypes = mode === :vector ? (Float32, Float64, ComplexF32, ComplexF64) :
        (ComplexF64,)
    orths = mode === :vector ? (cgs2, mgs2, cgsr, mgsr) : (mgsr,)
    @testset for T in scalartypes
        @testset for orth in orths
            A = rand(T, (n, n)) .- one(T) / 2
            v = rand(T, (n,))
            w = rand(T, (n,))
            n1 = div(n, 2)
            alg = BiArnoldi(; orth = orth, krylovdim = n, maxiter = 1, tol = tolerance(T))
            #! format: off
            D1, (V1, W1), (infoV1, infoV2) =
                @constinferred bieigsolve(wrapop(A, Val(mode)),
                                          wrapvec(v, Val(mode)), wrapvec(w, Val(mode)),
                                          n1, :SR, alg)
            #! format: on

            # Some of these still fail
            alg = BiArnoldi(;
                orth = orth, krylovdim = n, maxiter = 1, tol = tolerance(T),
                verbosity = SILENT_LEVEL
            )
            @test_logs bieigsolve(
                wrapop(A, Val(mode)), wrapvec(v, Val(mode)),
                wrapvec(w, Val(mode)), n1, :SR, alg
            )
            alg = BiArnoldi(;
                orth = orth, krylovdim = n, maxiter = 1, tol = tolerance(T),
                verbosity = WARN_LEVEL
            )
            @test_logs bieigsolve(
                wrapop(A, Val(mode)), wrapvec(v, Val(mode)),
                wrapvec(w, Val(mode)), n1, :SR, alg
            )
            alg = BiArnoldi(;
                orth = orth, krylovdim = n1 + 2, maxiter = 1, tol = tolerance(T),
                verbosity = WARN_LEVEL
            )
            @test_logs (:warn,) bieigsolve(
                wrapop(A, Val(mode)), wrapvec(v, Val(mode)),
                wrapvec(w, Val(mode)), n1,
                :SR, alg
            )
            alg = BiArnoldi(;
                orth = orth, krylovdim = n, maxiter = 1, tol = tolerance(T),
                verbosity = STARTSTOP_LEVEL
            )
            @test_logs (:info,) bieigsolve(
                wrapop(A, Val(mode)), wrapvec(v, Val(mode)),
                wrapvec(w, Val(mode)), n1,
                :SR, alg
            )
            alg = BiArnoldi(;
                orth = orth, krylovdim = n1, maxiter = 3, tol = tolerance(T),
                verbosity = EACHITERATION_LEVEL
            )
            @test_logs(
                (:info,), (:info,), (:info,), (:warn,),
                bieigsolve(
                    wrapop(A, Val(mode)), wrapvec(v, Val(mode)),
                    wrapvec(w, Val(mode)), 1, :SR, alg
                )
            )
            alg = BiArnoldi(;
                orth = orth, krylovdim = 4, maxiter = 1, tol = tolerance(T),
                verbosity = EACHITERATION_LEVEL + 1
            )
            # since it is impossible to know exactly the size of the Krylov subspace after shrinking,
            # we only know the output for a sigle iteration
            @test_logs(
                (:info,), (:info,), (:info,), (:info,),
                (:info,), (:info,), (:info,), (:info,), (:info,), (:warn,),
                bieigsolve(
                    wrapop(A, Val(mode)), wrapvec(v, Val(mode)),
                    wrapvec(w, Val(mode)), 1, :SR, alg
                )
            )

            n2 = n - n1
            alg = BiArnoldi(; orth = orth, krylovdim = 2 * n, maxiter = 1, tol = tolerance(T))
            #! format: off
            D2, (V2, W2), (infoV2, infoW2) =
                @constinferred bieigsolve(wrapop(A, Val(mode)), 
                                          wrapvec(v, Val(mode)), wrapvec(w, Val(mode)),
                                          n2, :LR, alg)
            #! format: on
            D = sort(sort(eigvals(A); by = imag, rev = true); alg = MergeSort, by = real)
            D2′ = sort(sort(D2; by = imag, rev = true); alg = MergeSort, by = real)
            @test vcat(D1[1:n1], D2′[(end - n2 + 1):end]) ≊ D

            UV1 = stack(unwrapvec, V1)
            UV2 = stack(unwrapvec, V2)
            @test A * UV1 ≈ UV1 * Diagonal(D1)
            @test A * UV2 ≈ UV2 * Diagonal(D2)

            UW1 = stack(unwrapvec, W1)
            UW2 = stack(unwrapvec, W2)
            @test A' * UW1 ≈ UW1 * Diagonal(conj.(D1))
            @test A' * UW2 ≈ UW2 * Diagonal(conj.(D2))

            # check biorthogonality
            @test UW1' * UV1 ≈ Matrix(I, size(UW1, 2), size(UV1, 2))
            @test UW2' * UV2 ≈ Matrix(I, size(UW2, 2), size(UV2, 2))

            if T <: Complex
                n1 = div(n, 2)
                D1, (V1, W1), (infoV1, infoW1) = bieigsolve(
                    wrapop(A, Val(mode)),
                    wrapvec(v, Val(mode)),
                    wrapvec(w, Val(mode)),
                    n1, :SI, alg
                )
                n2 = n - n1
                D2, (V2, W2), (infoV2, infoW2) = bieigsolve(
                    wrapop(A, Val(mode)),
                    wrapvec(v, Val(mode)),
                    wrapvec(w, Val(mode)),
                    n2, :LI, alg
                )
                D = sort(eigvals(A); by = imag)
                @test vcat(D1[1:n1], reverse(D2[1:n2])) ≊ D

                UV1 = stack(unwrapvec, V1)
                UV2 = stack(unwrapvec, V2)
                @test A * UV1 ≈ UV1 * Diagonal(D1)
                @test A * UV2 ≈ UV2 * Diagonal(D2)

                UW1 = stack(unwrapvec, W1)
                UW2 = stack(unwrapvec, W2)
                @test A' * UW1 ≈ UW1 * Diagonal(conj.(D1))
                @test A' * UW2 ≈ UW2 * Diagonal(conj.(D2))

                # check biorthogonality
                @test UW1' * UV1 ≈ Matrix(I, size(UW1, 2), size(UV1, 2))
                @test UW2' * UV2 ≈ Matrix(I, size(UW2, 2), size(UV2, 2))
            end
        end
    end
end

@testset "BiArnoldi - eigsolve iteratively ($mode)" for mode in
    (:vector, :inplace, :outplace)
    scalartypes = mode === :vector ? (Float32, Float64, ComplexF32, ComplexF64) :
        (ComplexF64,)
    orths = mode === :vector ? (cgs2, mgs2, cgsr, mgsr) : (mgsr,)
    @testset for eager in (true, false)
        @testset for T in scalartypes
            @testset for orth in orths
                A = rand(T, (N, N)) .- one(T) / 2
                v = rand(T, (N,))
                w = rand(T, (N,))
                alg = BiArnoldi(;
                    krylovdim = 3 * n, maxiter = 40, eager,
                    tol = tolerance(T), verbosity = SILENT_LEVEL
                )
                #! format: off
                D1, (V1, W1), (infoV1, infoW1) = @constinferred bieigsolve(
                    wrapop(A, Val(mode)), wrapvec(v, Val(mode)), wrapvec(w, Val(mode)), 
                    n, :SR, alg)
                D2, (V2, W2), (infoV2, infoW2) = bieigsolve(
                    wrapop(A, Val(mode)), wrapvec(v, Val(mode)), wrapvec(w, Val(mode)), 
                    n, :LR, alg)
                D3, (V3, W3), (infoV3, infoW3) = bieigsolve(
                    wrapop(A, Val(mode)), wrapvec(v, Val(mode)), wrapvec(w, Val(mode)), 
                    n, :LM, alg)
                #! format: on
                D = sort(eigvals(A); by = imag, rev = true)

                @test infoV1.converged == infoW1.converged
                @test infoV2.converged == infoW2.converged
                @test infoV3.converged == infoW3.converged

                l1 = infoV1.converged
                l2 = infoV2.converged
                l3 = infoV3.converged
                @test l1 > 0
                @test l2 > 0
                @test l3 > 0
                @test D1[1:l1] ≊ sort(D; alg = MergeSort, by = real)[1:l1]
                @test D2[1:l2] ≊ sort(D; alg = MergeSort, by = real, rev = true)[1:l2]
                # sorting by abs does not seem very reliable if two distinct eigenvalues are close
                # in absolute value, so we perform a second sort afterwards using the real part
                @test D3[1:l3] ≊ sort(D; by = abs, rev = true)[1:l3]

                UV1 = stack(unwrapvec, V1)
                UV2 = stack(unwrapvec, V2)
                UV3 = stack(unwrapvec, V3)
                RV1 = stack(unwrapvec, infoV1.residual)
                RV2 = stack(unwrapvec, infoV2.residual)
                RV3 = stack(unwrapvec, infoV3.residual)

                UW1 = stack(unwrapvec, W1)
                UW2 = stack(unwrapvec, W2)
                UW3 = stack(unwrapvec, W3)
                RW1 = stack(unwrapvec, infoW1.residual)
                RW2 = stack(unwrapvec, infoW2.residual)
                RW3 = stack(unwrapvec, infoW3.residual)

                @test A * UV1 ≈ UV1 * Diagonal(D1) + RV1
                @test A' * UW1 ≈ UW1 * Diagonal(D1)' + RW1
                @test A * UV2 ≈ UV2 * Diagonal(D2) + RV2
                @test A' * UW2 ≈ UW2 * Diagonal(D2)' + RW2
                @test A * UV3 ≈ UV3 * Diagonal(D3) + RV3
                @test A' * UW3 ≈ UW3 * Diagonal(D3)' + RW3

                if T <: Complex
                    #! format: off
                    D1, (V1, W1), (infoV1, infoW1) = bieigsolve(
                        wrapop(A, Val(mode)), wrapvec(v, Val(mode)), wrapvec(w, Val(mode)), 
                        n, :SI, alg)
                    D2, (V2, W2), (infoV2, infoW2) = bieigsolve(
                        wrapop(A, Val(mode)), wrapvec(v, Val(mode)), wrapvec(w, Val(mode)), 
                        n, :LI, alg)
                    #! format: on

                    @test infoV1.converged == infoW1.converged
                    @test infoV2.converged == infoW2.converged

                    l1 = infoV1.converged
                    l2 = infoV2.converged
                    @test l1 > 0
                    @test l2 > 0
                    @test D1[1:l1] ≈ sort(D; by = imag)[1:l1]
                    @test D2[1:l2] ≈ sort(D; by = imag, rev = true)[1:l2]

                    UV1 = stack(unwrapvec, V1)
                    UV2 = stack(unwrapvec, V2)
                    RV1 = stack(unwrapvec, infoV1.residual)
                    RV2 = stack(unwrapvec, infoV2.residual)

                    UW1 = stack(unwrapvec, W1)
                    UW2 = stack(unwrapvec, W2)
                    RW1 = stack(unwrapvec, infoW1.residual)
                    RW2 = stack(unwrapvec, infoW2.residual)

                    @test A * UV1 ≈ UV1 * Diagonal(D1) + RV1
                    @test A' * UW1 ≈ UW1 * Diagonal(D1)' + RW1
                    @test A * UV2 ≈ UV2 * Diagonal(D2) + RV2
                    @test A' * UW2 ≈ UW2 * Diagonal(D2)' + RW2
                end
            end
        end
    end
end

@testset "BiArnoldi - shortened api ($mode)" for mode in (:vector,)
    scalartypes = mode === :vector ? (Float32, Float64, ComplexF32, ComplexF64) :
        (ComplexF64,)
    orths = mode === :vector ? (cgs2, mgs2, cgsr, mgsr) : (mgsr,)
    @testset for T in scalartypes
        @testset for orth in orths
            A = rand(T, (n, n)) .- one(T) / 2
            v = rand(T, (n,))
            w = rand(T, (n,))
            n1 = div(n, 2)

            @constinferred bieigsolve(
                wrapop(A, Val(mode)), wrapvec(v, Val(mode)),
                wrapvec(w, Val(mode)),
                n1; orth = orth, krylovdim = n, maxiter = 1,
                tol = tolerance(T)
            )

            @constinferred bieigsolve(
                wrapop(A, Val(mode)), n, n1;
                orth = orth, krylovdim = n, maxiter = 1, tol = tolerance(T)
            )
        end
    end
end

module RepeatedEigsolveAD

using KrylovKit, LinearAlgebra
using KrylovKit: SILENT_LEVEL, WARN_LEVEL, STARTSTOP_LEVEL, EACHITERATION_LEVEL
using Random, Test, TestExtras
using ChainRulesCore, ChainRulesTestUtils, Zygote, FiniteDifferences
using ..TestSetup
Random.seed!(987654321)

fdm = ChainRulesTestUtils._fdm
n = 10
N = 30

function build_mat_example(A, B, C, x, alg, alg_rrule)
    howmany = 1
    which = :LM

    Avec, A_fromvec = to_vec(A)
    Bvec, B_fromvec = to_vec(B)
    Cvec, C_fromvec = to_vec(C)
    xvec, x_fromvec = to_vec(x)

    M = [zero(A) zero(A) C; A zero(A) zero(A); zero(A) B zero(A)]
    vals, vecs, info = eigsolve(M, x, howmany, which, alg)
    info.converged < howmany && @warn "eigsolve did not converge"

    function mat_example(Av, Bv, Cv, xv)
        Ã = A_fromvec(Av)
        B̃ = B_fromvec(Bv)
        C̃ = C_fromvec(Cv)
        x̃ = x_fromvec(xv)
        M̃ = [zero(Ã) zero(Ã) C̃; Ã zero(Ã) zero(Ã); zero(Ã) B̃ zero(Ã)]
        vals′, vecs′, info′ = eigsolve(M̃, x̃, howmany, which, alg; alg_rrule = alg_rrule)
        info′.converged < howmany && println("eigsolve did not converge")
        catresults = vcat(vals′[1:howmany], vecs′[1:howmany]...)
        if eltype(catresults) <: Complex
            return vcat(real(catresults), imag(catresults))
        else
            return catresults
        end
    end

    function mat_example_fun(Av, Bv, Cv, xv)
        Ã = A_fromvec(Av)
        B̃ = B_fromvec(Bv)
        C̃ = C_fromvec(Cv)
        x̃ = x_fromvec(xv)
        M̃ = [zero(Ã) zero(Ã) C̃; Ã zero(Ã) zero(Ã); zero(Ã) B̃ zero(Ã)]
        f = x -> M̃ * x
        vals′, vecs′, info′ = eigsolve(f, x̃, howmany, which, alg; alg_rrule = alg_rrule)
        info′.converged < howmany && println("eigsolve did not converge")
        catresults = vcat(vals′[1:howmany], vecs′[1:howmany]...)
        if eltype(catresults) <: Complex
            return vcat(real(catresults), imag(catresults))
        else
            return catresults
        end
    end

    function mat_example_fd(Av, Bv, Cv, xv)
        Ã = A_fromvec(Av)
        B̃ = B_fromvec(Bv)
        C̃ = C_fromvec(Cv)
        x̃ = x_fromvec(xv)
        M̃ = [zero(Ã) zero(Ã) C̃; Ã zero(Ã) zero(Ã); zero(Ã) B̃ zero(Ã)]
        howmany′ = (eltype(Av) <: Complex ? 3 : 6) * howmany
        vals′, vecs′, info′ = eigsolve(M̃, x̃, howmany′, which, alg; alg_rrule = alg_rrule)
        _, i = findmin(abs.(vals′ .- vals[1]))
        info′.converged < i && println("eigsolve did not converge")
        d = dot(vecs[1], vecs′[i])
        @assert abs(d) > sqrt(eps(real(eltype(A))))
        phasefix = abs(d) / d
        vecs′[i] = vecs′[i] * phasefix
        catresults = vcat(vals′[i:i], vecs′[i:i]...)
        if eltype(catresults) <: Complex
            return vcat(real(catresults), imag(catresults))
        else
            return catresults
        end
    end

    return mat_example, mat_example_fun, mat_example_fd, Avec, Bvec, Cvec, xvec, vals,
        vecs
end

@timedtestset "Repeated eigsolve AD test with eltype=$T" for T in (Float64, ComplexF64)
    n = 10
    N = 3n

    A = randn(T, n, n)
    B = randn(T, n, n)
    C = randn(T, n, n)

    M = [zeros(T, n, 2n) A; B zeros(T, n, 2n); zeros(T, n, n) C zeros(T, n, n)]
    x = randn(T, N)

    tol = tolerance(T) #2 * N^2 * eps(real(T))
    alg = Arnoldi(; tol = tol, krylovdim = 2n)
    alg_rrule1 = Arnoldi(; tol = tol, krylovdim = 2n, verbosity = SILENT_LEVEL)
    alg_rrule2 = GMRES(; tol = tol, krylovdim = 2n, verbosity = SILENT_LEVEL)
    #! format: off
    mat_example1, mat_example_fun1, mat_example_fd, Avec, Bvec, Cvec, xvec, vals, vecs =
        build_mat_example(A, B, C, x, alg, alg_rrule1)
    mat_example2, mat_example_fun2, mat_example_fd, Avec, Bvec, Cvec, xvec, vals, vecs =
        build_mat_example(A, B, C, x, alg, alg_rrule2)
    #! format: on
    (JA, JB, JC, Jx) = FiniteDifferences.jacobian(
        fdm, mat_example_fd, Avec, Bvec,
        Cvec, xvec
    )
    (JA1, JB1, JC1, Jx1) = Zygote.jacobian(mat_example1, Avec, Bvec, Cvec, xvec)
    (JA2, JB2, JC2, Jx2) = Zygote.jacobian(mat_example_fun1, Avec, Bvec, Cvec, xvec)
    (JA3, JB3, JC3, Jx3) = Zygote.jacobian(mat_example2, Avec, Bvec, Cvec, xvec)
    (JA4, JB4, JC4, Jx4) = Zygote.jacobian(mat_example_fun2, Avec, Bvec, Cvec, xvec)

    @test isapprox(JA, JA1; rtol = N * sqrt(eps(real(T))))
    @test isapprox(JB, JB1; rtol = N * sqrt(eps(real(T))))
    @test isapprox(JC, JC1; rtol = N * sqrt(eps(real(T))))

    @test all(isapprox.(JA1, JA2; atol = n * eps(real(T))))
    @test all(isapprox.(JB1, JB2; atol = n * eps(real(T))))
    @test all(isapprox.(JC1, JC2; atol = n * eps(real(T))))

    @test all(isapprox.(JA1, JA3; atol = tol))
    @test all(isapprox.(JB1, JB3; atol = tol))
    @test all(isapprox.(JC1, JC3; atol = tol))

    @test all(isapprox.(JA1, JA4; atol = tol))
    @test all(isapprox.(JB1, JB4; atol = tol))
    @test all(isapprox.(JC1, JC4; atol = tol))

    @test norm(Jx, Inf) < N * sqrt(eps(real(T)))
    @test all(iszero, Jx1)
    @test all(iszero, Jx2)
    @test all(iszero, Jx3)
    @test all(iszero, Jx4)

    # some analysis
    ∂valsA = complex.(JA1[1, :], JA1[N + 2, :])
    ∂valsB = complex.(JB1[1, :], JB1[N + 2, :])
    ∂valsC = complex.(JC1[1, :], JC1[N + 2, :])
    ∂vecsA = complex.(JA1[1 .+ (1:N), :], JA1[N + 2 .+ (1:N), :])
    ∂vecsB = complex.(JB1[1 .+ (1:N), :], JB1[N + 2 .+ (1:N), :])
    ∂vecsC = complex.(JC1[1 .+ (1:N), :], JC1[N + 2 .+ (1:N), :])
    if T <: Complex # test holomorphicity / Cauchy-Riemann equations
        # for eigenvalues
        @test real(∂valsA[1:2:(2n^2)]) ≈ +imag(∂valsA[2:2:(2n^2)])
        @test imag(∂valsA[1:2:(2n^2)]) ≈ -real(∂valsA[2:2:(2n^2)])
        @test real(∂valsB[1:2:(2n^2)]) ≈ +imag(∂valsB[2:2:(2n^2)])
        @test imag(∂valsB[1:2:(2n^2)]) ≈ -real(∂valsB[2:2:(2n^2)])
        @test real(∂valsC[1:2:(2n^2)]) ≈ +imag(∂valsC[2:2:(2n^2)])
        @test imag(∂valsC[1:2:(2n^2)]) ≈ -real(∂valsC[2:2:(2n^2)])
        # and for eigenvectors
        @test real(∂vecsA[:, 1:2:(2n^2)]) ≈ +imag(∂vecsA[:, 2:2:(2n^2)])
        @test imag(∂vecsA[:, 1:2:(2n^2)]) ≈ -real(∂vecsA[:, 2:2:(2n^2)])
        @test real(∂vecsB[:, 1:2:(2n^2)]) ≈ +imag(∂vecsB[:, 2:2:(2n^2)])
        @test imag(∂vecsB[:, 1:2:(2n^2)]) ≈ -real(∂vecsB[:, 2:2:(2n^2)])
        @test real(∂vecsC[:, 1:2:(2n^2)]) ≈ +imag(∂vecsC[:, 2:2:(2n^2)])
        @test imag(∂vecsC[:, 1:2:(2n^2)]) ≈ -real(∂vecsC[:, 2:2:(2n^2)])
    end
    # test orthogonality of vecs and ∂vecs
    @test all(isapprox.(abs.(vecs[1]' * ∂vecsA), 0; atol = sqrt(eps(real(T)))))
    @test all(isapprox.(abs.(vecs[1]' * ∂vecsB), 0; atol = sqrt(eps(real(T)))))
    @test all(isapprox.(abs.(vecs[1]' * ∂vecsC), 0; atol = sqrt(eps(real(T)))))
end

end

# Test CG complete
@testset "CG small problem ($mode)" for mode in (:vector, :inplace, :outplace)
    scalartypes = mode === :vector ? (Float32, Float64, ComplexF32, ComplexF64) :
        (ComplexF64,)
    @testset for T in scalartypes
        A = rand(T, (n, n))
        A = sqrt(A * A')
        b = rand(T, n)
        alg = CG(; maxiter = 2n, tol = tolerance(T) * norm(b), verbosity = SILENT_LEVEL) # because of loss of orthogonality, we choose maxiter = 2n
        x, info = @constinferred linsolve(
            wrapop(A, Val(mode)), wrapvec(b, Val(mode));
            ishermitian = true, isposdef = true, maxiter = 2n,
            krylovdim = 1, rtol = tolerance(T),
            verbosity = SILENT_LEVEL
        )
        @test info.converged > 0
        @test unwrapvec(b) ≈ A * unwrapvec(x)
        @test_logs linsolve(
            wrapop(A, Val(mode)), wrapvec(b, Val(mode));
            ishermitian = true, isposdef = true, maxiter = 2n,
            krylovdim = 1, rtol = tolerance(T),
            verbosity = SILENT_LEVEL
        )
        @test_logs linsolve(
            wrapop(A, Val(mode)), wrapvec(b, Val(mode));
            ishermitian = true, isposdef = true, maxiter = 2n,
            krylovdim = 1, rtol = tolerance(T),
            verbosity = WARN_LEVEL
        )
        @test_logs (:info,) (:info,) linsolve(
            wrapop(A, Val(mode)), wrapvec(b, Val(mode));
            ishermitian = true, isposdef = true, maxiter = 2n,
            krylovdim = 1, rtol = tolerance(T),
            verbosity = STARTSTOP_LEVEL
        )
        @test_logs min_level = Logging.Warn linsolve(
            wrapop(A, Val(mode)),
            wrapvec(b, Val(mode));
            ishermitian = true, isposdef = true,
            maxiter = 2n,
            krylovdim = 1, rtol = tolerance(T),
            verbosity = EACHITERATION_LEVEL
        )

        x, info = linsolve(wrapop(A, Val(mode)), wrapvec(b, Val(mode)), x, alg)
        @test info.numops == 1
        @test_logs linsolve(wrapop(A, Val(mode)), wrapvec(b, Val(mode)), x, alg)
        alg = CG(; maxiter = 2n, tol = tolerance(T) * norm(b), verbosity = WARN_LEVEL)
        @test_logs linsolve(wrapop(A, Val(mode)), wrapvec(b, Val(mode)), x, alg)
        alg = CG(; maxiter = 2n, tol = tolerance(T) * norm(b), verbosity = STARTSTOP_LEVEL)
        @test_logs (:info,) linsolve(wrapop(A, Val(mode)), wrapvec(b, Val(mode)), x, alg)
        alg = CG(; maxiter = 2n, tol = tolerance(T) * norm(b), verbosity = SILENT_LEVEL)

        A = rand(T, (n, n))
        A = sqrt(A * A')
        α₀ = rand(real(T)) + 1
        α₁ = rand(real(T))
        x, info = @constinferred linsolve(
            wrapop(A, Val(mode)), wrapvec(b, Val(mode)),
            wrapvec(zerovector(b), Val(mode)), alg, α₀, α₁
        )
        @test unwrapvec(b) ≈ (α₀ * I + α₁ * A) * unwrapvec(x)
        @test info.converged > 0
    end
end

# Test CG complete
@testset "CG large problem ($mode)" for mode in (:vector, :inplace, :outplace)
    scalartypes = mode === :vector ? (Float32, Float64, ComplexF32, ComplexF64) :
        (ComplexF64,)
    @testset for T in scalartypes
        A = rand(T, (N, N))
        A = sqrt(sqrt(A * A')) / N
        b = rand(T, N)
        x₀ = rand(T, N)
        x, info = @constinferred linsolve(
            wrapop(A, Val(mode)), wrapvec(b, Val(mode)),
            wrapvec(x₀, Val(mode));
            isposdef = true, maxiter = 1, krylovdim = N,
            rtol = tolerance(T)
        )
        @test unwrapvec(b) ≈ A * unwrapvec(x) + unwrapvec(info.residual)
        if info.converged == 0
            @test_logs linsolve(
                wrapop(A, Val(mode)), wrapvec(b, Val(mode)),
                wrapvec(x₀, Val(mode));
                isposdef = true, maxiter = 1, krylovdim = N,
                rtol = tolerance(T), verbosity = SILENT_LEVEL
            )
            @test_logs (:warn,) linsolve(
                wrapop(A, Val(mode)), wrapvec(b, Val(mode)),
                wrapvec(x₀, Val(mode));
                isposdef = true, maxiter = 1, krylovdim = N,
                rtol = tolerance(T), verbosity = WARN_LEVEL
            )
            @test_logs (:info,) (:warn,) linsolve(
                wrapop(A, Val(mode)),
                wrapvec(b, Val(mode)),
                wrapvec(x₀, Val(mode));
                isposdef = true, maxiter = 1, krylovdim = N,
                rtol = tolerance(T),
                verbosity = STARTSTOP_LEVEL
            )
        end

        α₀ = rand(real(T)) + 1
        α₁ = rand(real(T))
        x, info = @constinferred linsolve(
            wrapop(A, Val(mode)), wrapvec(b, Val(mode)),
            α₀, α₁;
            isposdef = true, maxiter = 1, krylovdim = N,
            rtol = tolerance(T)
        )
        @test unwrapvec(b) ≈ (α₀ * I + α₁ * A) * unwrapvec(x) + unwrapvec(info.residual)
    end
end

# Test GMRES complete
@testset "GMRES full factorization ($mode)" for mode in (:vector, :inplace, :outplace)
    scalartypes = mode === :vector ? (Float32, Float64, ComplexF32, ComplexF64) :
        (ComplexF64,)
    @testset for T in scalartypes
        A = rand(T, (n, n)) .- one(T) / 2
        b = rand(T, n)
        alg = GMRES(;
            krylovdim = n, maxiter = 2, tol = tolerance(T) * norm(b),
            verbosity = SILENT_LEVEL
        )
        x, info = @constinferred linsolve(
            wrapop(A, Val(mode)), wrapvec(b, Val(mode));
            krylovdim = n, maxiter = 2,
            rtol = tolerance(T), verbosity = SILENT_LEVEL
        )
        @test info.converged == 1
        @test unwrapvec(b) ≈ A * unwrapvec(x)
        @test_logs linsolve(
            wrapop(A, Val(mode)), wrapvec(b, Val(mode));
            krylovdim = n, maxiter = 2,
            rtol = tolerance(T), verbosity = SILENT_LEVEL
        )
        @test_logs linsolve(
            wrapop(A, Val(mode)), wrapvec(b, Val(mode));
            krylovdim = n, maxiter = 2,
            rtol = tolerance(T), verbosity = WARN_LEVEL
        )
        @test_logs (:info,) (:info,) linsolve(
            wrapop(A, Val(mode)), wrapvec(b, Val(mode));
            krylovdim = n, maxiter = 2,
            rtol = tolerance(T), verbosity = STARTSTOP_LEVEL
        )
        @test_logs min_level = Logging.Warn linsolve(
            wrapop(A, Val(mode)),
            wrapvec(b, Val(mode));
            krylovdim = n, maxiter = 2,
            rtol = tolerance(T),
            verbosity = EACHITERATION_LEVEL
        )

        alg = GMRES(;
            krylovdim = n, maxiter = 2, tol = tolerance(T) * norm(b),
            verbosity = SILENT_LEVEL
        )
        x, info = @constinferred linsolve(
            wrapop(A, Val(mode)), wrapvec(b, Val(mode)), x,
            alg
        )
        @test info.numops == 1
        @test_logs linsolve(wrapop(A, Val(mode)), wrapvec(b, Val(mode)), x, alg)
        alg = GMRES(;
            krylovdim = n, maxiter = 2, tol = tolerance(T) * norm(b),
            verbosity = WARN_LEVEL
        )
        @test_logs linsolve(wrapop(A, Val(mode)), wrapvec(b, Val(mode)), x, alg)
        alg = GMRES(;
            krylovdim = n, maxiter = 2, tol = tolerance(T) * norm(b),
            verbosity = STARTSTOP_LEVEL
        )
        @test_logs (:info,) linsolve(wrapop(A, Val(mode)), wrapvec(b, Val(mode)), x, alg)
        alg = GMRES(;
            krylovdim = n, maxiter = 2, tol = tolerance(T) * norm(b),
            verbosity = SILENT_LEVEL
        )

        nreal = (T <: Real) ? n : 2n
        algr = GMRES(;
            krylovdim = nreal, maxiter = 2, tol = tolerance(T) * norm(b),
            verbosity = SILENT_LEVEL
        )
        xr, infor = @constinferred reallinsolve(
            wrapop(A, Val(mode)), wrapvec(b, Val(mode)),
            zerovector(x), algr
        )
        @test infor.converged == 1
        @test unwrapvec(x) ≈ unwrapvec(xr)

        A = rand(T, (n, n))
        α₀ = rand(T)
        α₁ = -rand(T)
        x, info = @constinferred(linsolve(A, b, zerovector(b), alg, α₀, α₁))
        @test unwrapvec(b) ≈ (α₀ * I + α₁ * A) * unwrapvec(x)
        @test info.converged == 1

        if mode == :vector && T <: Complex
            B = rand(T, (n, n))
            f = buildrealmap(A, B)
            α₀ = rand(real(T))
            α₁ = -rand(real(T))
            xr, infor = @constinferred reallinsolve(f, b, zerovector(b), algr, α₀, α₁)
            @test infor.converged == 1
            @test b ≈ (α₀ * xr + α₁ * A * xr + α₁ * B * conj(xr))
        end
    end
end

# Test GMRES with restart
@testset "GMRES with restarts ($mode)" for mode in (:vector, :inplace, :outplace)
    scalartypes = mode === :vector ? (Float32, Float64, ComplexF32, ComplexF64) :
        (ComplexF64,)
    @testset for T in scalartypes
        A = rand(T, (N, N)) .- one(T) / 2
        A = I - T(9 / 10) * A / maximum(abs, eigvals(A))
        b = rand(T, N)
        x₀ = rand(T, N)
        x, info = @constinferred linsolve(
            wrapop(A, Val(mode)), wrapvec(b, Val(mode)),
            wrapvec(x₀, Val(mode));
            krylovdim = 3 * n,
            maxiter = 50, rtol = tolerance(T)
        )
        @test unwrapvec(b) ≈ A * unwrapvec(x) + unwrapvec(info.residual)
        if info.converged == 0
            @test_logs linsolve(
                wrapop(A, Val(mode)), wrapvec(b, Val(mode)),
                wrapvec(x₀, Val(mode));
                krylovdim = 3 * n,
                maxiter = 50, rtol = tolerance(T), verbosity = SILENT_LEVEL
            )
            @test_logs (:warn,) linsolve(
                wrapop(A, Val(mode)), wrapvec(b, Val(mode)),
                wrapvec(x₀, Val(mode));
                krylovdim = 3 * n,
                maxiter = 50, rtol = tolerance(T),
                verbosity = WARN_LEVEL
            )
            @test_logs (:info,) (:warn,) linsolve(
                wrapop(A, Val(mode)),
                wrapvec(b, Val(mode)),
                wrapvec(x₀, Val(mode));
                krylovdim = 3 * n,
                maxiter = 50, rtol = tolerance(T),
                verbosity = STARTSTOP_LEVEL
            )
        end

        alg = GMRES(;
            krylovdim = 3 * n, maxiter = 50, tol = tolerance(T) * norm(b),
            verbosity = SILENT_LEVEL
        )
        xr, infor = @constinferred reallinsolve(
            wrapop(A, Val(mode)), wrapvec(b, Val(mode)),
            zerovector(x), alg
        )
        @test unwrapvec(b) ≈ A * unwrapvec(xr) + unwrapvec(infor.residual)

        A = rand(T, (N, N)) .- one(T) / 2
        α₀ = maximum(abs, eigvals(A))
        α₁ = -9 * rand(T) / 10
        x, info = @constinferred linsolve(
            wrapop(A, Val(mode)), wrapvec(b, Val(mode)), α₀,
            α₁; krylovdim = 3 * n,
            maxiter = 50, rtol = tolerance(T)
        )
        @test unwrapvec(b) ≈ (α₀ * I + α₁ * A) * unwrapvec(x) + unwrapvec(info.residual)

        if mode == :vector && T <: Complex
            A = rand(T, (N, N)) .- one(T) / 2
            B = rand(T, (N, N)) .- one(T) / 2
            f = buildrealmap(A, B)
            α₀ = 1
            α₁ = -1 / (maximum(abs, eigvals(A)) + maximum(abs, eigvals(B)))
            xr, infor = @constinferred reallinsolve(f, b, zerovector(b), alg, α₀, α₁)
            @test b ≈ (α₀ * xr + α₁ * A * xr + α₁ * B * conj(xr)) + infor.residual
        end
    end
end

# Test BiCGStab
@testset "BiCGStab small problem ($mode)" for mode in (:vector, :inplace, :outplace)
    scalartypes = mode === :vector ? (Float32, Float64, ComplexF32, ComplexF64) :
        (ComplexF64,)
    @testset for T in scalartypes
        A = rand(T, (n, n)) .- one(T) / 2
        A = I - T(9 / 10) * A / maximum(abs, eigvals(A))
        b = rand(T, n)
        alg = BiCGStab(; maxiter = 4n, tol = tolerance(T) * norm(b), verbosity = SILENT_LEVEL)
        x, info = @constinferred linsolve(
            wrapop(A, Val(mode)), wrapvec(b, Val(mode)),
            wrapvec(zerovector(b), Val(mode)), alg
        )
        @test info.converged > 0
        @test unwrapvec(b) ≈ A * unwrapvec(x)
        alg = BiCGStab(; maxiter = 4n, tol = tolerance(T) * norm(b), verbosity = SILENT_LEVEL)
        @test_logs linsolve(
            wrapop(A, Val(mode)), wrapvec(b, Val(mode)),
            wrapvec(zerovector(b), Val(mode)), alg
        )
        alg = BiCGStab(; maxiter = 4n, tol = tolerance(T) * norm(b), verbosity = WARN_LEVEL)
        @test_logs linsolve(
            wrapop(A, Val(mode)), wrapvec(b, Val(mode)),
            wrapvec(zerovector(b), Val(mode)), alg
        )
        alg = BiCGStab(; maxiter = 4n, tol = tolerance(T) * norm(b), verbosity = STARTSTOP_LEVEL)
        @test_logs (:info,) (:info,) linsolve(
            wrapop(A, Val(mode)), wrapvec(b, Val(mode)),
            wrapvec(zerovector(b), Val(mode)), alg
        )
        alg = BiCGStab(;
            maxiter = 4n, tol = tolerance(T) * norm(b),
            verbosity = EACHITERATION_LEVEL
        )
        @test_logs min_level = Logging.Warn linsolve(
            wrapop(A, Val(mode)),
            wrapvec(b, Val(mode)),
            wrapvec(zerovector(b), Val(mode)), alg
        )
        alg = BiCGStab(; maxiter = 4n, tol = tolerance(T) * norm(b), verbosity = SILENT_LEVEL)

        x, info = @constinferred linsolve(
            wrapop(A, Val(mode)), wrapvec(b, Val(mode)), x,
            alg
        )
        @test info.numops == 1
        alg = BiCGStab(; maxiter = 4n, tol = tolerance(T) * norm(b), verbosity = SILENT_LEVEL)
        @test_logs linsolve(wrapop(A, Val(mode)), wrapvec(b, Val(mode)), x, alg)
        alg = BiCGStab(; maxiter = 4n, tol = tolerance(T) * norm(b), verbosity = WARN_LEVEL)
        @test_logs linsolve(wrapop(A, Val(mode)), wrapvec(b, Val(mode)), x, alg)
        alg = BiCGStab(; maxiter = 4n, tol = tolerance(T) * norm(b), verbosity = STARTSTOP_LEVEL)
        @test_logs (:info,) linsolve(wrapop(A, Val(mode)), wrapvec(b, Val(mode)), x, alg)
        alg = BiCGStab(; maxiter = 4n, tol = tolerance(T) * norm(b), verbosity = SILENT_LEVEL)

        α₀ = rand(real(T)) + 1
        α₁ = rand(real(T))
        x, info = @constinferred linsolve(
            wrapop(A, Val(mode)), wrapvec(b, Val(mode)),
            wrapvec(zerovector(b), Val(mode)), alg, α₀, α₁
        )
        @test unwrapvec(b) ≈ (α₀ * I + α₁ * A) * unwrapvec(x)
        @test info.converged > 0
    end
end

@testset "BiCGStab large problem ($mode)" for mode in (:vector, :inplace, :outplace)
    scalartypes = mode === :vector ? (Float32, Float64, ComplexF32, ComplexF64) :
        (ComplexF64,)
    @testset for T in scalartypes
        A = rand(T, (N, N)) .- one(T) / 2
        b = rand(T, N)
        α₀ = maximum(abs, eigvals(A))
        α₁ = -9 * rand(real(T)) / 10
        alg = BiCGStab(; maxiter = 2, tol = tolerance(T) * norm(b), verbosity = SILENT_LEVEL)
        x, info = @constinferred linsolve(
            wrapop(A, Val(mode)), wrapvec(b, Val(mode)),
            wrapvec(zerovector(b), Val(mode)), alg, α₀,
            α₁
        )
        @test unwrapvec(b) ≈ (α₀ * I + α₁ * A) * unwrapvec(x) + unwrapvec(info.residual)
        if info.converged == 0
            @test_logs linsolve(
                wrapop(A, Val(mode)), wrapvec(b, Val(mode)),
                wrapvec(zerovector(b), Val(mode)), alg, α₀, α₁
            )
            alg = BiCGStab(; maxiter = 2, tol = tolerance(T) * norm(b), verbosity = WARN_LEVEL)
            @test_logs (:warn,) linsolve(
                wrapop(A, Val(mode)), wrapvec(b, Val(mode)),
                wrapvec(zerovector(b), Val(mode)), alg, α₀, α₁
            )
            alg = BiCGStab(;
                maxiter = 2, tol = tolerance(T) * norm(b),
                verbosity = STARTSTOP_LEVEL
            )
            @test_logs (:info,) (:warn,) linsolve(
                wrapop(A, Val(mode)),
                wrapvec(b, Val(mode)),
                wrapvec(zerovector(b), Val(mode)), alg,
                α₀, α₁
            )
        end

        alg = BiCGStab(; maxiter = 10 * N, tol = tolerance(T) * norm(b), verbosity = SILENT_LEVEL)
        x, info = @constinferred linsolve(
            wrapop(A, Val(mode)), wrapvec(b, Val(mode)), x,
            alg, α₀, α₁
        )
        @test info.converged > 0
        @test unwrapvec(b) ≈ (α₀ * I + α₁ * A) * unwrapvec(x)

        xr, infor = @constinferred reallinsolve(
            wrapop(A, Val(mode)), wrapvec(b, Val(mode)),
            zerovector(x), alg, α₀, α₁
        )
        @test infor.converged > 0
        @test unwrapvec(xr) ≈ unwrapvec(x)

        if mode == :vector && T <: Complex
            A = rand(T, (N, N)) .- one(T) / 2
            B = rand(T, (N, N)) .- one(T) / 2
            f = buildrealmap(A, B)
            α₀ = 1
            α₁ = -1 / (maximum(abs, eigvals(A)) + maximum(abs, eigvals(B)))
            xr, infor = @constinferred reallinsolve(f, b, zerovector(b), alg, α₀, α₁)
            @test info.converged > 0
            @test b ≈ (α₀ * xr + α₁ * A * xr + α₁ * B * conj(xr))
        end
    end
end

mutable struct BiArnoldiFactorization{T, S} <: KrylovFactorization{T, S}
    VH::ArnoldiFactorization{T, S}
    WK::ArnoldiFactorization{T, S}
end

Base.length(F::BiArnoldiFactorization) = length(F.VH)
Base.sizehint!(F::BiArnoldiFactorization, n) = begin
    sizehint!(F.VH, n)
    sizehint!(F.WK, n)
    return F
end
Base.eltype(F::BiArnoldiFactorization) = eltype(typeof(F))
Base.eltype(::Type{<:BiArnoldiFactorization{<:Any, S}}) where {S} = S

basis(F::BiArnoldiFactorization) = basis.((F.VH, F.WK))
rayleighquotient(F::BiArnoldiFactorization) = rayleighquotient.((F.VH, F.WK))
residual(F::BiArnoldiFactorization) = residual.((F.VH, F.WK))
normres(F::BiArnoldiFactorization) = normres.((F.VH, F.WK))
rayleighextension(F::BiArnoldiFactorization) = rayleighextension.((F.VH, F.WK))

struct BiArnoldiIterator{I1 <: ArnoldiIterator, I2 <: ArnoldiIterator}
    iterVH::I1
    iterWK::I2
    function BiArnoldiIterator(
            f::F, v₀, w₀, orth1::Orthogonalizer, orth2::Orthogonalizer
        ) where {F}
        iterVH = ArnoldiIterator(Base.Fix1(apply_normal, f), v₀, orth1)
        iterWK = ArnoldiIterator(Base.Fix1(apply_adjoint, f), w₀, orth2)
        I1 = typeof(iterVH)
        I2 = typeof(iterWK)
        return new{I1, I2}(iterVH, iterWK)
    end
end
function BiArnoldiIterator(f, v₀, w₀ = v₀, orth = KrylovDefaults.orth)
    return BiArnoldiIterator(f, v₀, w₀, orth, orth)
end

Base.IteratorSize(::Type{<:BiArnoldiIterator}) = Base.SizeUnknown()
Base.IteratorEltype(::Type{<:BiArnoldiIterator}) = Base.EltypeUnknown()

function Base.iterate(iter::BiArnoldiIterator)
    state = initialize(iter)
    return state, state
end
function Base.iterate(iter::BiArnoldiIterator, state)
    nr = normres(state)
    if minimum(nr) < eps(typeof(nr))
        return nothing
    else
        state = expand!(iter, deepcopy(state))
        return state, state
    end
end

function initialize(iter::BiArnoldiIterator; verbosity::Int = KrylovDefaults.verbosity[])
    VH = initialize(iter.iterVH; verbosity = verbosity)
    WK = initialize(iter.iterWK; verbosity = verbosity)
    return BiArnoldiFactorization(VH, WK)
end
function initialize!(
        iter::BiArnoldiIterator, state::BiArnoldiFactorization;
        verbosity::Int = KrylovDefaults.verbosity[]
    )
    state.VH = initialize!(iter.iterVH, state.VH; verbosity = verbosity)
    state.WK = initialize!(iter.iterWK, state.WK; verbosity = verbosity)
    return state
end
function expand!(
        iter::BiArnoldiIterator, state::BiArnoldiFactorization;
        verbosity::Int = KrylovDefaults.verbosity[]
    )
    state.VH = expand!(iter.iterVH, state.VH; verbosity = verbosity)
    state.WK = expand!(iter.iterWK, state.WK; verbosity = verbosity)
    return state
end
function shrink!(
        state::BiArnoldiFactorization, k;
        verbosity::Int = KrylovDefaults.verbosity[]
    )
    state.VH = shrink!(state.VH, k; verbosity = verbosity)
    state.WK = shrink!(state.WK, k; verbosity = verbosity)
    return state
end

function geneigsolve(f, x₀, howmany::Int, which::Selector, alg::GolubYe)
    krylovdim = alg.krylovdim
    maxiter = alg.maxiter
    howmany > krylovdim &&
        error("krylov dimension $(krylovdim) too small to compute $howmany eigenvalues")

    ## FIRST ITERATION: setting up
    numiter = 1
    ax₀, bx₀ = genapply(f, x₀)
    numops = 1
    β₀ = norm(x₀)
    iszero(β₀) && throw(ArgumentError("initial vector should not have norm zero"))
    xax = inner(x₀, ax₀) / β₀^2
    xbx = inner(x₀, bx₀) / β₀^2
    T = promote_type(typeof(xax), typeof(xbx))
    invβ₀ = one(T) / β₀
    v = scale(x₀, invβ₀)
    av = scale!!(zerovector(v), ax₀, invβ₀)
    bv = scale!!(zerovector(v), bx₀, invβ₀)
    ρ = checkhermitian(xax) / checkposdef(xbx)
    r = add!!(av, bv, -ρ)
    tol::typeof(ρ) = alg.tol

    # allocate storage
    HHA = fill(zero(T), krylovdim + 1, krylovdim + 1)
    HHB = fill(zero(T), krylovdim + 1, krylovdim + 1)

    # Start Lanczos iteration with A - ρ ⋅ B
    numiter = 1
    vold = v
    V = OrthonormalBasis([v])
    BV = [bv]
    sizehint!(V, krylovdim + 1)
    sizehint!(BV, krylovdim + 1)

    r, α = orthogonalize!!(r, v, alg.orth) # α should be zero, otherwise ρ was miscalculated
    β = norm(r)
    converged = 0

    values = resize!(Vector{typeof(ρ)}(undef, howmany), 0)
    vectors = resize!(Vector{typeof(v)}(undef, howmany), 0)
    residuals = resize!(Vector{typeof(r)}(undef, howmany), 0)
    normresiduals = resize!(Vector{typeof(β)}(undef, howmany), 0)

    K = 1
    HHA[K, K] = real(α)
    if alg.verbosity >= EACHITERATION_LEVEL + 1
        @info "Golub-Ye iteration $numiter, step $K: normres = $(normres2string(β))"
    end
    while true
        β = norm(r)
        if β <= tol && K < howmany
            if alg.verbosity >= WARN_LEVEL
                msg = "Invariant subspace of dimension $K (up to requested tolerance `tol = $tol`), "
                msg *= "which is smaller than the number of requested eigenvalues (i.e. `howmany == $howmany`);"
                msg *= "setting `howmany = $K`."
                @warn msg
            end
            howmany = K
        end
        if K == krylovdim - converged || β <= tol # process
            if numiter > 1
                # add vold - v, or thus just vold as v is first vector in subspace
                v, = orthonormalize!!(vold, V, alg.orth)
                av, bv = genapply(f, v)
                numops += 1
                av = add!!(av, bv, -ρ)
                for i in 1:K
                    HHA[i, K + 1] = inner(V[i], av)
                    HHA[K + 1, i] = conj(HHA[i, K + 1])
                end
                K += 1
                HHA[K, K] = checkhermitian(inner(v, av))
                push!(V, v)
                push!(BV, bv)
            end
            for i in 1:converged
                # add converged vectors
                v, = orthonormalize(vectors[i], V, alg.orth)
                av, bv = genapply(f, v)
                numops += 1
                av = add!!(av, bv, -ρ)
                for j in 1:K
                    HHA[j, K + 1] = inner(V[j], av)
                    HHA[K + 1, j] = conj(HHA[j, K + 1])
                end
                K += 1
                HHA[K, K] = checkhermitian(inner(v, av))
                push!(V, v)
                push!(BV, bv)
            end

            # Process
            HA = view(HHA, 1:K, 1:K)
            HB = view(HHB, 1:K, 1:K)
            buildHB!(HB, V, BV)
            HA .+= ρ .* HB

            D, Z = geneigh!(HA, HB)
            by, rev = eigsort(which)
            p = sortperm(D; by, rev)
            xold = V[1]

            converged = 0
            resize!(values, 0)
            resize!(vectors, 0)
            resize!(residuals, 0)
            resize!(normresiduals, 0)
            for k in 1:K
                z = view(Z, :, p[k])
                v = unproject!!(zerovector(vold), V, z)
                av, bv = genapply(f, v)
                numops += 1
                ρ = checkhermitian(inner(v, av)) / checkposdef(inner(v, bv))
                r = add!!(av, bv, -ρ)
                β = norm(r)

                if β < tol * norm(z)
                    converged += 1
                elseif numiter < maxiter
                    break # in last iteration, keep adding nonconverged vectors up to howmany
                end
                push!(values, ρ)
                push!(vectors, v)
                push!(residuals, r)
                push!(normresiduals, β)
                if (k == howmany && numiter == maxiter)
                    break
                end
            end
            if converged >= howmany
                howmany = converged
                break
            end
            if alg.verbosity >= EACHITERATION_LEVEL
                @info "Golub-Ye geneigsolve in iter $numiter: $converged values converged, normres = $(normres2string(normresiduals))"
            end
        end

        if K < krylovdim - converged
            # expand
            v = scale!!(r, 1 / β)
            push!(V, v)
            HHA[K + 1, K] = β
            HHA[K, K + 1] = β
            βold = β
            r, α, β, bv = golubyerecurrence(f, ρ, V, βold, alg.orth)
            numops += 1
            K += 1
            n = hypot(α, β, βold)
            HHA[K, K] = checkhermitian(α, n)
            push!(BV, bv)

            if alg.verbosity >= EACHITERATION_LEVEL + 1
                @info "Golub-Ye iteration $numiter, step $K: normres = $(normres2string(β))"
            end
        else # restart
            numiter == maxiter && break
            resize!(V, 0)
            resize!(BV, 0)
            fill!(HHA, zero(T))
            fill!(HHB, zero(T))
            K = 1

            invβ = 1 / norm(v)
            v = scale!!(v, invβ)
            bv = scale!!(bv, invβ)
            r = scale!!(r, invβ)
            r, α = orthogonalize!!(r, v, alg.orth) # α should be zero, otherwise ρ was miscalculated
            β = norm(r)
            push!(V, v)
            HHA[K, K] = real(α)
            push!(BV, bv)
            numiter += 1
            if alg.verbosity >= EACHITERATION_LEVEL + 1
                @info "Golub-Ye iteration $numiter, step $K: normres = $(normres2string(β))"
            end
        end
    end
    if (converged < howmany) && alg.verbosity >= WARN_LEVEL
        @warn """Golub-Ye geneigsolve stopped without convergence after $numiter iterations:
        * $converged eigenvalues converged
        * norm of residuals = $(normres2string(normresiduals))
        * number of operations = $numops"""
    elseif alg.verbosity >= STARTSTOP_LEVEL
        @info """Golub-Ye geneigsolve finished after $numiter iterations:
        * $converged eigenvalues converged
        * norm of residuals = $(normres2string(normresiduals))
        * number of operations = $numops"""
    end

    return values, vectors,
        ConvergenceInfo(converged, residuals, normresiduals, numiter, numops)
end

function golubyerecurrence(f, ρ, V::OrthonormalBasis, β, orth::ClassicalGramSchmidt)
    v = V[end]
    av, bv = genapply(f, v)
    w = add!!(av, bv, -ρ)
    α = inner(v, w)

    w = add!!(w, V[end - 1], -β)
    w = add!!(w, v, -α)
    β = norm(w)
    return w, α, β, bv
end
function golubyerecurrence(f, ρ, V::OrthonormalBasis, β, orth::ModifiedGramSchmidt)
    v = V[end]
    av, bv = genapply(f, v)
    w = add!!(av, bv, -ρ)
    w = add!!(w, V[end - 1], -β)

    w, α = orthogonalize!!(w, v, orth)
    β = norm(w)
    return w, α, β, bv
end
function golubyerecurrence(f, ρ, V::OrthonormalBasis, β, orth::ClassicalGramSchmidt2)
    v = V[end]
    av, bv = genapply(f, v)
    w = add!!(av, bv, -ρ)
    α = inner(v, w)
    w = add!!(w, V[end - 1], -β)
    w = add!!(w, v, -α)

    w, s = orthogonalize!!(w, V, ClassicalGramSchmidt())
    α += s[end]
    β = norm(w)
    return w, α, β, bv
end
function golubyerecurrence(f, ρ, V::OrthonormalBasis, β, orth::ModifiedGramSchmidt2)
    v = V[end]
    av, bv = genapply(f, v)
    w = add!!(av, bv, -ρ)
    w = add!!(w, V[end - 1], -β)
    w, α = orthogonalize!!(w, v, ModifiedGramSchmidt())

    s = α
    for q in V
        w, s = orthogonalize!!(w, q, ModifiedGramSchmidt())
    end
    α += s
    β = norm(w)
    return w, α, β, bv
end
function golubyerecurrence(f, ρ, V::OrthonormalBasis, β, orth::ClassicalGramSchmidtIR)
    v = V[end]
    av, bv = genapply(f, v)
    w = add!!(av, bv, -ρ)
    α = inner(v, w)
    w = add!!(w, V[end - 1], -β)
    w = add!!(w, v, -α)

    ab2 = abs2(α) + abs2(β)
    β = norm(w)
    nold = sqrt(abs2(β) + ab2)
    while eps(one(β)) < β < orth.η * nold
        nold = β
        w, s = orthogonalize!!(w, V, ClassicalGramSchmidt())
        α += s[end]
        β = norm(w)
    end
    return w, α, β, bv
end
function golubyerecurrence(f, ρ, V::OrthonormalBasis, β, orth::ModifiedGramSchmidtIR)
    v = V[end]
    av, bv = genapply(f, v)
    w = add!!(av, bv, -ρ)
    w = add!!(w, V[end - 1], -β)

    w, α = orthogonalize!!(w, v, ModifiedGramSchmidt())
    ab2 = abs2(α) + abs2(β)
    β = norm(w)
    nold = sqrt(abs2(β) + ab2)
    while eps(one(β)) < β < orth.η * nold
        nold = β
        s = zero(α)
        for q in V
            w, s = orthogonalize!!(w, q, ModifiedGramSchmidt())
        end
        α += s
        β = norm(w)
    end
    return w, α, β, bv
end

function buildHB!(HB, V, BV)
    m = length(V)
    return @inbounds for j in 1:m
        HB[j, j] = checkposdef(inner(V[j], BV[j]))
        for i in (j + 1):m
            HB[i, j] = inner(V[i], BV[j])
            HB[j, i] = conj(HB[i, j])
        end
    end
end

module SvdsolveAD
using KrylovKit, LinearAlgebra
using KrylovKit: SILENT_LEVEL, WARN_LEVEL, STARTSTOP_LEVEL, EACHITERATION_LEVEL
using Random, Test, TestExtras
using ChainRulesCore, ChainRulesTestUtils, Zygote, FiniteDifferences
Random.seed!(123456789)

fdm = ChainRulesTestUtils._fdm
n = 10
N = 30

function build_mat_example(A, x, howmany::Int, alg, alg_rrule)
    Avec, A_fromvec = to_vec(A)
    xvec, x_fromvec = to_vec(x)

    vals, lvecs, rvecs, info = svdsolve(A, x, howmany, :LR, alg)
    info.converged < howmany && @warn "svdsolve did not converge"

    function mat_example_mat(Av, xv)
        Ã = A_fromvec(Av)
        x̃ = x_fromvec(xv)
        vals′, lvecs′, rvecs′, info′ = svdsolve(
            Ã, x̃, howmany, :LR, alg;
            alg_rrule = alg_rrule
        )
        info′.converged < howmany && println("svdsolve did not converge")
        catresults = vcat(vals′[1:howmany], lvecs′[1:howmany]..., rvecs′[1:howmany]...)
        if eltype(catresults) <: Complex
            return vcat(real(catresults), imag(catresults))
        else
            return catresults
        end
    end
    function mat_example_fval(Av, xv)
        Ã = A_fromvec(Av)
        x̃ = x_fromvec(xv)
        f = (x, adj::Val) -> (adj isa Val{true}) ? adjoint(Ã) * x : Ã * x
        vals′, lvecs′, rvecs′, info′ = svdsolve(
            f, x̃, howmany, :LR, alg;
            alg_rrule = alg_rrule
        )
        info′.converged < howmany && println("svdsolve did not converge")
        catresults = vcat(vals′[1:howmany], lvecs′[1:howmany]..., rvecs′[1:howmany]...)
        if eltype(catresults) <: Complex
            return vcat(real(catresults), imag(catresults))
        else
            return catresults
        end
    end
    function mat_example_ftuple(Av, xv)
        Ã = A_fromvec(Av)
        x̃ = x_fromvec(xv)
        (f, fᴴ) = (x -> Ã * x, x -> adjoint(Ã) * x)
        vals′, lvecs′, rvecs′, info′ = svdsolve(
            (f, fᴴ), x̃, howmany, :LR, alg;
            alg_rrule = alg_rrule
        )
        info′.converged < howmany && println("svdsolve did not converge")
        catresults = vcat(vals′[1:howmany], lvecs′[1:howmany]..., rvecs′[1:howmany]...)
        if eltype(catresults) <: Complex
            return vcat(real(catresults), imag(catresults))
        else
            return catresults
        end
    end

    function mat_example_fd(Av, xv)
        Ã = A_fromvec(Av)
        x̃ = x_fromvec(xv)
        vals′, lvecs′, rvecs′, info′ = svdsolve(
            Ã, x̃, howmany, :LR, alg;
            alg_rrule = alg_rrule
        )
        info′.converged < howmany && println("svdsolve did not converge")
        for i in 1:howmany
            dl = dot(lvecs[i], lvecs′[i])
            dr = dot(rvecs[i], rvecs′[i])
            @assert abs(dl) > sqrt(eps(real(eltype(A))))
            @assert abs(dr) > sqrt(eps(real(eltype(A))))
            phasefix = sqrt(abs(dl * dr) / (dl * dr))
            lvecs′[i] = lvecs′[i] * phasefix
            rvecs′[i] = rvecs′[i] * phasefix
        end
        catresults = vcat(vals′[1:howmany], lvecs′[1:howmany]..., rvecs′[1:howmany]...)
        if eltype(catresults) <: Complex
            return vcat(real(catresults), imag(catresults))
        else
            return catresults
        end
    end

    return mat_example_mat, mat_example_ftuple, mat_example_fval, mat_example_fd, Avec,
        xvec, vals, lvecs, rvecs
end

function build_fun_example(A, x, c, d, howmany::Int, alg, alg_rrule)
    Avec, matfromvec = to_vec(A)
    xvec, xvecfromvec = to_vec(x)
    cvec, cvecfromvec = to_vec(c)
    dvec, dvecfromvec = to_vec(d)

    f = y -> A * y + c * dot(d, y)
    fᴴ = y -> adjoint(A) * y + d * dot(c, y)
    vals, lvecs, rvecs, info = svdsolve((f, fᴴ), x, howmany, :LR, alg)
    info.converged < howmany && @warn "svdsolve did not converge"

    function fun_example_ad(Av, xv, cv, dv)
        Ã = matfromvec(Av)
        x̃ = xvecfromvec(xv)
        c̃ = cvecfromvec(cv)
        d̃ = dvecfromvec(dv)

        f = y -> Ã * y + c̃ * dot(d̃, y)
        fᴴ = y -> adjoint(Ã) * y + d̃ * dot(c̃, y)
        vals′, lvecs′, rvecs′, info′ = svdsolve(
            (f, fᴴ), x̃, howmany, :LR, alg;
            alg_rrule = alg_rrule
        )
        info′.converged < howmany && println("svdsolve did not converge")
        catresults = vcat(vals′[1:howmany], lvecs′[1:howmany]..., rvecs′[1:howmany]...)
        if eltype(catresults) <: Complex
            return vcat(real(catresults), imag(catresults))
        else
            return catresults
        end
    end
    function fun_example_fd(Av, xv, cv, dv)
        Ã = matfromvec(Av)
        x̃ = xvecfromvec(xv)
        c̃ = cvecfromvec(cv)
        d̃ = dvecfromvec(dv)

        f = y -> Ã * y + c̃ * dot(d̃, y)
        fᴴ = y -> adjoint(Ã) * y + d̃ * dot(c̃, y)
        vals′, lvecs′, rvecs′, info′ = svdsolve(
            (f, fᴴ), x̃, howmany, :LR, alg;
            alg_rrule = alg_rrule
        )
        info′.converged < howmany && println("svdsolve did not converge")
        for i in 1:howmany
            dl = dot(lvecs[i], lvecs′[i])
            dr = dot(rvecs[i], rvecs′[i])
            @assert abs(dl) > sqrt(eps(real(eltype(A))))
            @assert abs(dr) > sqrt(eps(real(eltype(A))))
            phasefix = sqrt(abs(dl * dr) / (dl * dr))
            lvecs′[i] = lvecs′[i] * phasefix
            rvecs′[i] = rvecs′[i] * phasefix
        end
        catresults = vcat(vals′[1:howmany], lvecs′[1:howmany]..., rvecs′[1:howmany]...)
        if eltype(catresults) <: Complex
            return vcat(real(catresults), imag(catresults))
        else
            return catresults
        end
    end
    return fun_example_ad, fun_example_fd, Avec, xvec, cvec, dvec, vals, lvecs, rvecs
end

@timedtestset "Small svdsolve AD test with eltype=$T" for T in
    (
        Float32, Float64, ComplexF32,
        ComplexF64,
    )
    A = 2 * (rand(T, (n, 2 * n)) .- one(T) / 2)
    x = 2 * (rand(T, n) .- one(T) / 2)
    x /= norm(x)
    condA = cond(A)

    howmany = 3
    tol = 3 * n * condA * (T <: Real ? eps(T) : 4 * eps(real(T)))
    alg = GKL(; krylovdim = 2n, tol = tol)
    alg_rrule1 = Arnoldi(; tol = tol, krylovdim = 4n, verbosity = SILENT_LEVEL)
    alg_rrule2 = GMRES(; tol = tol, krylovdim = 3n, verbosity = SILENT_LEVEL)
    config = Zygote.ZygoteRuleConfig()
    for alg_rrule in (alg_rrule1, alg_rrule2)
        # unfortunately, rrule does not seem type stable for function arguments, because the
        # `rrule_via_ad` call does not produce type stable `rrule`s for the function
        _, pb = ChainRulesCore.rrule(
            config, svdsolve, A, x, howmany, :LR, alg;
            alg_rrule = alg_rrule
        )
        @constinferred pb((ZeroTangent(), ZeroTangent(), ZeroTangent(), NoTangent()))
        @constinferred pb(
            (
                randn(real(T), howmany), ZeroTangent(), ZeroTangent(),
                NoTangent(),
            )
        )
        @constinferred pb(
            (
                randn(real(T), howmany), [randn(T, n)], ZeroTangent(),
                NoTangent(),
            )
        )
        @constinferred pb(
            (
                randn(real(T), howmany), [randn(T, n) for _ in 1:howmany],
                [randn(T, 2 * n) for _ in 1:howmany], NoTangent(),
            )
        )
    end
    for alg_rrule in (alg_rrule1, alg_rrule2)
        (
            mat_example_mat, mat_example_ftuple, mat_example_fval, mat_example_fd,
            Avec, xvec, vals, lvecs, rvecs,
        ) = build_mat_example(A, x, howmany, alg, alg_rrule)

        (JA, Jx) = FiniteDifferences.jacobian(fdm, mat_example_fd, Avec, xvec)
        (JA1, Jx1) = Zygote.jacobian(mat_example_mat, Avec, xvec)
        (JA2, Jx2) = Zygote.jacobian(mat_example_fval, Avec, xvec)
        (JA3, Jx3) = Zygote.jacobian(mat_example_ftuple, Avec, xvec)

        # finite difference comparison using some kind of tolerance heuristic
        @test isapprox(JA, JA1; rtol = 3 * n * n * condA * sqrt(eps(real(T))))
        @test all(isapprox.(JA1, JA2; atol = n * eps(real(T))))
        @test all(isapprox.(JA1, JA3; atol = n * eps(real(T))))
        @test norm(Jx, Inf) < 5 * condA * sqrt(eps(real(T)))
        @test all(iszero, Jx1)
        @test all(iszero, Jx2)
        @test all(iszero, Jx3)

        # some analysis
        if eltype(A) <: Complex # test holomorphicity / Cauchy-Riemann equations
            ∂vals = complex.(
                JA1[1:howmany, :],
                JA1[howmany * (3 * n + 1) .+ (1:howmany), :]
            )
            ∂lvecs = map(1:howmany) do i
                return complex.(
                    JA1[(howmany + (i - 1) * n) .+ (1:n), :],
                    JA1[(howmany * (3 * n + 2) + (i - 1) * n) .+ (1:n), :]
                )
            end
            ∂rvecs = map(1:howmany) do i
                return complex.(
                    JA1[(howmany * (n + 1) + (i - 1) * (2 * n)) .+ (1:(2n)), :],
                    JA1[(howmany * (4 * n + 2) + (i - 1) * 2n) .+ (1:(2n)), :]
                )
            end
        else
            ∂vals = JA1[1:howmany, :]
            ∂lvecs = map(1:howmany) do i
                return JA1[(howmany + (i - 1) * n) .+ (1:n), :]
            end
            ∂rvecs = map(1:howmany) do i
                return JA1[(howmany * (n + 1) + (i - 1) * (2 * n)) .+ (1:(2n)), :]
            end
        end
        # test orthogonality of vecs and ∂vecs
        for i in 1:howmany
            prec = 4 * cond(A) * sqrt(eps(real(T)))
            @test all(<(prec), real.(lvecs[i]' * ∂lvecs[i]))
            @test all(<(prec), real.(rvecs[i]' * ∂rvecs[i]))
            @test all(<(prec), abs.(lvecs[i]' * ∂lvecs[i] + rvecs[i]' * ∂rvecs[i]))
        end
    end
    if T <: Complex
        @testset "test warnings and info" begin
            alg = GKL(; krylovdim = 2n, tol = tol, verbosity = SILENT_LEVEL)
            alg_rrule = Arnoldi(; tol = tol, krylovdim = 4n, verbosity = SILENT_LEVEL)
            (vals, lvecs, rvecs, info), pb = ChainRulesCore.rrule(
                config, svdsolve, A, x,
                howmany, :LR, alg;
                alg_rrule = alg_rrule
            )
            @test_logs pb(
                (
                    ZeroTangent(), im .* lvecs[1:2] .+ lvecs[2:-1:1], ZeroTangent(),
                    NoTangent(),
                )
            )

            alg = GKL(; krylovdim = 2n, tol = tol, verbosity = WARN_LEVEL)
            alg_rrule = Arnoldi(; tol = tol, krylovdim = 4n, verbosity = WARN_LEVEL)
            (vals, lvecs, rvecs, info), pb = ChainRulesCore.rrule(
                config, svdsolve, A, x,
                howmany, :LR, alg;
                alg_rrule = alg_rrule
            )
            @test_logs (:warn,) pb(
                (
                    ZeroTangent(),
                    im .* lvecs[1:2] .+ lvecs[2:-1:1],
                    ZeroTangent(),
                    NoTangent(),
                )
            )
            @test_logs (:warn,) pb(
                (
                    ZeroTangent(), lvecs[2:-1:1],
                    im .* rvecs[1:2] .+ rvecs[2:-1:1],
                    ZeroTangent(),
                    NoTangent(),
                )
            )
            @test_logs pb(
                (
                    ZeroTangent(), lvecs[1:2] .+ lvecs[2:-1:1],
                    ZeroTangent(),
                    NoTangent(),
                )
            )
            @test_logs (:warn,) pb(
                (
                    ZeroTangent(),
                    im .* lvecs[1:2] .+ lvecs[2:-1:1],
                    +im .* rvecs[1:2] + rvecs[2:-1:1],
                    NoTangent(),
                )
            )
            @test_logs pb(
                (
                    ZeroTangent(), (1 + im) .* lvecs[1:2] .+ lvecs[2:-1:1],
                    (1 - im) .* rvecs[1:2] + rvecs[2:-1:1],
                    NoTangent(),
                )
            )

            alg = GKL(; krylovdim = 2n, tol = tol, verbosity = WARN_LEVEL)
            alg_rrule = Arnoldi(; tol = tol, krylovdim = 4n, verbosity = STARTSTOP_LEVEL)
            (vals, lvecs, rvecs, info), pb = ChainRulesCore.rrule(
                config, svdsolve, A, x,
                howmany, :LR, alg;
                alg_rrule = alg_rrule
            )
            @test_logs (:warn,) (:info,) pb(
                (
                    ZeroTangent(),
                    im .* lvecs[1:2] .+ lvecs[2:-1:1],
                    ZeroTangent(),
                    NoTangent(),
                )
            )
            @test_logs (:warn,) (:info,) pb(
                (
                    ZeroTangent(), lvecs[2:-1:1],
                    im .* rvecs[1:2] .+ rvecs[2:-1:1],
                    ZeroTangent(),
                    NoTangent(),
                )
            )
            @test_logs (:info,) pb(
                (
                    ZeroTangent(), lvecs[1:2] .+ lvecs[2:-1:1],
                    ZeroTangent(),
                    NoTangent(),
                )
            )
            @test_logs (:warn,) (:info,) pb(
                (
                    ZeroTangent(),
                    im .* lvecs[1:2] .+ lvecs[2:-1:1],
                    +im .* rvecs[1:2] + rvecs[2:-1:1],
                    NoTangent(),
                )
            )
            @test_logs (:info,) pb(
                (
                    ZeroTangent(), (1 + im) .* lvecs[1:2] .+ lvecs[2:-1:1],
                    (1 - im) .* rvecs[1:2] + rvecs[2:-1:1],
                    NoTangent(),
                )
            )

            alg = GKL(; krylovdim = 2n, tol = tol, verbosity = SILENT_LEVEL)
            alg_rrule = GMRES(; tol = tol, krylovdim = 3n, verbosity = SILENT_LEVEL)
            (vals, lvecs, rvecs, info), pb = ChainRulesCore.rrule(
                config, svdsolve, A, x,
                howmany, :LR, alg;
                alg_rrule = alg_rrule
            )
            @test_logs pb(
                (
                    ZeroTangent(), im .* lvecs[1:2] .+ lvecs[2:-1:1], ZeroTangent(),
                    NoTangent(),
                )
            )

            alg = GKL(; krylovdim = 2n, tol = tol, verbosity = WARN_LEVEL)
            alg_rrule = GMRES(; tol = tol, krylovdim = 3n, verbosity = WARN_LEVEL)
            (vals, lvecs, rvecs, info), pb = ChainRulesCore.rrule(
                config, svdsolve, A, x,
                howmany, :LR, alg;
                alg_rrule = alg_rrule
            )
            @test_logs (:warn,) (:warn,) pb(
                (
                    ZeroTangent(),
                    im .* lvecs[1:2] .+
                        lvecs[2:-1:1], ZeroTangent(),
                    NoTangent(),
                )
            )
            @test_logs (:warn,) (:warn,) pb(
                (
                    ZeroTangent(), lvecs[2:-1:1],
                    im .* rvecs[1:2] .+
                        rvecs[2:-1:1], ZeroTangent(),
                    NoTangent(),
                )
            )
            @test_logs pb(
                (
                    ZeroTangent(), lvecs[1:2] .+ lvecs[2:-1:1],
                    ZeroTangent(),
                    NoTangent(),
                )
            )
            @test_logs (:warn,) (:warn,) pb(
                (
                    ZeroTangent(),
                    im .* lvecs[1:2] .+
                        lvecs[2:-1:1],
                    +im .* rvecs[1:2] +
                        rvecs[2:-1:1],
                    NoTangent(),
                )
            )
            @test_logs pb(
                (
                    ZeroTangent(),
                    (1 + im) .* lvecs[1:2] .+ lvecs[2:-1:1],
                    (1 - im) .* rvecs[1:2] + rvecs[2:-1:1],
                    NoTangent(),
                )
            )

            alg = GKL(; krylovdim = 2n, tol = tol, verbosity = WARN_LEVEL)
            alg_rrule = GMRES(; tol = tol, krylovdim = 3n, verbosity = STARTSTOP_LEVEL)
            (vals, lvecs, rvecs, info), pb = ChainRulesCore.rrule(
                config, svdsolve, A, x,
                howmany, :LR, alg;
                alg_rrule = alg_rrule
            )
            @test_logs (:warn,) (:info,) (:info,) (:warn,) (:info,) (:info,) pb(
                (
                    ZeroTangent(),
                    im .*
                        lvecs[1:2] .+
                        lvecs[2:-1:1],
                    ZeroTangent(),
                    NoTangent(),
                )
            )
            @test_logs (:warn,) (:info,) (:info,) (:warn,) (:info,) (:info,) pb(
                (
                    ZeroTangent(),
                    lvecs[2:-1:1],
                    im .*
                        rvecs[1:2] .+
                        rvecs[2:-1:1],
                    ZeroTangent(),
                    NoTangent(),
                )
            )
            @test_logs (:info,) (:info,) (:info,) (:info,) pb(
                (
                    ZeroTangent(),
                    lvecs[1:2] .+ lvecs[2:-1:1],
                    ZeroTangent(),
                    NoTangent(),
                )
            )
            @test_logs (:warn,) (:info,) (:info,) (:warn,) (:info,) (:info,) pb(
                (
                    ZeroTangent(),
                    im .*
                        lvecs[1:2] .+
                        lvecs[2:-1:1],
                    +im .*
                        rvecs[1:2] +
                        rvecs[2:-1:1],
                    NoTangent(),
                )
            )
            @test_logs (:info,) (:info,) (:info,) (:info,) pb(
                (
                    ZeroTangent(),
                    (1 + im) .* lvecs[1:2] .+
                        lvecs[2:-1:1],
                    (1 - im) .* rvecs[1:2] +
                        rvecs[2:-1:1],
                    NoTangent(),
                )
            )
        end
    end
end
@timedtestset "Large svdsolve AD test with eltype=$T" for T in (Float64, ComplexF64)
    which = :LR
    A = rand(T, (N, N + n)) .- one(T) / 2
    A = I[1:N, 1:(N + n)] - (9 // 10) * A / maximum(svdvals(A))
    x = 2 * (rand(T, N) .- one(T) / 2)
    x /= norm(x)
    c = 2 * (rand(T, N) .- one(T) / 2)
    d = 2 * (rand(T, N + n) .- one(T) / 2)

    howmany = 2
    tol = 2 * N^2 * eps(real(T))
    alg = GKL(; tol = tol, krylovdim = 2n)
    alg_rrule1 = Arnoldi(; tol = tol, krylovdim = 2n, verbosity = SILENT_LEVEL - 1)
    alg_rrule2 = GMRES(; tol = tol, krylovdim = 2n, verbosity = SILENT_LEVEL - 1)
    for alg_rrule in (alg_rrule1, alg_rrule2)
        #! format: off
        fun_example_ad, fun_example_fd, Avec, xvec, cvec, dvec, vals, lvecs, rvecs =
            build_fun_example(A, x, c, d, howmany, alg, alg_rrule)
        #! format: on

        (JA, Jx, Jc, Jd) = FiniteDifferences.jacobian(
            fdm, fun_example_fd, Avec, xvec,
            cvec, dvec
        )
        (JA′, Jx′, Jc′, Jd′) = Zygote.jacobian(fun_example_ad, Avec, xvec, cvec, dvec)
        @test JA ≈ JA′
        @test Jc ≈ Jc′
        @test Jd ≈ Jd′
        @test norm(Jx, Inf) < (T <: Complex ? 4n : n) * sqrt(eps(real(T)))
    end
end
end

apply(A::AbstractMatrix, x::AbstractVector) = A * x
apply(f, x) = f(x)

function apply(operator, x, α₀, α₁)
    y = apply(operator, x)
    if α₀ != zero(α₀) || α₁ != one(α₁)
        y = add!!(y, x, α₀, α₁)
    end

    return y
end

# GKL, SVD, LSMR
apply_normal(A::AbstractMatrix, x::AbstractVector) = A * x
apply_adjoint(A::AbstractMatrix, x::AbstractVector) = A' * x
apply_normal((f, fadjoint)::Tuple{Any, Any}, x) = f(x)
apply_adjoint((f, fadjoint)::Tuple{Any, Any}, x) = fadjoint(x)
apply_normal(f, x) = f(x, Val(false))
apply_adjoint(f, x) = f(x, Val(true))

# generalized eigenvalue problem
genapply((A, B)::Tuple{Any, Any}, x) = (apply(A, x), apply(B, x))
genapply(f, x) = f(x)

# attempt type inference first but fall back to actual values if failed
function apply_scalartype(f, x, as::Number...)
    0 <= length(as) <= 2 || throw(ArgumentError("unknown type of function application"))
    Tfx = Base.promote_op(apply, typeof(f), typeof(x), typeof.(as)...)
    if Tfx !== Union{} && Tfx !== Any
        T = Base.promote_op(inner, typeof(x), Tfx)
        T <: Number && return T
    end
    # if this is reached, type inference failed due to instability or error
    # retry in value domain - will also give better stacktrace
    return typeof(inner(x, apply(f, x, as...)))
end

function genapply_scalartype(f, x)
    Tfx = Base.promote_op(genapply, typeof(f), typeof(x))
    if Tfx <: Tuple
        @assert length(fieldtypes(Tfx)) == 2
        Tfx1, Tfx2 = fieldtypes(Tfx)
        T1 = Base.promote_op(inner, typeof(x), Tfx1)
        T2 = Base.promote_op(inner, typeof(x), Tfx2)
        T = promote_type(T1, T2)
        T <: Number && return T
    end
    # if this is reached, type inference failed due to instability or error
    # retry in value domain - will also give better stacktrace
    fx1, fx2 = genapply(f, x)
    α1 = inner(x, fx1)
    α2 = inner(x, fx2)
    return promote_type(typeof(α1), typeof(α2))
end

@testset "GolubYe - geneigsolve full ($mode)" for mode in (:vector, :inplace, :outplace)
    scalartypes = mode === :vector ? (Float32, Float64, ComplexF32, ComplexF64) :
        (ComplexF64,)
    orths = mode === :vector ? (cgs2, mgs2, cgsr, mgsr) : (mgsr,)
    @testset for T in scalartypes
        @testset for orth in orths
            A = rand(T, (n, n)) .- one(T) / 2
            A = (A + A') / 2
            B = rand(T, (n, n)) .- one(T) / 2
            B = sqrt(B * B')
            v = rand(T, (n,))
            alg = GolubYe(;
                orth = orth, krylovdim = n, maxiter = 1, tol = tolerance(T),
                verbosity = WARN_LEVEL
            )
            n1 = div(n, 2)
            D1, V1, info = @constinferred geneigsolve(
                (
                    wrapop(A, Val(mode)),
                    wrapop(B, Val(mode)),
                ),
                wrapvec(v, Val(mode)),
                n1, :SR; orth = orth, krylovdim = n,
                maxiter = 1, tol = tolerance(T),
                ishermitian = true, isposdef = true,
                verbosity = SILENT_LEVEL
            )

            if info.converged < n1
                @test_logs geneigsolve(
                    (
                        wrapop(A, Val(mode)),
                        wrapop(B, Val(mode)),
                    ),
                    wrapvec(v, Val(mode)),
                    n1, :SR; orth = orth, krylovdim = n,
                    maxiter = 1, tol = tolerance(T),
                    ishermitian = true, isposdef = true,
                    verbosity = SILENT_LEVEL
                )
                @test_logs geneigsolve(
                    (
                        wrapop(A, Val(mode)),
                        wrapop(B, Val(mode)),
                    ),
                    wrapvec(v, Val(mode)),
                    n1, :SR; orth = orth, krylovdim = n,
                    maxiter = 1, tol = tolerance(T),
                    ishermitian = true, isposdef = true,
                    verbosity = WARN_LEVEL
                )
                @test_logs (:warn,) geneigsolve(
                    (
                        wrapop(A, Val(mode)),
                        wrapop(B, Val(mode)),
                    ),
                    wrapvec(v, Val(mode)),
                    n1, :SR; orth = orth, krylovdim = n1 + 1,
                    maxiter = 1, tol = tolerance(T),
                    ishermitian = true, isposdef = true,
                    verbosity = WARN_LEVEL
                )
                @test_logs (:info,) geneigsolve(
                    (
                        wrapop(A, Val(mode)),
                        wrapop(B, Val(mode)),
                    ),
                    wrapvec(v, Val(mode)),
                    n1, :SR; orth = orth, krylovdim = n,
                    maxiter = 1, tol = tolerance(T),
                    ishermitian = true, isposdef = true,
                    verbosity = STARTSTOP_LEVEL
                )
                alg = GolubYe(;
                    orth = orth, krylovdim = n1, maxiter = 3, tol = tolerance(T),
                    verbosity = EACHITERATION_LEVEL
                )
                @test_logs(
                    (:info,), (:info,), (:info,), (:warn,),
                    geneigsolve(
                        (wrapop(A, Val(mode)), wrapop(B, Val(mode))),
                        wrapvec(v, Val(mode)), 1, :SR, alg
                    )
                )
                alg = GolubYe(;
                    orth = orth, krylovdim = 3, maxiter = 2, tol = tolerance(T),
                    verbosity = EACHITERATION_LEVEL + 1
                )
                @test_logs(
                    (:info,), (:info,), (:info,), (:info,),
                    (:info,), (:info,), (:info,), (:info,), (:warn,),
                    geneigsolve(
                        (wrapop(A, Val(mode)), wrapop(B, Val(mode))),
                        wrapvec(v, Val(mode)), 1, :SR, alg
                    )
                )
            end
            @test KrylovKit.geneigselector(
                (wrapop(A, Val(mode)), wrapop(B, Val(mode))),
                scalartype(v); orth = orth, krylovdim = n,
                maxiter = 1, tol = tolerance(T), ishermitian = true,
                isposdef = true
            ) isa GolubYe
            n2 = n - n1
            D2, V2, info = @constinferred geneigsolve(
                (
                    wrapop(A, Val(mode)),
                    wrapop(B, Val(mode)),
                ),
                wrapvec(v, Val(mode)),
                n2, :LR, alg
            )
            @test vcat(D1[1:n1], reverse(D2[1:n2])) ≈ eigvals(A, B)

            U1 = stack(unwrapvec, V1)
            U2 = stack(unwrapvec, V2)
            @test U1' * B * U1 ≈ I
            @test U2' * B * U2 ≈ I

            @test A * U1 ≈ B * U1 * Diagonal(D1)
            @test A * U2 ≈ B * U2 * Diagonal(D2)
        end
    end
end

@testset "GolubYe - geneigsolve iteratively ($mode)" for mode in
    (:vector, :inplace, :outplace)
    scalartypes = mode === :vector ? (Float64, ComplexF64) :
        (ComplexF64,)
    orths = mode === :vector ? (cgs2, mgs2, cgsr, mgsr) : (mgsr,)
    @testset for T in scalartypes
        @testset for orth in orths
            A = rand(T, (N, N)) .- one(T) / 2
            A = (A + A') / 2
            B = rand(T, (N, N)) .- one(T) / 2
            B = sqrt(B * B')
            v = rand(T, (N,))
            alg = GolubYe(;
                orth = orth, krylovdim = 3 * n, maxiter = 100,
                tol = cond(B) * tolerance(T), verbosity = SILENT_LEVEL
            )
            D1, V1, info1 = @constinferred geneigsolve(
                (
                    wrapop(A, Val(mode)),
                    wrapop(B, Val(mode)),
                ),
                wrapvec(v, Val(mode)),
                n, :SR, alg
            )
            D2, V2, info2 = geneigsolve(
                (wrapop(A, Val(mode)), wrapop(B, Val(mode))),
                wrapvec(v, Val(mode)), n, :LR, alg
            )

            l1 = info1.converged
            l2 = info2.converged
            @test l1 > 0
            @test l2 > 0
            @test D1[1:l1] ≊ eigvals(A, B)[1:l1]
            @test D2[1:l2] ≊ eigvals(A, B)[N:-1:(N - l2 + 1)]

            U1 = stack(unwrapvec, V1)
            U2 = stack(unwrapvec, V2)
            @test U1' * B * U1 ≈ I
            @test U2' * B * U2 ≈ I

            R1 = stack(unwrapvec, info1.residual)
            R2 = stack(unwrapvec, info2.residual)
            @test A * U1 ≈ B * U1 * Diagonal(D1) + R1
            @test A * U2 ≈ B * U2 * Diagonal(D2) + R2
        end
    end
end

"""
    # expert version:
    schursolve(f, x₀, howmany, which, algorithm)

Compute a partial Schur decomposition containing `howmany` eigenvalues from the linear map
encoded in the matrix or function `A`. Return the reduced Schur matrix, the basis of Schur
vectors, the extracted eigenvalues and a `ConvergenceInfo` structure.

See also [`eigsolve`](@ref) to obtain the eigenvectors instead. For real symmetric or
complex hermitian problems, the (partial) Schur decomposition is identical to the (partial)
eigenvalue decomposition, and `eigsolve` should always be used.

### Arguments:

The linear map can be an `AbstractMatrix` (dense or sparse) or a general function or
callable object, that acts on vector like objects similar to `x₀`, which is the starting
guess from which a Krylov subspace will be built. `howmany` specifies how many Schur vectors
should be converged before the algorithm terminates; `which` specifies which eigenvalues
should be targeted. Valid specifications of `which` are

  - `LM`: eigenvalues of largest magnitude
  - `LR`: eigenvalues with largest (most positive) real part
  - `SR`: eigenvalues with smallest (most negative) real part
  - `LI`: eigenvalues with largest (most positive) imaginary part, only if `T <: Complex`
  - `SI`: eigenvalues with smallest (most negative) imaginary part, only if `T <: Complex`
  - [`EigSorter(f; rev = false)`](@ref): eigenvalues `λ` that appear first (or last if
    `rev == true`) when sorted by `f(λ)`

!!! note "Note about selecting `which` eigenvalues"

    Krylov methods work well for extremal eigenvalues, i.e. eigenvalues on the periphery of
    the spectrum of the linear map. All of they valid `Symbol`s for `which` have this
    property, but could also be specified using `EigSorter`, e.g. `:LM` is equivalent to
    `Eigsorter(abs; rev = true)`. Note that smallest magnitude sorting is obtained using
    e.g. `EigSorter(abs; rev = false)`, but since no (shift-and)-invert is used, this will
    only be successful if you somehow know that eigenvalues close to zero are also close
    to the periphery of the spectrum.

!!! warning "Repeated eigenvalues"

    From a theoretical point of view, Krylov methods can at most find a single eigenvector
    associated with a targetted eigenvalue, even if the latter is repeated, i.e. the
    eigenvalue has multiple linearly independent eigenvectors or thus an eigenspace
    with dimension (geometric multiplicity) larger than one. In the case of such
    a repeated eigenvalue, the specific eigenvector that is returned is determined by the
    starting vector `x₀`. For large problems, this turns out to be less of an issue in
    practice, as often a second linearly independent eigenvector is generated out of the
    numerical noise resulting from the orthogonalisation steps in the Lanczos or Arnoldi
    iteration. Nonetheless, it is important to take this into account and to try not to
    depend on this potentially fragile behaviour, especially for smaller problems.

The `algorithm` argument currently only supports an instance of [`Arnoldi`](@ref), which
is where the parameters of the Krylov method (such as Krylov dimension and maximum number
of iterations) can be specified. Since `schursolve` is less commonly used as `eigsolve`,
it only supports this expert mode call syntax and no convenient keyword interface is
currently available.

### Return values:

The return value is always of the form `T, vecs, vals, info = schursolve(...)` with

  - `T`: a `Matrix` containing the partial Schur decomposition of the linear map, i.e. it's
    elements are given by `T[i,j] = inner(vecs[i], f(vecs[j]))`. It is of Schur form, i.e.
    upper triangular in case of complex arithmetic, and block upper triangular (with at most
    2x2 blocks) in case of real arithmetic.
  - `vecs`: a `Vector` of corresponding Schur vectors, of the same length as `vals`. Note
    that Schur vectors are not returned as a matrix, as the linear map could act on any
    custom  Julia type with vector like behavior, i.e. the elements of the list `vecs` are
    objects that are typically similar to the starting guess `x₀`, up to a possibly
    different `eltype`. When the linear map is a simple `AbstractMatrix`, `vecs` will be
    `Vector{Vector{<:Number}}`. Schur vectors are by definition orthogonal, i.e.
    `inner(vecs[i],vecs[j]) = I[i,j]`. Note that Schur vectors are real if the problem (i.e.
    the linear map and the initial guess) are real.
  - `vals`: a `Vector` of eigenvalues, i.e. the diagonal elements of `T` in case of complex
    arithmetic, or extracted from the diagonal blocks in case of real arithmetic. Note that
    `vals` will always be complex, independent of the underlying arithmetic.
  - `info`: an object of type [`ConvergenceInfo`], which has the following fields

      + `info.converged::Int`: indicates how many eigenvalues and Schur vectors were
        actually converged to the specified tolerance (see below under keyword arguments)

      + `info.residuals::Vector`: a list of the same length as `vals` containing the actual
        residuals

        ```julia
        info.residuals[i] = f(vecs[i]) - sum(vecs[j] * T[j, i] for j in 1:i+1)
        ```

        where `T[i+1,i]` is definitely zero in case of complex arithmetic and possibly zero
        in case of real arithmetic
      + `info.normres::Vector{<:Real}`: list of the same length as `vals` containing the
        norm of the residual for every Schur vector, i.e.
        `info.normes[i] = norm(info.residual[i])`
      + `info.numops::Int`: number of times the linear map was applied, i.e. number of times
        `f` was called, or a vector was multiplied with `A`
      + `info.numiter::Int`: number of times the Krylov subspace was restarted (see below)

!!! warning "Check for convergence"

    No warning is printed if not all requested eigenvalues were converged, so always check
    if `info.converged >= howmany`.

### Algorithm

The actual algorithm is an implementation of the Krylov-Schur algorithm, where the
[`Arnoldi`](@ref) algorithm is used to generate the Krylov subspace. During the algorithm,
the Krylov subspace is dynamically grown and shrunk, i.e. the restarts are so-called thick
restarts where a part of the current Krylov subspace is kept.
"""
function schursolve(A, x₀, howmany::Int, which::Selector, alg::Arnoldi)
    T, U, fact, converged, numiter, numops = _schursolve(A, x₀, howmany, which, alg)
    howmany′ = howmany
    if eltype(T) <: Real && howmany < length(fact) && T[howmany + 1, howmany] != 0
        howmany′ += 1
    elseif size(T, 1) < howmany
        howmany′ = size(T, 1)
    end
    if converged > howmany
        howmany′ = converged
    end
    TT = view(T, 1:howmany′, 1:howmany′)
    values = schur2eigvals(TT)

    vectors = let B = basis(fact)
        [B * u for u in cols(U, 1:howmany′)]
    end
    residuals = let r = residual(fact)
        [scale(r, last(u)) for u in cols(U, 1:howmany′)]
    end
    normresiduals = [normres(fact) * abs(last(u)) for u in cols(U, 1:howmany′)]

    if (converged < howmany) && alg.verbosity >= WARN_LEVEL
        @warn """Arnoldi schursolve stopped without convergence after $numiter iterations:
        * $converged eigenvalues converged
        * norm of residuals = $(normres2string(normresiduals))
        * number of operations = $numops"""
    elseif alg.verbosity >= STARTSTOP_LEVEL
        @info """Arnoldi schursolve finished after $numiter iterations:
        * $converged eigenvalues converged
        * norm of residuals = $(normres2string(normresiduals))
        * number of operations = $numops"""
    end
    return TT, vectors, values,
        ConvergenceInfo(converged, residuals, normresiduals, numiter, numops)
end

function eigsolve(A, x₀, howmany::Int, which::Selector, alg::Arnoldi; alg_rrule = alg)
    T, U, fact, converged, numiter, numops = _schursolve(A, x₀, howmany, which, alg)
    howmany′ = howmany
    if eltype(T) <: Real && howmany < length(fact) && T[howmany + 1, howmany] != 0
        howmany′ += 1
    elseif size(T, 1) < howmany
        howmany′ = size(T, 1)
    end
    if converged > howmany
        howmany′ = converged
    end
    TT = view(T, 1:howmany′, 1:howmany′)
    values = schur2eigvals(TT)

    # Compute eigenvectors
    V = view(U, :, 1:howmany′) * schur2eigvecs(TT)
    vectors = let B = basis(fact)
        [B * v for v in cols(V)]
    end
    residuals = let r = residual(fact)
        [scale(r, last(v)) for v in cols(V)]
    end
    normresiduals = [normres(fact) * abs(last(v)) for v in cols(V)]

    if (converged < howmany) && alg.verbosity >= WARN_LEVEL
        @warn """Arnoldi eigsolve stopped without convergence after $numiter iterations:
        * $converged eigenvalues converged
        * norm of residuals = $(normres2string(normresiduals))
        * number of operations = $numops"""
    elseif alg.verbosity >= STARTSTOP_LEVEL
        @info """Arnoldi eigsolve finished after $numiter iterations:
        * $converged eigenvalues converged
        * norm of residuals = $(normres2string(normresiduals))
        * number of operations = $numops"""
    end
    return values, vectors,
        ConvergenceInfo(converged, residuals, normresiduals, numiter, numops)
end

"""
    # expert version:
    realeigsolve(f, x₀, howmany, which, algorithm; alg_rrule=algorithm)

Compute the first `howmany` eigenvalues (according to the order specified by `which`)
from the real linear map encoded in the matrix `A` or by the function `f`, if it can be
guaranteed that these eigenvalues (and thus their associated eigenvectors) are real. An
error will be thrown if there are complex eigenvalues within the first `howmany` eigenvalues.

Return eigenvalues, eigenvectors and a `ConvergenceInfo` structure.

!!! note "Note about real linear maps"

    A function `f` is said to implement a real linear map if it satisfies 
    `f(add(x,y)) = add(f(x), f(y)` and `f(scale(x, α)) = scale(f(x), α)` for vectors `x`
    and `y` and scalars `α::Real`. Note that this is possible even when the vectors are
    represented using complex arithmetic. For example, the map `f=x-> x + conj(x)`
    represents a real linear map that is not (complex) linear, as it does not satisfy
    `f(scale(x, α)) = scale(f(x), α)` for complex scalars `α`. Note that complex linear
    maps are always real linear maps and thus can be used in this context, if looking
    specifically for real eigenvalues that they may have.

    To interpret the vectors `x` and `y` as elements from a real vector space, the standard
    inner product defined on them will be replaced with `real(inner(x,y))`. This has no
    effect if the vectors `x` and `y` were represented using real arithmetic to begin with,
    and allows to seemlessly use complex vectors as well.

### Arguments:

The linear map can be an `AbstractMatrix` (dense or sparse) or a general function or
callable object. A starting vector `x₀` needs to be provided. Note that `x₀` does not need
to be of type `AbstractVector`; any type that behaves as a vector and supports the required
interface (see KrylovKit docs) is accepted.

The argument `howmany` specifies how many eigenvalues should be computed; `which` specifies
which eigenvalues should be targeted. Valid specifications of `which` for real
problems are given by

  - `:LM`: eigenvalues of largest magnitude
  - `:LR`: eigenvalues with largest (most positive) real part
  - `:SR`: eigenvalues with smallest (most negative) real part
  - [`EigSorter(f; rev = false)`](@ref): eigenvalues `λ` that appear first (or last if
    `rev == true`) when sorted by `f(λ)`

!!! note "Note about selecting `which` eigenvalues"

    Krylov methods work well for extremal eigenvalues, i.e. eigenvalues on the periphery of
    the spectrum of the linear map. All of the valid `Symbol`s for `which` have this
    property, but could also be specified using `EigSorter`, e.g. `:LM` is equivalent to
    `Eigsorter(abs; rev = true)`. Note that smallest magnitude sorting is obtained using
    e.g. `EigSorter(abs; rev = false)`, but since no (shift-and)-invert is used, this will
    only be successful if you somehow know that eigenvalues close to zero are also close
    to the periphery of the spectrum.

!!! warning "Repeated eigenvalues"

    From a theoretical point of view, Krylov methods can at most find a single eigenvector
    associated with a targetted eigenvalue, even if the latter is repeated, i.e. the
    eigenvalue has multiple linearly independent eigenvectors or thus an eigenspace
    with dimension (geometric multiplicity) larger than one. In the case of such
    a repeated eigenvalue, the specific eigenvector that is returned is determined by the
    starting vector `x₀`. For large problems, this turns out to be less of an issue in
    practice, as often a second linearly independent eigenvector is generated out of the
    numerical noise resulting from the orthogonalisation steps in the Lanczos or Arnoldi
    iteration. Nonetheless, it is important to take this into account and to try not to
    depend on this potentially fragile behaviour, especially for smaller problems.

The `algorithm` argument currently only supports an instance of [`Arnoldi`](@ref), which
is where the parameters of the Krylov method (such as Krylov dimension and maximum number
of iterations) can be specified. Since `realeigsolve` is less commonly used as `eigsolve`,
it only supports this expert mode call syntax and no convenient keyword interface is
currently available.

The keyword argument `alg_rrule` can be used to specify an algorithm to be used for computing
the `pullback` of `realeigsolve` in the context of reverse-mode automatic differentation.
    
### Return values:

The return value is always of the form `vals, vecs, info = eigsolve(...)` with

  - `vals`: a `Vector` containing the eigenvalues, of length at least `howmany`, but could
    be longer if more eigenvalues were converged at the same cost. Eigenvalues will be real,
    an `ArgumentError` will be thrown if the first `howmany` eigenvalues ordered according
    to `which` of the linear map are not all real.
  - `vecs`: a `Vector` of corresponding eigenvectors, of the same length as `vals`. Note
    that eigenvectors are not returned as a matrix, as the linear map could act on any
    custom Julia type with vector like behavior, i.e. the elements of the list `vecs` are
    objects that are typically similar to the starting guess `x₀`. For a real problem with
    real eigenvalues, also the eigenvectors will be real and no complex arithmetic is used
    anywhere.
  - `info`: an object of type [`ConvergenceInfo`], which has the following fields

    + `info.converged::Int`: indicates how many eigenvalues and eigenvectors were actually
      converged to the specified tolerance `tol` (see below under keyword arguments)
    + `info.residual::Vector`: a list of the same length as `vals` containing the
      residuals `info.residual[i] = f(vecs[i]) - vals[i] * vecs[i]`
    + `info.normres::Vector{<:Real}`: list of the same length as `vals` containing the
      norm of the residual `info.normres[i] = norm(info.residual[i])`
    + `info.numops::Int`: number of times the linear map was applied, i.e. number of times
      `f` was called, or a vector was multiplied with `A`
    + `info.numiter::Int`: number of times the Krylov subspace was restarted (see below)

!!! warning "Check for convergence"

    No warning is printed if not all requested eigenvalues were converged, so always check
    if `info.converged >= howmany`.
"""
function realeigsolve(A, x₀, howmany::Int, which::Selector, alg::Arnoldi; alg_rrule = alg)
    T, U, fact, converged, numiter, numops = _schursolve(
        A, RealVec(x₀), howmany, which, alg
    )
    i = 0
    while i < howmany
        i += 1
        if i < length(fact)
            if abs(T[i + 1, i]) > alg.tol && alg.verbosity >= WARN_LEVEL
                impart = sqrt(-T[i + 1, i] * T[i, i + 1])
                warnmsg = "2 x 2 Schur block at position $i and $(i + 1) detected, complex eigenvalues "
                warnmsg *= "with imaginary part $impart will be ignored by setting T[i+1,i] = $(T[i + 1, i]) to zero."
                @warn warnmsg
            end
            T[i + 1, i] = 0
        end
    end
    while i < converged
        i += 1
        if i < length(fact)
            if abs(T[i + 1, i]) <= alg.tol
                T[i + 1, i] = 0
            else
                i -= 1
                break
            end
        end
    end
    howmany = i
    converged = min(converged, howmany)
    TT = view(T, 1:howmany, 1:howmany)
    values = diag(TT)

    # Compute eigenvectors
    V = view(U, :, 1:howmany) * schur2realeigvecs(TT)
    vectors = let B = basis(fact)
        [(B * v)[] for v in cols(V)]
    end
    residuals = let r = residual(fact)[]
        [scale(r, last(v)) for v in cols(V)]
    end
    normresiduals = [normres(fact) * abs(last(v)) for v in cols(V)]

    if (converged < howmany) && alg.verbosity >= WARN_LEVEL
        @warn """Arnoldi realeigsolve stopped without convergence after $numiter iterations:
        * $converged eigenvalues converged
        * norm of residuals = $(normres2string(normresiduals))
        * number of operations = $numops"""
    elseif alg.verbosity >= STARTSTOP_LEVEL
        @info """Arnoldi realeigsolve finished after $numiter iterations:
        * $converged eigenvalues converged
        * norm of residuals = $(normres2string(normresiduals))
        * number of operations = $numops"""
    end
    return values, vectors,
        ConvergenceInfo(converged, residuals, normresiduals, numiter, numops)
end

function _schursolve(A, x₀, howmany::Int, which::Selector, alg::Arnoldi)
    krylovdim = alg.krylovdim
    maxiter = alg.maxiter
    howmany > krylovdim &&
        error("krylov dimension $(krylovdim) too small to compute $howmany eigenvalues")

    ## FIRST ITERATION: setting up
    numiter = 1
    # initialize arnoldi factorization
    iter = ArnoldiIterator(A, x₀, alg.orth)
    fact = initialize(iter; verbosity = alg.verbosity)
    numops = 1
    sizehint!(fact, krylovdim)
    β = normres(fact)
    tol::eltype(β) = alg.tol

    # allocate storage
    HH = fill(zero(eltype(fact)), krylovdim, krylovdim)
    UU = fill(zero(eltype(fact)), krylovdim, krylovdim)
    ff = fill(zero(eltype(fact)), krylovdim)

    # initialize storage
    K = length(fact) # == 1
    converged = 0
    local T, U, f
    while true
        β = normres(fact)
        K = length(fact)

        if β <= tol && K < howmany
            if alg.verbosity >= WARN_LEVEL
                msg = "Invariant subspace of dimension $K (up to requested tolerance `tol = $tol`), "
                msg *= "which is smaller than the number of requested eigenvalues (i.e. `howmany == $howmany`)."
                @warn msg
            end
        end
        if K == krylovdim || β <= tol || (alg.eager && K >= howmany) # process
            H = view(HH, 1:K, 1:K)
            U = view(UU, 1:K, 1:K)
            f = view(ff, 1:K)
            copyto!(U, I)
            copyto!(H, rayleighquotient(fact))

            # compute dense schur factorization
            T, U, values = hschur!(H, U)
            by, rev = eigsort(which)
            p = sortperm(values; by = by, rev = rev)
            T, U = permuteschur!(T, U, p)
            f .= conj.(view(U, K, :)) .* β
            converged = 0
            while converged < length(fact) && abs(f[converged + 1]) <= tol
                converged += 1
            end
            if 0 < converged < length(fact) && !iszero(T[converged + 1, converged])
                converged -= 1
            end

            if converged >= howmany || β <= tol
                break
            elseif alg.verbosity >= EACHITERATION_LEVEL
                @info "Arnoldi schursolve in iteration $numiter, step = $K: $converged values converged, normres = $(normres2string(abs.(f[1:howmany])))"
            end
        end

        if K < krylovdim # expand
            fact = expand!(iter, fact; verbosity = alg.verbosity)
            numops += 1
        else # shrink
            numiter == maxiter && break

            # Determine how many to keep
            keep = div(3 * krylovdim + 2 * converged, 5) # strictly smaller than krylovdim since converged < howmany <= krylovdim, at least equal to converged
            if !iszero(H[keep + 1, keep])
                # we are in the middle of a 2x2 block; this cannot happen if keep == converged, so we can decrease keep
                # however, we have to make sure that we do not end up with keep = 0
                if keep > 1
                    keep -= 1 # conservative choice
                else
                    keep += 1
                    if krylovdim == 2
                        alg.verbosity >= WARN_LEVEL &&
                            @warn "Arnoldi iteration got stuck in a 2x2 block, consider increasing the Krylov dimension"
                        break
                    end
                end
            end

            # Restore Arnoldi form in the first keep columns before shrinking
            _restorearnoldiform!(U, H, f, keep)
            # Copy H back into compact Hessenberg form
            copy!(rayleighquotient(fact), H)
            # Update the basis
            B = basis(fact)
            basistransform!(B, view(U, :, 1:keep))
            B[keep + 1] = scale!!(residual(fact), 1 / β)
            # Everything is set up to shrink Arnoldi factorization
            fact = shrink!(fact, keep; verbosity = alg.verbosity)
            numiter += 1
        end
    end
    return T, U, fact, converged, numiter, numops
end

# Input:
# Square matrices `U` and `H` of some size `m x m`, a vector `f` of length `m` and an integer value `keep`
# such that:
# * there exists a general Krylov factorization of the form
#   ``A * V * U = V * U * H + v * f'``
#   with `V`` some orthonormal basis and `v` some unit-norm residual vector, i.e. `V'*v = 0` and `norm(v) = 1`
# * `keep < m`
# * `H[keep+1:m, 1:keep]` is zero (i.e. the first `keep` coordinate axis span an invariant subspace of `H`)
#
# Output:
# `U` and `H` are updated in place such that a truncated Krylov factorization of size `keep` in
# standard Arnoldi form is obtained, i.e.
# A * V * U[:, 1:keep] = V * U[:, 1:keep] * H[1:keep, 1:keep] + H[keep+1, keep] * v * eₖ
# with `H[1:keep, 1:keep]` in Hessenberg form and `eₖ` the unit vector along the `keep`-th coordinate axis.
function _restorearnoldiform!(U, H, f, keep)
    @inbounds for j in 1:keep
        H[keep + 1, j] = conj(f[j])
    end
    @inbounds for j in keep:-1:1
        h, ν = householder(H, j + 1, 1:j, j)
        H[j + 1, j] = ν
        H[j + 1, 1:(j - 1)] .= 0
        lmul!(h, H)
        rmul!(view(H, 1:j, :), h')
        rmul!(U, h')
    end
    return nothing
end

# Some modified wrappers for Lapack
import LinearAlgebra: BlasFloat, BlasInt,
    LAPACKException, DimensionMismatch, SingularException, PosDefException,
    chkstride1, checksquare
import LinearAlgebra.BLAS: @blasfunc, BlasReal, BlasComplex
import LinearAlgebra.LAPACK: chklapackerror
@static if VERSION >= v"1.7"
    const liblapack = LinearAlgebra.BLAS.libblastrampoline
else
    const liblapack = LinearAlgebra.LAPACK.liblapack
end

@static if isdefined(Base, :require_one_based_indexing)
    import Base: require_one_based_indexing
else
    function require_one_based_indexing(A...)
        return !Base.has_offset_axes(A...) ||
            throw(ArgumentError("offset arrays are not supported but got an array with index other than 1"))
    end
end

struct RowIterator{A <: AbstractMatrix, R <: IndexRange}
    a::A
    r::R
end
rows(a::AbstractMatrix, r::IndexRange = axes(a, 1)) = RowIterator(a, r)

function Base.iterate(iter::RowIterator)
    next = iterate(iter.r)
    if next === nothing
        return nothing
    else
        i, s = next
        return view(iter.a, i, :), s
    end
end
function Base.iterate(iter::RowIterator, s)
    next = iterate(iter.r, s)
    if next === nothing
        return nothing
    else
        i, s = next
        return view(iter.a, i, :), s
    end
end

Base.IteratorSize(::Type{<:RowIterator}) = Base.HasLength()
Base.IteratorEltype(::Type{<:RowIterator}) = Base.HasEltype()
Base.length(iter::RowIterator) = length(iter.r)
function Base.eltype(iter::RowIterator{A}) where {T, A <: DenseArray{T}}
    return SubArray{T, 1, A, Tuple{Int, Base.Slice{Base.OneTo{Int}}}, true}
end

struct ColumnIterator{A <: AbstractMatrix, R <: IndexRange}
    a::A
    r::R
end
cols(a::AbstractMatrix, r::IndexRange = axes(a, 2)) = ColumnIterator(a, r)

function Base.iterate(iter::ColumnIterator)
    next = iterate(iter.r)
    if next === nothing
        return nothing
    else
        i, s = next
        return view(iter.a, :, i), s
    end
end
function Base.iterate(iter::ColumnIterator, s)
    next = iterate(iter.r, s)
    if next === nothing
        return nothing
    else
        i, s = next
        return view(iter.a, :, i), s
    end
end

Base.IteratorSize(::Type{<:ColumnIterator}) = Base.HasLength()
Base.IteratorEltype(::Type{<:ColumnIterator}) = Base.HasEltype()
Base.length(iter::ColumnIterator) = length(iter.r)
function Base.eltype(iter::ColumnIterator{A}) where {T, A <: DenseArray{T}}
    return SubArray{T, 1, A, Tuple{Base.Slice{Base.OneTo{Int}}, Int}, true}
end

# # QR decomposition
# function qr!(A::StridedMatrix{<:BlasFloat})
#     m, n = size(A)
#     A, T = LAPACK.geqrt!(A, min(minimum(size(A)), 36))
#     Q = LAPACK.gemqrt!('L', 'N', A, T, eye(eltype(A), m, min(m,n)))
#     R = triu!(A[1:min(m,n), :])
#     return Q, R
# end

# Triangular division: for some reason this is faster than LAPACK's trsv
function ldiv!(A::UpperTriangular, y::AbstractVector, r::UnitRange{Int} = 1:length(y))
    R = A.data
    @inbounds for j in reverse(r)
        R[j, j] == zero(R[j, j]) && throw(SingularException(j))
        yj = (y[j] = R[j, j] \ y[j])
        @simd for i in first(r):(j - 1)
            y[i] -= R[i, j] * yj
        end
    end
    return y
end

# Eigenvalue decomposition of SymTridiagonal matrix
function tridiageigh!(A::SymTridiagonal{T}) where {T <: BlasFloat}
    Z = copyto!(similar(A.ev, size(A)), LinearAlgebra.I)
    return tridiageigh!(A, Z)
end
function tridiageigh!(A::SymTridiagonal{T}, Z::StridedMatrix{T}) where {T <: BlasFloat}
    return stegr!(A.dv, A.ev, Z)
end # redefined

# Generalized eigenvalue decomposition of symmetric / Hermitian problem
function geneigh!(A::StridedMatrix{T}, B::StridedMatrix{T}) where {T <: BlasFloat}
    return LAPACK.sygvd!(1, 'V', 'U', A, B)
end

# Singular value decomposition of a Bidiagonal matrix
function bidiagsvd!(
        B::Bidiagonal{T},
        U::AbstractMatrix{T} = one(B),
        VT::AbstractMatrix{T} = one(B)
    ) where {T <: BlasReal}
    s, Vt, U = LAPACK.bdsqr!(B.uplo, B.dv, B.ev, VT, U, similar(U, (size(B, 1), 0)))
    return U, s, Vt
end

function reversecols!(U::AbstractMatrix)
    n = size(U, 2)
    @inbounds for j in 1:div(n, 2)
        @simd for i in 1:size(U, 1)
            U[i, j], U[i, n + 1 - j] = U[i, n + 1 - j], U[i, j]
        end
    end
    return U
end
function reverserows!(V::AbstractVecOrMat)
    m = size(V, 1)
    @inbounds for j in 1:size(V, 2)
        @simd for i in 1:div(m, 2)
            V[i, j], V[m + 1 - i, j] = V[m + 1 - i, j], V[i, j]
        end
    end
    return V
end

# Schur factorization of a Hessenberg matrix
function hschur!(H::AbstractMatrix{T}, Z::AbstractMatrix{T} = one(H)) where {T <: BlasFloat}
    return hseqr!(H, Z)
end

schur2eigvals(T::AbstractMatrix{<:BlasFloat}) = schur2eigvals(T, 1:size(T, 1))

function schur2eigvals(T::AbstractMatrix{<:BlasComplex}, which::AbstractVector{Int})
    n = checksquare(T)
    which2 = unique(which)
    length(which2) == length(which) ||
        throw(ArgumentError("which should contain unique values"))
    return [T[i, i] for i in which2]
end

function schur2eigvals(T::AbstractMatrix{<:BlasReal}, which::AbstractVector{Int})
    n = checksquare(T)
    which2 = unique(which)
    length(which2) == length(which) ||
        throw(ArgumentError("which should contain unique values"))
    D = zeros(Complex{eltype(T)}, length(which2))
    for k in 1:length(which)
        i = which[k]
        if i < n && !iszero(T[i + 1, i])
            halftr = (T[i, i] + T[i + 1, i + 1]) / 2
            diff = (T[i, i] - T[i + 1, i + 1]) / 2
            d = diff * diff + T[i, i + 1] * T[i + 1, i]  # = hafltr*halftr - det
            D[i] = halftr + im * sqrt(-d)
        elseif i > 1 && !iszero(T[i, i - 1])
            halftr = (T[i, i] + T[i - 1, i - 1]) / 2
            diff = -(T[i, i] - T[i - 1, i - 1]) / 2
            d = diff * diff + T[i, i - 1] * T[i - 1, i]  # = hafltr*halftr - det
            D[i] = halftr - im * sqrt(-d)
        else
            D[i] = T[i, i]
        end
    end
    return D
end

function _normalizevecs!(V)
    @inbounds for k in 1:size(V, 2)
        normalize!(view(V, :, k))
    end
    return V
end
function schur2eigvecs(T::AbstractMatrix{<:BlasComplex})
    n = checksquare(T)
    VR = similar(T, n, n)
    VL = similar(T, n, 0)
    select = Vector{BlasInt}(undef, 0)
    trevc!('R', 'A', select, T, VL, VR)
    return _normalizevecs!(VR)
end
function schur2eigvecs(T::AbstractMatrix{<:BlasComplex}, which::AbstractVector{Int})
    n = checksquare(T)
    which2 = unique(which)
    length(which2) == length(which) ||
        throw(ArgumentError("which should contain unique values"))
    m = BlasInt(length(which2))
    VR = similar(T, n, m)
    VL = similar(T, n, 0)

    select = zeros(BlasInt, n)
    for k in 1:length(which2)
        i = which2[k]
        select[i] = one(BlasInt)
        trevc!('R', 'S', select, T, VL, view(VR, :, k:k))
        select[i] = zero(BlasInt)
    end
    return _normalizevecs!(VR)
end
function schur2eigvecs(T::StridedMatrix{<:BlasReal})
    n = checksquare(T)
    VR = similar(T, Complex{eltype(T)}, n, n)
    VR′ = similar(T, n, n)
    VL′ = similar(T, n, 0)
    select = Vector{BlasInt}(undef, 0)
    trevc!('R', 'A', select, T, VL′, VR′)
    i = 1
    while i <= n
        if i == n || iszero(T[i + 1, i])
            @inbounds @simd for k in 1:n
                VR[k, i] = VR′[k, i]
            end
            i += 1
        else
            @inbounds @simd for k in 1:n
                VR[k, i] = VR′[k, i] + im * VR′[k, i + 1]
                VR[k, i + 1] = VR′[k, i] - im * VR′[k, i + 1]
            end
            i += 2
        end
    end
    return _normalizevecs!(VR)
end
function schur2realeigvecs(T::StridedMatrix{<:BlasReal})
    n = checksquare(T)
    for i in 1:(n - 1)
        iszero(T[i + 1, i]) || throw(ArgumentError("T must be upper triangular"))
    end
    VR = similar(T, n, n)
    VL = similar(T, n, 0)
    select = Vector{BlasInt}(undef, 0)
    trevc!('R', 'A', select, T, VL, VR)
    return _normalizevecs!(VR)
end
function schur2eigvecs(T::AbstractMatrix{<:BlasReal}, which::AbstractVector{Int})
    n = checksquare(T)
    which2 = unique(which)
    length(which2) == length(which) ||
        throw(ArgumentError("which should contain unique values"))
    m = length(which2)
    VR = similar(T, Complex{eltype(T)}, n, m)
    VR′ = similar(T, n, 2)
    VL′ = similar(T, n, 0)

    select = zeros(BlasInt, n)
    i = 1
    while i <= n
        if i == n || iszero(T[i + 1, i])
            j = findfirst(isequal(i), which2)
            if j !== nothing
                select[i] = one(BlasInt)
                trevc!('R', 'S', select, T, VL′, VR′)
                @inbounds @simd for k in 1:n
                    VR[k, j] = VR′[k, 1]
                end
                select[i] = zero(BlasInt)
            end
            i += 1
        else
            j1 = findfirst(isequal(i), which2)
            j2 = findfirst(isequal(i + 1), which2)
            if j1 !== nothing || j2 !== nothing
                select[i] = one(BlasInt)
                select[i + 1] = one(BlasInt)
                trevc!('R', 'S', select, T, VL′, VR′)
                @inbounds @simd for k in 1:n
                    if j1 !== nothing
                        VR[k, j1] = VR′[k, 1] + im * VR′[k, 2]
                    end
                    if j2 !== nothing
                        VR[k, j2] = VR′[k, 1] - im * VR′[k, 2]
                    end
                end
                select[i] = zero(BlasInt)
                select[i + 1] = zero(BlasInt)
            end
            i += 2
        end
    end
    return _normalizevecs!(VR)
end

function permuteeig!(D::AbstractVector, V::AbstractMatrix, perm::AbstractVector{Int})
    n = checksquare(V)
    p = collect(perm) # makes copy cause will be overwritten
    isperm(p) && length(p) == n ||
        throw(ArgumentError("not a valid permutation of length $n"))
    i = 1
    @inbounds while true
        if p[i] == i
            i = 1
            while i <= n && p[i] == i
                i += 1
            end
            i > n && break
        else
            iprev = findfirst(isequal(i), p)
            inext = p[i]
            p[iprev] = inext
            p[i] = i

            D[i], D[inext] = D[inext], D[i]
            @simd for j in 1:n
                V[j, i], V[j, inext] = V[j, inext], V[j, i]
            end
            i = inext
        end
    end
    return D, V
end

function permuteschur!(T::AbstractMatrix{<:BlasFloat}, p::AbstractVector{Int})
    return permuteschur!(T, one(T), p)
end
function permuteschur!(
        T::AbstractMatrix{S}, Q::AbstractMatrix{S}, order::AbstractVector{Int}
    ) where {S <: BlasComplex}
    n = checksquare(T)
    p = collect(order) # makes copy cause will be overwritten
    @inbounds for i in 1:length(p)
        ifirst::BlasInt = p[i]
        ilast::BlasInt = i
        T, Q = LAPACK.trexc!(ifirst, ilast, T, Q)
        for k in (i + 1):length(p)
            if p[k] < p[i]
                p[k] += 1
            end
        end
    end
    return T, Q, schur2eigvals(T)
end

function permuteschur!(
        T::AbstractMatrix{S}, Q::AbstractMatrix{S}, order::AbstractVector{Int}
    ) where {S <: BlasReal}
    n = checksquare(T)
    p = collect(order) # makes copy cause will be overwritten
    i = 1
    @inbounds while i <= length(p)
        ifirst::BlasInt = p[i]
        ilast::BlasInt = i
        if ifirst == n || iszero(T[ifirst + 1, ifirst])
            T, Q = LAPACK.trexc!(ifirst, ilast, T, Q)
            @inbounds for k in (i + 1):length(p)
                if p[k] < p[i]
                    p[k] += 1
                end
            end
            i += 1
        else
            p[i + 1] == ifirst + 1 ||
                error("cannot split 2x2 blocks when permuting schur decomposition")
            T, Q = LAPACK.trexc!(ifirst, ilast, T, Q)
            @inbounds for k in (i + 2):length(p)
                if p[k] < p[i]
                    p[k] += 2
                end
            end
            i += 2
        end
    end
    return T, Q, schur2eigvals(T)
end

function partitionschur!(
        T::AbstractMatrix{S}, Q::AbstractMatrix{S}, select::AbstractVector{Bool}
    ) where {S <: BlasFloat}
    T, Q, vals = trsen!('N', 'V', convert(Vector{BlasInt}, select), T, Q)
    return T, Q, vals
end

# redefine LAPACK interface to tridiagonal eigenvalue problem
for (stegr, elty) in ((:dstegr_, :Float64), (:sstegr_, :Float32))
    @eval begin
        function stegr!(
                dv::AbstractVector{$elty}, ev::AbstractVector{$elty}, Z::AbstractMatrix{$elty}
            )
            require_one_based_indexing(dv, ev, Z)
            chkstride1(dv, ev, Z)
            n = length(dv)
            if length(ev) == n - 1
                eev = [ev; zero($elty)]
            elseif length(ev) == n
                eev = ev
            else
                throw(DimensionMismatch("ev has length $(length(ev)) but needs one less than dv's length, $n)"))
            end
            checksquare(Z) == n || throw(DimensionMismatch())
            ldz = max(1, stride(Z, 2))
            jobz = 'V'
            range = 'A'
            abstol = Vector{$elty}(undef, 1)
            il = 1
            iu = n
            vl = zero($elty)
            vu = zero($elty)
            m = Ref{BlasInt}()
            w = similar(dv, $elty, n)
            isuppz = similar(dv, BlasInt, 2 * size(Z, 2))
            work = Vector{$elty}(undef, 1)
            lwork = BlasInt(-1)
            iwork = Vector{BlasInt}(undef, 1)
            liwork = BlasInt(-1)
            info = Ref{BlasInt}()
            for i in 1:2  # first call returns lwork as work[1] and liwork as iwork[1]
                ccall(
                    (@blasfunc($stegr), liblapack),
                    Cvoid,
                    (
                        Ref{UInt8}, Ref{UInt8}, Ref{BlasInt},
                        Ptr{$elty}, Ptr{$elty}, Ref{$elty}, Ref{$elty},
                        Ref{BlasInt}, Ref{BlasInt}, Ptr{$elty}, Ptr{BlasInt},
                        Ptr{$elty}, Ptr{$elty}, Ref{BlasInt},
                        Ptr{BlasInt}, Ptr{$elty}, Ref{BlasInt}, Ptr{BlasInt}, Ref{BlasInt},
                        Ptr{BlasInt}, Clong, Clong,
                    ),
                    jobz, range, n,
                    dv, eev, vl, vu,
                    il, iu, abstol, m,
                    w, Z, ldz,
                    isuppz, work, lwork, iwork, liwork,
                    info, 1, 1
                )
                chklapackerror(info[])
                if i == 1
                    lwork = BlasInt(work[1])
                    resize!(work, lwork)
                    liwork = iwork[1]
                    resize!(iwork, liwork)
                end
            end
            return w, Z
        end
    end
end

# redefine LAPACK interface to schur
for (hseqr, trevc, trsen, elty) in
    ((:dhseqr_, :dtrevc_, :dtrsen_, :Float64), (:shseqr_, :strevc_, :strsen_, :Float32))
    @eval begin
        function hseqr!(H::StridedMatrix{$elty}, Z::StridedMatrix{$elty} = one(H))
            require_one_based_indexing(H, Z)
            chkstride1(H, Z)
            n = checksquare(H)
            checksquare(Z) == n || throw(DimensionMismatch())
            job = 'S'
            compz = 'V'
            ilo = 1
            ihi = n
            ldh = stride(H, 2)
            ldz = stride(Z, 2)
            wr = similar(H, $elty, n)
            wi = similar(H, $elty, n)
            work = Vector{$elty}(undef, 1)
            lwork = BlasInt(-1)
            info = Ref{BlasInt}()
            for i in 1:2  # first call returns lwork as work[1]
                ccall(
                    (@blasfunc($hseqr), liblapack),
                    Cvoid,
                    (
                        Ref{UInt8}, Ref{UInt8}, Ref{BlasInt}, Ref{BlasInt}, Ref{BlasInt},
                        Ptr{$elty}, Ref{BlasInt}, Ptr{$elty}, Ptr{$elty}, Ptr{$elty}, Ref{BlasInt},
                        Ptr{$elty}, Ref{BlasInt}, Ptr{BlasInt}, Clong, Clong,
                    ),
                    job, compz, n, ilo, ihi,
                    H, ldh, wr, wi, Z, ldz,
                    work, lwork, info, 1, 1
                )
                chklapackerror(info[])
                if i == 1
                    lwork = BlasInt(real(work[1]))
                    resize!(work, lwork)
                end
            end
            return H, Z, complex.(wr, wi)
        end
        function trevc!(
                side::Char, howmny::Char, select::StridedVector{BlasInt},
                T::AbstractMatrix{$elty}, VL::AbstractMatrix{$elty}, VR::AbstractMatrix{$elty}
            )
            # Extract
            if side ∉ ['L', 'R', 'B']
                throw(ArgumentError("side argument must be 'L' (left eigenvectors), 'R' (right eigenvectors), or 'B' (both), got $side"))
            end
            n = checksquare(T)
            mm = side == 'L' ? size(VL, 2) :
                (side == 'R' ? size(VR, 2) : min(size(VL, 2), size(VR, 2)))
            ldt, ldvl, ldvr = stride(T, 2), stride(VL, 2), stride(VR, 2)

            # Check
            chkstride1(T, select, VL, VR)

            # Allocate
            m = Ref{BlasInt}()
            work = Vector{$elty}(undef, 3n)
            info = Ref{BlasInt}()

            ccall(
                (@blasfunc($trevc), liblapack),
                Cvoid,
                (
                    Ref{UInt8}, Ref{UInt8}, Ptr{BlasInt}, Ref{BlasInt},
                    Ptr{$elty}, Ref{BlasInt}, Ptr{$elty}, Ref{BlasInt}, Ptr{$elty}, Ref{BlasInt},
                    Ref{BlasInt}, Ptr{BlasInt}, Ptr{$elty}, Ptr{BlasInt}, Clong, Clong,
                ),
                side, howmny, select, n,
                T, ldt, VL, ldvl, VR, ldvr,
                mm, m, work, info, 1, 1
            )
            chklapackerror(info[])

            return VL, VR, m
        end
        function trsen!(
                job::AbstractChar, compq::AbstractChar, select::AbstractVector{BlasInt},
                T::AbstractMatrix{$elty}, Q::AbstractMatrix{$elty}
            )
            chkstride1(T, Q, select)
            n = checksquare(T)
            checksquare(Q) == n || throw(DimensionMismatch())
            length(select) == n || throw(DimensionMismatch())
            ldt = max(1, stride(T, 2))
            ldq = max(1, stride(Q, 2))
            wr = similar(T, $elty, n)
            wi = similar(T, $elty, n)
            m = sum(select)
            work = Vector{$elty}(undef, 1)
            lwork = BlasInt(-1)
            iwork = Vector{BlasInt}(undef, 1)
            liwork = BlasInt(-1)
            info = Ref{BlasInt}()
            select = convert(Array{BlasInt}, select)
            s = Ref{$elty}(zero($elty))
            sep = Ref{$elty}(zero($elty))
            for i in 1:2  # first call returns lwork as work[1] and liwork as iwork[1]
                ccall(
                    (@blasfunc($trsen), liblapack), Cvoid,
                    (
                        Ref{UInt8}, Ref{UInt8}, Ptr{BlasInt}, Ref{BlasInt},
                        Ptr{$elty}, Ref{BlasInt}, Ptr{$elty}, Ref{BlasInt},
                        Ptr{$elty}, Ptr{$elty}, Ref{BlasInt}, Ref{$elty}, Ref{$elty},
                        Ptr{$elty}, Ref{BlasInt}, Ptr{BlasInt}, Ref{BlasInt},
                        Ptr{BlasInt}, Clong, Clong,
                    ),
                    job, compq, select, n,
                    T, ldt, Q, ldq,
                    wr, wi, m, s, sep,
                    work, lwork, iwork, liwork,
                    info, 1, 1
                )
                chklapackerror(info[])
                if i == 1 # only estimated optimal lwork, liwork
                    lwork = BlasInt(real(work[1]))
                    resize!(work, lwork)
                    liwork = BlasInt(real(iwork[1]))
                    resize!(iwork, liwork)
                end
            end
            return T, Q, complex.(wr, wi), s[], sep[]
        end
    end
end

for (hseqr, trevc, trsen, elty, relty) in
    (
        (:zhseqr_, :ztrevc_, :ztrsen_, :ComplexF64, :Float64),
        (:chseqr_, :ctrevc_, :ctrsen_, :ComplexF32, :Float32),
    )
    @eval begin
        function hseqr!(H::AbstractMatrix{$elty}, Z::AbstractMatrix{$elty} = one(H))
            require_one_based_indexing(H, Z)
            chkstride1(H, Z)
            n = checksquare(H)
            checksquare(Z) == n || throw(DimensionMismatch())
            job = 'S'
            compz = 'V'
            ilo = 1
            ihi = n
            ldh = stride(H, 2)
            ldz = stride(Z, 2)
            w = similar(H, $elty, n)
            work = Vector{$elty}(undef, 1)
            lwork = BlasInt(-1)
            info = Ref{BlasInt}()
            for i in 1:2  # first call returns lwork as work[1]
                ccall(
                    (@blasfunc($hseqr), liblapack),
                    Cvoid,
                    (
                        Ref{UInt8}, Ref{UInt8}, Ref{BlasInt}, Ref{BlasInt}, Ref{BlasInt},
                        Ptr{$elty}, Ref{BlasInt}, Ptr{$elty}, Ptr{$elty}, Ref{BlasInt},
                        Ptr{$elty}, Ref{BlasInt}, Ptr{BlasInt}, Clong, Clong,
                    ),
                    job, compz, n, ilo, ihi,
                    H, ldh, w, Z, ldz,
                    work, lwork, info, 1, 1
                )
                chklapackerror(info[])
                if i == 1
                    lwork = BlasInt(real(work[1]))
                    resize!(work, lwork)
                end
            end
            return H, Z, w
        end
        function trevc!(
                side::Char, howmny::Char, select::AbstractVector{BlasInt},
                T::AbstractMatrix{$elty}, VL::AbstractMatrix{$elty} = similar(T), VR::AbstractMatrix{$elty} = similar(T)
            )

            # Check
            require_one_based_indexing(select, T, VL, VR)
            chkstride1(T, select, VL, VR)

            # Extract
            if side ∉ ['L', 'R', 'B']
                throw(ArgumentError("side argument must be 'L' (left eigenvectors), 'R' (right eigenvectors), or 'B' (both), got $side"))
            end
            n = checksquare(T)
            mm = side == 'L' ? size(VL, 2) :
                (side == 'R' ? size(VR, 2) : min(size(VL, 2), size(VR, 2)))
            ldt, ldvl, ldvr = stride(T, 2), stride(VL, 2), stride(VR, 2)

            # Allocate
            m = Ref{BlasInt}()
            work = Vector{$elty}(undef, 2n)
            rwork = Vector{$relty}(undef, n)
            info = Ref{BlasInt}()
            ccall(
                (@blasfunc($trevc), liblapack),
                Cvoid,
                (
                    Ref{UInt8},
                    Ref{UInt8},
                    Ptr{BlasInt},
                    Ref{BlasInt},
                    Ptr{$elty},
                    Ref{BlasInt},
                    Ptr{$elty},
                    Ref{BlasInt},
                    Ptr{$elty},
                    Ref{BlasInt},
                    Ref{BlasInt},
                    Ptr{BlasInt},
                    Ptr{$elty},
                    Ptr{$relty},
                    Ptr{BlasInt},
                    Clong,
                    Clong,
                ),
                side,
                howmny,
                select,
                n,
                T,
                ldt,
                VL,
                ldvl,
                VR,
                ldvr,
                mm,
                m,
                work,
                rwork,
                info,
                1,
                1
            )
            chklapackerror(info[])

            return VL, VR, m
        end
        function trsen!(
                job::Char,
                compq::Char,
                select::AbstractVector{BlasInt},
                T::AbstractMatrix{$elty},
                Q::AbstractMatrix{$elty}
            )
            chkstride1(select, T, Q)
            n = checksquare(T)
            ldt = max(1, stride(T, 2))
            ldq = max(1, stride(Q, 2))
            w = similar(T, $elty, n)
            m = sum(select)
            work = Vector{$elty}(undef, 1)
            lwork = BlasInt(-1)
            info = Ref{BlasInt}()
            select = convert(Array{BlasInt}, select)
            s = Ref{$relty}(zero($relty))
            sep = Ref{$relty}(zero($relty))
            for i in 1:2  # first call returns lwork as work[1]
                ccall(
                    (@blasfunc($trsen), liblapack),
                    Nothing,
                    (
                        Ref{UInt8},
                        Ref{UInt8},
                        Ptr{BlasInt},
                        Ref{BlasInt},
                        Ptr{$elty},
                        Ref{BlasInt},
                        Ptr{$elty},
                        Ref{BlasInt},
                        Ptr{$elty},
                        Ref{BlasInt},
                        Ref{$relty},
                        Ref{$relty},
                        Ptr{$elty},
                        Ref{BlasInt},
                        Ptr{BlasInt},
                    ),
                    job,
                    compq,
                    select,
                    n,
                    T,
                    ldt,
                    Q,
                    ldq,
                    w,
                    m,
                    s,
                    sep,
                    work,
                    lwork,
                    info
                )
                chklapackerror(info[])
                if i == 1 # only estimated optimal lwork, liwork
                    lwork = BlasInt(real(work[1]))
                    resize!(work, lwork)
                end
            end
            return T, Q, w, s[], sep[]
        end
    end
end

# Elementary Householder reflection
struct Householder{T, V <: AbstractVector, R <: IndexRange}
    β::T
    v::V
    r::R
end

Base.adjoint(H::Householder) = Householder(conj(H.β), H.v, H.r)

function householder(x::AbstractVector, r::IndexRange = axes(x, 1), k = first(r))
    i = findfirst(isequal(k), r)
    i isa Nothing && error("k = $k should be in the range r = $r")
    β, v, ν = _householder!(x[r], i)
    return Householder(β, v, r), ν
end
# Householder reflector h that zeros the elements A[r,col] (except for A[k,col]) upon lmul!(A,h)
function householder(A::AbstractMatrix, r::IndexRange, col::Int, k = first(r))
    i = findfirst(isequal(k), r)
    i isa Nothing && error("k = $k should be in the range r = $r")
    β, v, ν = _householder!(A[r, col], i)
    return Householder(β, v, r), ν
end
# Householder reflector that zeros the elements A[row,r] (except for A[row,k]) upon rmul!(A,h')
function householder(A::AbstractMatrix, row::Int, r::IndexRange, k = first(r))
    i = findfirst(isequal(k), r)
    i isa Nothing && error("k = $k should be in the range r = $r")
    β, v, ν = _householder!(conj!(A[row, r]), i)
    return Householder(β, v, r), ν
end

# generate Householder vector based on vector v, such that applying the reflection
# to v yields a vector with single non-zero element on position i, whose value is
# positive and thus equal to norm(v)
function _householder!(v::AbstractVector{T}, i::Int) where {T}
    β::T = zero(T)
    @inbounds begin
        σ = abs2(zero(T))
        @simd for k in 1:(i - 1)
            σ += abs2(v[k])
        end
        @simd for k in (i + 1):length(v)
            σ += abs2(v[k])
        end
        vi = v[i]
        ν = sqrt(abs2(vi) + σ)

        if iszero(σ) && vi == ν
            β = zero(vi)
        else
            if real(vi) < 0
                vi = vi - ν
            else
                vi = ((vi - conj(vi)) * ν - σ) / (conj(vi) + ν)
            end
            @simd for k in 1:(i - 1)
                v[k] /= vi
            end
            v[i] = 1
            @simd for k in (i + 1):length(v)
                v[k] /= vi
            end
            β = -conj(vi) / (ν)
        end
    end
    return β, v, ν
end

function LinearAlgebra.lmul!(H::Householder, x::AbstractVector)
    v = H.v
    r = H.r
    β = H.β
    iszero(β) && return x
    @inbounds begin
        μ::eltype(x) = zero(eltype(x))
        i = 1
        @simd for j in r
            μ += conj(v[i]) * x[j]
            i += 1
        end
        μ *= β
        i = 1
        @simd for j in H.r
            x[j] -= μ * v[i]
            i += 1
        end
    end
    return x
end
function LinearAlgebra.lmul!(H::Householder, A::AbstractMatrix, cols = axes(A, 2))
    v = H.v
    r = H.r
    β = H.β
    iszero(β) && return A
    @inbounds begin
        for k in cols
            μ::eltype(A) = zero(eltype(A))
            i = 1
            @simd for j in r
                μ += conj(v[i]) * A[j, k]
                i += 1
            end
            μ *= β
            i = 1
            @simd for j in H.r
                A[j, k] -= μ * v[i]
                i += 1
            end
        end
    end
    return A
end
function LinearAlgebra.rmul!(A::AbstractMatrix, H::Householder, rows = axes(A, 1))
    v = H.v
    r = H.r
    β = H.β
    iszero(β) && return A
    w = similar(A, length(rows))
    fill!(w, zero(eltype(w)))
    @inbounds begin
        l = 1
        for k in r
            j = 1
            vl = v[l]
            @simd for i in rows
                w[j] += A[i, k] * vl
                j += 1
            end
            l += 1
        end
        l = 1
        for k in r
            j = 1
            vl = β * conj(v[l])
            @simd for i in rows
                A[i, k] -= w[j] * vl
                j += 1
            end
            l += 1
        end
    end
    return A
end
function LinearAlgebra.rmul!(b::OrthonormalBasis, H::Householder)
    v = H.v
    r = H.r
    β = H.β
    iszero(β) && return b
    w = zerovector(b[first(r)])
    @inbounds begin
        w = unproject!!(w, b, v, 1, 0, r)
        b = rank1update!(b, w, v, -β, 1, r)
    end
    return b
end

@testset "Lanczos - eigsolve full ($mode)" for mode in (:vector, :inplace, :outplace)
    scalartypes = mode === :vector ? (Float32, Float64, ComplexF32, ComplexF64) :
        (ComplexF64,)
    orths = mode === :vector ? (cgs2, mgs2, cgsr, mgsr) : (mgsr,)
    @testset for T in scalartypes
        @testset for orth in orths
            A = rand(T, (n, n)) .- one(T) / 2
            A = (A + A') / 2
            v = rand(T, (n,))
            n1 = div(n, 2)
            alg = Lanczos(;
                orth = orth, krylovdim = n, maxiter = 1, tol = tolerance(T),
                verbosity = STARTSTOP_LEVEL
            )
            D1, V1, info = @test_logs (:info,) eigsolve(
                wrapop(A, Val(mode)),
                wrapvec(v, Val(mode)), n1, :SR, alg
            )
            alg = Lanczos(;
                orth = orth, krylovdim = n, maxiter = 1, tol = tolerance(T),
                verbosity = WARN_LEVEL
            )
            @test_logs eigsolve(
                wrapop(A, Val(mode)),
                wrapvec(v, Val(mode)), n1, :SR, alg
            )
            alg = Lanczos(;
                orth = orth, krylovdim = n1 + 1, maxiter = 1, tol = tolerance(T),
                verbosity = WARN_LEVEL
            )
            @test_logs (:warn,) eigsolve(
                wrapop(A, Val(mode)),
                wrapvec(v, Val(mode)), n1, :SR, alg
            )
            alg = Lanczos(;
                orth = orth, krylovdim = n, maxiter = 1, tol = tolerance(T),
                verbosity = STARTSTOP_LEVEL
            )
            @test_logs (:info,) eigsolve(
                wrapop(A, Val(mode)),
                wrapvec(v, Val(mode)), n1, :SR, alg
            )
            alg = Lanczos(;
                orth = orth, krylovdim = n1, maxiter = 3, tol = tolerance(T),
                verbosity = EACHITERATION_LEVEL
            )
            @test_logs(
                (:info,), (:info,), (:info,), (:warn,),
                eigsolve(wrapop(A, Val(mode)), wrapvec(v, Val(mode)), 1, :SR, alg)
            )
            alg = Lanczos(;
                orth = orth, krylovdim = 4, maxiter = 1, tol = tolerance(T),
                verbosity = EACHITERATION_LEVEL + 1
            )
            # since it is impossible to know exactly the size of the Krylov subspace after shrinking,
            # we only know the output for a sigle iteration
            @test_logs(
                (:info,), (:info,), (:info,), (:info,), (:info,), (:warn,),
                eigsolve(wrapop(A, Val(mode)), wrapvec(v, Val(mode)), 1, :SR, alg)
            )

            @test KrylovKit.eigselector(
                wrapop(A, Val(mode)), scalartype(v); krylovdim = n,
                maxiter = 1,
                tol = tolerance(T), ishermitian = true
            ) isa Lanczos
            n2 = n - n1
            alg = Lanczos(; krylovdim = 2 * n, maxiter = 1, tol = tolerance(T))
            D2, V2, info = @constinferred eigsolve(
                wrapop(A, Val(mode)),
                wrapvec(v, Val(mode)),
                n2, :LR, alg
            )
            @test vcat(D1[1:n1], reverse(D2[1:n2])) ≊ eigvals(A)

            U1 = stack(unwrapvec, V1)
            U2 = stack(unwrapvec, V2)
            @test U1' * U1 ≈ I
            @test U2' * U2 ≈ I

            @test A * U1 ≈ U1 * Diagonal(D1)
            @test A * U2 ≈ U2 * Diagonal(D2)

            alg = Lanczos(;
                orth = orth, krylovdim = 2n, maxiter = 1, tol = tolerance(T),
                verbosity = WARN_LEVEL
            )
            @test_logs (:warn,) (:warn,) eigsolve(
                wrapop(A, Val(mode)),
                wrapvec(v, Val(mode)), n + 1, :LM, alg
            )
        end
    end
end

@testset "Lanczos - eigsolve iteratively ($mode)" for mode in (:vector, :inplace, :outplace)
    scalartypes = mode === :vector ? (Float32, Float64, ComplexF32, ComplexF64) :
        (ComplexF64,)
    orths = mode === :vector ? (cgs2, mgs2, cgsr, mgsr) : (mgsr,)
    @testset for T in scalartypes
        @testset for orth in orths
            A = rand(T, (N, N)) .- one(T) / 2
            A = (A + A') / 2
            v = rand(T, (N,))
            alg = Lanczos(;
                krylovdim = 2 * n, maxiter = 10,
                tol = tolerance(T), eager = true, verbosity = SILENT_LEVEL
            )
            D1, V1, info1 = @constinferred eigsolve(
                wrapop(A, Val(mode)),
                wrapvec(v, Val(mode)), n, :SR, alg
            )
            D2, V2, info2 = eigsolve(
                wrapop(A, Val(mode)), wrapvec(v, Val(mode)), n, :LR,
                alg
            )

            l1 = info1.converged
            l2 = info2.converged
            @test l1 > 0
            @test l2 > 0
            @test D1[1:l1] ≈ eigvals(A)[1:l1]
            @test D2[1:l2] ≈ eigvals(A)[N:-1:(N - l2 + 1)]

            U1 = stack(unwrapvec, V1)
            U2 = stack(unwrapvec, V2)
            @test U1' * U1 ≈ I
            @test U2' * U2 ≈ I

            R1 = stack(unwrapvec, info1.residual)
            R2 = stack(unwrapvec, info2.residual)
            @test A * U1 ≈ U1 * Diagonal(D1) + R1
            @test A * U2 ≈ U2 * Diagonal(D2) + R2
        end
    end
end

@testset "Arnoldi - eigsolve full ($mode)" for mode in (:vector, :inplace, :outplace)
    scalartypes = mode === :vector ? (Float32, Float64, ComplexF32, ComplexF64) :
        (ComplexF64,)
    orths = mode === :vector ? (cgs2, mgs2, cgsr, mgsr) : (mgsr,)
    @testset for T in scalartypes
        @testset for orth in orths
            A = rand(T, (n, n)) .- one(T) / 2
            v = rand(T, (n,))
            n1 = div(n, 2)
            alg = Arnoldi(; orth = orth, krylovdim = n, maxiter = 1, tol = tolerance(T))
            D1, V1, info1 = @constinferred eigsolve(
                wrapop(A, Val(mode)),
                wrapvec(v, Val(mode)), n1, :SR, alg
            )

            alg = Arnoldi(;
                orth = orth, krylovdim = n, maxiter = 1, tol = tolerance(T),
                verbosity = SILENT_LEVEL
            )
            @test_logs eigsolve(wrapop(A, Val(mode)), wrapvec(v, Val(mode)), n1, :SR, alg)
            alg = Arnoldi(;
                orth = orth, krylovdim = n, maxiter = 1, tol = tolerance(T),
                verbosity = WARN_LEVEL
            )
            @test_logs eigsolve(wrapop(A, Val(mode)), wrapvec(v, Val(mode)), n1, :SR, alg)
            alg = Arnoldi(;
                orth = orth, krylovdim = n1 + 2, maxiter = 1, tol = tolerance(T),
                verbosity = WARN_LEVEL
            )
            @test_logs (:warn,) eigsolve(
                wrapop(A, Val(mode)), wrapvec(v, Val(mode)), n1,
                :SR, alg
            )
            alg = Arnoldi(;
                orth = orth, krylovdim = n, maxiter = 1, tol = tolerance(T),
                verbosity = STARTSTOP_LEVEL
            )
            @test_logs (:info,) eigsolve(
                wrapop(A, Val(mode)), wrapvec(v, Val(mode)), n1,
                :SR, alg
            )
            alg = Arnoldi(;
                orth = orth, krylovdim = n1, maxiter = 3, tol = tolerance(T),
                verbosity = EACHITERATION_LEVEL
            )
            @test_logs(
                (:info,), (:info,), (:info,), (:warn,),
                eigsolve(wrapop(A, Val(mode)), wrapvec(v, Val(mode)), 1, :SR, alg)
            )
            alg = Arnoldi(;
                orth = orth, krylovdim = 4, maxiter = 1, tol = tolerance(T),
                verbosity = EACHITERATION_LEVEL + 1
            )
            # since it is impossible to know exactly the size of the Krylov subspace after shrinking,
            # we only know the output for a sigle iteration
            @test_logs(
                (:info,), (:info,), (:info,), (:info,), (:info,), (:warn,),
                eigsolve(wrapop(A, Val(mode)), wrapvec(v, Val(mode)), 1, :SR, alg)
            )

            @test KrylovKit.eigselector(
                wrapop(A, Val(mode)), eltype(v); orth = orth,
                krylovdim = n, maxiter = 1,
                tol = tolerance(T)
            ) isa Arnoldi
            n2 = n - n1
            alg = Arnoldi(; orth = orth, krylovdim = 2 * n, maxiter = 1, tol = tolerance(T))
            D2, V2, info2 = @constinferred eigsolve(
                wrapop(A, Val(mode)),
                wrapvec(v, Val(mode)), n2, :LR, alg
            )
            D = sort(sort(eigvals(A); by = imag, rev = true); alg = MergeSort, by = real)
            D2′ = sort(sort(D2; by = imag, rev = true); alg = MergeSort, by = real)
            @test vcat(D1[1:n1], D2′[(end - n2 + 1):end]) ≈ D

            U1 = stack(unwrapvec, V1)
            U2 = stack(unwrapvec, V2)
            @test A * U1 ≈ U1 * Diagonal(D1)
            @test A * U2 ≈ U2 * Diagonal(D2)

            if T <: Complex
                n1 = div(n, 2)
                D1, V1, info = eigsolve(
                    wrapop(A, Val(mode)), wrapvec(v, Val(mode)), n1,
                    :SI,
                    alg
                )
                n2 = n - n1
                D2, V2, info = eigsolve(
                    wrapop(A, Val(mode)), wrapvec(v, Val(mode)), n2,
                    :LI,
                    alg
                )
                D = sort(eigvals(A); by = imag)

                @test vcat(D1[1:n1], reverse(D2[1:n2])) ≊ D

                U1 = stack(unwrapvec, V1)
                U2 = stack(unwrapvec, V2)
                @test A * U1 ≈ U1 * Diagonal(D1)
                @test A * U2 ≈ U2 * Diagonal(D2)
            end

            alg = Arnoldi(;
                orth = orth, krylovdim = 2n, maxiter = 1, tol = tolerance(T),
                verbosity = WARN_LEVEL
            )
            @test_logs (:warn,) (:warn,) eigsolve(
                wrapop(A, Val(mode)),
                wrapvec(v, Val(mode)), n + 1, :LM, alg
            )
        end
    end
end

@testset "Arnoldi - eigsolve iteratively ($mode)" for mode in (:vector, :inplace, :outplace)
    scalartypes = mode === :vector ? (Float32, Float64, ComplexF32, ComplexF64) :
        (ComplexF64,)
    orths = mode === :vector ? (cgs2, mgs2, cgsr, mgsr) : (mgsr,)
    @testset for T in scalartypes
        @testset for orth in orths
            A = rand(T, (N, N)) .- one(T) / 2
            v = rand(T, (N,))
            alg = Arnoldi(;
                krylovdim = 3 * n, maxiter = 20,
                tol = tolerance(T), eager = true, verbosity = SILENT_LEVEL
            )
            D1, V1, info1 = @constinferred eigsolve(
                wrapop(A, Val(mode)),
                wrapvec(v, Val(mode)), n, :SR, alg
            )
            D2, V2, info2 = eigsolve(
                wrapop(A, Val(mode)), wrapvec(v, Val(mode)), n, :LR,
                alg
            )
            D3, V3, info3 = eigsolve(
                wrapop(A, Val(mode)), wrapvec(v, Val(mode)), n, :LM,
                alg
            )
            D = sort(eigvals(A); by = imag, rev = true)

            l1 = info1.converged
            l2 = info2.converged
            l3 = info3.converged
            @test l1 > 0
            @test l2 > 0
            @test l3 > 0
            @test D1[1:l1] ≊ sort(D; alg = MergeSort, by = real)[1:l1]
            @test D2[1:l2] ≊ sort(D; alg = MergeSort, by = real, rev = true)[1:l2]
            # sorting by abs does not seem very reliable if two distinct eigenvalues are close
            # in absolute value, so we perform a second sort afterwards using the real part
            @test D3[1:l3] ≊ sort(D; by = abs, rev = true)[1:l3]

            U1 = stack(unwrapvec, V1)
            U2 = stack(unwrapvec, V2)
            U3 = stack(unwrapvec, V3)
            R1 = stack(unwrapvec, info1.residual)
            R2 = stack(unwrapvec, info2.residual)
            R3 = stack(unwrapvec, info3.residual)
            @test A * U1 ≈ U1 * Diagonal(D1) + R1
            @test A * U2 ≈ U2 * Diagonal(D2) + R2
            @test A * U3 ≈ U3 * Diagonal(D3) + R3

            if T <: Complex
                D1, V1, info1 = eigsolve(
                    wrapop(A, Val(mode)), wrapvec(v, Val(mode)), n,
                    :SI, alg
                )
                D2, V2, info2 = eigsolve(
                    wrapop(A, Val(mode)), wrapvec(v, Val(mode)), n,
                    :LI, alg
                )
                D = eigvals(A)

                l1 = info1.converged
                l2 = info2.converged
                @test l1 > 0
                @test l2 > 0
                @test D1[1:l1] ≈ sort(D; by = imag)[1:l1]
                @test D2[1:l2] ≈ sort(D; by = imag, rev = true)[1:l2]

                U1 = stack(unwrapvec, V1)
                U2 = stack(unwrapvec, V2)
                R1 = stack(unwrapvec, info1.residual)
                R2 = stack(unwrapvec, info2.residual)
                @test A * U1 ≈ U1 * Diagonal(D1) + R1
                @test A * U2 ≈ U2 * Diagonal(D2) + R2
            end
        end
    end
end

@testset "Arnoldi - realeigsolve iteratively ($mode)" for mode in
    (:vector, :inplace, :outplace)
    scalartypes = mode === :vector ? (Float32, Float64) : (Float64,)
    orths = mode === :vector ? (cgs2, mgs2, cgsr, mgsr) : (mgsr,)
    @testset for T in scalartypes
        @testset for orth in orths
            V = exp(randn(T, (N, N)) / 10)
            D = randn(T, N)
            A = V * Diagonal(D) / V
            v = rand(T, (N,))
            alg = Arnoldi(;
                krylovdim = 3 * n, maxiter = 20,
                tol = tolerance(T), eager = true, verbosity = SILENT_LEVEL
            )
            D1, V1, info1 = @constinferred realeigsolve(
                wrapop(A, Val(mode)),
                wrapvec(v, Val(mode)), n, :SR, alg
            )
            D2, V2, info2 = realeigsolve(
                wrapop(A, Val(mode)), wrapvec(v, Val(mode)), n,
                :LR,
                alg
            )
            D3, V3, info3 = realeigsolve(
                wrapop(A, Val(mode)), wrapvec(v, Val(mode)), n,
                :LM,
                alg
            )
            l1 = info1.converged
            l2 = info2.converged
            l3 = info3.converged
            @test l1 > 0
            @test l2 > 0
            @test l3 > 0
            @test D1[1:l1] ≊ sort(D; alg = MergeSort)[1:l1]
            @test D2[1:l2] ≊ sort(D; alg = MergeSort, rev = true)[1:l2]
            # sorting by abs does not seem very reliable if two distinct eigenvalues are close
            # in absolute value, so we perform a second sort afterwards using the real part
            @test D3[1:l3] ≊ sort(D; by = abs, rev = true)[1:l3]

            @test eltype(D1) == T
            @test eltype(D2) == T
            @test eltype(D3) == T

            U1 = stack(unwrapvec, V1)
            U2 = stack(unwrapvec, V2)
            U3 = stack(unwrapvec, V3)
            R1 = stack(unwrapvec, info1.residual)
            R2 = stack(unwrapvec, info2.residual)
            R3 = stack(unwrapvec, info3.residual)
            @test A * U1 ≈ U1 * Diagonal(D1) + R1
            @test A * U2 ≈ U2 * Diagonal(D2) + R2
            @test A * U3 ≈ U3 * Diagonal(D3) + R3

            if mode == :vector # solve eigenvalue problem as complex problem with real linear operator
                V = exp(randn(T, (2N, 2N)) / 10)
                D = randn(T, 2N)
                Ar = V * Diagonal(D) / V
                Z = zeros(T, N, N)
                J = [Z -I; I Z]
                Ar1 = (Ar - J * Ar * J) / 2
                Ar2 = (Ar + J * Ar * J) / 2
                A = complex.(Ar1[1:N, 1:N], -Ar1[1:N, (N + 1):end])
                B = complex.(Ar2[1:N, 1:N], +Ar2[1:N, (N + 1):end])
                f = buildrealmap(A, B)
                v = rand(complex(T), (N,))
                alg = Arnoldi(;
                    krylovdim = 3 * n, maxiter = 20,
                    tol = tolerance(T), eager = true, verbosity = SILENT_LEVEL
                )
                D1, V1, info1 = @constinferred realeigsolve(f, v, n, :SR, alg)
                D2, V2, info2 = realeigsolve(f, v, n, :LR, alg)
                D3, V3, info3 = realeigsolve(f, v, n, :LM, alg)

                l1 = info1.converged
                l2 = info2.converged
                l3 = info3.converged
                @test l1 > 0
                @test l2 > 0
                @test l3 > 0
                @test D1[1:l1] ≊ sort(D; alg = MergeSort)[1:l1]
                @test D2[1:l2] ≊ sort(D; alg = MergeSort, rev = true)[1:l2]
                # sorting by abs does not seem very reliable if two distinct eigenvalues are close
                # in absolute value, so we perform a second sort afterwards using the real part
                @test D3[1:l3] ≊ sort(D; by = abs, rev = true)[1:l3]

                @test eltype(D1) == T
                @test eltype(D2) == T
                @test eltype(D3) == T

                U1 = stack(V1)
                U2 = stack(V2)
                U3 = stack(V3)
                R1 = stack(info1.residual)
                R2 = stack(info2.residual)
                R3 = stack(info3.residual)
                @test A * U1 + B * conj(U1) ≈ U1 * Diagonal(D1) + R1
                @test A * U2 + B * conj(U2) ≈ U2 * Diagonal(D2) + R2
                @test A * U3 + B * conj(U3) ≈ U3 * Diagonal(D3) + R3
            end
        end
    end
end

@testset "Arnoldi - realeigsolve imaginary eigenvalue warning" begin
    A = diagm(vcat(1, 1, exp.(-(0.1:0.02:2))))
    A[2, 1] = 1.0e-9
    A[1, 2] = -1.0e-9
    v = ones(Float64, size(A, 1))
    @test_logs realeigsolve(A, v, 1, :LM, Arnoldi(; tol = 1.0e-8, verbosity = SILENT_LEVEL))
    @test_logs realeigsolve(A, v, 1, :LM, Arnoldi(; tol = 1.0e-8, verbosity = WARN_LEVEL))
    @test_logs (:info,) realeigsolve(
        A, v, 1, :LM,
        Arnoldi(; tol = 1.0e-8, verbosity = STARTSTOP_LEVEL)
    )
    @test_logs (:warn,) realeigsolve(
        A, v, 1, :LM,
        Arnoldi(; tol = 1.0e-10, verbosity = WARN_LEVEL)
    )
    @test_logs (:warn,) (:info,) realeigsolve(
        A, v, 1, :LM,
        Arnoldi(;
            tol = 1.0e-10,
            verbosity = STARTSTOP_LEVEL
        )
    )

    # this should not trigger a warning
    A[1, 2] = A[2, 1] = 0
    A[1, 1] = 1
    A[2, 2] = A[3, 3] = 0.99
    A[3, 2] = 1.0e-6
    A[2, 3] = -1.0e-6
    @test_logs realeigsolve(A, v, 1, :LM, Arnoldi(; tol = 1.0e-12, verbosity = SILENT_LEVEL))
    @test_logs realeigsolve(A, v, 1, :LM, Arnoldi(; tol = 1.0e-12, verbosity = WARN_LEVEL))
    @test_logs (:info,) realeigsolve(
        A, v, 1, :LM,
        Arnoldi(; tol = 1.0e-12, verbosity = STARTSTOP_LEVEL)
    )
end

@testset "BlockLanczos - eigsolve for large sparse matrix and map input" begin
    # There are 2 * m * n qubits and I choose to enumerate all the horizontal ones from 1:m*n
    # and all the vertical ones as (m*n+1):(2*m*n)
    function toric_code_strings(m::Int, n::Int)
        li = LinearIndices((m, n))
        bottom(i, j) = li[mod1(i, m), mod1(j, n)] + m * n
        right(i, j) = li[mod1(i, m), mod1(j, n)]
        xstrings = NTuple{4, Int}[]
        zstrings = NTuple{4, Int}[]
        for i in 1:m, j in 1:n
            # plaquette
            push!(xstrings, (bottom(i, j + 1), right(i, j), bottom(i, j), right(i - 1, j)))
            # vertex
            push!(zstrings, (right(i, j), bottom(i, j), right(i, j - 1), bottom(i + 1, j)))
        end
        return xstrings, zstrings
    end

    function pauli_kron(n::Int, ops::Pair{Int, Char}...)
        mat = sparse(1.0I, 2^n, 2^n)
        for (pos, op) in ops
            if op == 'X'
                σ = sparse([0 1; 1 0])
            elseif op == 'Y'
                σ = sparse([0 -im; im 0])
            elseif op == 'Z'
                σ = sparse([1 0; 0 -1])
            elseif op == 'I'
                σ = sparse(1.0I, 2, 2)
            else
                error("Unknown Pauli operator $op")
            end

            left = sparse(1.0I, 2^(pos - 1), 2^(pos - 1))
            right = sparse(1.0I, 2^(n - pos), 2^(n - pos))
            mat = kron(left, kron(σ, right)) * mat
        end
        return mat
    end

    # define the function to construct the Hamiltonian matrix
    function toric_code_hamiltonian_matrix(m::Int, n::Int)
        xstrings, zstrings = toric_code_strings(m, n)
        N = 2 * m * n  # total number of qubits

        # initialize the Hamiltonian matrix as a zero matrix
        H = spzeros(2^N, 2^N)

        # add the X-type operator terms
        for xs in xstrings[1:(end - 1)]
            H += pauli_kron(N, (i => 'X' for i in xs)...)
        end

        for zs in zstrings[1:(end - 1)]
            H += pauli_kron(N, (i => 'Z' for i in zs)...)
        end

        return H
    end

    sites_num = 3
    p = 5 # block size
    M = 2^(2 * sites_num^2)
    x₀ = Block([rand(M) for _ in 1:p])
    get_value_num = 10
    tol = 1.0e-6
    h_mat = toric_code_hamiltonian_matrix(sites_num, sites_num)

    # matrix input
    alg = BlockLanczos(; tol = tol, maxiter = 1)
    D, U, info = eigsolve(-h_mat, x₀, get_value_num, :SR, alg)
    @test count(x -> abs(x + 16.0) < 2.0 - tol, D[1:get_value_num]) == 4
    @test count(x -> abs(x + 16.0) < tol, D[1:get_value_num]) == 4

    # map input
    D, U, info = eigsolve(x -> -h_mat * x, x₀, get_value_num, :SR, alg)
    @test count(x -> abs(x + 16.0) < 1.9, D[1:get_value_num]) == 4
    @test count(x -> abs(x + 16.0) < 1.0e-8, D[1:get_value_num]) == 4
end

# For user interface, input is a block.
@testset "BlockLanczos - eigsolve full $mode" for mode in (:vector, :inplace, :outplace)
    scalartypes = mode === :vector ? (Float32, Float64, ComplexF32, ComplexF64) :
        (ComplexF64,)
    @testset for T in scalartypes
        block_size = 2
        A = mat_with_eigrepition(T, n, block_size)
        x₀ = Block([wrapvec(rand(T, n), Val(mode)) for _ in 1:block_size])
        n1 = div(n, 2)  # eigenvalues to solve
        eigvalsA = eigvals(A)
        alg = BlockLanczos(;
            krylovdim = n, maxiter = 1, tol = tolerance(T),
            verbosity = STARTSTOP_LEVEL
        )
        D1, V1, info = @test_logs (:info,) eigsolve(
            wrapop(A, Val(mode)),
            x₀, n1, :SR, alg
        )
        alg = BlockLanczos(;
            krylovdim = n, maxiter = 1, tol = tolerance(T),
            verbosity = WARN_LEVEL
        )
        @test_logs eigsolve(wrapop(A, Val(mode)), x₀, n1, :SR, alg)
        alg = BlockLanczos(;
            krylovdim = n1 + 1, maxiter = 1, tol = tolerance(T),
            verbosity = WARN_LEVEL
        )
        @test_logs (:warn,) eigsolve(wrapop(A, Val(mode)), x₀, n1, :SR, alg)
        alg = BlockLanczos(;
            krylovdim = n, maxiter = 1, tol = tolerance(T),
            verbosity = STARTSTOP_LEVEL
        )
        @test_logs (:info,) eigsolve(wrapop(A, Val(mode)), x₀, n1, :SR, alg)
        alg = BlockLanczos(;
            krylovdim = 3, maxiter = 3, tol = tolerance(T),
            verbosity = EACHITERATION_LEVEL
        )
        @test_logs(
            (:info,), (:info,), (:info,), (:warn,),
            eigsolve(wrapop(A, Val(mode)), x₀, 1, :SR, alg)
        )
        alg = BlockLanczos(;
            krylovdim = 4, maxiter = 1, tol = tolerance(T),
            verbosity = EACHITERATION_LEVEL + 1
        )
        @test_logs(
            (:info,), (:info,), (:info,), (:warn,),
            eigsolve(wrapop(A, Val(mode)), x₀, 1, :SR, alg)
        )
        n2 = n - n1
        alg = BlockLanczos(; krylovdim = 2 * n, maxiter = 4, tol = tolerance(T))
        D2, V2, info = eigsolve(wrapop(A, Val(mode)), x₀, n2, :LR, alg)
        @test vcat(D1[1:n1], reverse(D2[1:n2])) ≊ eigvalsA

        U1 = hcat(unwrapvec.(V1)...)
        U2 = hcat(unwrapvec.(V2)...)

        @test U1' * U1 ≈ I
        @test U2' * U2 ≈ I

        @test (x -> KrylovKit.apply(A, x)).(unwrapvec.(V1)) ≈ D1 .* unwrapvec.(V1)
        @test (x -> KrylovKit.apply(A, x)).(unwrapvec.(V2)) ≈ D2 .* unwrapvec.(V2)

        alg = BlockLanczos(;
            krylovdim = 2n, maxiter = 1, tol = tolerance(T),
            verbosity = WARN_LEVEL
        )
        @test_logs (:warn,) (:warn,) eigsolve(wrapop(A, Val(mode)), x₀, n + 1, :LM, alg)
    end
end

@testset "BlockLanczos - eigsolve iteratively $mode" for mode in
    (:vector, :inplace, :outplace)
    scalartypes = mode === :vector ? (Float32, Float64, ComplexF32, ComplexF64) :
        (ComplexF64,)
    @testset for T in scalartypes
        block_size = 4
        A = mat_with_eigrepition(T, N, block_size)
        x₀ = Block([wrapvec(rand(T, N), Val(mode)) for _ in 1:block_size])
        eigvalsA = eigvals(A)

        alg = BlockLanczos(;
            krylovdim = N, maxiter = 10, tol = tolerance(T),
            eager = true, verbosity = SILENT_LEVEL
        )
        D1, V1, info1 = eigsolve(wrapop(A, Val(mode)), x₀, n, :SR, alg)
        D2, V2, info2 = eigsolve(wrapop(A, Val(mode)), x₀, n, :LR, alg)

        l1 = info1.converged
        l2 = info2.converged

        @test l1 > 0
        @test l2 > 0
        @test D1[1:n] ≈ eigvalsA[1:n]
        @test D2[1:n] ≈ eigvalsA[N:-1:(N - n + 1)]

        U1 = hcat(unwrapvec.(V1[1:l1])...)
        U2 = hcat(unwrapvec.(V2[1:l2])...)
        R1 = hcat(unwrapvec.(info1.residual[1:l1])...)
        R2 = hcat(unwrapvec.(info2.residual[1:l2])...)

        @test U1' * U1 ≈ I
        @test U2' * U2 ≈ I
        @test hcat([KrylovKit.apply(A, U1[:, i]) for i in 1:l1]...) ≈
            U1 * Diagonal(D1) + R1
        @test hcat([KrylovKit.apply(A, U2[:, i]) for i in 1:l2]...) ≈
            U2 * Diagonal(D2) + R2
    end
end

@testset "BlockLanczos - eigsolve for abstract type" begin
    T = ComplexF64
    block_size = 2
    H = mat_with_eigrepition(T, n, block_size)
    H = H' * H + I
    eig_num = 2
    Hip(x::Vector, y::Vector) = x' * H * y
    x₀ = Block([InnerProductVec(rand(T, n), Hip) for _ in 1:block_size])
    Aip(x::InnerProductVec) = InnerProductVec(H * x.vec, Hip)
    D, V, info = eigsolve(
        Aip, x₀, eig_num, :SR,
        BlockLanczos(;
            krylovdim = n, maxiter = 1, tol = tolerance(T),
            verbosity = SILENT_LEVEL
        )
    )
    D_true = eigvals(H)
    BlockV = KrylovKit.Block(V)
    @test D[1:eig_num] ≈ D_true[1:eig_num]
    @test KrylovKit.block_inner(BlockV, BlockV) ≈ I
    @test findmax([norm(Aip(V[i]) - D[i] * V[i]) for i in 1:eig_num])[1] < tolerance(T)
end

# with the same krylovdim, BlockLanczos has lower accuracy with the size of block larger than 1.
@testset "Compare Lanczos and BlockLanczos $mode" for mode in
    (:vector, :inplace, :outplace)
    scalartypes = mode === :vector ? (Float32, Float64, ComplexF32, ComplexF64) :
        (ComplexF64,)
    @testset for T in scalartypes
        A = rand(T, (2N, 2N)) .- one(T) / 2
        A = (A + A') / 2
        block_size = 1
        x₀_block = Block([wrapvec(rand(T, 2N), Val(mode)) for _ in 1:block_size])
        x₀_lanczos = x₀_block[1]
        alg1 = Lanczos(;
            krylovdim = 2n, maxiter = 10, tol = tolerance(T),
            verbosity = SILENT_LEVEL
        )
        alg2 = BlockLanczos(;
            krylovdim = 2n, maxiter = 10, tol = tolerance(T),
            verbosity = SILENT_LEVEL
        )
        evals1, _, info1 = eigsolve(wrapop(A, Val(mode)), x₀_lanczos, n, :SR, alg1)
        evals2, _, info2 = eigsolve(wrapop(A, Val(mode)), x₀_block, n, :SR, alg2)
        @test info1.converged == info2.converged
        @test info1.numiter == info2.numiter
        @test info1.numops + 1 == info2.numops # one extra operation for the BlockLanczos initialization
        @test isapprox(info1.normres, info2.normres, atol = tolerance(T))
        @test isapprox(
            unwrapvec.(info1.residual[1:(info1.converged)])[2],
            unwrapvec.(info2.residual[1:(info2.converged)])[2];
            atol = tolerance(T)
        )
        @test evals1[1:(info1.converged)] ≈ evals2[1:(info2.converged)]
    end
    @testset for T in (Float64, ComplexF64)
        A = rand(T, (2N, 2N)) .- one(T) / 2
        A = (A + A') / 2
        block_size = 2
        x₀_block = Block([wrapvec(rand(T, 2N), Val(mode)) for _ in 1:block_size])
        x₀ = rand(T, 2N) # Lanczos input
        x₁ = A^n * x₀ # effectively build the same Krylov subspace in `BlockLanczos`
        x₀_lanczos = wrapvec(x₀, Val(mode))
        x₀_block = Block([wrapvec(x₀, Val(mode)), wrapvec(x₁, Val(mode))])
        alg1 = Lanczos(;
            krylovdim = 2n, maxiter = 1, tol = tolerance(T),
            verbosity = SILENT_LEVEL
        )
        alg2 = BlockLanczos(;
            krylovdim = 2n, maxiter = 1, tol = tolerance(T),
            verbosity = SILENT_LEVEL
        )
        vals1, vecs1, info1 = eigsolve(wrapop(A, Val(mode)), x₀_lanczos, n, :SR, alg1)
        vals2, vecs2, info2 = eigsolve(wrapop(A, Val(mode)), x₀_block, n, :SR, alg2)
        @test vals1 ≈ vals2
        @test all(abs.(inner.(vecs1, vecs2)) .≈ 1)
        @test info1.normres ≈ info2.normres
    end
end

# Test effectiveness of shrink!() in BlockLanczos
@testset "Test effectiveness of shrink!() in BlockLanczos $mode" for mode in
    (
        :vector, :inplace,
        :outplace,
    )
    scalartypes = mode === :vector ? (Float32, Float64, ComplexF32, ComplexF64) :
        (ComplexF64,)
    @testset for T in scalartypes
        block_size = 5
        A = mat_with_eigrepition(T, N, block_size)
        x₀ = Block([wrapvec(rand(T, N), Val(mode)) for _ in 1:block_size])
        values0 = eigvals(A)[1:n]
        n1 = n ÷ 2
        alg = BlockLanczos(;
            krylovdim = 3 * n ÷ 2, maxiter = 1, tol = 1.0e-12,
            verbosity = SILENT_LEVEL
        )
        values, _, _ = eigsolve(wrapop(A, Val(mode)), x₀, n, :SR, alg)
        error1 = norm(values[1:n1] - values0[1:n1])
        alg_shrink = BlockLanczos(;
            krylovdim = 3 * n ÷ 2, maxiter = 2, tol = 1.0e-12,
            verbosity = SILENT_LEVEL
        )
        values_shrink, _, _ = eigsolve(wrapop(A, Val(mode)), x₀, n, :SR, alg_shrink)
        error2 = norm(values_shrink[1:n1] - values0[1:n1])
        @test error2 < error1
    end
end

@testset "BlockLanczos - eigsolve without alg $mode" for mode in
    (:vector, :inplace, :outplace)
    scalartypes = mode === :vector ? (Float32, Float64, ComplexF32, ComplexF64) :
        (ComplexF64,)
    @testset for T in scalartypes
        block_size = 2
        A = mat_with_eigrepition(T, n, block_size)
        x₀ = Block([wrapvec(rand(T, n), Val(mode)) for _ in 1:block_size])
        if mode === :vector
            D1, V1, info1 = eigsolve(wrapop(A, Val(mode)), x₀, 1, :SR)
            @test info1.converged >= 1
            eigA = eigvals(A)
            @test D1[1] ≈ eigA[1]
            D2, V2, info2 = eigsolve(wrapop(A, Val(mode)), x₀)
            @test info1.converged >= 1
            @test D2[1] ≈ (abs(eigA[1]) > abs(eigA[end]) ? eigA[1] : eigA[end])
            @test_throws ErrorException eigsolve(wrapop(A, Val(mode)), x₀, 1, :LI)
            B = copy(A)
            B[1, 2] += T(1) # error for non-symmetric/hermitian operator
            @test_throws ErrorException eigsolve(wrapop(B, Val(mode)), x₀, 1, :SR)
        else
            @test_throws ErrorException eigsolve(wrapop(A, Val(mode)), x₀, 1, :SR)
        end
    end
end

using Documenter
using KrylovKit

makedocs(;
    modules = [KrylovKit],
    sitename = "KrylovKit.jl",
    authors = "Jutho Haegeman and collaborators",
    pages = [
        "Home" => "index.md",
        "Manual" => [
            "man/intro.md",
            "man/linear.md",
            "man/leastsquares.md",
            "man/eig.md",
            "man/svd.md",
            "man/matfun.md",
            "man/reallinear.md",
            "man/algorithms.md",
            "man/implementation.md",
        ],
    ],
    format = Documenter.HTML(; prettyurls = get(ENV, "CI", nothing) == "true")
)

deploydocs(; repo = "github.com/Jutho/KrylovKit.jl.git")

using Random
Random.seed!(76543210)

using Test, TestExtras, Logging
using LinearAlgebra, SparseArrays
using KrylovKit
using KrylovKit: SILENT_LEVEL, WARN_LEVEL, STARTSTOP_LEVEL, EACHITERATION_LEVEL
using VectorInterface

include("testsetup.jl")
using ..TestSetup

# Parameters
# ----------
const n = 10
const N = 100

const η₀ = 0.75 # seems to be necessary to get sufficient convergence for GKL iteration with Float32 precision
const cgs = ClassicalGramSchmidt()
const mgs = ModifiedGramSchmidt()
const cgs2 = ClassicalGramSchmidt2()
const mgs2 = ModifiedGramSchmidt2()
const cgsr = ClassicalGramSchmidtIR(η₀)
const mgsr = ModifiedGramSchmidtIR(η₀)

# Tests
# -----
t = time()
@testset "Krylov factorisations" verbose = true begin
    include("factorize.jl")
end
@testset "Linear problems with linsolve" verbose = true begin
    include("linsolve.jl")
end
@testset "Least squares problems with lssolve" verbose = true begin
    include("lssolve.jl")
end
@testset "Eigenvalue problems with eigsolve" verbose = true begin
    include("eigsolve.jl")
    include("schursolve.jl")
    include("geneigsolve.jl")
end
@testset "Biorthogonal eigenvalue problems with bieigsolve" verbose = true begin
    include("bieigsolve.jl")
end
@testset "Singular value problems with svdsolve" verbose = true begin
    include("svdsolve.jl")
end
@testset "Exponentiate and exponential integrator" verbose = true begin
    include("expintegrator.jl")
end
@testset "Linear Algebra Utilities" verbose = true begin
    include("linalg.jl")
end
@testset "Singular value problems via eigsolve with nested tuples" verbose = true begin
    include("nestedtuple.jl")
end

@testset "Linsolve differentiation rules" verbose = true begin
    include("ad/linsolve.jl")
end
@testset "Eigsolve differentiation rules" verbose = true begin
    include("ad/eigsolve.jl")
    include("ad/repeatedeigsolve.jl")
end
@testset "Svdsolve differentiation rules" verbose = true begin
    include("ad/svdsolve.jl")
end
@testset "block" verbose = true begin
    include("block.jl")
end
t = time() - t

# Issues
# ------
@testset "Known issues" verbose = true begin
    include("issues.jl")
end
println("Tests finished in $t seconds")

module AquaTests
    using KrylovKit
    using Aqua
    Aqua.test_all(KrylovKit; ambiguities = false)
    # treat ambiguities special because of ambiguities between ChainRulesCore and Base
    Aqua.test_ambiguities([KrylovKit, Base, Core]; exclude = [Base.:(==)])

end

"""
    mutable struct ArnoldiFactorization{T,S} <: KrylovFactorization{T,S}

Structure to store an Arnoldi factorization of a linear map `A` of the form

```julia
A * V = V * B + r * b'
```

For a given Arnoldi factorization `fact` of length `k = length(fact)`, the basis `V` is
obtained via [`basis(fact)`](@ref basis) and is an instance of [`OrthonormalBasis{T}`](@ref
Basis), with also `length(V) == k` and where `T` denotes the type of vector like objects
used in the problem. The Rayleigh quotient `B` is obtained as
[`rayleighquotient(fact)`](@ref) and is of type [`B::PackedHessenberg{S<:Number}`](@ref
PackedHessenberg) with `size(B) == (k,k)`. The residual `r` is obtained as
[`residual(fact)`](@ref) and is of type `T`. One can also query [`normres(fact)`](@ref) to
obtain `norm(r)`, the norm of the residual. The vector `b` has no dedicated name but can be
obtained via [`rayleighextension(fact)`](@ref). It takes the default value ``e_k``, i.e. the
unit vector of all zeros and a one in the last entry, which is represented using
[`SimpleBasisVector`](@ref).

An Arnoldi factorization `fact` can be destructured as `V, B, r, nr, b = fact` with
`nr = norm(r)`.

`ArnoldiFactorization` is mutable because it can [`expand!`](@ref) or [`shrink!`](@ref).
See also [`ArnoldiIterator`](@ref) for an iterator that constructs a progressively expanding
Arnoldi factorizations of a given linear map and a starting vector. See
[`LanczosFactorization`](@ref) and [`LanczosIterator`](@ref) for a Krylov factorization that
is optimized for real symmetric or complex hermitian linear maps.
"""
mutable struct ArnoldiFactorization{T, S} <: KrylovFactorization{T, S}
    k::Int # current Krylov dimension
    V::OrthonormalBasis{T} # basis of length k
    H::Vector{S} # stores the Hessenberg matrix in packed form
    r::T # residual
end

Base.length(F::ArnoldiFactorization) = F.k
Base.sizehint!(F::ArnoldiFactorization, n) = begin
    sizehint!(F.V, n)
    sizehint!(F.H, (n * n + 3 * n) >> 1)
    return F
end
Base.eltype(F::ArnoldiFactorization) = eltype(typeof(F))
Base.eltype(::Type{<:ArnoldiFactorization{<:Any, S}}) where {S} = S

basis(F::ArnoldiFactorization) = F.V
rayleighquotient(F::ArnoldiFactorization) = PackedHessenberg(F.H, F.k)
residual(F::ArnoldiFactorization) = F.r
@inbounds normres(F::ArnoldiFactorization) = abs(F.H[end])
rayleighextension(F::ArnoldiFactorization) = SimpleBasisVector(F.k, F.k)

# Arnoldi iteration for constructing the orthonormal basis of a Krylov subspace.
"""
    struct ArnoldiIterator{F,T,O<:Orthogonalizer} <: KrylovIterator{F,T}
    ArnoldiIterator(f, v₀, [orth::Orthogonalizer = KrylovDefaults.orth])

Iterator that takes a general linear map `f::F` and an initial vector `v₀::T` and generates
an expanding `ArnoldiFactorization` thereof. In particular, `ArnoldiIterator` iterates over
progressively expanding Arnoldi factorizations using the
[Arnoldi iteration](https://en.wikipedia.org/wiki/Arnoldi_iteration).

The argument `f` can be a matrix, or a function accepting a single argument `v`, so that
`f(v)` implements the action of the linear map on the vector `v`.

The optional argument `orth` specifies which [`Orthogonalizer`](@ref) to be used. The
default value in [`KrylovDefaults`](@ref) is to use [`ModifiedGramSchmidtIR`](@ref), which
possibly uses reorthogonalization steps.

When iterating over an instance of `ArnoldiIterator`, the values being generated are
instances of [`ArnoldiFactorization`](@ref), which can be immediately destructured into a
[`basis`](@ref), [`rayleighquotient`](@ref), [`residual`](@ref), [`normres`](@ref) and
[`rayleighextension`](@ref), for example as

```julia
for (V, B, r, nr, b) in ArnoldiIterator(f, v₀)
    # do something
    nr < tol && break # a typical stopping criterion
end
```

Since the iterator does not know the dimension of the underlying vector space of
objects of type `T`, it keeps expanding the Krylov subspace until the residual norm `nr`
falls below machine precision `eps(typeof(nr))`.

The internal state of `ArnoldiIterator` is the same as the return value, i.e. the
corresponding `ArnoldiFactorization`. However, as Julia's Base iteration interface (using
`Base.iterate`) requires that the state is not mutated, a `deepcopy` is produced upon every
next iteration step.

Instead, you can also mutate the `ArnoldiFactorization` in place, using the following
interface, e.g. for the same example above

```julia
iterator = ArnoldiIterator(f, v₀)
factorization = initialize(iterator)
while normres(factorization) > tol
    expand!(iterator, factorization)
    V, B, r, nr, b = factorization
    # do something
end
```

Here, [`initialize(::KrylovIterator)`](@ref) produces the first Krylov factorization of
length 1, and `expand!(::KrylovIterator, ::KrylovFactorization)`(@ref) expands the
factorization in place. See also [`initialize!(::KrylovIterator,
::KrylovFactorization)`](@ref) to initialize in an already existing factorization (most
information will be discarded) and [`shrink!(::KrylovFactorization, k)`](@ref) to shrink an
existing factorization down to length `k`.
"""
struct ArnoldiIterator{F, T, O <: Orthogonalizer} <: KrylovIterator{F, T}
    operator::F
    x₀::T
    orth::O
end
ArnoldiIterator(A, x₀) = ArnoldiIterator(A, x₀, KrylovDefaults.orth)

Base.IteratorSize(::Type{<:ArnoldiIterator}) = Base.SizeUnknown()
Base.IteratorEltype(::Type{<:ArnoldiIterator}) = Base.EltypeUnknown()

function Base.iterate(iter::ArnoldiIterator)
    state = initialize(iter)
    return state, state
end
function Base.iterate(iter::ArnoldiIterator, state)
    nr = normres(state)
    if nr < eps(typeof(nr))
        return nothing
    else
        state = expand!(iter, deepcopy(state))
        return state, state
    end
end

function initialize(iter::ArnoldiIterator; verbosity::Int = KrylovDefaults.verbosity[])
    # initialize without using eltype
    x₀ = iter.x₀
    β₀ = norm(x₀)
    iszero(β₀) && throw(ArgumentError("initial vector should not have norm zero"))
    Ax₀ = apply(iter.operator, x₀)
    α = inner(x₀, Ax₀) / (β₀ * β₀)
    T = typeof(α) # scalar type of the Rayleigh quotient
    # this line determines the vector type that we will henceforth use
    # vector scalar type can be different from `T`, e.g. for real inner products
    v = add!!(scale(Ax₀, zero(α)), x₀, 1 / β₀)
    if typeof(Ax₀) != typeof(v)
        r = add!!(zerovector(v), Ax₀, 1 / β₀)
    else
        r = scale!!(Ax₀, 1 / β₀)
    end
    βold = norm(r)
    r = add!!(r, v, -α)
    β = norm(r)
    # possibly reorthogonalize
    if iter.orth isa Union{ClassicalGramSchmidt2, ModifiedGramSchmidt2}
        dα = inner(v, r)
        α += dα
        r = add!!(r, v, -dα)
        β = norm(r)
    elseif iter.orth isa Union{ClassicalGramSchmidtIR, ModifiedGramSchmidtIR}
        while eps(one(β)) < β < iter.orth.η * βold
            βold = β
            dα = inner(v, r)
            α += dα
            r = add!!(r, v, -dα)
            β = norm(r)
        end
    end
    V = OrthonormalBasis([v])
    H = T[α, β]
    if verbosity > EACHITERATION_LEVEL
        @info "Arnoldi initiation at dimension 1: subspace normres = $(normres2string(β))"
    end
    return state = ArnoldiFactorization(1, V, H, r)
end
function initialize!(
        iter::ArnoldiIterator, state::ArnoldiFactorization;
        verbosity::Int = KrylovDefaults.verbosity[]
    )
    x₀ = iter.x₀
    V = state.V
    while length(V) > 1
        pop!(V)
    end
    H = empty!(state.H)

    V[1] = scale!!(V[1], x₀, 1 / norm(x₀))
    w = apply(iter.operator, V[1])
    r, α = orthogonalize!!(w, V[1], iter.orth)
    β = norm(r)
    state.k = 1
    push!(H, α, β)
    state.r = r
    if verbosity > EACHITERATION_LEVEL
        @info "Arnoldi initiation at dimension 1: subspace normres = $(normres2string(β))"
    end
    return state
end
function expand!(
        iter::ArnoldiIterator, state::ArnoldiFactorization;
        verbosity::Int = KrylovDefaults.verbosity[]
    )
    state.k += 1
    k = state.k
    V = state.V
    H = state.H
    r = state.r
    β = normres(state)
    push!(V, scale(r, 1 / β))
    m = length(H)
    resize!(H, m + k + 1)
    r, β = arnoldirecurrence!!(iter.operator, V, view(H, (m + 1):(m + k)), iter.orth)
    H[m + k + 1] = β
    state.r = r
    if verbosity > EACHITERATION_LEVEL
        @info "Arnoldi expansion to dimension $k: subspace normres = $(normres2string(β))"
    end
    return state
end
function shrink!(state::ArnoldiFactorization, k; verbosity::Int = KrylovDefaults.verbosity[])
    length(state) <= k && return state
    V = state.V
    H = state.H
    while length(V) > k + 1
        pop!(V)
    end
    r = pop!(V)
    resize!(H, (k * k + 3 * k) >> 1)
    state.k = k
    β = normres(state)
    if verbosity > EACHITERATION_LEVEL
        @info "Arnoldi reduction to dimension $k: subspace normres = $(normres2string(β))"
    end
    state.r = scale!!(r, β)
    return state
end

# Arnoldi recurrence: simply use provided orthonormalization routines
function arnoldirecurrence!!(
        operator, V::OrthonormalBasis, h::AbstractVector, orth::Orthogonalizer
    )
    w = apply(operator, last(V))
    r, h = orthogonalize!!(w, V, h, orth)
    return r, norm(r)
end

function ϕ(A, v, p)
    m = LinearAlgebra.checksquare(A)
    length(v) == m ||
        throw(DimensionMismatch("second dimension of A, $m, does not match length of x, $(length(v))"))
    p == 0 && return exp(A) * v
    A′ = fill!(similar(A, m + p, m + p), 0)
    copyto!(view(A′, 1:m, 1:m), A)
    copyto!(view(A′, 1:m, m + 1), v)
    for k in 1:(p - 1)
        A′[m + k, m + k + 1] = 1
    end
    return exp(A′)[1:m, end]
end

@testset "Lanczos - expintegrator full ($mode)" for mode in (:vector, :inplace, :outplace)
    scalartypes = mode === :vector ? (Float32, Float64, ComplexF32, ComplexF64) :
        (ComplexF64,)
    orths = mode === :vector ? (cgs2, mgs2, cgsr, mgsr) : (mgsr,)
    @testset for T in scalartypes
        @testset for orth in orths
            A = rand(T, (n, n)) .- one(T) / 2
            A = (A + A') / 2
            V = one(A)
            W = zero(A)
            alg = Lanczos(;
                orth = orth, krylovdim = n, maxiter = 2, tol = tolerance(T),
                verbosity = STARTSTOP_LEVEL
            )
            for k in 1:n
                w, = @test_logs (:info,) exponentiate(
                    wrapop(A, Val(mode)), 1,
                    wrapvec(
                        view(V, :, k),
                        Val(mode)
                    ), alg
                )
                W[:, k] = unwrapvec(w)
            end
            @test W ≈ exp(A)

            pmax = 5
            alg = Lanczos(;
                orth = orth, krylovdim = n, maxiter = 2, tol = tolerance(T),
                verbosity = SILENT_LEVEL
            )
            for t in (
                    rand(real(T)), -rand(real(T)), im * randn(real(T)),
                    randn(real(T)) + im * randn(real(T)),
                )
                for p in 1:pmax
                    u = ntuple(i -> rand(T, n), p + 1)
                    w, info = @constinferred expintegrator(
                        wrapop(A, Val(mode)), t,
                        wrapvec.(u, Ref(Val(mode))), alg
                    )
                    w2 = exp(t * A) * u[1]
                    for j in 1:p
                        w2 .+= t^j * ϕ(t * A, u[j + 1], j)
                    end
                    @test info.converged > 0
                    @test w2 ≈ unwrapvec(w)
                end
            end
        end
    end
end

@testset "Arnoldi - expintegrator full ($mode)" for mode in (:vector, :inplace, :outplace)
    scalartypes = mode === :vector ? (Float32, Float64, ComplexF32, ComplexF64) :
        (ComplexF64,)
    orths = mode === :vector ? (cgs2, mgs2, cgsr, mgsr) : (mgsr,)
    @testset for T in scalartypes
        @testset for orth in orths
            A = rand(T, (n, n)) .- one(T) / 2
            V = one(A)
            W = zero(A)
            alg = Arnoldi(;
                orth = orth, krylovdim = n, maxiter = 2, tol = tolerance(T),
                verbosity = STARTSTOP_LEVEL
            )
            for k in 1:n
                w, = @test_logs (:info,) exponentiate(
                    wrapop(A, Val(mode)), 1,
                    wrapvec(
                        view(V, :, k),
                        Val(mode)
                    ), alg
                )
                W[:, k] = unwrapvec(w)
            end
            @test W ≈ exp(A)

            pmax = 5
            alg = Arnoldi(;
                orth = orth, krylovdim = n, maxiter = 2, tol = tolerance(T),
                verbosity = SILENT_LEVEL
            )
            for t in (
                    rand(real(T)), -rand(real(T)), im * randn(real(T)),
                    randn(real(T)) + im * randn(real(T)),
                )
                for p in 1:pmax
                    u = ntuple(i -> rand(T, n), p + 1)
                    w, info = @constinferred expintegrator(
                        wrapop(A, Val(mode)), t,
                        wrapvec.(u, Ref(Val(mode))), alg
                    )
                    w2 = exp(t * A) * u[1]
                    for j in 1:p
                        w2 .+= t^j * ϕ(t * A, u[j + 1], j)
                    end
                    @test info.converged > 0
                    @test w2 ≈ unwrapvec(w)
                end
            end
        end
    end
end

@testset "Lanczos - expintegrator iteratively ($mode)" for mode in
    (:vector, :inplace, :outplace)
    scalartypes = mode === :vector ? (Float32, Float64, ComplexF32, ComplexF64) :
        (ComplexF64,)
    orths = mode === :vector ? (cgs2, mgs2, cgsr, mgsr) : (mgsr,)
    @testset for T in scalartypes
        @testset for orth in orths
            A = (1 // 2) .* (rand(T, (N, N)) .- one(T) / 2)
            A = (A + A') / 2
            pmax = 5
            for t in (
                    rand(real(T)), -rand(real(T)), im * randn(real(T)),
                    randn(real(T)) + im * randn(real(T)),
                )
                for p in 1:pmax
                    u = ntuple(i -> rand(T, N), p + 1)
                    w1, info = @constinferred expintegrator(
                        wrapop(A, Val(mode)), t,
                        wrapvec.(u, Ref(Val(mode)))...;
                        maxiter = 100, krylovdim = n,
                        eager = true
                    )
                    @test info.converged > 0
                    w2 = exp(t * A) * u[1]
                    for j in 1:p
                        w2 .+= t^j * ϕ(t * A, u[j + 1], j)
                    end
                    @test w2 ≈ unwrapvec(w1)
                    w1, info = @constinferred expintegrator(
                        wrapop(A, Val(mode)), t,
                        wrapvec.(u, Ref(Val(mode)))...;
                        maxiter = 100, krylovdim = n,
                        tol = 1.0e-3, eager = true
                    )
                    @test unwrapvec(w1) ≈ w2 atol = 1.0e-2 * abs(t)
                end
            end
        end
    end
end

@testset "Arnoldi - expintegrator iteratively ($mode)" for mode in
    (:vector, :inplace, :outplace)
    scalartypes = mode === :vector ? (Float32, Float64, ComplexF32, ComplexF64) :
        (ComplexF64,)
    orths = mode === :vector ? (cgs2, mgs2, cgsr, mgsr) : (mgsr,)
    @testset for T in scalartypes
        @testset for orth in orths
            A = (1 // 2) .* (rand(T, (N, N)) .- one(T) / 2)
            pmax = 5
            for t in (
                    rand(real(T)), -rand(real(T)), im * randn(real(T)),
                    randn(real(T)) + im * randn(real(T)),
                )
                for p in 1:pmax
                    u = ntuple(i -> rand(T, N), p + 1)
                    w1, info = @constinferred expintegrator(
                        wrapop(A, Val(mode)), t,
                        wrapvec.(u, Ref(Val(mode)))...;
                        maxiter = 100, krylovdim = n,
                        eager = true
                    )
                    @test info.converged > 0
                    w2 = exp(t * A) * u[1]
                    for j in 1:p
                        w2 .+= t^j * ϕ(t * A, u[j + 1], j)
                    end
                end
            end
        end
    end
end

@testset "Arnoldi - expintegrator fixed point branch" begin
    @testset for T in (ComplexF32, ComplexF64) # less probable that :LR eig is repeated
        A = rand(T, (N, N)) / 10
        v₀ = rand(T, N)
        λs, vs, infoR = eigsolve(A, v₀, 1, :LR)
        @test infoR.converged > 0
        r = vs[1]
        A = A - λs[1] * I
        λs, vs, infoL = eigsolve(A', v₀, 1, :LR)
        @test infoL.converged > 0
        l = vs[1]
        w1, info1 = expintegrator(A, 1000.0, v₀)
        @test info1.converged > 0
        @test abs(dot(r, w1)) / norm(r) / norm(w1) ≈ 1 atol = 1.0e-4
        v₁ = rand(T, N)
        v₁ -= r * dot(l, v₁) / dot(l, r)
        w2, info2 = expintegrator(A, 1000.0, v₀, v₁)
        @test info2.converged > 0
        @test A * w2 ≈ -v₁
    end
end

# Test LSMR complete
@testset "LSMR small problem ($mode)" for mode in (:vector, :inplace, :outplace, :mixed)
    scalartypes = mode === :vector ? (Float32, Float64, ComplexF32, ComplexF64) :
        (ComplexF64,)
    @testset for T in scalartypes
        A = rand(T, (2 * n, n))
        U, S, V = svd(A)
        invS = 1 ./ S
        S[end] = 0 # make rank deficient
        invS[end] = 0 # choose minimal norm solution
        A = U * Diagonal(S) * V'

        b = rand(T, 2 * n)
        tol = tol = 10 * n * eps(real(T))
        x, info = @constinferred lssolve(
            wrapop(A, Val(mode)), wrapvec(b, Val(mode));
            maxiter = 3, krylovdim = 1, verbosity = SILENT_LEVEL
        ) # no reorthogonalization
        r = b - A * unwrapvec(x)
        @test unwrapvec(info.residual) ≈ r
        @test info.normres ≈ norm(A' * r)
        @test info.converged == 0
        @test_logs lssolve(
            wrapop(A, Val(mode)), wrapvec(b, Val(mode)); maxiter = 3,
            verbosity = SILENT_LEVEL
        )
        @test_logs (:warn,) lssolve(
            wrapop(A, Val(mode)), wrapvec(b, Val(mode)); maxiter = 3,
            verbosity = WARN_LEVEL
        )
        @test_logs (:info,) (:warn,) lssolve(
            wrapop(A, Val(mode)), wrapvec(b, Val(mode));
            maxiter = 3, verbosity = STARTSTOP_LEVEL
        )

        alg = LSMR(; maxiter = n, tol = tol, verbosity = SILENT_LEVEL, krylovdim = n)
        # reorthogonalisation is essential here to converge in exactly n iterations
        x, info = @constinferred lssolve(wrapop(A, Val(mode)), wrapvec(b, Val(mode)), alg)

        @test info.converged > 0
        @test abs(inner(V[:, end], unwrapvec(x))) < alg.tol
        @test unwrapvec(x) ≈ V * Diagonal(invS) * U' * b
        @test_logs lssolve(wrapop(A, Val(mode)), wrapvec(b, Val(mode)), alg)
        alg = LSMR(; maxiter = 2 * n, tol = tol, verbosity = WARN_LEVEL)
        @test_logs lssolve(wrapop(A, Val(mode)), wrapvec(b, Val(mode)), alg)
        alg = LSMR(; maxiter = 2 * n, tol = tol, verbosity = STARTSTOP_LEVEL)
        @test_logs (:info,) (:info,) lssolve(
            wrapop(A, Val(mode)), wrapvec(b, Val(mode)),
            alg
        )
        alg = LSMR(; maxiter = 2 * n, tol = tol, verbosity = EACHITERATION_LEVEL)
        @test_logs min_level = Logging.Warn lssolve(
            wrapop(A, Val(mode)),
            wrapvec(b, Val(mode)),
            alg
        )

        λ = rand(real(T))
        alg = LSMR(; maxiter = n, tol = tol, verbosity = SILENT_LEVEL, krylovdim = n)
        # reorthogonalisation is essential here to converge in exactly n iterations
        x, info = @constinferred lssolve(
            wrapop(A, Val(mode)), wrapvec(b, Val(mode)), alg,
            λ
        )

        r = b - A * unwrapvec(x)
        @test info.converged > 0
        @test A' * r ≈ λ^2 * unwrapvec(x) atol = 2 * tol

        if mode == :vector && T <: Complex
            A = rand(T, (2 * n, n)) .- one(T) / 2
            B = rand(T, (2 * n, n)) .- one(T) / 2
            f = buildrealmap(A, B)
            # the effective linear problem has twice the size, so 4n x 2n
            alg = LSMR(; maxiter = 2 * n, tol = tol, verbosity = SILENT_LEVEL, krylovdim = 2 * n)
            xr, infor = @constinferred reallssolve(f, b, alg)
            @test infor.converged > 0
            y = (A * xr + B * conj(xr))
            @test b ≈ y + infor.residual
            @test (A' * b + conj(B' * b)) ≈ (A' * y + conj(B' * y))
        end
    end
end
@testset "LSMR large problem ($mode)" for mode in (:vector, :inplace, :outplace, :mixed)
    scalartypes = mode === :vector ? (Float64, ComplexF64) : (ComplexF64,)
    @testset for T in scalartypes
        A = rand(T, (2 * N, N)) .- (one(T) / 2)
        b = rand(T, 2 * N) .- (one(T) / 2)

        tol = 10 * N * eps(real(T))
        x, info = @constinferred lssolve(
            wrapop(A, Val(mode)), wrapvec(b, Val(mode));
            maxiter = N, tol = tol, verbosity = SILENT_LEVEL,
            krylovdim = 5
        )

        r = b - A * unwrapvec(x)
        @test info.converged > 0
        @test norm(A' * r) < 5 * tol # there seems to be some loss of precision in the computation of the convergence measure

        if mode == :vector && T <: Complex
            A = rand(T, (2 * N, N)) .- one(T) / 2
            B = rand(T, (2 * N, N)) .- one(T) / 2
            f = buildrealmap(A, B)
            alg = LSMR(; maxiter = N, tol = tol, verbosity = SILENT_LEVEL, krylovdim = 5)
            xr, infor = @constinferred reallssolve(f, b, alg)
            @test infor.converged > 0
            y = (A * xr + B * conj(xr))
            @test b ≈ y + infor.residual
            @test (A' * b + conj(B' * b)) ≈ (A' * y + conj(B' * y))
        end
    end
end

@testset "Block constructor" begin
    for mode in (:vector, :inplace, :outplace)
        scalartypes = mode === :vector ? (Float32, Float64, ComplexF32, ComplexF64) :
            (ComplexF64,)
        @testset for T in scalartypes
            x₀ = Block([wrapvec(rand(T, n), Val(mode)) for _ in 1:n])
            x₁ = Block([wrapvec(rand(T, n), Val(mode)) for _ in 1:n])
            @test typeof(x₀) == typeof(x₁)
        end
    end
    T = ComplexF64
    A = rand(T, n, n) .- one(T) / 2
    A = A' * A + I
    f(x, y) = x' * A * y
    x₀ = Block([InnerProductVec(rand(T, n), f) for _ in 1:n])
    x₁ = Block([InnerProductVec(rand(T, n), f) for _ in 1:n])
    @test typeof(x₀) == typeof(x₁)
end

@testset "apply on Block" begin
    for mode in (:vector, :inplace, :outplace)
        scalartypes = mode === :vector ? (Float32, Float64, ComplexF32, ComplexF64) :
            (ComplexF64,)
        @testset for T in scalartypes
            A = rand(T, n, n) .- one(T) / 2
            A = (A + A') / 2
            wx₀ = Block([wrapvec(rand(T, n), Val(mode)) for _ in 1:n])
            wy = KrylovKit.apply(wrapop(A, Val(mode)), wx₀)
            y = unwrapvec.(wy)
            x₀ = unwrapvec.(wx₀)
            @test isapprox(hcat(y...), A * hcat(x₀...); atol = tolerance(T))
        end
    end
    T = ComplexF64
    A = rand(T, n, n) .- one(T) / 2
    A = A' * A + I
    f(x, y) = x' * A * y
    Af(x::InnerProductVec) = KrylovKit.InnerProductVec(A * x[], x.dotf)
    x₀ = Block([InnerProductVec(rand(T, n), f) for _ in 1:n])
    y = KrylovKit.apply(Af, x₀)
    @test isapprox(
        hcat([y[i].vec for i in 1:n]...), A * hcat([x₀[i].vec for i in 1:n]...);
        atol = tolerance(T)
    )
end

@testset "copy for Block" begin
    for mode in (:vector, :inplace, :outplace)
        scalartypes = mode === :vector ? (Float32, Float64, ComplexF32, ComplexF64) :
            (ComplexF64,)
        @testset for T in scalartypes
            block0 = Block([wrapvec(rand(T, N), Val(mode)) for _ in 1:n])
            block1 = copy(block0)
            @test typeof(block0) == typeof(block1)
            @test unwrapvec.(block0.vec) == unwrapvec.(block1.vec)
        end
    end

    # test for abtract type
    T = ComplexF64
    A = rand(T, N, N) .- one(T) / 2
    A = A' * A + I
    f(x, y) = x' * A * y
    block0 = Block([InnerProductVec(rand(T, N), f) for _ in 1:n])
    block1 = copy(block0)
    @test typeof(block0) == typeof(block1)
    @test [block0.vec[i].vec for i in 1:n] == [block1.vec[i].vec for i in 1:n]
end

#=
block_inner(x,y):
M[i,j] = inner(x[i],y[j])
=#
@testset "block_inner for non-full vectors $mode" for mode in (:vector, :inplace, :outplace)
    scalartypes = mode === :vector ? (Float32, Float64, ComplexF64) : (ComplexF64,)
    @testset for T in scalartypes
        A = [rand(T, N) for _ in 1:n]
        B = [rand(T, N) for _ in 1:n]
        M0 = hcat(A...)' * hcat(B...)
        BlockA = Block(wrapvec.(A, Val(mode)))
        BlockB = Block(wrapvec.(B, Val(mode)))
        M = KrylovKit.block_inner(BlockA, BlockB)
        @test eltype(M) == T
        @test isapprox(M, M0; atol = relax_tol(T))
    end
end

@testset "block_inner for abstract inner product" begin
    T = ComplexF64
    H = rand(T, N, N) .- one(T) / 2
    H = H' * H + I
    ip(x, y) = x' * H * y
    X = [InnerProductVec(rand(T, N), ip) for _ in 1:n]
    Y = [InnerProductVec(rand(T, N), ip) for _ in 1:n]
    BlockX = Block(X)
    BlockY = Block(Y)
    M = KrylovKit.block_inner(BlockX, BlockY)
    Xm = hcat([X[i].vec for i in 1:n]...)
    Ym = hcat([Y[i].vec for i in 1:n]...)
    M0 = Xm' * H * Ym
    @test eltype(M) == T
    @test isapprox(M, M0; atol = relax_tol(T))
end

@testset "block_reorthogonalize! for non-full vectors $mode" for mode in
    (
        :vector, :inplace,
        :outplace,
    )
    scalartypes = mode === :vector ? (Float32, Float64, ComplexF32, ComplexF64) :
        (ComplexF64,)
    @testset for T in scalartypes
        A = rand(T, n, n) .- one(T) / 2
        A = (A + A') / 2
        x₀ = [wrapvec(rand(T, N), Val(mode)) for i in 1:n]
        x₁ = [wrapvec(rand(T, N), Val(mode)) for i in 1:(2 * n)]
        b₀ = Block(x₀)
        b₁ = Block(x₁)
        KrylovKit.block_qr!(b₁, tolerance(T))
        orthobasis_x₁ = KrylovKit.OrthonormalBasis(b₁.vec)
        KrylovKit.block_reorthogonalize!(b₀, orthobasis_x₁)
        @test norm(KrylovKit.block_inner(b₀, b₁)) < tolerance(T)
    end
end

@testset "block_reorthogonalize! for abstract inner product" begin
    T = ComplexF64
    H = rand(T, N, N) .- one(T) / 2
    H = H' * H + I
    ip(x, y) = x' * H * y

    x₀ = [InnerProductVec(rand(T, N), ip) for i in 1:n]
    x₁ = [InnerProductVec(rand(T, N), ip) for i in 1:(2 * n)]
    b₀ = Block(x₀)
    b₁ = Block(x₁)
    KrylovKit.block_qr!(b₁, tolerance(T))
    orthobasis_x₁ = KrylovKit.OrthonormalBasis(b₁.vec)
    KrylovKit.block_reorthogonalize!(b₀, orthobasis_x₁)
    @test norm(KrylovKit.block_inner(b₀, b₁)) < tolerance(T)
end

@testset "block_qr! for non-full vectors $mode" for mode in
    (:vector, :inplace, :outplace)
    scalartypes = mode === :vector ? (Float32, Float64, ComplexF32, ComplexF64) :
        (ComplexF64,)
    @testset for T in scalartypes
        A = rand(T, n, n) .- one(T) / 2
        B = copy(A)
        Av = [A[:, i] for i in 1:size(A, 2)]
        # A is a non-full rank matrix
        Av[n ÷ 2] = sum(Av[(n ÷ 2 + 1):end] .* rand(T, n - n ÷ 2))
        Bv = deepcopy(Av)
        wAv = wrapvec.(Av, Val(mode))
        R, gi = KrylovKit.block_qr!(Block(wAv), tolerance(T))
        Av1 = [unwrapvec(wAv[i]) for i in gi]
        @test length(gi) < n
        @test eltype(R) == eltype(A) == T
        @test isapprox(hcat(Av1...) * R, hcat(Bv...); atol = tolerance(T))
        @test isapprox(hcat(Av1...)' * hcat(Av1...), I; atol = tolerance(T))
    end
end

@testset "block_qr! for abstract inner product" begin
    T = ComplexF64
    H = rand(T, N, N) .- one(T) / 2
    H = H' * H + I
    ip(x, y) = x' * H * y
    X = [InnerProductVec(rand(T, N), ip) for _ in 1:n]

    # Make sure X is not full rank
    X[end] = sum(X[1:(end - 1)] .* rand(T, n - 1))
    Xcopy = deepcopy(X)
    R, gi = KrylovKit.block_qr!(Block(X), tolerance(T))

    @test length(gi) < n
    @test eltype(R) == T
    BlockX = Block(X[gi])
    @test isapprox(KrylovKit.block_inner(BlockX, BlockX), I; atol = tolerance(T))
    @test isapprox(
        hcat([X[i].vec for i in gi]...) * R,
        hcat([Xcopy[i].vec for i in 1:n]...); atol = tolerance(T)
    )
end

"""
    abstract type KrylovFactorization{T,S<:Number}

Abstract type to store a Krylov factorization of a linear map `A` of the form

```julia
A * V = V * B + r * b'
```

For a given Krylov factorization `fact` of length `k = length(fact)`, the basis `V` is
obtained via [`basis(fact)`](@ref basis) and is an instance of some subtype of
[`Basis{T}`](@ref Basis), with also `length(V) == k` and where `T` denotes the type of
vector like objects used in the problem. The Rayleigh quotient `B` is obtained as
[`rayleighquotient(fact)`](@ref) and `typeof(B)` is some subtype of `AbstractMatrix{S}` with
`size(B) == (k,k)`, typically a structured matrix. The residual `r` is obtained as
[`residual(fact)`](@ref) and is of type `T`. One can also query [`normres(fact)`](@ref) to
obtain `norm(r)`, the norm of the residual. The vector `b` has no dedicated name and often
takes a default form (see below). It should be a subtype of `AbstractVector` of length `k`
and can be obtained as [`rayleighextension(fact)`](@ref) (by lack of a better dedicated
name).

A Krylov factorization `fact` can be destructured as `V, B, r, nr, b = fact` with
`nr = norm(r)`.

See also [`LanczosFactorization`](@ref) and [`ArnoldiFactorization`](@ref) for concrete
implementations, and [`KrylovIterator`](@ref) (with in particular [`LanczosIterator`](@ref)
and [`ArnoldiIterator`](@ref)) for iterators that construct progressively expanding Krylov
factorizations of a given linear map and a starting vector.
"""
abstract type KrylovFactorization{T, S} end

"""
    abstract type KrylovIterator{F,T}

Abstract type for iterators that take a linear map of type `F` and an initial vector of type
`T` and generate an expanding `KrylovFactorization` thereof.

When iterating over an instance of `KrylovIterator`, the values being generated are subtypes
of [`KrylovFactorization`](@ref), which can be immediately destructured into a
[`basis`](@ref), [`rayleighquotient`](@ref), [`residual`](@ref), [`normres`](@ref) and
[`rayleighextension`](@ref).

See [`LanczosIterator`](@ref) and [`ArnoldiIterator`](@ref) for concrete implementations and
more information.
"""
abstract type KrylovIterator{F, T} end

"""
        basis(fact::KrylovFactorization)

Return the list of basis vectors of a [`KrylovFactorization`](@ref), which span the Krylov
subspace. The return type is a subtype of `Basis{T}`, where `T` represents the type of the
vectors used by the problem.
"""
function basis end

"""
    rayleighquotient(fact::KrylovFactorization)

Return the Rayleigh quotient of a [`KrylovFactorization`](@ref), i.e. the reduced matrix
within the basis of the Krylov subspace. The return type is a subtype of
`AbstractMatrix{<:Number}`, typically some structured matrix type.
"""
function rayleighquotient end

"""
    residual(fact::KrylovFactorization)

Return the residual of a [`KrylovFactorization`](@ref). The return type is some vector of
the same type as used in the problem. See also [`normres(F)`](@ref) for its norm, which
typically has been computed already.
"""
function residual end

"""
    normres(fact::KrylovFactorization)

Return the norm of the residual of a [`KrylovFactorization`](@ref). As this has typically
already been computed, it is cheaper than (but otherwise equivalent to) `norm(residual(F))`.
"""
function normres end

"""
    rayleighextension(fact::KrylovFactorization)

Return the vector `b` appearing in the definition of a [`KrylovFactorization`](@ref); often
it is simply the last coordinate unit vector, which can be represented using
[`SimpleBasisVector`](@ref).
"""
function rayleighextension end

"""
    shrink!(fact::KrylovFactorization, k)

Shrink an existing Krylov factorization `fact` down to have length `k`. Does nothing if
`length(fact)<=k`.
"""
function shrink! end

"""
    expand!(iter::KrylovIterator, fact::KrylovFactorization)

Expand the Krylov factorization `fact` by one using the linear map and parameters in `iter`.
"""
function expand! end

"""
    initialize!(iter::KrylovIterator, fact::KrylovFactorization)

Initialize a length 1 Krylov factorization corresponding to `iter` in the already existing
factorization `fact`, thereby destroying all the information it currently holds.
"""
function initialize! end

"""
    initialize(iter::KrylovIterator)

Initialize a length 1 Krylov factorization corresponding to `iter`.
"""
function initialize end

# iteration for destructuring into components
Base.iterate(F::KrylovFactorization) = (basis(F), Val(:rayleighquotient))
function Base.iterate(F::KrylovFactorization, ::Val{:rayleighquotient})
    return (rayleighquotient(F), Val(:residual))
end
Base.iterate(F::KrylovFactorization, ::Val{:residual}) = (residual(F), Val(:normres))
function Base.iterate(F::KrylovFactorization, ::Val{:normres})
    return (normres(F), Val(:rayleighextension))
end
function Base.iterate(F::KrylovFactorization, ::Val{:rayleighextension})
    return (rayleighextension(F), Val(:done))
end
Base.iterate(F::KrylovFactorization, ::Val{:done}) = nothing

function linsolve(operator, b, x₀, alg::BiCGStab, a₀::Number = 0, a₁::Number = 1; alg_rrule = alg)
    # Initial function operation and division defines number type
    y₀ = apply(operator, x₀)
    T = typeof(inner(b, y₀) / norm(b) * one(a₀) * one(a₁))
    α₀ = convert(T, a₀)
    α₁ = convert(T, a₁)
    # Continue computing r = b - a₀ * x₀ - a₁ * operator(x₀)
    r = scale(b, one(T))
    r = iszero(α₀) ? r : add!!(r, x₀, -α₀)
    r = add!!(r, y₀, -α₁)
    x = scale!!(zerovector(r), x₀, 1)
    normr = norm(r)
    S = typeof(normr)

    # Algorithm parameters
    maxiter = alg.maxiter
    tol::S = alg.tol
    numops = 1 # operator has been applied once to determine r
    numiter = 0

    # Check for early return
    if normr < tol
        if alg.verbosity >= STARTSTOP_LEVEL
            @info """BiCGStab linsolve converged without any iterations:
            * norm of residual = $(normres2string(normr))
            * number of operations = $numops"""
        end
        return (x, ConvergenceInfo(1, r, normr, numiter, numops))
    elseif alg.verbosity >= STARTSTOP_LEVEL
        @info "BiCGStab linsolve starts with norm of residual = $(normres2string(normr))"
    end

    # First iteration
    numiter += 1
    r_shadow = scale!!(zerovector(r), r, 1)     # shadow residual
    ρ = inner(r_shadow, r)

    # Method fails if ρ is zero.
    if ρ ≈ 0.0
        if alg.verbosity >= WARN_LEVEL
            @warn """BiCGStab linsolve errored after $numiter iterations:
            * norm of residual = $(normres2string(normr))
            * number of operations = $numops"""
        end
        return (x, ConvergenceInfo(0, r, normr, numiter, numops))
    end

    ## BiCG part of the algorithm.
    p = scale!!(zerovector(r), r, 1)
    v = apply(operator, p, α₀, α₁)
    numops += 1

    σ = inner(r_shadow, v)
    α = ρ / σ

    s = scale!!(zerovector(r), r, 1)
    s = add!!(s, v, -α) # half step residual

    xhalf = scale!!(zerovector(x), x, 1)
    xhalf = add!!(xhalf, p, +α) # half step iteration

    normr = norm(s)

    # Check for early return at half step.
    if normr < tol
        # Replace approximate residual with the actual residual.
        s = scale!!(zerovector(b), b, 1)
        s = add!!(s, apply(operator, xhalf, α₀, α₁), -1)
        numops += 1

        normr_act = norm(s)
        if normr_act < tol
            if alg.verbosity >= STARTSTOP_LEVEL
                @info """BiCGStab linsolve converged at iteration $(numiter - 1 / 2):
                * norm of residual = $(normres2string(normr_act))
                * number of operations = $numops"""
            end
            return (xhalf, ConvergenceInfo(1, s, normr_act, numiter, numops))
        end
    end

    ## GMRES part of the algorithm.
    t = apply(operator, s, α₀, α₁)
    numops += 1

    ω = inner(t, s) / inner(t, t)

    x = scale!!(x, xhalf, 1)
    x = add!!(x, s, +ω) # full step iteration

    r = scale!!(r, s, 1)
    r = add!!(r, t, -ω) # full step residual

    # Check for early return at full step.
    normr = norm(r)
    if normr < tol
        # Replace approximate residual with the actual residual.
        r = scale!!(r, b, 1)
        r = add!!(r, apply(operator, x, α₀, α₁), -1)
        numops += 1

        normr_act = norm(r)
        if normr_act < tol
            if alg.verbosity >= STARTSTOP_LEVEL
                @info """BiCGStab linsolve converged at iteration $(numiter):
                * norm of residual = $(normres2string(normr_act))
                * number of operations = $numops"""
            end
            return (x, ConvergenceInfo(1, r, normr_act, numiter, numops))
        end
    end
    if alg.verbosity >= EACHITERATION_LEVEL
        @info "BiCGStab linsolve in iteration $numiter: normres = $(normres2string(normr))"
    end

    while true
        numiter += 1
        ρold = ρ
        ρ = inner(r_shadow, r)
        β = (ρ / ρold) * (α / ω)

        p = add!!(p, v, -ω)
        p = add!!(p, r, 1, β)

        v = apply(operator, p, α₀, α₁)
        numops += 1

        σ = inner(r_shadow, v)
        α = ρ / σ

        s = scale!!(s, r, 1)
        s = add!!(s, v, -α) # half step residual

        xhalf = scale!!(xhalf, x, 1)
        xhalf = add!!(xhalf, p, +α) # half step iteration

        normr = norm(s)

        # Check for return at half step.
        if normr < tol
            # Compute non-approximate residual.
            s = scale!!(zerovector(b), b, 1)
            s = add!!(s, apply(operator, xhalf, α₀, α₁), -1)
            numops += 1

            normr_act = norm(s)
            if normr_act < tol
                if alg.verbosity >= STARTSTOP_LEVEL
                    @info """BiCGStab linsolve converged at iteration $(numiter - 1 / 2):
                    * norm of residual = $(normres2string(normr_act))
                    * number of operations = $numops"""
                end
                return (xhalf, ConvergenceInfo(1, s, normr_act, numiter, numops))
            end
        end
        if alg.verbosity >= EACHITERATION_LEVEL
            @info "BiCGStab linsolve in iteration $(numiter - 1 / 2): normres = $(normres2string(normr))"
        end

        ## GMRES part of the algorithm.
        t = apply(operator, s, α₀, α₁)
        numops += 1

        ω = inner(t, s) / inner(t, t)

        x = scale!!(x, xhalf, 1)
        x = add!!(x, s, +ω) # full step iteration

        r = scale!!(r, s, 1)
        r = add!!(r, t, -ω) # full step residual

        # Check for return at full step.
        normr = norm(r)
        if normr < tol
            # Replace approximate residual with the actual residual.
            r = scale!!(r, b, 1)
            r = add!!(r, apply(operator, x, α₀, α₁), -1)
            numops += 1

            normr_act = norm(r)
            if normr_act < tol
                if alg.verbosity >= STARTSTOP_LEVEL
                    @info """BiCGStab linsolve converged at iteration $(numiter):
                    * norm of residual = $(normres2string(normr_act))
                    * number of operations = $numops"""
                end
                return (x, ConvergenceInfo(1, r, normr_act, numiter, numops))
            end
        end
        if numiter >= maxiter
            if alg.verbosity >= WARN_LEVEL
                @warn """BiCGStab linsolve stopped without converging after $numiter iterations:
                * norm of residual = $(normres2string(normr))
                * number of operations = $numops"""
            end
            return (x, ConvergenceInfo(0, r, normr, numiter, numops))
        end
        if alg.verbosity >= EACHITERATION_LEVEL
            @info "BiCGStab linsolve in iteration $numiter: normres = $(normres2string(normr))"
        end
    end
    return
end

# Elementary Givens rotation
using LinearAlgebra: Givens

# for reference: Julia LinearAlgebra.Givens
# immutable Givens{T} <: AbstractRotation{T}
#     i1::Int
#     i2::Int
#     c::T
#     s::T
# end

function LinearAlgebra.rmul!(b::OrthonormalBasis{T}, G::Givens) where {T}
    if T isa AbstractArray && IndexStyle(T) isa IndexLinear
        return _rmul_linear!(b, G)
    else
        return _rmul!(b, G)
    end
end

@fastmath function _rmul_linear!(b::OrthonormalBasis{<:AbstractArray}, G::Givens)
    q1, q2 = b[G.i1], b[G.i2]
    c = G.c
    s = G.s
    @inbounds @simd for i in 1:length(q1)
        q1[i], q2[i] = c * q1[i] - conj(s) * q2[i], s * q1[i] + c * q2[i]
    end
    return b
end

function _rmul!(b::OrthonormalBasis, G::Givens)
    q1, q2 = b[G.i1], b[G.i2]
    q1′ = add(q1, q2, -conj(G.s), G.c)
    q2′ = add!!(q2, q1, G.s, G.c)
    b[G.i1], b[G.i2] = q1′, q2′
    return b
end

# New types for discarding or for storing successive Givens transformations
struct NoVecs end
const novecs = NoVecs()
rmulc!(::NoVecs, ::Any) = novecs

using KrylovKit: OrthonormalBasis, householder, rows, cols, hschur!, schur2eigvals,
    schur2eigvecs, permuteschur!

@testset "Orthonormalize with algorithm $alg" for alg in (cgs, mgs, cgs2, mgs2, cgsr, mgsr)
    @testset for S in (Float32, Float64, ComplexF32, ComplexF64)
        b = OrthonormalBasis{Vector{S}}()
        A = randn(S, (n, n))
        v, r, x = orthonormalize(A[:, 1], b, alg)
        @test r ≈ norm(A[:, 1])
        @test norm(v) ≈ 1
        @test length(x) == 0
        push!(b, v)
        for i in 2:n
            v, r, x = orthonormalize(A[:, i], b, alg)
            @test norm([r, norm(x)]) ≈ norm(A[:, i])
            @test norm(v) ≈ 1
            @test length(x) == i - 1
            push!(b, v)
        end
        U = hcat(b...)
        @test U' * U ≈ I
        v = randn(S, n)
        @test U * v ≈ b * v
    end
end

@testset "Givens and Householder" begin
    @testset for S in (Float32, Float64, ComplexF32, ComplexF64)
        U, = svd!(randn(S, (n, n)))
        b = OrthonormalBasis(map(copy, cols(U)))
        v = randn(S, (n,))
        g, r = givens(v, 1, n)
        @test rmul!(U, g) ≈ hcat(rmul!(b, g)...)
        h, r = householder(v, axes(v, 1), 3)
        @test r ≈ norm(v)
        v2 = lmul!(h, copy(v))
        v3 = zero(v2)
        v3[3] = r
        @test v2 ≈ v3
        @test lmul!(h, one(U)) ≈ rmul!(one(U), h)
        @test lmul!(h, one(U))' ≈ lmul!(h', one(U))
        @test rmul!(U, h) ≈ hcat(rmul!(b, h)...)
    end
end

@testset "Rows and cols iterator" begin
    @testset for S in (Float32, Float64, ComplexF32, ComplexF64)
        A = randn(S, (n, n))
        rowiter = rows(A)
        @test typeof(first(rowiter)) == eltype(rowiter)
        @test all(t -> t[1] == t[2], zip(rowiter, [A[i, :] for i in 1:n]))
        coliter = cols(A)
        @test typeof(first(coliter)) == eltype(coliter)
        @test all(t -> t[1] == t[2], zip(coliter, [A[:, i] for i in 1:n]))
    end
end

@testset "Dense Schur factorisation and associated methods" begin
    @testset for S in (Float32, Float64, ComplexF32, ComplexF64)
        H = convert(Matrix, hessenberg(rand(S, n, n)).H) # convert for compatibility with 1.3

        # schur factorisation of Hessenberg matrix
        T, U, w = hschur!(copy(H))
        @test H * U ≈ U * T
        @test schur2eigvals(T) ≈ w

        # full eigenvector computation
        V = schur2eigvecs(T)
        @test T * V ≈ V * Diagonal(w)

        # selected eigenvector computation
        p = randperm(n)
        select = p[1:(n >> 1)]
        V2 = schur2eigvecs(T, select)
        @test T * V2 ≈ V2 * Diagonal(w[select])

        # permuting / reordering schur: take permutations that keep 2x2 blocks together in real case
        p = sortperm(w; by = real)
        T2, U2 = permuteschur!(copy(T), copy(U), p)
        @test H * U2 ≈ U2 * T2
        @test schur2eigvals(T2) ≈ w[p]

        p = sortperm(w; by = abs)
        T2, U2 = permuteschur!(copy(T), copy(U), p)
        @test H * U2 ≈ U2 * T2
        @test schur2eigvals(T2) ≈ w[p]
    end
end

"""
    v = InnerProductVec(vec, dotf)

Create a new vector `v` from an existing vector `dotf` with a modified inner product given
by `inner`. The vector `vec`, which can be any type (not necessarily `Vector`) that supports
the basic vector interface required by KrylovKit, is wrapped in a custom struct
`v::InnerProductVec`. All vector space functionality such as addition and multiplication
with scalars (both out of place and in place using `mul!`, `rmul!`, `axpy!` and `axpby!`)
applied to `v` is simply forwarded to `v.vec`. The inner product between vectors
`v1 = InnerProductVec(vec1, dotf)` and `v2 = InnerProductVec(vec2, dotf)` is computed as
`dot(v1, v2) = dotf(v1.vec, v2.vec) = dotf(vec1, vec2)`. The inner product between vectors
with different `dotf` functions is not defined. Similarly, The norm of `v::InnerProductVec`
is defined as `v = sqrt(real(dot(v, v))) = sqrt(real(dotf(vec, vec)))`.

In a (linear) map applied to `v`, the original vector can be obtained as `v.vec` or simply
as `v[]`.
"""
struct InnerProductVec{F, T}
    vec::T
    dotf::F
end

Base.:-(v::InnerProductVec) = InnerProductVec(-v.vec, v.dotf)
function Base.:+(v::InnerProductVec{F}, w::InnerProductVec{F}) where {F}
    return InnerProductVec(v.vec + w.vec, v.dotf)
end
function Base.:-(v::InnerProductVec{F}, w::InnerProductVec{F}) where {F}
    return InnerProductVec(v.vec - w.vec, v.dotf)
end
Base.:*(v::InnerProductVec, a::Number) = InnerProductVec(v.vec * a, v.dotf)
Base.:*(a::Number, v::InnerProductVec) = InnerProductVec(a * v.vec, v.dotf)
Base.:/(v::InnerProductVec, a::Number) = InnerProductVec(v.vec / a, v.dotf)
Base.:\(a::Number, v::InnerProductVec) = InnerProductVec(a \ v.vec, v.dotf)

function Base.similar(v::InnerProductVec, (::Type{T}) = scalartype(v)) where {T}
    return InnerProductVec(similar(v.vec), v.dotf)
end

Base.getindex(v::InnerProductVec) = v.vec

function Base.copy!(w::InnerProductVec{F}, v::InnerProductVec{F}) where {F}
    copy!(w.vec, v.vec)
    return w
end

function LinearAlgebra.mul!(
        w::InnerProductVec{F}, a::Number, v::InnerProductVec{F}
    ) where {F}
    mul!(w.vec, a, v.vec)
    return w
end

function LinearAlgebra.mul!(
        w::InnerProductVec{F}, v::InnerProductVec{F}, a::Number
    ) where {F}
    mul!(w.vec, v.vec, a)
    return w
end

function LinearAlgebra.rmul!(v::InnerProductVec, a::Number)
    rmul!(v.vec, a)
    return v
end

function LinearAlgebra.axpy!(
        a::Number, v::InnerProductVec{F}, w::InnerProductVec{F}
    ) where {F}
    axpy!(a, v.vec, w.vec)
    return w
end
function LinearAlgebra.axpby!(
        a::Number, v::InnerProductVec{F}, b, w::InnerProductVec{F}
    ) where {F}
    axpby!(a, v.vec, b, w.vec)
    return w
end

function LinearAlgebra.dot(v::InnerProductVec{F}, w::InnerProductVec{F}) where {F}
    return v.dotf(v.vec, w.vec)
end

VectorInterface.scalartype(::Type{<:InnerProductVec{F, T}}) where {F, T} = scalartype(T)

function VectorInterface.zerovector(v::InnerProductVec, T::Type{<:Number})
    return InnerProductVec(zerovector(v.vec, T), v.dotf)
end
function VectorInterface.zerovector!(v::InnerProductVec)
    return InnerProductVec(zerovector!(v.vec), v.dotf)
end
function VectorInterface.zerovector!!(v::InnerProductVec)
    return InnerProductVec(zerovector!!(v.vec), v.dotf)
end

function VectorInterface.scale(v::InnerProductVec, a::Number)
    return InnerProductVec(scale(v.vec, a), v.dotf)
end
function VectorInterface.scale!!(v::InnerProductVec, a::Number)
    return InnerProductVec(scale!!(v.vec, a), v.dotf)
end
function VectorInterface.scale!(v::InnerProductVec, a::Number)
    scale!(v.vec, a)
    return v
end
function VectorInterface.scale!!(
        w::InnerProductVec{F}, v::InnerProductVec{F}, a::Number
    ) where {F}
    return InnerProductVec(scale!!(w.vec, v.vec, a), w.dotf)
end
function VectorInterface.scale!(
        w::InnerProductVec{F}, v::InnerProductVec{F}, a::Number
    ) where {F}
    scale!(w.vec, v.vec, a)
    return w
end

function VectorInterface.add(
        v::InnerProductVec{F}, w::InnerProductVec{F}, a::Number, b::Number
    ) where {F}
    return InnerProductVec(add(v.vec, w.vec, a, b), v.dotf)
end
function VectorInterface.add!!(
        v::InnerProductVec{F}, w::InnerProductVec{F}, a::Number, b::Number
    ) where {F}
    return InnerProductVec(add!!(v.vec, w.vec, a, b), v.dotf)
end
function VectorInterface.add!(
        v::InnerProductVec{F}, w::InnerProductVec{F}, a::Number, b::Number
    ) where {F}
    add!(v.vec, w.vec, a, b)
    return v
end

function VectorInterface.inner(v::InnerProductVec{F}, w::InnerProductVec{F}) where {F}
    return v.dotf(v.vec, w.vec)
end

VectorInterface.norm(v::InnerProductVec) = sqrt(real(inner(v, v)))

# Test complete Lanczos factorization
@testset "Complete Lanczos factorization ($mode)" for mode in (:vector, :inplace, :outplace)
    scalartypes = mode === :vector ? (Float32, Float64, ComplexF32, ComplexF64) :
        (ComplexF64,)
    orths = mode === :vector ? (cgs2, mgs2, cgsr, mgsr) : (cgs2,)
    @testset for T in scalartypes
        @testset for orth in orths # tests fail miserably for cgs and mgs
            A = rand(T, (n, n))
            v = rand(T, (n,))
            A = (A + A')
            iter = LanczosIterator(wrapop(A, Val(mode)), wrapvec(v, Val(mode)), orth)
            fact = @constinferred initialize(iter)
            @constinferred expand!(iter, fact)
            @test_logs initialize(iter; verbosity = EACHITERATION_LEVEL)
            @test_logs (:info,) initialize(iter; verbosity = EACHITERATION_LEVEL + 1)
            verbosity = EACHITERATION_LEVEL + 1
            while length(fact) < n
                if verbosity == EACHITERATION_LEVEL + 1
                    @test_logs (:info,) expand!(iter, fact; verbosity = verbosity)
                    verbosity = EACHITERATION_LEVEL
                else
                    @test_logs expand!(iter, fact; verbosity = verbosity)
                    verbosity = EACHITERATION_LEVEL + 1
                end
            end
            V = stack(unwrapvec, basis(fact))
            H = rayleighquotient(fact)
            @test normres(fact) < 10 * n * eps(real(T))
            @test V' * V ≈ I
            @test A * V ≈ V * H

            states = collect(Iterators.take(iter, n)) # collect tests size and eltype?
            @test rayleighquotient(last(states)) ≈ H

            @constinferred shrink!(fact, n - 1)
            @test_logs (:info,) shrink!(fact, n - 2; verbosity = EACHITERATION_LEVEL + 1)
            @test_logs shrink!(fact, n - 3; verbosity = EACHITERATION_LEVEL)
            @constinferred initialize!(iter, deepcopy(fact))
            @test_logs initialize!(iter, deepcopy(fact); verbosity = EACHITERATION_LEVEL)
            @test_logs (:info,) initialize!(
                iter, deepcopy(fact);
                verbosity = EACHITERATION_LEVEL + 1
            )

            if T <: Complex
                A = rand(T, (n, n)) # test warnings for non-hermitian matrices
                v = rand(T, (n,))
                iter = LanczosIterator(wrapop(A, Val(mode)), wrapvec(v, Val(mode)), orth)
                fact = @constinferred initialize(iter; verbosity = SILENT_LEVEL)
                @constinferred expand!(iter, fact; verbosity = SILENT_LEVEL)
                @test_logs initialize(iter; verbosity = SILENT_LEVEL)
                @test_logs (:warn,) initialize(iter)
                verbosity = WARN_LEVEL
                while length(fact) < n
                    if verbosity == WARN_LEVEL
                        @test_logs (:warn,) expand!(iter, fact; verbosity = verbosity)
                        verbosity = SILENT_LEVEL
                    else
                        @test_logs expand!(iter, fact; verbosity = verbosity)
                        verbosity = WARN_LEVEL
                    end
                end
            end
        end
    end
end

# Test complete Arnoldi factorization
@testset "Complete Arnoldi factorization ($mode)" for mode in (:vector, :inplace, :outplace)
    scalartypes = mode === :vector ? (Float32, Float64, ComplexF32, ComplexF64) :
        (ComplexF64,)
    orths = mode === :vector ? (cgs, mgs, cgs2, mgs2, cgsr, mgsr) : (cgs2,)

    @testset for T in scalartypes
        @testset for orth in orths
            A = rand(T, (n, n))
            v = rand(T, (n,))
            iter = ArnoldiIterator(wrapop(A, Val(mode)), wrapvec(v, Val(mode)), orth)
            fact = @constinferred initialize(iter)
            @constinferred expand!(iter, fact)
            @test_logs initialize(iter; verbosity = EACHITERATION_LEVEL)
            @test_logs (:info,) initialize(iter; verbosity = EACHITERATION_LEVEL + 1)
            verbosity = EACHITERATION_LEVEL + 1
            while length(fact) < n
                if verbosity == EACHITERATION_LEVEL + 1
                    @test_logs (:info,) expand!(iter, fact; verbosity = verbosity)
                    verbosity = EACHITERATION_LEVEL
                else
                    @test_logs expand!(iter, fact; verbosity = verbosity)
                    verbosity = EACHITERATION_LEVEL + 1
                end
            end
            V = stack(unwrapvec, basis(fact))
            H = rayleighquotient(fact)
            factor = (orth == cgs || orth == mgs ? 250 : 10)
            @test normres(fact) < factor * n * eps(real(T))
            @test V' * V ≈ I
            @test A * V ≈ V * H

            states = collect(Iterators.take(iter, n)) # collect tests size and eltype?
            @test rayleighquotient(last(states)) ≈ H

            @constinferred shrink!(fact, n - 1)
            @test_logs (:info,) shrink!(fact, n - 2; verbosity = EACHITERATION_LEVEL + 1)
            @test_logs shrink!(fact, n - 3; verbosity = EACHITERATION_LEVEL)
            @constinferred initialize!(iter, deepcopy(fact))
            @test_logs initialize!(iter, deepcopy(fact); verbosity = EACHITERATION_LEVEL)
            @test_logs (:info,) initialize!(
                iter, deepcopy(fact);
                verbosity = EACHITERATION_LEVEL + 1
            )
        end
    end
end

# Test incomplete Lanczos factorization
@testset "Incomplete Lanczos factorization ($mode)" for mode in
    (:vector, :inplace, :outplace)
    scalartypes = mode === :vector ?
        (Float32, Float64, ComplexF32, ComplexF64, Complex{Int}) : (ComplexF64,)
    orths = mode === :vector ? (cgs2, mgs2, cgsr, mgsr) : (cgs2,)

    @testset for T in scalartypes
        @testset for orth in orths # tests fail miserably for cgs and mgs
            if T === Complex{Int}
                A = rand(-100:100, (N, N)) + im * rand(-100:100, (N, N))
                v = rand(-100:100, (N,))
            else
                A = rand(T, (N, N))
                v = rand(T, (N,))
            end
            A = (A + A')
            iter = @constinferred LanczosIterator(
                wrapop(A, Val(mode)),
                wrapvec(v, Val(mode)),
                orth
            )
            krylovdim = n
            fact = @constinferred initialize(iter)
            while normres(fact) > eps(float(real(T))) && length(fact) < krylovdim
                @constinferred expand!(iter, fact)
                Ṽ, H, r̃, β, e = fact
                V = stack(unwrapvec, Ṽ)
                r = unwrapvec(r̃)
                @test V' * V ≈ I
                @test norm(r) ≈ β
                @test A * V ≈ V * H + r * e'
            end

            fact = @constinferred shrink!(fact, div(n, 2))
            V = stack(unwrapvec, @constinferred basis(fact))
            H = @constinferred rayleighquotient(fact)
            r = @constinferred unwrapvec(residual(fact))
            β = @constinferred normres(fact)
            e = @constinferred rayleighextension(fact)
            @test V' * V ≈ I
            @test norm(r) ≈ β
            @test A * V ≈ V * H + r * e'
        end
    end
end

# Test incomplete Arnoldi factorization
@testset "Incomplete Arnoldi factorization ($mode)" for mode in
    (:vector, :inplace, :outplace)
    scalartypes = mode === :vector ?
        (Float32, Float64, ComplexF32, ComplexF64, Complex{Int}) : (ComplexF64,)
    orths = mode === :vector ? (cgs2, mgs2, cgsr, mgsr) : (cgs2,)

    @testset for T in scalartypes
        @testset for orth in orths
            if T === Complex{Int}
                A = rand(-100:100, (N, N)) + im * rand(-100:100, (N, N))
                v = rand(-100:100, (N,))
            else
                A = rand(T, (N, N))
                v = rand(T, (N,))
            end
            iter = @constinferred ArnoldiIterator(
                wrapop(A, Val(mode)),
                wrapvec(v, Val(mode)), orth
            )
            krylovdim = 3 * n
            fact = @constinferred initialize(iter)
            while normres(fact) > eps(float(real(T))) && length(fact) < krylovdim
                @constinferred expand!(iter, fact)
                Ṽ, H, r̃, β, e = fact
                V = stack(unwrapvec, Ṽ)
                r = unwrapvec(r̃)
                @test V' * V ≈ I
                @test norm(r) ≈ β
                @test A * V ≈ V * H + r * e'
            end

            fact = @constinferred shrink!(fact, div(n, 2))
            V = stack(unwrapvec, @constinferred basis(fact))
            H = @constinferred rayleighquotient(fact)
            r = unwrapvec(@constinferred residual(fact))
            β = @constinferred normres(fact)
            e = @constinferred rayleighextension(fact)
            @test V' * V ≈ I
            @test norm(r) ≈ β
            @test A * V ≈ V * H + r * e'
        end
    end
end

# Test complete Golub-Kahan-Lanczos factorization
@testset "Complete Golub-Kahan-Lanczos factorization ($mode)" for mode in
    (
        :vector, :inplace,
        :outplace, :mixed,
    )
    scalartypes = mode === :vector ? (Float32, Float64, ComplexF32, ComplexF64) :
        (ComplexF64,)
    orths = mode === :vector ? (cgs2, mgs2, cgsr, mgsr) : (mgsr,)
    @testset for T in scalartypes
        @testset for orth in orths
            A = rand(T, (2n, n))
            v = A * rand(T, (n,)) # ensure v is in column space of A
            iter = GKLIterator(wrapop(A, Val(mode)), wrapvec(v, Val(mode)), orth)
            fact = @constinferred initialize(iter)
            @constinferred expand!(iter, fact)
            @test_logs initialize(iter; verbosity = EACHITERATION_LEVEL)
            @test_logs (:info,) initialize(iter; verbosity = EACHITERATION_LEVEL + 1)
            verbosity = EACHITERATION_LEVEL + 1
            while length(fact) < n
                if verbosity == EACHITERATION_LEVEL + 1
                    @test_logs (:info,) expand!(iter, fact; verbosity = verbosity)
                    verbosity = EACHITERATION_LEVEL
                else
                    @test_logs expand!(iter, fact; verbosity = verbosity)
                    verbosity = EACHITERATION_LEVEL + 1
                end
            end
            U = stack(unwrapvec, basis(fact, Val(:U)))
            V = stack(unwrapvec, basis(fact, Val(:V)))
            B = rayleighquotient(fact)
            @test normres(fact) < n * sqrt(eps(real(T)))
            @test U' * U ≈ I
            @test V' * V ≈ I
            @test A * V ≈ U * B
            @test A' * U ≈ V * B'

            states = collect(Iterators.take(iter, n)) # collect tests size and eltype?
            @test rayleighquotient(last(states)) ≈ B

            @constinferred shrink!(fact, n - 1)
            @test_logs (:info,) shrink!(fact, n - 2; verbosity = EACHITERATION_LEVEL + 1)
            @test_logs shrink!(fact, n - 3; verbosity = EACHITERATION_LEVEL)
            @constinferred initialize!(iter, deepcopy(fact))
            @test_logs initialize!(iter, deepcopy(fact); verbosity = EACHITERATION_LEVEL)
            @test_logs (:info,) initialize!(
                iter, deepcopy(fact);
                verbosity = EACHITERATION_LEVEL + 1
            )
        end
    end
end

# Test incomplete Golub-Kahan-Lanczos factorization
@testset "Incomplete Golub-Kahan-Lanczos factorization ($mode)" for mode in
    (
        :vector, :inplace,
        :outplace, :mixed,
    )
    scalartypes = mode === :vector ? (Float32, Float64, ComplexF32, ComplexF64) :
        (ComplexF64,)
    orths = mode === :vector ? (cgs2, mgs2, cgsr, mgsr) : (mgsr,)
    @testset for T in scalartypes
        @testset for orth in orths
            if T == Complex{Int}
                A = rand(-100:100, (N, N)) + im * rand(-100:100, (N, N))
                v = rand(-100:100, (N,))
            else
                A = rand(T, (N, N))
                v = rand(T, (N,))
            end
            iter = @constinferred GKLIterator(
                wrapop(A, Val(mode)), wrapvec(v, Val(mode)),
                orth
            )
            krylovdim = 3 * n
            fact = @constinferred initialize(iter)
            while normres(fact) > eps(float(real(T))) && length(fact) < krylovdim
                @constinferred expand!(iter, fact)
                Ũ, Ṽ, B, r̃, β, e = fact
                U = stack(unwrapvec, Ũ)
                V = stack(unwrapvec, Ṽ)
                r = unwrapvec(r̃)
                @test U' * U ≈ I
                @test V' * V ≈ I
                @test norm(r) ≈ β
                @test A * V ≈ U * B + r * e'
                @test A' * U ≈ V * B'
            end

            fact = @constinferred shrink!(fact, div(n, 2))
            U = stack(unwrapvec, @constinferred basis(fact, Val(:U)))
            V = stack(unwrapvec, @constinferred basis(fact, Val(:V)))
            B = @constinferred rayleighquotient(fact)
            r = unwrapvec(@constinferred residual(fact))
            β = @constinferred normres(fact)
            e = @constinferred rayleighextension(fact)
            @test U' * U ≈ I
            @test V' * V ≈ I
            @test norm(r) ≈ β
            @test A * V ≈ U * B + r * e'
            @test A' * U ≈ V * B'
        end
    end
end

# Test complete BlockLanczos factorization
@testset "Complete BlockLanczos factorization " for mode in (:vector, :inplace, :outplace)
    scalartypes = mode === :vector ? (Float32, Float64, ComplexF32, ComplexF64) :
        (ComplexF64,)
    @testset for T in scalartypes
        block_size = 5
        A = mat_with_eigrepition(T, N, block_size)
        x₀m = Matrix(qr(rand(T, N, block_size)).Q)
        x₀ = KrylovKit.Block([wrapvec(x₀m[:, i], Val(mode)) for i in 1:block_size])
        eigvalsA = eigvals(A)
        iter = BlockLanczosIterator(
            wrapop(A, Val(mode)), x₀, N,
            KrylovKit.KrylovDefaults.orth, tolerance(T)
        )
        fact = @constinferred initialize(iter)
        @constinferred expand!(iter, fact)
        @test_logs initialize(iter; verbosity = EACHITERATION_LEVEL)
        @test_logs (:info,) initialize(iter; verbosity = EACHITERATION_LEVEL + 1)
        verbosity = EACHITERATION_LEVEL + 1
        while fact.k < n
            if verbosity == EACHITERATION_LEVEL + 1
                @test_logs (:info,) expand!(iter, fact; verbosity = verbosity)
                verbosity = EACHITERATION_LEVEL
            else
                @test_logs expand!(iter, fact; verbosity = verbosity)
                verbosity = EACHITERATION_LEVEL + 1
            end
        end

        if T <: Complex
            B = rand(T, (n, n)) # test warnings for non-hermitian matrices
            bs = 2
            v₀m = Matrix(qr(rand(T, n, bs)).Q)
            v₀ = KrylovKit.Block([wrapvec(v₀m[:, i], Val(mode)) for i in 1:bs])
            iter = BlockLanczosIterator(
                wrapop(B, Val(mode)), v₀, N,
                KrylovKit.KrylovDefaults.orth, tolerance(T)
            )
            fact = @constinferred initialize(iter; verbosity = SILENT_LEVEL)
            @constinferred expand!(iter, fact; verbosity = SILENT_LEVEL)
            @test_logs initialize(iter; verbosity = SILENT_LEVEL)
            @test_logs (:warn,) initialize(iter)
            verbosity = WARN_LEVEL
            while fact.k < n
                if verbosity == WARN_LEVEL
                    @test_logs (:warn,) expand!(iter, fact; verbosity = verbosity)
                    verbosity = SILENT_LEVEL
                else
                    @test_logs expand!(iter, fact; verbosity = verbosity)
                    verbosity = WARN_LEVEL
                end
            end
        end
    end
end

# Test incomplete BlockLanczos factorization
@testset "Incomplete BlockLanczos factorization " for mode in
    (:vector, :inplace, :outplace)
    scalartypes = mode === :vector ? (Float32, Float64, ComplexF32, ComplexF64) :
        (ComplexF64,)
    @testset for T in scalartypes
        block_size = 5
        A = mat_with_eigrepition(T, N, block_size)
        x₀m = Matrix(qr(rand(T, N, block_size)).Q)
        x₀ = KrylovKit.Block([wrapvec(x₀m[:, i], Val(mode)) for i in 1:block_size])
        iter = @constinferred BlockLanczosIterator(
            wrapop(A, Val(mode)), x₀, N,
            KrylovKit.KrylovDefaults.orth,
            tolerance(T)
        )
        krylovdim = n
        fact = @constinferred initialize(iter)
        while fact.norm_R > eps(float(real(T))) && fact.k < krylovdim
            @constinferred expand!(iter, fact)
            k = fact.k
            rs = fact.R_size
            V0 = fact.V[1:k]
            r0 = fact.R[1:rs]
            H = fact.H[1:k, 1:k]
            norm_R = fact.norm_R
            V = hcat([unwrapvec(v) for v in V0]...)
            r = hcat([unwrapvec(r0[i]) for i in 1:rs]...)
            e = hcat(zeros(T, rs, k - rs), I)
            @test V' * V ≈ I
            @test norm(r) ≈ norm_R
            @test A * V ≈ V * H + r * e
        end
    end
end

module KrylovKitChainRulesCoreExt

using KrylovKit
using ChainRulesCore
using LinearAlgebra
using VectorInterface

using KrylovKit: apply_normal, apply_adjoint
using KrylovKit: WARN_LEVEL, STARTSTOP_LEVEL, EACHITERATION_LEVEL

include("utilities.jl")
include("linsolve.jl")
include("eigsolve.jl")
include("svdsolve.jl")

# mark some functions as non-differentiable to help Zygote:
@non_differentiable KrylovKit.apply_scalartype(args...)
@non_differentiable KrylovKit.genapply_scalartype(args...)

end # module

function lssolve(operator, b, alg::LSMR, λ_::Real = 0)
    # Initialisation: determine number type
    u₀ = b
    v₀ = apply_adjoint(operator, u₀)
    T = typeof(inner(v₀, v₀) / inner(u₀, u₀))
    u = scale(u₀, one(T))
    v = scale(v₀, one(T))
    β = norm(u)
    S = typeof(β)
    u = scale!!(u, 1 / β)
    v = scale!!(v, 1 / β)
    α = norm(v)
    v = scale!!(v, 1 / α)

    V = OrthonormalBasis([v])
    K = alg.krylovdim
    sizehint!(V, K)
    Vv = zeros(T, K) # storage for reorthogonalization

    # Scalar variables for the bidiagonalization
    ᾱ = α
    ζ̄ = α * β
    ρ = one(S)
    θ = zero(S)
    ρ̄ = one(S)
    c̄ = one(S)
    s̄ = zero(S)

    absζ̄ = abs(ζ̄)

    # Vector variables
    x = zerovector(v)
    h = scale(v, one(T)) # we need h to be a copy of v when we reuse v₀ in the reorthogonalisation
    h̄ = zerovector(v)

    r = scale(u, β)
    Ah = zerovector(u)
    Ah̄ = zerovector(u)

    # Algorithm parameters
    numiter = 0
    numops = 1 # One (adjoint) function application for v
    maxiter = alg.maxiter
    tol::S = alg.tol
    λ::S = convert(S, λ_)

    # Check for early return
    if absζ̄ < tol
        if alg.verbosity > STARTSTOP_LEVEL
            @info """LSMR lssolve converged without any iterations:
            * ‖b - A * x ‖ = $(normres2string(β))
            * ‖[b - A * x; λ * x] ‖ = $(normres2string(β))
            * ‖ Aᴴ(b - A x) - λ^2 x ‖ = $(normres2string(absζ̄))
            * number of operations = $numops"""
        end
        return (x, ConvergenceInfo(1, r, absζ̄, numiter, numops))
    elseif alg.verbosity >= STARTSTOP_LEVEL
        @info "LSMR lssolve starts with convergence measure ‖ Aᴴ(b - A x) - λ^2 x ‖ = $(normres2string(absζ̄))"
    end

    while true
        numiter += 1
        Av = apply_normal(operator, v)
        numops += 1
        Ah = add!!(Ah, Av, 1, -θ / ρ)

        # βₖ₊₁ uₖ₊₁ = A vₖ - αₖ uₖ₊₁
        u = add!!(Av, u, -α)
        β = norm(u)
        if β > tol
            u = scale!!(u, 1 / β)
            # αₖ₊₁ vₖ₊₁ = Aᴴ uₖ₊₁ - βₖ₊₁ vₖ
            v = add!!(apply_adjoint(operator, u), v, -β)
            numops += 1
            # Reorthogonalize v against previous vectors
            if K > 1
                v, = orthogonalize!!(v, V, view(Vv, 1:min(K, numiter)), alg.orth)
            end

            α = norm(v)
            if α > tol
                v = scale!!(v, 1 / α)
                # add new vector to subspace at position numiter+1
                if numiter < K
                    push!(V, v)
                else
                    V[mod1(numiter + 1, K)] = v
                end
            end
        end

        # Construct rotation P̂ₖ
        α̂ = hypot(ᾱ, λ) # α̂ₖ = sqrt(ᾱₖ^2 + λ^2)
        ĉ = ᾱ / α̂ # ĉ = ᾱₖ / α̂ₖ
        ŝ = λ / α̂ # ŝₖ = λ / α̂ₖ

        # Use a plane rotation Pₖ to turn Bₖ to Rₖ
        ρold = ρ # ρₖ₋₁
        ρ = hypot(α̂, β) # ρₖ
        c = α̂ / ρ # cₖ = α̂ₖ / ρₖ
        s = β / ρ # sₖ = βₖ₊₁ / ρₖ
        θ = s * α # θₖ₊₁ = sₖ * αₖ₊₁
        ᾱ = c * α # ᾱₖ₊₁ = cₖ * αₖ₊₁

        # Use a plane rotation P̄ₖ to turn Rₖᵀ to R̄ₖ
        ρ̄old = ρ̄ # ρ̄ₖ₋₁
        θ̄ = s̄ * ρ # θ̄ₖ = s̄ₖ₋₁ * ρₖ
        c̄ρ = c̄ * ρ # c̄ₖ₋₁ * ρₖ
        ρ̄ = hypot(c̄ρ, θ) # ρ̄ₖ = sqrt((c̄ₖ₋₁ * ρₖ)^2 + θₖ₊₁^2)
        c̄ = c̄ρ / ρ̄ # c̄ₖ = c̄ₖ₋₁ * ρₖ / ρ̄ₖ
        s̄ = θ / ρ̄ # s̄ₖ = θₖ₊₁ / ρ̄ₖ
        ζ = c̄ * ζ̄ # ζₖ = c̄ₖ * ζ̄_{k}
        ζ̄ = -s̄ * ζ̄ # ζ̄ₖ₊₁ = -s̄ₖ * ζ̄ₖ

        # Update h, h̄, x
        h̄ = add!!(h̄, h, 1, -θ̄ * ρ / (ρold * ρ̄old)) # h̄ₖ = hₖ - θ̄ₖ * ρₖ / (ρₖ₋₁ * ρ̄ₖ₋₁) * h̄ₖ₋₁
        Ah̄ = add!!(Ah̄, Ah, 1, -θ̄ * ρ / (ρold * ρ̄old)) # h̄ₖ = hₖ - θ̄ₖ * ρₖ / (ρₖ₋₁ * ρ̄ₖ₋₁) * h̄ₖ₋₁

        x = add!!(x, h̄, ζ / (ρ * ρ̄)) # xₖ = xₖ₋₁ + ζₖ / (ρₖ * ρ̄ₖ) * h̄ₖ
        r = add!!(r, Ah̄, -ζ / (ρ * ρ̄)) # rₖ = rₖ₋₁ - ζₖ / (ρₖ * ρ̄ₖ) * Ah̄ₖ

        h = add!!(h, v, 1, -θ / ρ) # hₖ₊₁ = vₖ₊₁ - θₖ₊₁ / ρₖ * hₖ
        # Ah is updated in the next iteration when A v is computed

        absζ̄ = abs(ζ̄)
        if absζ̄ <= tol
            if alg.verbosity >= STARTSTOP_LEVEL
                @info """LSMR lssolve converged at iteration $numiter:
                * ‖ b - A x ‖ = $(normres2string(norm(r)))
                * ‖ x ‖ = $(normres2string(norm(x)))
                * ‖ Aᴴ(b - A x) - λ^2 x ‖ = $(normres2string(absζ̄))
                * number of operations = $numops"""
            end
            return (x, ConvergenceInfo(1, r, absζ̄, numiter, numops))
        end
        if numiter >= maxiter
            if alg.verbosity >= WARN_LEVEL
                @warn """LSMR lssolve finished without converging after $numiter iterations:
                * ‖ b - A x ‖ = $(normres2string(norm(r)))
                * ‖ x ‖ = $(normres2string(norm(x)))
                * ‖ Aᴴ(b - A x) - λ^2 x ‖ = $(normres2string(absζ̄))
                * number of operations = $numops"""
            end
            return (x, ConvergenceInfo(0, r, absζ̄, numiter, numops))
        end
        if alg.verbosity >= EACHITERATION_LEVEL
            @info "LSMR lssolve in iter $numiter: convergence measure ‖ Aᴴ(b - A x) - λ^2 x ‖ = $(normres2string(absζ̄))"
        end
    end
    return
end

function eigsolve(
        A, x₀::Block{T}, howmany::Int, which::Selector, alg::BlockLanczos;
        alg_rrule = Arnoldi(;
            tol = alg.tol,
            krylovdim = alg.krylovdim,
            maxiter = alg.maxiter,
            eager = alg.eager,
            orth = alg.orth
        )
    ) where {T}
    maxiter = alg.maxiter
    krylovdim = alg.krylovdim
    if howmany > krylovdim
        error("krylov dimension $(krylovdim) too small to compute $howmany eigenvalues")
    end
    tol = alg.tol
    verbosity = alg.verbosity

    bs = length(x₀)
    iter = BlockLanczosIterator(A, x₀, krylovdim + bs, alg.orth, alg.qr_tol)
    fact = initialize(iter; verbosity = verbosity)  # Returns a BlockLanczosFactorization
    numops = bs + 1 # Number of matrix-vector multiplications (for logging)
    numiter = 1

    converged = 0
    local normresiduals, D, U

    while true
        K = length(fact)
        β = normres(fact)

        if β < tol && K < howmany && verbosity >= WARN_LEVEL
            msg = "Invariant subspace of dimension $(K) (up to requested tolerance `tol = $tol`), "
            msg *= "which is smaller than the number of requested eigenvalues (i.e. `howmany == $howmany`)."
            @warn msg
        end
        # BlockLanczos can access the case of K = 1 and doesn't need extra processing
        if K >= krylovdim || β <= tol || (alg.eager && K >= howmany)
            # Compute eigenvalues
            # Note: Fast eigen solver for block tridiagonal matrices is not implemented yet.
            BTD = view(fact.H, 1:K, 1:K)
            D, U = eigen(Hermitian(BTD))
            by, rev = eigsort(which)
            p = sortperm(D; by = by, rev = rev)
            D, U = permuteeig!(D, U, p)

            # Detect convergence by computing the residuals
            bs_R = fact.R_size   # The block size of the residual (decreases as the iteration goes)
            r = residual(fact)
            UU = view(U, (K - bs_R + 1):K, :)  # The last bs_R rows of U, used to compute the residuals
            normresiduals = let R = block_inner(r, r)
                map(u -> sqrt(real(dot(u, R, u))), cols(UU))
            end
            converged = 0
            while converged < K && normresiduals[converged + 1] <= tol
                converged += 1
            end
            if converged >= howmany || β <= tol  # Successfully find enough eigenvalues.
                break
            elseif verbosity >= EACHITERATION_LEVEL
                @info "BlockLanczos eigsolve in iteration $numiter, Krylov dimension = $K: $converged values converged, normres = $(normres2string(normresiduals[1:howmany]))"
            end
        end

        if K < krylovdim
            expand!(iter, fact; verbosity = verbosity)
            numops += fact.R_size
        else # Shrink and restart following the shrinking method of `Lanczos`.
            numiter >= maxiter && break
            keep = max(div(3 * krylovdim + 2 * converged, 5 * bs), 1) * bs
            H = zeros(eltype(fact.H), keep + bs, keep)
            # The last bs rows of U contribute to calculate errors of Ritz values.
            @inbounds for j in 1:keep
                H[j, j] = D[j]
                H[(keep + 1):end, j] = view(U, (K - bs + 1):K, j)
            end
            # Turn diagonal matrix D into a block tridiagonal matrix, and make sure
            # The residual of krylov subspace keeps the form of [0,..,0,R]
            @inbounds for j in keep:-1:1
                h, ν = householder(H, j + bs, 1:j, j)
                H[j + bs, j] = ν
                H[j + bs, 1:(j - 1)] .= zero(eltype(H))
                lmul!(h, H)
                rmul!(view(H, 1:(j + bs - 1), :), h')
                rmul!(U, h')
            end
            # Transform the basis and update the residual and update the BTD.
            fill!(BTD, zero(eltype(BTD)))
            Hkeep = view(H, 1:keep, 1:keep)
            BTD[1:keep, 1:keep] .= (Hkeep .+ Hkeep') ./ 2 # make exactly Hermitian
            B = basis(fact)
            basistransform!(B, view(U, :, 1:keep))

            R_new = OrthonormalBasis(fact.R.vec[1:bs_R])
            view_H = view(H, (keep + bs - bs_R + 1):(keep + bs), (keep - bs_R + 1):keep)
            basistransform!(R_new, view_H)
            fact.R.vec[1:bs_R] = R_new[1:bs_R]

            while length(fact) > keep
                pop!(fact.V)
                fact.k -= 1
            end
            numiter += 1
        end
    end

    howmany_actual = howmany
    if converged > howmany
        howmany_actual = converged
    elseif length(D) < howmany
        howmany_actual = length(D)
    end
    values = D[1:howmany_actual]
    U1 = view(U, :, 1:howmany_actual)
    vectors = let V = basis(fact)
        [V * u for u in cols(U1)]
    end
    bs_R = fact.R_size
    K = length(fact)
    U2 = view(U, (K - bs_R + 1):K, 1:howmany_actual)
    R = fact.R
    residuals = [zerovector(R[1]) for _ in 1:howmany_actual]
    @inbounds for i in 1:howmany_actual
        for j in 1:bs_R
            residuals[i] = add!!(residuals[i], R[j], U2[j, i])
        end
    end
    normresiduals = normresiduals[1:howmany_actual]

    if (converged < howmany) && verbosity >= WARN_LEVEL
        @warn """BlockLanczos eigsolve stopped without full convergence after $(K) iterations:
        * $converged eigenvalues converged
        * norm of residuals = $(normres2string(normresiduals))
        * number of operations = $numops"""
    elseif verbosity >= STARTSTOP_LEVEL
        @info """BlockLanczos eigsolve finished after $(K) iterations:
        * $converged eigenvalues converged
        * norm of residuals = $(normres2string(normresiduals))
        * number of operations = $numops"""
    end

    return values, vectors,
        ConvergenceInfo(converged, residuals, normresiduals, numiter, numops)
end

# TODO: Remove RecursiveVec and simply use tuple when RecursiveVec is removed.
@testset "Nested tuples - singular values full" begin
    @testset for T in (Float32, Float64, ComplexF32, ComplexF64)
        @testset for orth in (cgs2, mgs2, cgsr, mgsr)
            A = rand(T, (n, n))
            v = rand(T, (n,))
            v2 = (v, zero(v))
            alg = Lanczos(; orth = orth, krylovdim = 2 * n, maxiter = 1, tol = tolerance(T))
            D, V, info = eigsolve(v2, n, :LR, alg) do x
                x1, x2 = x
                y1 = A * x2
                y2 = A' * x1
                return (y1, y2)
            end
            @test info.converged >= n
            S = D[1:n]
            @test S ≈ svdvals(A)
            UU = hcat((sqrt(2 * one(T)) * v[1] for v in V[1:n])...)
            VV = hcat((sqrt(2 * one(T)) * v[2] for v in V[1:n])...)
            @test UU * Diagonal(S) * VV' ≈ A
        end
    end
end

@testset "Nested tuples - singular values iteratively" begin
    @testset for T in (Float32, Float64, ComplexF32, ComplexF64)
        @testset for orth in (cgs2, mgs2, cgsr, mgsr)
            A = rand(T, (N, 2 * N))
            v = rand(T, (N,))
            w = rand(T, (2 * N,))
            v2 = (v, w)
            alg = Lanczos(; orth = orth, krylovdim = n, maxiter = 300, tol = tolerance(T))
            n1 = div(n, 2)
            D, V, info = eigsolve(v2, n1, :LR, alg) do x
                x1, x2 = x
                y1 = A * x2
                y2 = A' * x1
                return (y1, y2)
            end
            @test info.converged >= n1
            S = D[1:n1]
            @test S ≈ svdvals(A)[1:n1]
            UU = hcat((sqrt(2 * one(T)) * v[1] for v in V[1:n1])...)
            VV = hcat((sqrt(2 * one(T)) * v[2] for v in V[1:n1])...)
            @test Diagonal(S) ≈ UU' * A * VV
        end
    end
end

safe_inv(a, tol) = abs(a) < tol ? zero(a) : inv(a)

# vecs are assumed orthonormal
function orthogonalprojector(vecs, n)
    function projector(w)
        w′ = zerovector(w)
        @inbounds for i in 1:n
            w′ = VectorInterface.add!!(w′, vecs[i], inner(vecs[i], w))
        end
        return w′
    end
    return projector
end
function orthogonalcomplementprojector(vecs, n)
    function projector(w)
        w′ = scale(w, 1)
        @inbounds for i in 1:n
            w′ = VectorInterface.add!!(w′, vecs[i], -inner(vecs[i], w))
        end
        return w′
    end
    return projector
end
# vecs are not assumed orthonormal, G is the Cholesky factorisation of the overlap matrix
function orthogonalprojector(vecs, n, G::Cholesky)
    overlaps = zeros(eltype(G), n)
    function projector(w)
        @inbounds for i in 1:n
            overlaps[i] = inner(vecs[i], w)
        end
        overlaps = ldiv!(G, overlaps)
        w′ = zerovector(w)
        @inbounds for i in 1:n
            w′ = VectorInterface.add!!(w′, vecs[i], +overlaps[i])
        end
        return w′
    end
    return projector
end
function orthogonalcomplementprojector(vecs, n, G::Cholesky)
    overlaps = zeros(eltype(G), n)
    function projector(w)
        @inbounds for i in 1:n
            overlaps[i] = inner(vecs[i], w)
        end
        overlaps = ldiv!(G, overlaps)
        w′ = scale(w, 1)
        @inbounds for i in 1:n
            w′ = VectorInterface.add!!(w′, vecs[i], -overlaps[i])
        end
        return w′
    end
    return projector
end

function _realview(v::AbstractVector{Complex{T}}) where {T}
    v_real = reinterpret(T, v)
    return view(v_real, axes(v_real, 1)[begin:2:end])
end

function _imagview(v::AbstractVector{Complex{T}}) where {T}
    v_real = reinterpret(T, v)
    return view(v_real, axes(v_real, 1)[(begin + 1):2:end])
end

@testset "GKL - svdsolve full ($mode)" for mode in (:vector, :inplace, :outplace, :mixed)
    scalartypes = mode === :vector ? (Float32, Float64, ComplexF32, ComplexF64) :
        (ComplexF64,)
    orths = mode === :vector ? (cgs2, mgs2, cgsr, mgsr) : (mgsr,)
    @testset for T in scalartypes
        @testset for orth in orths
            A = rand(T, (n, n))
            alg = GKL(; orth = orth, krylovdim = 2 * n, maxiter = 1, tol = tolerance(T))
            S, lvecs, rvecs, info = @constinferred svdsolve(
                wrapop(A, Val(mode)),
                wrapvec(A[:, 1], Val(mode)), n,
                :LR, alg
            )
            @test S ≈ svdvals(A)
            @test info.converged == n

            n1 = div(n, 2)
            @test_logs svdsolve(
                wrapop(A, Val(mode)), wrapvec(A[:, 1], Val(mode)), n1, :LR,
                alg
            )
            alg = GKL(;
                orth = orth, krylovdim = 2 * n, maxiter = 1, tol = tolerance(T),
                verbosity = WARN_LEVEL
            )
            @test_logs svdsolve(
                wrapop(A, Val(mode)), wrapvec(A[:, 1], Val(mode)), n1, :LR,
                alg
            )
            alg = GKL(;
                orth = orth, krylovdim = n1 + 1, maxiter = 1, tol = tolerance(T),
                verbosity = WARN_LEVEL
            )
            @test_logs (:warn,) svdsolve(
                wrapop(A, Val(mode)), wrapvec(A[:, 1], Val(mode)),
                n1, :LR,
                alg
            )
            alg = GKL(;
                orth = orth, krylovdim = 2 * n, maxiter = 1, tol = tolerance(T),
                verbosity = STARTSTOP_LEVEL
            )
            @test_logs (:info,) svdsolve(
                wrapop(A, Val(mode)), wrapvec(A[:, 1], Val(mode)),
                n1, :LR,
                alg
            )
            alg = GKL(;
                orth = orth, krylovdim = 2 * n, maxiter = 1, tol = tolerance(T),
                verbosity = EACHITERATION_LEVEL + 1
            )
            @test_logs min_level = Logging.Warn svdsolve(
                wrapop(A, Val(mode)),
                wrapvec(A[:, 1], Val(mode)),
                n1, :LR,
                alg
            )

            U = stack(unwrapvec, lvecs)
            V = stack(unwrapvec, rvecs)
            @test U' * U ≈ I
            @test V' * V ≈ I
            @test A * V ≈ U * Diagonal(S)
        end
    end
end

@testset "GKL - svdsolve iteratively ($mode)" for mode in
    (:vector, :inplace, :outplace, :mixed)
    scalartypes = mode === :vector ? (Float32, Float64, ComplexF32, ComplexF64) :
        (ComplexF64,)
    orths = mode === :vector ? (cgs2, mgs2, cgsr, mgsr) : (mgsr,)
    @testset for T in scalartypes
        @testset for orth in orths
            A = rand(T, (2 * N, N))
            v = rand(T, (2 * N,))
            n₁ = div(n, 2)
            alg = GKL(;
                orth = orth, krylovdim = n, maxiter = 10, tol = tolerance(T), eager = true,
                verbosity = SILENT_LEVEL
            )
            S, lvecs, rvecs, info = @constinferred svdsolve(
                wrapop(A, Val(mode)),
                wrapvec(v, Val(mode)),
                n₁, :LR, alg
            )

            l = info.converged
            @test S[1:l] ≈ svdvals(A)[1:l]

            U = stack(unwrapvec, lvecs)
            V = stack(unwrapvec, rvecs)
            @test U[:, 1:l]' * U[:, 1:l] ≈ I
            @test V[:, 1:l]' * V[:, 1:l] ≈ I

            R = stack(unwrapvec, info.residual)
            @test A' * U ≈ V * Diagonal(S)
            @test A * V ≈ U * Diagonal(S) + R
        end
    end
end

"""
    function exponentiate(A, t::Number, x; kwargs...)
    function exponentiate(A, t::Number, x, algorithm)

Compute ``y = exp(t*A) x``, where `A` is a general linear map, i.e. a `AbstractMatrix` or
just a general function or callable object and `x` is of any Julia type with vector like
behavior.

### Arguments:

The linear map `A` can be an `AbstractMatrix` (dense or sparse) or a general function or
callable object that implements the action of the linear map on a vector. If `A` is an
`AbstractMatrix`, `x` is expected to be an `AbstractVector`, otherwise `x` can be of any
type that behaves as a vector and supports the required methods (see KrylovKit docs).

The time parameter `t` can be real or complex, and it is better to choose `t` e.g. imaginary
and `A` hermitian, then to absorb the imaginary unit in an antihermitian `A`. For the
former, the Lanczos scheme is used to built a Krylov subspace, in which an approximation to
the exponential action of the linear map is obtained. The argument `x` can be of any type
and should be in the domain of `A`.

### Return values:

The return value is always of the form `y, info = exponentiate(...)` with

  - `y`: the result of the computation, i.e. `y = exp(t*A)*x`

  - `info`: an object of type [`ConvergenceInfo`], which has the following fields

      + `info.converged::Int`: 0 or 1 if the solution `y` at time `t` was found with an
        error below the requested tolerance per unit time, i.e. if `info.normres <= tol * abs(t)`
      + `info.residual::Nothing`: value `nothing`, there is no concept of a residual in
        this case
      + `info.normres::Real`: a (rough) estimate of the total error accumulated in the
        solution
      + `info.numops::Int`: number of times the linear map was applied, i.e. number of times
        `f` was called, or a vector was multiplied with `A`
      + `info.numiter::Int`: number of times the Krylov subspace was restarted (see below)

!!! warning "Check for convergence"

    By default (i.e. if `verbosity = SILENT_LEVEL`, see below), no warning is printed if the solution
    was not found with the requested precision, so be sure to check `info.converged == 1`.

### Keyword arguments:

Keyword arguments and their default values are given by:

  - `verbosity::Int = SILENT_LEVEL`: verbosity level, i.e. 
    - SILENT_LEVEL (suppress all messages)
    - WARN_LEVEL (only warnings)
    - STARTSTOP_LEVEL (one message with convergence info at the end)
    - EACHITERATION_LEVEL (progress info after every iteration)
    - EACHITERATION_LEVEL+ (all of the above and additional information about the Lanczos or Arnoldi iteration)
  - `krylovdim = 30`: the maximum dimension of the Krylov subspace that will be constructed.
    Note that the dimension of the vector space is not known or checked, e.g. `x₀` should
    not necessarily support the `Base.length` function. If you know the actual problem
    dimension is smaller than the default value, it is useful to reduce the value of
    `krylovdim`, though in principle this should be detected.
  - `tol = 1e-12`: the requested accuracy per unit time, i.e. if you want a certain
    precision `ϵ` on the final result, set `tol = ϵ/abs(t)`. If you work in e.g. single
    precision (`Float32`), you should definitely change the default value.
  - `maxiter::Int = 100`: the number of times the Krylov subspace can be rebuilt; see below
    for further details on the algorithms.
  - `issymmetric`: if the linear map is symmetric, only meaningful if `T<:Real`
  - `ishermitian`: if the linear map is hermitian
    The default value for the last two depends on the method. If an `AbstractMatrix` is
    used, `issymmetric` and `ishermitian` are checked for that matrix, otherwise the default
    values are `issymmetric = false` and `ishermitian = T <: Real && issymmetric`.
  - `eager::Bool = false`: if true, eagerly try to compute the result after every expansion
    of the Krylov subspace to test for convergence, otherwise wait until the Krylov subspace
    as dimension `krylovdim`. This can result in a faster return, for example if the total
    time for the evolution is quite small, but also has some overhead, as more computations
    are performed after every expansion step.

### Algorithm

This is actually a simple wrapper over more general method [`expintegrator`](@ref) for
for integrating a linear non-homogeneous ODE.
"""
function exponentiate end

exponentiate(A, t::Number, v; kwargs...) = expintegrator(A, t, v; kwargs...)
exponentiate(A, t::Number, v, alg::Union{Lanczos, Arnoldi}) = expintegrator(A, t, (v,), alg)

@testset "Arnoldi - schursolve full ($mode)" for mode in (:vector, :inplace, :outplace)
    scalartypes = mode === :vector ? (Float32, Float64, ComplexF32, ComplexF64) :
        (ComplexF64,)
    orths = mode === :vector ? (cgs2, mgs2, cgsr, mgsr) : (mgsr,)
    @testset for T in scalartypes
        @testset for orth in orths
            A = rand(T, (n, n)) .- one(T) / 2
            v = rand(T, (n,))
            alg = Arnoldi(; orth = orth, krylovdim = n, maxiter = 1, tol = tolerance(T))
            n1 = div(n, 2)
            T1, V1, D1, info1 = @constinferred schursolve(
                wrapop(A, Val(mode)),
                wrapvec(v, Val(mode)), n1, :SR,
                alg
            )
            @test_logs schursolve(
                wrapop(A, Val(mode)), wrapvec(v, Val(mode)), n1, :SR,
                alg
            )
            alg = Arnoldi(;
                orth = orth, krylovdim = n, maxiter = 1, tol = tolerance(T),
                verbosity = WARN_LEVEL
            )
            @test_logs schursolve(
                wrapop(A, Val(mode)), wrapvec(v, Val(mode)), n1, :SR,
                alg
            )
            alg = Arnoldi(;
                orth = orth, krylovdim = n1 + 1, maxiter = 1, tol = tolerance(T),
                verbosity = WARN_LEVEL
            )
            @test_logs (:warn,) schursolve(
                wrapop(A, Val(mode)), wrapvec(v, Val(mode)), n1,
                :SR,
                alg
            )
            alg = Arnoldi(;
                orth = orth, krylovdim = n, maxiter = 1, tol = tolerance(T),
                verbosity = STARTSTOP_LEVEL
            )
            @test_logs (:info,) schursolve(
                wrapop(A, Val(mode)), wrapvec(v, Val(mode)), n1,
                :SR,
                alg
            )

            alg = Arnoldi(; orth = orth, krylovdim = n, maxiter = 1, tol = tolerance(T))
            n2 = n - n1
            T2, V2, D2, info2 = schursolve(
                wrapop(A, Val(mode)), wrapvec(v, Val(mode)), n2,
                :LR, alg
            )
            D = sort(sort(eigvals(A); by = imag, rev = true); alg = MergeSort, by = real)
            D2′ = sort(sort(D2; by = imag, rev = true); alg = MergeSort, by = real)

            @test vcat(D1[1:n1], D2′[(end - n2 + 1):end]) ≈ D

            U1 = stack(unwrapvec, V1)
            U2 = stack(unwrapvec, V2)
            @test U1' * U1 ≈ I
            @test U2' * U2 ≈ I

            @test A * U1 ≈ U1 * T1
            @test A * U2 ≈ U2 * T2

            if T <: Complex
                T1, V1, D1, info = schursolve(
                    wrapop(A, Val(mode)), wrapvec(v, Val(mode)),
                    n1, :SI, alg
                )
                T2, V2, D2, info = schursolve(
                    wrapop(A, Val(mode)), wrapvec(v, Val(mode)),
                    n2, :LI, alg
                )
                D = sort(eigvals(A); by = imag)

                @test vcat(D1[1:n1], reverse(D2[1:n2])) ≈ D

                U1 = stack(unwrapvec, V1)
                U2 = stack(unwrapvec, V2)
                @test U1' * U1 ≈ I
                @test U2' * U2 ≈ I

                @test A * U1 ≈ U1 * T1
                @test A * U2 ≈ U2 * T2
            end
        end
    end
end

@testset "Arnoldi - schursolve iteratively ($mode)" for mode in
    (:vector, :inplace, :outplace)
    scalartypes = mode === :vector ? (Float32, Float64, ComplexF32, ComplexF64) :
        (ComplexF64,)
    orths = mode === :vector ? (cgs2, mgs2, cgsr, mgsr) : (mgsr,)
    @testset for T in scalartypes
        @testset for orth in orths
            A = rand(T, (N, N)) .- one(T) / 2
            v = rand(T, (N,))
            alg = Arnoldi(;
                orth = orth, krylovdim = 3 * n, maxiter = 10, tol = tolerance(T),
                verbosity = SILENT_LEVEL
            )
            T1, V1, D1, info1 = @constinferred schursolve(
                wrapop(A, Val(mode)),
                wrapvec(v, Val(mode)), n, :SR,
                alg
            )
            T2, V2, D2, info2 = schursolve(
                wrapop(A, Val(mode)), wrapvec(v, Val(mode)), n,
                :LR, alg
            )
            T3, V3, D3, info3 = schursolve(
                wrapop(A, Val(mode)), wrapvec(v, Val(mode)), n,
                :LM, alg
            )
            D = sort(eigvals(A); by = imag, rev = true)

            l1 = info1.converged
            l2 = info2.converged
            l3 = info3.converged
            @test D1[1:l1] ≊ sort(D; alg = MergeSort, by = real)[1:l1]
            @test D2[1:l2] ≊ sort(D; alg = MergeSort, by = real, rev = true)[1:l2]
            @test D3[1:l3] ≊ sort(D; alg = MergeSort, by = abs, rev = true)[1:l3]

            U1 = stack(unwrapvec, V1)
            U2 = stack(unwrapvec, V2)
            U3 = stack(unwrapvec, V3)
            @test U1' * U1 ≈ one(U1' * U1)
            @test U2' * U2 ≈ one(U2' * U2)
            @test U3' * U3 ≈ one(U3' * U3)

            R1 = stack(unwrapvec, info1.residual)
            R2 = stack(unwrapvec, info2.residual)
            R3 = stack(unwrapvec, info3.residual)
            @test A * U1 ≈ U1 * T1 + R1
            @test A * U2 ≈ U2 * T2 + R2
            @test A * U3 ≈ U3 * T3 + R3

            if T <: Complex
                T1, V1, D1, info1 = schursolve(
                    wrapop(A, Val(mode)), wrapvec(v, Val(mode)),
                    n, :SI, alg
                )
                T2, V2, D2, info2 = schursolve(
                    wrapop(A, Val(mode)), wrapvec(v, Val(mode)),
                    n, :LI, alg
                )
                D = eigvals(A)

                l1 = info1.converged
                l2 = info2.converged
                @test D1[1:l1] ≊ sort(D; by = imag)[1:l1]
                @test D2[1:l2] ≊ sort(D; by = imag, rev = true)[1:l2]

                U1 = stack(unwrapvec, V1)
                U2 = stack(unwrapvec, V2)
                @test U1[:, 1:l1]' * U1[:, 1:l1] ≈ I
                @test U2[:, 1:l2]' * U2[:, 1:l2] ≈ I

                R1 = stack(unwrapvec, info1.residual)
                R2 = stack(unwrapvec, info2.residual)
                @test A * U1 ≈ U1 * T1 + R1
                @test A * U2 ≈ U2 * T2 + R2
            end
        end
    end
end

module EigsolveAD
using KrylovKit, LinearAlgebra
using KrylovKit: SILENT_LEVEL, WARN_LEVEL, STARTSTOP_LEVEL, EACHITERATION_LEVEL
using Random, Test, TestExtras
using ChainRulesCore, ChainRulesTestUtils, Zygote, FiniteDifferences
using ..TestSetup
Random.seed!(987654321)

fdm = ChainRulesTestUtils._fdm
n = 10
N = 30

function build_mat_example(A, x, howmany::Int, which, alg, alg_rrule)
    Avec, A_fromvec = to_vec(A)
    xvec, x_fromvec = to_vec(x)

    vals, vecs, info = eigsolve(A, x, howmany, which, alg)
    info.converged < howmany && @warn "eigsolve did not converge"
    if eltype(A) <: Real && length(vals) > howmany &&
            vals[howmany] == conj(vals[howmany + 1])
        howmany += 1
    end

    function mat_example(Av, xv)
        Ã = A_fromvec(Av)
        x̃ = x_fromvec(xv)
        vals′, vecs′, info′ = eigsolve(Ã, x̃, howmany, which, alg; alg_rrule = alg_rrule)
        info′.converged < howmany && println("eigsolve did not converge")
        catresults = vcat(vals′[1:howmany], vecs′[1:howmany]...)
        if eltype(catresults) <: Complex
            return vcat(real(catresults), imag(catresults))
        else
            return catresults
        end
    end

    function mat_example_fun(Av, xv)
        Ã = A_fromvec(Av)
        x̃ = x_fromvec(xv)
        f = x -> Ã * x
        vals′, vecs′, info′ = eigsolve(f, x̃, howmany, which, alg; alg_rrule = alg_rrule)
        info′.converged < howmany && println("eigsolve did not converge")
        catresults = vcat(vals′[1:howmany], vecs′[1:howmany]...)
        if eltype(catresults) <: Complex
            return vcat(real(catresults), imag(catresults))
        else
            return catresults
        end
    end

    function mat_example_fd(Av, xv)
        Ã = A_fromvec(Av)
        x̃ = x_fromvec(xv)
        vals′, vecs′, info′ = eigsolve(Ã, x̃, howmany, which, alg; alg_rrule = alg_rrule)
        info′.converged < howmany && println("eigsolve did not converge")
        for i in 1:howmany
            d = dot(vecs[i], vecs′[i])
            @assert abs(d) > sqrt(eps(real(eltype(A))))
            phasefix = abs(d) / d
            vecs′[i] = vecs′[i] * phasefix
        end
        catresults = vcat(vals′[1:howmany], vecs′[1:howmany]...)
        if eltype(catresults) <: Complex
            return vcat(real(catresults), imag(catresults))
        else
            return catresults
        end
    end

    return mat_example, mat_example_fun, mat_example_fd, Avec, xvec, vals, vecs, howmany
end

function testfun(A, x, c, d)
    return A * x + c * dot(d, x)
end
testfunthunk(A, x, c, d) = testfun(A, x, c, d)
function ChainRulesCore.rrule(
        config::RuleConfig{>:HasReverseMode}, ::typeof(testfunthunk),
        args...
    )
    y = testfunthunk(args...)
    function thunkedpb(dy)
        pb = rrule_via_ad(config, testfun, args...)[2]
        return map(z -> @thunk(z), pb(dy))
    end
    return y, thunkedpb
end

function build_fun_example(A, x, c, d, howmany::Int, which, alg, alg_rrule)
    Avec, matfromvec = to_vec(A)
    xvec, vecfromvec = to_vec(x)
    cvec, = to_vec(c)
    dvec, = to_vec(d)

    vals, vecs, info = eigsolve(x, howmany, which, alg) do y
        return testfunthunk(A, y, c, d)
    end
    info.converged < howmany && @warn "eigsolve did not converge"
    if eltype(A) <: Real && length(vals) > howmany &&
            vals[howmany] == conj(vals[howmany + 1])
        howmany += 1
    end

    fun_example_ad = let howmany′ = howmany
        function (Av, xv, cv, dv)
            Ã = matfromvec(Av)
            x̃ = vecfromvec(xv)
            c̃ = vecfromvec(cv)
            d̃ = vecfromvec(dv)

            vals′, vecs′, info′ = eigsolve(
                x̃, howmany′, which, alg;
                alg_rrule = alg_rrule
            ) do y
                return testfunthunk(Ã, y, c̃, d̃)
            end
            info′.converged < howmany′ && println("eigsolve did not converge")
            catresults = vcat(vals′[1:howmany′], vecs′[1:howmany′]...)
            if eltype(catresults) <: Complex
                return vcat(real(catresults), imag(catresults))
            else
                return catresults
            end
        end
    end

    fun_example_fd = let howmany′ = howmany
        function (Av, xv, cv, dv)
            Ã = matfromvec(Av)
            x̃ = vecfromvec(xv)
            c̃ = vecfromvec(cv)
            d̃ = vecfromvec(dv)

            vals′, vecs′, info′ = eigsolve(
                x̃, howmany′, which, alg;
                alg_rrule = alg_rrule
            ) do y
                return Ã * y + c̃ * dot(d̃, y)
            end
            info′.converged < howmany′ && println("eigsolve did not converge")
            for i in 1:howmany′
                d = dot(vecs[i], vecs′[i])
                @assert abs(d) > sqrt(eps(real(eltype(A))))
                phasefix = abs(d) / d
                vecs′[i] = vecs′[i] * phasefix
            end
            catresults = vcat(vals′[1:howmany′], vecs′[1:howmany′]...)
            if eltype(catresults) <: Complex
                return vcat(real(catresults), imag(catresults))
            else
                return catresults
            end
        end
    end

    return fun_example_ad, fun_example_fd, Avec, xvec, cvec, dvec, vals, vecs, howmany
end

function build_hermitianfun_example(A, x, c, howmany::Int, which, alg, alg_rrule)
    Avec, matfromvec = to_vec(A)
    xvec, xvecfromvec = to_vec(x)
    cvec, cvecfromvec = to_vec(c)

    vals, vecs, info = eigsolve(x, howmany, which, alg) do y
        return testfunthunk(Hermitian(A), y, c, c)
    end
    info.converged < howmany && @warn "eigsolve did not converge"

    function fun_example(Av, xv, cv)
        Ã = matfromvec(Av)
        x̃ = xvecfromvec(xv)
        c̃ = cvecfromvec(cv)

        vals′, vecs′, info′ = eigsolve(
            x̃, howmany, which, alg;
            alg_rrule = alg_rrule
        ) do y
            return testfunthunk(Hermitian(Ã), y, c̃, c̃)
        end
        info′.converged < howmany && println("eigsolve did not converge")
        catresults = vcat(vals′[1:howmany], vecs′[1:howmany]...)
        if eltype(catresults) <: Complex
            return vcat(real(catresults), imag(catresults))
        else
            return catresults
        end
    end

    function fun_example_fd(Av, xv, cv)
        Ã = matfromvec(Av)
        x̃ = xvecfromvec(xv)
        c̃ = cvecfromvec(cv)

        vals′, vecs′, info′ = eigsolve(
            x̃, howmany, which, alg;
            alg_rrule = alg_rrule
        ) do y
            return Hermitian(Ã) * y + c̃ * dot(c̃, y)
        end
        info′.converged < howmany && println("eigsolve did not converge")
        for i in 1:howmany
            d = dot(vecs[i], vecs′[i])
            @assert abs(d) > sqrt(eps(real(eltype(A))))
            phasefix = abs(d) / d
            vecs′[i] = vecs′[i] * phasefix
        end
        catresults = vcat(vals′[1:howmany], vecs′[1:howmany]...)
        if eltype(catresults) <: Complex
            return vcat(real(catresults), imag(catresults))
        else
            return catresults
        end
    end

    return fun_example, fun_example_fd, Avec, xvec, cvec, vals, vecs, howmany
end

@timedtestset "Small eigsolve AD test for eltype=$T" for T in
    (
        Float32, Float64, ComplexF32,
        ComplexF64,
    )
    if T <: Complex
        whichlist = (:LM, :SR, :LR, :SI, :LI)
    else
        whichlist = (:LM, :SR, :LR)
    end
    A = 2 * (rand(T, (n, n)) .- one(T) / 2)
    x = 2 * (rand(T, n) .- one(T) / 2)
    x /= norm(x)

    howmany = 3
    condA = cond(A)
    tol = tolerance(T) # n * condA * (T <: Real ? eps(T) : 4 * eps(real(T)))
    alg = Arnoldi(; tol = tol, krylovdim = n)
    alg_rrule1 = Arnoldi(; tol = tol, krylovdim = 2n, verbosity = SILENT_LEVEL)
    alg_rrule2 = GMRES(; tol = tol, krylovdim = n + 1, verbosity = SILENT_LEVEL)
    config = Zygote.ZygoteRuleConfig()
    @testset for which in whichlist
        for alg_rrule in (alg_rrule1, alg_rrule2)
            # unfortunately, rrule does not seem type stable for function arguments, because the
            # `rrule_via_ad` call does not produce type stable `rrule`s for the function
            (vals, vecs, info), pb = ChainRulesCore.rrule(
                config, eigsolve, A, x, howmany,
                which, alg; alg_rrule = alg_rrule
            )
            # NOTE: the following is not necessary here, as it is corrected for in the `eigsolve` rrule
            # if length(vals) > howmany && vals[howmany] == conj(vals[howmany + 1])
            #     howmany += 1
            # end
            @constinferred pb((ZeroTangent(), ZeroTangent(), NoTangent()))
            @constinferred pb((randn(T, howmany), ZeroTangent(), NoTangent()))
            @constinferred pb((randn(T, howmany), [randn(T, n)], NoTangent()))
            @constinferred pb(
                (
                    randn(T, howmany), [randn(T, n) for _ in 1:howmany],
                    NoTangent(),
                )
            )
        end

        for alg_rrule in (alg_rrule1, alg_rrule2)
            #! format: off
            mat_example, mat_example_fun, mat_example_fd, Avec, xvec, vals, vecs, howmany = 
                build_mat_example(A, x, howmany, which, alg, alg_rrule)
            #! format: on
            (JA, Jx) = FiniteDifferences.jacobian(fdm, mat_example_fd, Avec, xvec)
            (JA1, Jx1) = Zygote.jacobian(mat_example, Avec, xvec)
            (JA2, Jx2) = Zygote.jacobian(mat_example_fun, Avec, xvec)

            # finite difference comparison using some kind of tolerance heuristic
            @test isapprox(JA, JA1; rtol = condA * sqrt(eps(real(T))))
            @test all(isapprox.(JA1, JA2; atol = n * eps(real(T))))
            @test norm(Jx, Inf) < condA * sqrt(eps(real(T)))
            @test all(iszero, Jx1)
            @test all(iszero, Jx2)

            # some analysis
            ∂vals = complex.(JA1[1:howmany, :], JA1[howmany * (n + 1) .+ (1:howmany), :])
            ∂vecs = map(1:howmany) do i
                return complex.(
                    JA1[(howmany + (i - 1) * n) .+ (1:n), :],
                    JA1[(howmany * (n + 2) + (i - 1) * n) .+ (1:n), :]
                )
            end
            if eltype(A) <: Complex # test holomorphicity / Cauchy-Riemann equations
                # for eigenvalues
                @test real(∂vals[:, 1:2:(2n^2)]) ≈ +imag(∂vals[:, 2:2:(2n^2)])
                @test imag(∂vals[:, 1:2:(2n^2)]) ≈ -real(∂vals[:, 2:2:(2n^2)])
                # and for eigenvectors
                for i in 1:howmany
                    @test real(∂vecs[i][:, 1:2:(2n^2)]) ≈ +imag(∂vecs[i][:, 2:2:(2n^2)])
                    @test imag(∂vecs[i][:, 1:2:(2n^2)]) ≈ -real(∂vecs[i][:, 2:2:(2n^2)])
                end
            end
            # test orthogonality of vecs and ∂vecs
            for i in 1:howmany
                @test all(isapprox.(abs.(vecs[i]' * ∂vecs[i]), 0; atol = sqrt(eps(real(T)))))
            end
        end
    end

    if T <: Complex
        @testset "test warnings and info" begin
            alg = Arnoldi(; tol = tol, krylovdim = n, verbosity = SILENT_LEVEL)
            alg_rrule = Arnoldi(; tol = tol, krylovdim = n, verbosity = SILENT_LEVEL)
            (vals, vecs, info), pb = ChainRulesCore.rrule(
                config, eigsolve, A, x, howmany,
                :LR, alg; alg_rrule = alg_rrule
            )
            @test_logs pb((ZeroTangent(), im .* vecs[1:2] .+ vecs[2:-1:1], NoTangent()))

            alg = Arnoldi(; tol = tol, krylovdim = n, verbosity = SILENT_LEVEL)
            alg_rrule = Arnoldi(; tol = tol, krylovdim = n, verbosity = WARN_LEVEL)
            (vals, vecs, info), pb = ChainRulesCore.rrule(
                config, eigsolve, A, x, howmany,
                :LR, alg; alg_rrule = alg_rrule
            )
            @test_logs (:warn,) pb(
                (
                    ZeroTangent(), im .* vecs[1:2] .+ vecs[2:-1:1],
                    NoTangent(),
                )
            )
            pbs = @test_logs pb((ZeroTangent(), vecs[1:2], NoTangent()))
            @test norm(unthunk(pbs[1]), Inf) < condA * sqrt(eps(real(T)))

            alg = Arnoldi(; tol = tol, krylovdim = n, verbosity = WARN_LEVEL)
            alg_rrule = Arnoldi(; tol = tol, krylovdim = n, verbosity = STARTSTOP_LEVEL)
            (vals, vecs, info), pb = ChainRulesCore.rrule(
                config, eigsolve, A, x, howmany,
                :LR, alg; alg_rrule = alg_rrule
            )
            @test_logs (:warn,) (:info,) pb(
                (
                    ZeroTangent(), im .* vecs[1:2] .+ vecs[2:-1:1],
                    NoTangent(),
                )
            )
            pbs = @test_logs (:info,) pb((ZeroTangent(), vecs[1:2], NoTangent()))
            @test norm(unthunk(pbs[1]), Inf) < condA * sqrt(eps(real(T)))

            alg = Arnoldi(; tol = tol, krylovdim = n, verbosity = SILENT_LEVEL)
            alg_rrule = GMRES(; tol = tol, krylovdim = n, verbosity = SILENT_LEVEL)
            (vals, vecs, info), pb = ChainRulesCore.rrule(
                config, eigsolve, A, x, howmany,
                :LR, alg; alg_rrule = alg_rrule
            )
            @test_logs pb((ZeroTangent(), im .* vecs[1:2] .+ vecs[2:-1:1], NoTangent()))

            alg = Arnoldi(; tol = tol, krylovdim = n, verbosity = SILENT_LEVEL)
            alg_rrule = GMRES(; tol = tol, krylovdim = n, verbosity = WARN_LEVEL)
            (vals, vecs, info), pb = ChainRulesCore.rrule(
                config, eigsolve, A, x, howmany,
                :LR, alg; alg_rrule = alg_rrule
            )
            @test_logs (:warn,) (:warn,) pb(
                (
                    ZeroTangent(),
                    im .* vecs[1:2] .+
                        vecs[2:-1:1],
                    NoTangent(),
                )
            )
            pbs = @test_logs pb((ZeroTangent(), vecs[1:2], NoTangent()))
            @test norm(unthunk(pbs[1]), Inf) < condA * sqrt(eps(real(T)))

            alg = Arnoldi(; tol = tol, krylovdim = n, verbosity = WARN_LEVEL)
            alg_rrule = GMRES(; tol = tol, krylovdim = n, verbosity = STARTSTOP_LEVEL)
            (vals, vecs, info), pb = ChainRulesCore.rrule(
                config, eigsolve, A, x, howmany,
                :LR, alg; alg_rrule = alg_rrule
            )
            @test_logs (:warn,) (:info,) (:info,) (:warn,) (:info,) (:info,) pb(
                (
                    ZeroTangent(),
                    im .*
                        vecs[1:2] .+
                        vecs[2:-1:1],
                    NoTangent(),
                )
            )
            pbs = @test_logs (:info,) (:info,) pb((ZeroTangent(), vecs[1:2], NoTangent()))
            @test norm(unthunk(pbs[1]), Inf) < condA * sqrt(eps(real(T)))
        end
    end
end
@timedtestset "Large eigsolve AD test with eltype=$T" for T in (Float64, ComplexF64)
    if T <: Complex
        whichlist = (:LM, :SI)
    else
        whichlist = (:LM, :SR)
    end
    @testset for which in whichlist
        A = rand(T, (N, N)) .- one(T) / 2
        A = I - (9 // 10) * A / maximum(abs, eigvals(A))
        x = 2 * (rand(T, N) .- one(T) / 2)
        x /= norm(x)
        c = 2 * (rand(T, N) .- one(T) / 2)
        d = 2 * (rand(T, N) .- one(T) / 2)

        howmany = 2
        tol = tolerance(T) # 2 * N^2 * eps(real(T))
        alg = Arnoldi(; tol = tol, krylovdim = 2n)
        alg_rrule1 = Arnoldi(; tol = tol, krylovdim = 2n, verbosity = SILENT_LEVEL)
        alg_rrule2 = GMRES(; tol = tol, krylovdim = 2n, verbosity = SILENT_LEVEL)
        @testset for alg_rrule in (alg_rrule1, alg_rrule2)
            #! format: off
            fun_example, fun_example_fd, Avec, xvec, cvec, dvec, vals, vecs, howmany =
                build_fun_example(A, x, c, d, howmany, which, alg, alg_rrule)
            #! format: on

            (JA, Jx, Jc, Jd) = FiniteDifferences.jacobian(
                fdm, fun_example_fd, Avec, xvec,
                cvec, dvec
            )
            (JA′, Jx′, Jc′, Jd′) = Zygote.jacobian(fun_example, Avec, xvec, cvec, dvec)

            rtol = cond(A + c * d') * sqrt(eps(real(T)))
            @test isapprox(JA, JA′; rtol = rtol)
            @test isapprox(Jc, Jc′; rtol = rtol)
            @test isapprox(Jd, Jd′; rtol = rtol)
        end
    end
end
@timedtestset "Large Hermitian eigsolve AD test with eltype=$T" for T in
    (Float64, ComplexF64)
    whichlist = (:LR, :SR)
    @testset for which in whichlist
        A = rand(T, (N, N)) .- one(T) / 2
        A = I - (9 // 10) * A / maximum(abs, eigvals(A))
        x = 2 * (rand(T, N) .- one(T) / 2)
        x /= norm(x)
        c = 2 * (rand(T, N) .- one(T) / 2)

        howmany = 2
        tol = tolerance(T)
        alg = Lanczos(; tol = tol, krylovdim = 2n)
        alg_rrule1 = Arnoldi(; tol = tol, krylovdim = 2n, verbosity = SILENT_LEVEL)
        alg_rrule2 = GMRES(; tol = tol, krylovdim = 2n, verbosity = SILENT_LEVEL)
        @testset for alg_rrule in (alg_rrule1, alg_rrule2)
            #! format: off
            fun_example, fun_example_fd, Avec, xvec, cvec, vals, vecs, howmany =
                build_hermitianfun_example(A, x, c, howmany, which, alg, alg_rrule)
            #! format: on

            (JA, Jx, Jc) = FiniteDifferences.jacobian(
                fdm, fun_example_fd, Avec, xvec,
                cvec
            )
            (JA′, Jx′, Jc′) = Zygote.jacobian(fun_example, Avec, xvec, cvec)
            rtol = cond(A + c * c') * sqrt(eps(real(T)))
            @test isapprox(JA, JA′; rtol = rtol)
            @test isapprox(Jc, Jc′; rtol = rtol)
        end
    end
end

end

"""
    x₀ = Block{S}(vec)
    x₀ = Block(vec)

Structure for storing vectors in a block format. The type parameter `T` represents the type of vector elements,
while `S` represents the type of inner products between vectors. To create an instance of the `Block` type,
one can specify `S` explicitly and use `Block{S}(vec)`, or use `Block(vec)` directly, in which case an
inner product is performed to infer `S`.
"""
struct Block{T}
    vec::Vector{T}
    function Block{T}(vec::Vector{T}) where {T}
        length(vec) > 0 || throw(ArgumentError("blocklength must be >(0)"))
        return new{T}(vec)
    end
end
Block(vec::Vector{T}) where {T} = Block{T}(vec)

Base.length(b::Block) = length(b.vec)

Base.@propagate_inbounds Base.getindex(b::Block, i::Int) = b.vec[i]
Base.@propagate_inbounds function Base.getindex(b::Block, idxs::AbstractVector{<:Integer})
    return Block(b.vec[idxs])
end

Base.@propagate_inbounds function Base.setindex!(b::Block, v, i::Int)
    b.vec[i] = v
    return b
end
Base.@propagate_inbounds function Base.setindex!(
        b₁::Block, b₂::Block, idxs::AbstractVector{Int}
    )
    b₁.vec[idxs] = b₂.vec
    return b₁
end

LinearAlgebra.norm(b::Block) = norm(b.vec)

apply(f, block::Block) = Block(map(Base.Fix1(apply, f), block.vec))

apply_scalartype(f, x₀::Block, as::Number...) = apply_scalartype(f, first(x₀), as...)

function block_inner(B₁::Block{T}, B₂::Block{T}) where {T}
    m₁₁ = inner(B₁[1], B₂[1])
    M = Matrix{typeof(m₁₁)}(undef, length(B₁), length(B₂))
    @inbounds M[1, 1] = m₁₁
    @inbounds for j in axes(M, 2), i in axes(M, 1)
        i == j == 1 && continue
        M[i, j] = inner(B₁[i], B₂[j])
    end
    return M
end

function Base.push!(V::OrthonormalBasis{T}, b::Block{T}) where {T}
    for i in 1:length(b)
        push!(V, b[i])
    end
    return V
end

Base.copy(b::Block{T}) where {T} = Block{T}(scale.(b.vec, One()))

Base.iterate(b::Block) = iterate(b.vec)
Base.iterate(b::Block, state) = iterate(b.vec, state)

"""
    mutable struct BlockLanczosFactorization{T,S<:Number,SR<:Real} <: KrylovFactorization{T,S}

Structure to store a BlockLanczos factorization of a real symmetric or complex hermitian linear
map `A` of the form

```julia
A * V = V * H + R * B'
```

For a given BlockLanczos factorization `fact`, length `k = length(fact)` and basis `V = basis(fact)` are
like [`LanczosFactorization`](@ref). The hermitian block tridiagonal matrix `H` is preallocated
in `BlockLanczosFactorization` and can reach a maximal size of `(krylovdim + bs₀, krylovdim + bs₀)`, where `bs₀` is the size of the initial block
and `krylovdim` is the maximum dimension of the Krylov subspace. A list of residual vectors is contained in `R` is of type `Vector{T}`.
One can also query [`normres(fact)`](@ref) to obtain `norm(R)`, which computes a total norm of all residual vectors combined. The matrix
`B` takes the default value ``[0; I]``, i.e. the matrix of size `(k,bs)` containing a unit matrix in the last
`bs` rows and all zeros in the other rows. `bs` is the size of the last block.

`BlockLanczosFactorization` is mutable because it can [`expand!`](@ref). But it does not support `shrink!`
because it is implemented in its `eigsolve`.
See also [`BlockLanczosIterator`](@ref) for an iterator that constructs a progressively expanding
BlockLanczos factorizations of a given linear map and a starting block.
"""
mutable struct BlockLanczosFactorization{T, S <: Number, SR <: Real} <: KrylovFactorization{T, S}
    k::Int
    V::OrthonormalBasis{T}      # BlockLanczos Basis
    H::Matrix{S}                # block tridiagonal matrix, and S is the matrix element type
    R::Block{T}                 # residual block
    R_size::Int                 # size of the residual block
    norm_R::SR                  # norm of the residual block
end
Base.length(fact::BlockLanczosFactorization) = fact.k
normres(fact::BlockLanczosFactorization) = fact.norm_R
basis(fact::BlockLanczosFactorization) = fact.V
residual(fact::BlockLanczosFactorization) = fact.R[1:(fact.R_size)]

"""
    struct BlockLanczosIterator{F,T,S<:Real,O<:Orthogonalizer} <: KrylovIterator{F,T}
    BlockLanczosIterator(f, x₀, maxdim, qr_tol, [orth::Orthogonalizer = KrylovDefaults.orth])

Iterator that takes a linear map `f::F` (supposed to be real symmetric or complex hermitian)
and an initial block `x₀::Block{T}` and generates an expanding `BlockLanczosFactorization` thereof. In
particular, `BlockLanczosIterator` uses the
BlockLanczos iteration(see: *Golub, G. H., & Van Loan, C. F. (2013). Matrix Computations* (4th ed., pp. 566–569))
scheme to build a successively expanding BlockLanczos factorization. While `f` cannot be tested to be symmetric or
hermitian directly when the linear map is encoded as a general callable object or function, with `block_inner(X, f.(X))`,
it is tested whether `norm(M-M')` is sufficiently small to be neglected.

The argument `f` can be a matrix, or a function accepting a single argument `v`, so that
`f(v)` implements the action of the linear map on the vector `v`.

The optional argument `orth` specifies which [`Orthogonalizer`](@ref) to be used. The
default value in [`KrylovDefaults`](@ref) is to use [`ModifiedGramSchmidt2`](@ref), which
uses reorthogonalization steps in every iteration.
Now our orthogonalizer is only ModifiedGramSchmidt2. So we don't need to provide "keepvecs" because we have to reverse all krylove vectors.
Dimension of Krylov subspace in BlockLanczosIterator is usually much bigger than lanczos and its Default value is 100.
`qr_tol` is the tolerance used in [`block_qr!`](@ref) to resolve the rank of a block of vectors.

When iterating over an instance of `BlockLanczosIterator`, the values being generated are
instances of [`BlockLanczosFactorization`](@ref). 

The internal state of `BlockLanczosIterator` is the same as the return value, i.e. the
corresponding `BlockLanczosFactorization`.

Here, [`initialize(::KrylovIterator)`](@ref) produces the first Krylov factorization,
and [`expand!(iter::KrylovIterator, fact::KrylovFactorization)`](@ref) expands the
factorization in place.
"""
struct BlockLanczosIterator{F, T, O <: Orthogonalizer, S <: Real} <: KrylovIterator{F, T}
    operator::F
    x₀::Block{T}
    maxdim::Int
    orth::O
    qr_tol::S
    function BlockLanczosIterator{F, T, O, S}(
            operator::F, x₀::Block{T}, maxdim::Int, orth::O, qr_tol::S
        ) where {F, T, O <: Orthogonalizer, S <: Real}
        return new{F, T, O, S}(operator, x₀, maxdim, orth, qr_tol)
    end
end
function BlockLanczosIterator(
        operator::F, x₀::Block{T}, maxdim::Int,
        orth::O = KrylovDefaults.orth, qr_tol::Real = KrylovDefaults.tol[]
    ) where {
        F, T,
        O <: Orthogonalizer,
    }
    norm(x₀) < qr_tol && @error "initial vector should not have norm zero"
    orth != ModifiedGramSchmidt2() &&
        @error "BlockLanczosIterator only supports ModifiedGramSchmidt2 orthogonalizer"
    return BlockLanczosIterator{F, T, O, typeof(qr_tol)}(operator, x₀, maxdim, orth, qr_tol)
end

function initialize(
        iter::BlockLanczosIterator;
        verbosity::Int = KrylovDefaults.verbosity[]
    )
    X₀ = iter.x₀
    maxdim = iter.maxdim
    A = iter.operator

    # Some overhead to determine the proper types for the rest of the computation
    β₀ = norm(X₀)
    iszero(β₀) && throw(ArgumentError("initial vector should not have norm zero"))
    x₀ = X₀[1]
    Ax₀ = apply(A, x₀) # one extra application of the operator: can be avoided but is it worth it?
    α = inner(x₀, Ax₀) / β₀ # this value has no meaning, we only care about its type
    X₁ = Block(map(Base.Fix2(scale, one(α)), X₀.vec))

    # Orthogonalization of the initial block
    _, good_idx, _ = block_qr!(X₁, iter.qr_tol)
    X₁ = X₁[good_idx]
    V = OrthonormalBasis(X₁.vec)
    bs = length(X₁) # block size of the first block

    AX₁ = apply(A, X₁)
    M₁ = block_inner(X₁, AX₁)
    BTD = zeros(eltype(M₁), maxdim, maxdim)
    BTD[1:bs, 1:bs] = view(M₁, 1:bs, 1:bs)
    verbosity >= WARN_LEVEL && warn_nonhermitian(M₁)

    # Get the first residual
    for j in 1:length(X₁)
        for i in 1:length(X₁)
            AX₁[j] = add!!(AX₁[j], X₁[i], -M₁[i, j])
        end
    end
    norm_R = norm(AX₁)
    if verbosity > EACHITERATION_LEVEL
        @info "BlockLanczos initiation at dimension $bs: subspace normres = $(normres2string(norm_R))"
    end
    return BlockLanczosFactorization(bs, V, BTD, AX₁, bs, norm_R)
end

function expand!(
        iter::BlockLanczosIterator, state::BlockLanczosFactorization;
        verbosity::Int = KrylovDefaults.verbosity[]
    )
    k = state.k
    R = state.R[1:(state.R_size)]
    bs = length(R)
    V = state.V
    Rcopy = copy(R)

    # Calculate the new basis and B
    B, good_idx, is_drift = block_qr!(R, iter.qr_tol)
    if is_drift # Prevent column subspace of R from drifting caused by an excessively small β in block_qr!
        block_reorthogonalize!(R, V)
        _, good_idx, is_drift = block_qr!(R, iter.qr_tol)
        B = block_inner(R[good_idx], Rcopy) # Make sure R = XB
    end

    bs_next = length(good_idx)
    push!(V, R[good_idx])
    state.H[(k + 1):(k + bs_next), (k - bs + 1):k] = view(B, 1:bs_next, 1:bs)
    state.H[(k - bs + 1):k, (k + 1):(k + bs_next)] = view(B, 1:bs_next, 1:bs)'

    # Calculate the new residual and orthogonalize the new basis
    Rnext, Mnext = block_lanczosrecurrence(iter.operator, V, B, iter.orth)
    verbosity >= WARN_LEVEL && warn_nonhermitian(Mnext)

    state.H[(k + 1):(k + bs_next), (k + 1):(k + bs_next)] = view(
        Mnext, 1:bs_next,
        1:bs_next
    )
    state.R.vec[1:bs_next] = Rnext.vec
    state.norm_R = norm(Rnext)
    state.k += bs_next
    state.R_size = bs_next

    if verbosity > EACHITERATION_LEVEL
        @info "BlockLanczos expansion to dimension $(state.k): subspace normres = $(normres2string(state.norm_R))"
    end
    return state
end

function block_lanczosrecurrence(
        operator, V::OrthonormalBasis, B::AbstractMatrix, orth::ModifiedGramSchmidt2
    )
    # Apply the operator and calculate the M. Get Xnext and Mnext.
    bs, bs_prev = size(B)
    k = length(V)
    X = Block(V[(k - bs + 1):k])
    AX = apply(operator, X)
    M = block_inner(X, AX)
    # Calculate the new residual in AX.
    Xprev = Block(V[(k - bs_prev - bs + 1):(k - bs)])
    @inbounds for j in 1:length(X)
        for i in 1:length(X)
            AX[j] = add!!(AX[j], X[i], -M[i, j])
        end
        for i in 1:length(Xprev)
            AX[j] = add!!(AX[j], Xprev[i], -conj(B[j, i]))
        end
    end
    block_reorthogonalize!(AX, V)
    return AX, M
end

"""
    block_reorthogonalize!(R::Block{T}, V::OrthonormalBasis{T}) where {T}

This function orthogonalizes the vectors in `R` with respect to the previously orthonormalized set `V` by using the modified Gram-Schmidt process.
Specifically, it modifies each vector `R[i]` by projecting out its components along the directions spanned by `V`, i.e.,

```
    R[i] = R[i] - sum(j=1:length(V)) <R[i], V[j]> V[j]
```

Here,`⟨·,·⟩` denotes the inner product. The function assumes that `V` is already orthonormal.
"""
function block_reorthogonalize!(R::Block{T}, V::OrthonormalBasis{T}) where {T}
    for i in 1:length(R)
        for q in V
            R[i], _ = orthogonalize!!(R[i], q, ModifiedGramSchmidt())
        end
    end
    return R
end

function warn_nonhermitian(M::AbstractMatrix)
    return if !isapprox(M, M'; atol = eps(real(eltype(M)))^(2 / 5))
        @warn "ignoring the antihermitian part of the block triangular matrix: operator might not be hermitian?" M
    end
end

"""
    block_qr!(block::Block{T,S}, tol::Real) where {T,S}

This function performs a QR factorization of a block of abstract vectors using the modified Gram-Schmidt process.

```
    [v₁,..,vₚ] -> [u₁,..,uᵣ] * R
```

It takes as input a block of abstract vectors and a tolerance parameter, which is used to determine whether a vector is considered numerically zero.
The operation is performed in-place, transforming the input block into a block of orthonormal vectors.

The function returns a matrix of size `(r, p)`, a vector of indices `goodidx` and a boolean flag `is_drift`. Here, `p` denotes the number of input vectors,
and `r` is the numerical rank of the input block. The matrix represents the upper-triangular factor of the QR decomposition,
restricted to the `r` linearly independent components. The vector `goodidx` contains the indices of the non-zero
(i.e., numerically independent) vectors in the orthonormalized block.
If a small value of β (the norm of a vector after first orthogonalization) is detected, the function will carry out an additional
reorthogonalization step to further ensure the input block vectors are orthonormalized.
In such cases, is_drift is set to true to indicate potential numerical instability.
"""
function block_qr!(block::Block, tol::Real)
    n = length(block)
    is_drift = false
    idx = trues(n)
    r₁₁ = inner(block[1], block[1])
    R = zeros(typeof(r₁₁), n, n)
    β = sqrt(real(r₁₁)) # norm(block[1])
    if β > tol
        R[1, 1] = β
        block[1] = scale!!(block[1], 1 / β)
    else
        block[1] = zerovector!!(block[1])
        idx[1] = false
    end
    for j in 2:n
        # first MGS
        for i in 1:(j - 1)
            R[i, j] = inner(block[i], block[j])
            block[j] = add!!(block[j], block[i], -R[i, j])
        end
        β = norm(block[j])

        if tol < β < 100 * tol # DGKS reorthogonalization
            is_drift = true
            for i in 1:(j - 1)
                δ = inner(block[i], block[j])
                R[i, j] += δ
                block[j] = add!!(block[j], block[i], -δ)
            end
            β = norm(block[j])
        end
        if β < tol
            block[j] = zerovector!!(block[j])
            idx[j] = false
        else
            R[j, j] = β
            block[j] = scale!!(block[j], 1 / β)
        end
    end
    good_idx = findall(idx)
    return R[good_idx, :], good_idx, is_drift
end

# Reverse rule adopted from tsvd! rrule as found in TensorKit.jl
function ChainRulesCore.rrule(
        config::RuleConfig, ::typeof(svdsolve), f, x₀, howmany, which,
        alg_primal::GKL;
        alg_rrule = Arnoldi(;
            tol = alg_primal.tol,
            krylovdim = alg_primal.krylovdim,
            maxiter = alg_primal.maxiter,
            eager = alg_primal.eager,
            orth = alg_primal.orth,
            verbosity = alg_primal.verbosity
        )
    )
    vals, lvecs, rvecs, info = svdsolve(f, x₀, howmany, which, alg_primal)
    svdsolve_pullback = make_svdsolve_pullback(
        config, f, x₀, howmany, which, alg_primal,
        alg_rrule, vals, lvecs, rvecs, info
    )
    return (vals, lvecs, rvecs, info), svdsolve_pullback
end

function make_svdsolve_pullback(
        config, f, x₀, howmany, which, alg_primal, alg_rrule, vals,
        lvecs, rvecs, info
    )
    function svdsolve_pullback(ΔX)
        ∂self = NoTangent()
        ∂x₀ = ZeroTangent()
        ∂howmany = NoTangent()
        ∂which = NoTangent()
        ∂alg = NoTangent()

        # Prepare inputs:
        #----------------
        _Δvals = unthunk(ΔX[1])
        _Δlvecs = unthunk(ΔX[2])
        _Δrvecs = unthunk(ΔX[3])
        # special case: propagate zero tangent
        if _Δvals isa AbstractZero && _Δlvecs isa AbstractZero && _Δrvecs isa AbstractZero
            ∂f = ZeroTangent()
            return ∂self, ∂f, ∂x₀, ∂howmany, ∂which, ∂alg
        end
        # discard vals/vecs from n + 1 onwards if contribution is zero
        _n_vals = _Δvals isa AbstractZero ? nothing : findlast(!iszero, _Δvals)
        _n_lvecs = _Δlvecs isa AbstractZero ? nothing :
            findlast(!Base.Fix2(isa, AbstractZero), _Δlvecs)
        _n_rvecs = _Δrvecs isa AbstractZero ? nothing :
            findlast(!Base.Fix2(isa, AbstractZero), _Δrvecs)
        n_vals = isnothing(_n_vals) ? 0 : _n_vals
        n_lvecs = isnothing(_n_lvecs) ? 0 : _n_lvecs
        n_rvecs = isnothing(_n_rvecs) ? 0 : _n_rvecs
        n = max(n_vals, n_lvecs, n_rvecs)
        # special case (can this happen?): try to maintain type stability
        if n == 0
            if howmany == 0
                _lvecs = [zerovector(x₀)]
                _rvecs = [apply_adjoint(f, x₀)]
                xs = [_lvecs[1]]
                ys = [_rvecs[1]]
                ∂f = construct∂f_svd(config, f, _lvecs, _rvecs, xs, ys)
                return ∂self, ∂f, ∂x₀, ∂howmany, ∂which, ∂alg
            else
                xs = [zerovector(lvecs[1])]
                ys = [zerovector(rvecs[1])]
                ∂f = construct∂f_svd(config, f, lvecs, rvecs, xs, ys)
                return ∂self, ∂f, ∂x₀, ∂howmany, ∂which, ∂alg
            end
        end
        Δvals = fill(zero(vals[1]), n)
        if n_vals > 0
            Δvals[1:n_vals] .= view(_Δvals, 1:n_vals)
        end
        if _Δlvecs isa AbstractZero && _Δrvecs isa AbstractZero
            # case of no contribution of singular vectors
            Δlvecs = fill(ZeroTangent(), n)
            Δrvecs = fill(ZeroTangent(), n)
        else
            Δlvecs = fill(zerovector(lvecs[1]), n)
            Δrvecs = fill(zerovector(rvecs[1]), n)
            if n_lvecs > 0
                Δlvecs[1:n_lvecs] .= view(_Δlvecs, 1:n_lvecs)
            end
            if n_rvecs > 0
                Δrvecs[1:n_rvecs] .= view(_Δrvecs, 1:n_rvecs)
            end
        end

        # Compute actual pullback data:
        #------------------------------
        xs, ys = compute_svdsolve_pullback_data(
            Δvals, Δlvecs, Δrvecs,
            view(vals, 1:n), view(lvecs, 1:n), view(rvecs, 1:n),
            info, f, which,
            alg_primal, alg_rrule
        )

        # Return pullback in correct form:
        #---------------------------------
        ∂f = construct∂f_svd(config, f, lvecs, rvecs, xs, ys)
        return ∂self, ∂f, ∂x₀, ∂howmany, ∂which, ∂alg
    end
    return svdsolve_pullback
end

function compute_svdsolve_pullback_data(
        Δvals, Δlvecs, Δrvecs,
        vals, lvecs, rvecs,
        info, f, which,
        alg_primal, alg_rrule::Union{GMRES, BiCGStab}
    )
    xs = similar(lvecs, length(Δvals))
    ys = similar(rvecs, length(Δvals))
    for i in 1:length(vals)
        Δσ = Δvals[i]
        Δu = Δlvecs[i]
        Δv = Δrvecs[i]
        σ = vals[i]
        u = lvecs[i]
        v = rvecs[i]

        # First treat special cases
        if isa(Δv, AbstractZero) && isa(Δu, AbstractZero) # no contribution
            xs[i] = scale(u, real(Δσ) / 2)
            ys[i] = scale(v, real(Δσ) / 2)
            continue
        end
        udΔu = inner(u, Δu)
        vdΔv = inner(v, Δv)
        if (udΔu isa Complex) || (vdΔv isa Complex)
            if alg_rrule.verbosity >= WARN_LEVEL
                gauge = abs(imag(udΔu + vdΔv))
                gauge > alg_primal.tol &&
                    @warn "`svdsolve` cotangents for singular vectors $i are sensitive to gauge choice: (|gauge| = $gauge)"
            end
            Δs = real(Δσ) + im * imag(udΔu - vdΔv) / (2 * σ)
        else
            Δs = real(Δσ)
        end
        b = (add(Δu, u, -udΔu), add(Δv, v, -vdΔv))
        (x, y), reverse_info = let σ = σ, u = u, v = v
            linsolve(b, zerovector(b), alg_rrule) do (x, y)
                x′ = VectorInterface.add!!(apply_normal(f, y), x, σ, -1)
                y′ = VectorInterface.add!!(apply_adjoint(f, x), y, σ, -1)
                x′ = VectorInterface.add!!(x′, u, -inner(u, x′))
                y′ = VectorInterface.add!!(y′, v, -inner(v, y′))
                return (x′, y′)
            end
        end
        if info.converged >= i && reverse_info.converged == 0 &&
                alg_primal.verbosity >= WARN_LEVEL
            @warn "`svdsolve` cotangent linear problem ($i) did not converge, whereas the primal eigenvalue problem did: normres = $(reverse_info.normres)"
        end
        x = VectorInterface.add!!(x, u, Δs / 2)
        y = VectorInterface.add!!(y, v, conj(Δs) / 2)
        xs[i] = x
        ys[i] = y
    end
    return xs, ys
end
function compute_svdsolve_pullback_data(
        Δvals, Δlvecs, Δrvecs,
        vals, lvecs, rvecs,
        info, f, which,
        alg_primal, alg_rrule::Arnoldi
    )
    @assert which == :LR "pullback currently only implemented for `which == :LR`"
    T = scalartype(lvecs)
    n = length(Δvals)
    UdΔU = zeros(T, n, n)
    VdΔV = zeros(T, n, n)
    for j in 1:n
        for i in 1:n
            if !(Δlvecs[j] isa AbstractZero)
                UdΔU[i, j] = inner(lvecs[i], Δlvecs[j])
            end
            if !(Δrvecs[j] isa AbstractZero)
                VdΔV[i, j] = inner(rvecs[i], Δrvecs[j])
            end
        end
    end
    aUdΔU = rmul!(UdΔU - UdΔU', 1 / 2)
    aVdΔV = rmul!(VdΔV - VdΔV', 1 / 2)

    tol = alg_primal.tol
    if alg_rrule.verbosity >= WARN_LEVEL
        mask = abs.(vals' .- vals) .< tol
        gaugepart = view(aUdΔU, mask) + view(aVdΔV, mask)
        gauge = norm(gaugepart, Inf)
        gauge > alg_primal.tol &&
            @warn "`svdsolve` cotangents for singular vectors are sensitive to gauge choice: (|gauge| = $gauge)"
    end
    UdΔAV = (aUdΔU .+ aVdΔV) .* safe_inv.(vals' .- vals, tol) .+
        (aUdΔU .- aVdΔV) .* safe_inv.(vals' .+ vals, tol)
    if !(Δvals isa ZeroTangent)
        UdΔAV[diagind(UdΔAV)] .+= real.(Δvals)
    end

    xs = similar(lvecs, n)
    ys = similar(rvecs, n)
    for i in 1:n
        x = scale(lvecs[1], UdΔAV[1, i] / 2)
        y = scale(rvecs[1], conj(UdΔAV[i, 1]) / 2)
        for j in 2:n
            x = VectorInterface.add!!(x, lvecs[j], UdΔAV[j, i] / 2)
            y = VectorInterface.add!!(y, rvecs[j], conj(UdΔAV[i, j]) / 2)
        end
        xs[i] = x
        ys[i] = y
    end

    sylvesterargx = similar(lvecs)
    for i in 1:n
        x = zerovector(lvecs[1])
        if !(Δlvecs[i] isa AbstractZero)
            x = VectorInterface.add!!(x, Δlvecs[i], +1)
            for j in 1:n
                x = VectorInterface.add!!(x, lvecs[j], -UdΔU[j, i])
            end
        end
        sylvesterargx[i] = x
    end
    sylvesterargy = similar(rvecs)
    for i in 1:n
        y = zerovector(rvecs[1])
        if !(Δrvecs[i] isa AbstractZero)
            y = VectorInterface.add!!(y, Δrvecs[i], +1)
            for j in 1:n
                y = VectorInterface.add!!(y, rvecs[j], -VdΔV[j, i])
            end
        end
        sylvesterargy[i] = y
    end

    W₀ = (zerovector(lvecs[1]), zerovector(rvecs[1]), fill(one(T), n))
    QU = orthogonalcomplementprojector(lvecs, n)
    QV = orthogonalcomplementprojector(rvecs, n)
    solver = (T <: Real) ? KrylovKit.realeigsolve : KrylovKit.eigsolve
    rvals, Ws, reverse_info = let QU = QU, QV = QV, ΔU = sylvesterargx, ΔV = sylvesterargy
        solver(W₀, n, :LR, alg_rrule) do w
            x, y, z = w
            x′ = QU(apply_normal(f, y))
            y′ = QV(apply_adjoint(f, x))
            @inbounds for i in 1:length(z)
                x′ = VectorInterface.add!!(x′, ΔU[i], -z[i])
                y′ = VectorInterface.add!!(y′, ΔV[i], -z[i])
            end
            return (x′, y′, vals .* z)
        end
    end
    if info.converged >= n && reverse_info.converged < n &&
            alg_primal.verbosity >= WARN_LEVEL
        @warn "`svdsolve` cotangent problem did not converge, whereas the primal singular value problem did"
    end

    # cleanup and construct final result
    tol = alg_rrule.tol
    Z = zeros(T, n, n)
    for i in 1:n
        copy!(view(Z, :, i), Ws[i][3])
    end
    Zinv = inv(Z)
    error = norm(Diagonal(view(vals, 1:n)) - Z * Diagonal(view(rvals, 1:n)) * Zinv, Inf)
    if error > 10 * tol && alg_primal.verbosity >= WARN_LEVEL
        @warn "`svdsolve` cotangent linear problem returns unexpected result: error = $error vs tol = $tol"
    end
    for i in 1:n
        for j in 1:n
            xs[i] = VectorInterface.add!!(xs[i], Ws[j][1], -Zinv[j, i])
            ys[i] = VectorInterface.add!!(ys[i], Ws[j][2], -Zinv[j, i])
        end
    end
    return xs, ys
end

function construct∂f_svd(config, f, lvecs, rvecs, xs, ys)
    config isa RuleConfig{>:HasReverseMode} ||
        throw(ArgumentError("`svdsolve` reverse-mode AD requires AD engine that supports calling back into AD"))

    u, v = lvecs[1], rvecs[1]
    x, y = xs[1], ys[1]
    ∂f = rrule_via_ad(config, f, v, Val(false))[2](x)[1]
    ∂f = ChainRulesCore.add!!(∂f, rrule_via_ad(config, f, u, Val(true))[2](y)[1])
    for i in 2:length(xs)
        u, v = lvecs[i], rvecs[i]
        x, y = xs[i], ys[i]
        ∂f = ChainRulesCore.add!!(∂f, rrule_via_ad(config, f, v, Val(false))[2](x)[1])
        ∂f = ChainRulesCore.add!!(∂f, rrule_via_ad(config, f, u, Val(true))[2](y)[1])
    end
    return ∂f
end
function construct∂f_svd(config, (f, fᴴ)::Tuple{Any, Any}, lvecs, rvecs, xs, ys)
    config isa RuleConfig{>:HasReverseMode} ||
        throw(ArgumentError("`svdsolve` reverse-mode AD requires AD engine that supports calling back into AD"))

    u, v = lvecs[1], rvecs[1]
    x, y = xs[1], ys[1]
    ∂f = rrule_via_ad(config, f, v)[2](x)[1]
    ∂fᴴ = rrule_via_ad(config, fᴴ, u)[2](y)[1]
    for i in 2:length(xs)
        u, v = lvecs[i], rvecs[i]
        x, y = xs[i], ys[i]
        ∂f = ChainRulesCore.add!!(∂f, rrule_via_ad(config, f, v)[2](x)[1])
        ∂fᴴ = ChainRulesCore.add!!(∂fᴴ, rrule_via_ad(config, fᴴ, u)[2](y)[1])
    end
    return (∂f, ∂fᴴ)
end
function construct∂f_svd(config, A::AbstractMatrix, lvecs, rvecs, xs, ys)
    if A isa StridedMatrix
        return InplaceableThunk(
            Ā -> _buildĀ_svd!(Ā, lvecs, rvecs, xs, ys),
            @thunk(_buildĀ_svd!(zero(A), lvecs, rvecs, xs, ys))
        )
    else
        return @thunk(ProjectTo(A)(_buildĀ_svd!(zero(A), lvecs, rvecs, xs, ys)))
    end
end
function _buildĀ_svd!(Ā, lvecs, rvecs, xs, ys)
    for i in 1:length(xs)
        u, v = lvecs[i], rvecs[i]
        x, y = xs[i], ys[i]
        mul!(Ā, x, v', +1, +1)
        mul!(Ā, u, y', +1, +1)
    end
    return Ā
end

"""
    bieigsolve(A::AbstractMatrix, [howmany = 1, which = :LM, T = eltype(A)]; kwargs...))
    bieigsolve(f, n::Int, [howmany = 1, which = :LM, T = Float64]; kwargs...)
    bieigsolve(f, v₀, w₀, [howmany = 1, which = :LM]; kwargs...)
    bieigsolve(f, v₀, w₀, howmany, which, alg::BiArnoldi)

Compute at least `howmany` eigenvalues from the linear map encoded in the matrix `A` or by the function `f`. Return eigenvalues, left- and right-eigenvectors and a `ConvergenceInfo` structure.

### Arguments:

The linear map can be an `AbstractMatrix` (dense or sparse) or a general function or
callable object. Since both the action of the linear map and its adjoint are required in
order to compute right- and left-eigenvectors, `f` can either be a tuple of two callable objects (each
accepting a single argument), representing the linear map and its adjoint respectively, or,
`f` can be a single callable object that accepts two input arguments, where the second
argument is a flag of type `Val{true}` or `Val{false}` that indicates whether the adjoint or
the normal action of the linear map needs to be computed. This is the same implementation as 
for `svd_solve`.

If the linear map is encoded more
generally as a a callable function or method, the best approach is to provide an explicit
starting guess `v₀` and `w₀` for  the right- and left-eigenvector. Note that `v₀` and `w₀` do not need to be of type `AbstractVector`; any type
that behaves as a vector and supports the required methods (see KrylovKit docs) is accepted.
If instead of `v₀` and `w₀` an integer `n` is specified, it is assumed that both are a regular vector
and they are initialized to `rand(T, n)`, where the default value of `T` is `Float64`, unless
specified differently.

The next arguments are optional, but should typically be specified. `howmany` specifies how
many eigenvalues should be computed; `which` specifies which eigenvalues should be
targeted. Valid specifications of `which` are given by

  - `:LM`: eigenvalues of largest magnitude
  - `:LR`: eigenvalues with largest (most positive) real part
  - `:SR`: eigenvalues with smallest (most negative) real part
  - `:LI`: eigenvalues with largest (most positive) imaginary part, only if `T <: Complex`
  - `:SI`: eigenvalues with smallest (most negative) imaginary part, only if `T <: Complex`
  - [`EigSorter(f; rev = false)`](@ref): eigenvalues `λ` that appear first (or last if
    `rev == true`) when sorted by `f(λ)`

### Return Values

Returns a tuple `(values, (vectorsV, vectorsW), (infoV, infoW))` where:

- `values`: Vector of computed eigenvalues.
- `vectorsV`: Vector of right eigenvectors (corresponding to `A`).
- `vectorsW`: Vector of left eigenvectors (corresponding to `A'`).
- `infoV`, `infoW`: `ConvergenceInfo` objects for right and left eigenproblems, containing:
    - `converged`: Number of converged eigenvalues.
    - `residual`: List of residual vectors.
    - `normres`: List of residual norms.
    - `numiter`: Number of Krylov restarts.
    - `numops`: Number of operator applications.

### Notes

- The BiArnoldi method is designed for non-Hermitian problems and returns both left and right eigenvectors, which are biorthogonal.
- For Hermitian or symmetric problems, prefer using `eigsolve` or `realeigsolve`.


!!! warning "Check for convergence"

    No warning is printed if not all requested eigenvalues were converged, so always check
    if `info.converged >= howmany`.

### Keyword arguments:

Keyword arguments and their default values are given by:

  - `verbosity::Int = SILENT_LEVEL`: verbosity level, i.e. 
    - SILENT_LEVEL (suppress all messages)
    - WARN_LEVEL (only warnings)
    - STARTSTOP_LEVEL (one message with convergence info at the end)
    - EACHITERATION_LEVEL (progress info after every iteration)
    - EACHITERATION_LEVEL+ (all of the above and additional information about the Lanczos, BlockLanczos, or Arnoldi iteration)
  - `tol::Real`: the requested accuracy (corresponding to the 2-norm of the residual for
    Schur vectors, not the eigenvectors). If you work in e.g. single precision (`Float32`),
    you should definitely change the default value.
  - `krylovdim::Integer`: the maximum dimension of the Krylov subspace that will be
    constructed. Note that the dimension of the vector space is not known or checked, e.g.
    `x₀` should not necessarily support the `Base.length` function. If you know the actual
    problem dimension is smaller than the default value, it is useful to reduce the value of
    `krylovdim`, though in principle this should be detected.
  - `maxiter::Integer`: the number of times the Krylov subspace can be rebuilt; see below
    for further details on the algorithms.
  - `orth::Orthogonalizer`: the orthogonalization method to be used, see
    [`Orthogonalizer`](@ref)

The default values are given by `tol = KrylovDefaults.tol`,
`krylovdim = KrylovDefaults.krylovdim`, `maxiter = KrylovDefaults.maxiter`,
`orth = KrylovDefaults.orth`; see [`KrylovDefaults`](@ref) for details.


### Example

```julia
A = randn(10, 10)
vals, (vecsR, vecsL), (infoR, infoL) = bieigsolve(A, 3, :LM)
```

See also: [`eigsolve`](@ref), [`realeigsolve`](@ref), [`BiArnoldi`](@ref)
"""
function bieigsolve end

function bieigsolve(
        A::AbstractMatrix, howmany::Int = 1, which::Selector = :LM, T::Type = eltype(A);
        kwargs...
    )
    v₀ = Random.rand!(similar(A, T, size(A, 1)))
    w₀ = Random.rand!(similar(A, T, size(A, 1)))
    return bieigsolve(A, v₀, w₀, howmany, which; kwargs...)
end

function bieigsolve(
        f, n::Int, howmany::Int = 1, which::Selector = :LM, T::Type = Float64;
        kwargs...
    )
    return bieigsolve(f, rand(T, n), rand(T, n), howmany, which; kwargs...)
end

function bieigsolve(
        f, v₀, w₀, howmany::Int = 1, which::Selector = :LM;
        krylovdim::Int = KrylovDefaults.krylovdim[],
        maxiter::Int = KrylovDefaults.maxiter[],
        eager::Bool = false,
        tol::Real = KrylovDefaults.tol[],
        orth::Orthogonalizer = KrylovDefaults.orth,
        verbosity::Int = KrylovDefaults.verbosity[]
    )
    return bieigsolve(
        f, v₀, w₀, howmany, which,
        BiArnoldi(; orth, krylovdim, maxiter, tol, eager, verbosity)
    )
end

function bieigsolve(f, v₀, w₀, howmany::Int, which::Selector, alg::BiArnoldi)
    #! format: off
    (S, T), (Q, Z), (V, W), (rV, rW), (h, k), M, converged, numiter, numops =
        _bischursolve(f, v₀, w₀, howmany, which, alg)
    #! format: on

    howmany′ = howmany
    if eltype(T) <: Real && howmany < size(T, 1) && !iszero(T[howmany + 1, howmany])
        howmany′ += 1
    elseif size(T, 1) < howmany
        howmany′ = size(T, 1)
    end
    if converged > howmany
        howmany′ = converged
    end

    # Compute the eigenvalues and eigenvectors of the reduced matrices
    SS = view(S, 1:howmany′, 1:howmany′)
    TT = view(T, 1:howmany′, 1:howmany′)
    valuesS = schur2eigvals(SS)
    vecsS = schur2eigvecs(SS)

    # Instead of computing the eigenvectors of TT separately, we can use the
    # relation ZᴴMQ * S = T' * ZᴴMQ to compute vecsT directly from vecsS.
    # In this way, we avoid the potential ordering mismatch, and the resulting
    # left and right eigenvectors will automatically be biorthogonal.
    # Note that this requires that ZᴴMQ can be accurately inverted.
    ZᴴMQ = view(Z, :, 1:howmany′)' * M * view(Q, :, 1:howmany′)
    vecsT = inv(adjoint(ZᴴMQ * vecsS))
    valuesT = conj(valuesS)

    if !isapprox(TT * vecsT, vecsT * Diagonal(valuesT)) && alg.verbosity >= WARN_LEVEL
        @warn """Unexpected relation between S and T in BiArnoldi eigsolve:
        left eigenvectors might not be correctly computed
        """
    end

    # Construct the actual eigenvectors and residuals
    VS = view(Q, :, 1:howmany′) * vecsS
    vectorsS = [V * v for v in cols(VS)]
    hᴴVS = map(Base.Fix1(dot, h[1:howmany′]), cols(vecsS))
    residualsS = [scale(rV, s) for s in hᴴVS]
    normresidualsS = map(Base.Fix1(*, norm(rV)) ∘ abs, hᴴVS)
    VT = view(Z, :, 1:howmany′) * vecsT
    vectorsT = [W * v for v in cols(VT)]
    kᴴVT = map(Base.Fix1(dot, k[1:howmany′]), cols(vecsT))
    residualsT = [scale(rW, s) for s in kᴴVT]
    normresidualsT = map(Base.Fix1(*, norm(rW)) ∘ abs, kᴴVT)

    if (converged < howmany) && alg.verbosity >= WARN_LEVEL
        @warn """BiArnoldi eigsolve stopped without convergence after $numiter iterations:
        * $converged eigenvalues converged
        * norm of residuals = $(normres2string(normresidualsS))
        * number of operations = $numops"""
    elseif alg.verbosity >= STARTSTOP_LEVEL
        @info """BiArnoldi eigsolve finished after $numiter iterations:
        * $converged eigenvalues converged
        * norm of residuals = $(normres2string(normresidualsS))
        * number of operations = $numops"""
    end

    infoS = ConvergenceInfo(converged, residualsS, normresidualsS, numiter, numops)
    infoT = ConvergenceInfo(converged, residualsT, normresidualsT, numiter, numops)

    return valuesS, (vectorsS, vectorsT), (infoS, infoT)
end

function _bischursolve(f, v₀, w₀, howmany::Int, which::Selector, alg::BiArnoldi)
    krylovdim = alg.krylovdim
    maxiter = alg.maxiter
    howmany > krylovdim &&
        error("krylov dimension $(krylovdim) too small to compute $howmany eigenvalues")

    ## FIRST ITERATION: setting up
    numiter = 1
    # initialize arnoldi factorization
    iter = BiArnoldiIterator(f, v₀, w₀, alg.orth)
    fact = initialize(iter; verbosity = alg.verbosity)
    numops = 1
    sizehint!(fact, krylovdim)
    βv, βw = normres(fact)
    tol::eltype(βv) = alg.tol

    # allocate storage
    HH = fill(zero(eltype(fact)), krylovdim + 1, krylovdim)
    KK = fill(zero(eltype(fact)), krylovdim + 1, krylovdim)
    QQ = fill(zero(eltype(fact)), krylovdim, krylovdim)
    ZZ = fill(zero(eltype(fact)), krylovdim, krylovdim)
    Wᴴvv = fill(zero(eltype(fact)), krylovdim)
    Vᴴww = fill(zero(eltype(fact)), krylovdim)

    MM = fill(zero(eltype(fact)), krylovdim, krylovdim)
    MMQQ = fill(zero(eltype(fact)), krylovdim, krylovdim)
    ZZMMQQ = fill(zero(eltype(fact)), krylovdim, krylovdim)

    # initialize storage
    L = length(fact) # == 1
    V, W = basis(fact)
    MM[L, L] = inner(W[L], V[L])
    converged = 0
    local S, T, Q, Z, rV, rW, h, k, M
    while true
        βv, βw = normres(fact)
        L = length(fact)

        if (βv <= tol || βw <= tol) && L < howmany
            if alg.verbosity >= WARN_LEVEL
                msg = "Invariant subspace of dimension $L (up to requested tolerance `tol = $tol`), "
                msg *= "which is smaller than the number of requested eigenvalues (i.e. `howmany == $howmany`)."
                @warn msg
            end
        end
        if L == krylovdim || (βv <= tol && βw <= tol) || (alg.eager && L >= howmany) # process
            # Assign storage as views of the allocated arrays
            H = view(HH, 1:L, 1:L)
            K = view(KK, 1:L, 1:L)
            Q = view(QQ, 1:L, 1:L)
            Z = view(ZZ, 1:L, 1:L)
            M = view(MM, 1:L, 1:L)
            h = view(HH, L + 1, 1:L)
            k = view(KK, L + 1, 1:L)
            Wᴴv = view(Wᴴvv, 1:L)
            Vᴴw = view(Vᴴww, 1:L)
            MQ = view(MMQQ, 1:L, 1:L)
            ZMQ = view(ZZMMQQ, 1:L, 1:L)

            # Initialize values
            copyto!(Q, I)
            copyto!(Z, I)
            copyto!.((H, K), rayleighquotient(fact))
            # h .= SimpleBasisVector(L, L)
            # k .= SimpleBasisVector(L, L)

            # Step 1 - Normalize residuals so that they represent next Arnoldi vectors
            rV, rW = residual(fact)
            if L < krylovdim
                # explicitly copy the residual to not disturb future expansion steps
                rV = scale(rV, 1 / βv) # vℓ₊₁
                rW = scale(rW, 1 / βw) # wℓ₊₁
            else
                rV = scale!!(rV, 1 / βv) # vℓ₊₁
                rW = scale!!(rW, 1 / βw) # wℓ₊₁
            end
            # we remember the value of h and k until the first time we actually need to construt them
            # h .*= βv # or thus: h = βv * SimpleBasisVector(L, L)
            # k .*= βw # or thus: k = βw * SimpleBasisVector(L, L)

            # Step 2 - 3 - Correct H, K and the residuals using the oblique projection
            # Compute the projections Wᴴ * residual(V) and Vᴴ * residual(W)
            V, W = basis(fact)
            @inbounds for i in 1:L
                Wᴴv[i] = inner(W[i], rV)
                Vᴴw[i] = inner(V[i], rW)
            end

            luM = lu(M)
            M⁻¹Wᴴv = luM \ Wᴴv
            M⁻ᴴVᴴw = luM' \ Vᴴw
            add!(view(H, :, L), M⁻¹Wᴴv, βv) # H̃ = H + (M \ (W' * v)) * h'
            add!(view(K, :, L), M⁻ᴴVᴴw, βw) # K̃ = K + (M' \ (V' * w)) * k'

            @inbounds for i in 1:L
                rV = add!!(rV, V[i], -M⁻¹Wᴴv[i]) # ṽℓ₊₁
                rW = add!!(rW, W[i], -M⁻ᴴVᴴw[i]) # w̃ℓ₊₁
            end

            βrV = norm(rV) # || ṽℓ₊₁ ||
            βrW = norm(rW) # || w̃ℓ₊₁ ||

            # Step 5 - Compute dense schur factorization
            S, Q, valuesH = hschur!(H, Q)
            T, Z, valuesK = hschur!(K, Z)

            # Step 6 - Order the Schur decompositions
            by, rev = eigsort(which)
            pH = sortperm(valuesH; by = by, rev = rev)
            pK = sortperm(valuesK; by = by ∘ conj, rev = rev)

            S, Q = permuteschur!(S, Q, pH)
            T, Z = permuteschur!(T, Z, pK)

            # Partially Step 7 & 8 - Correction of hm and km
            h .= conj.(view(Q, L, :)) .* βv # h̃ = Q' * h
            k .= conj.(view(Z, L, :)) .* βw # k̃ = Z' * k

            # At this point, we have the partial Schur decompositions of the form
            # A * V * Q = V * Q * S + rV * h'
            # A' * W * Z = W * Z * T + rW * k'
            # with W' * rV = 0 and V' * rW = 0

            converged = 0
            while converged < length(fact)
                # As in the Arnoldi case, we will not actually compute the
                # eigenvectors yet, but use the "residuals" of the Schur vectors
                # to determine how many vectors have converged.
                xh = βrV * abs(h[converged + 1])
                xk = βrW * abs(k[converged + 1])
                if max(xh, xk) <= tol
                    converged += 1
                else
                    break
                end
            end
            if 0 < converged < length(fact) && !iszero(S[converged + 1, converged])
                converged -= 1
            end

            if converged >= howmany || (βv <= tol && βw <= tol)
                break
            elseif alg.verbosity >= EACHITERATION_LEVEL
                @info "BiArnoldi schursolve in iteration $numiter, step = $L: $converged values converged, normres = $(normres2string(abs.(h[1:howmany])))"
            end
        end

        if L < krylovdim # expand
            fact = expand!(iter, fact; verbosity = alg.verbosity)
            V, W = basis(fact)

            # update M with the new basis vectors
            @inbounds for i in 1:L
                MM[i, L + 1] = inner(W[i], V[L + 1])
                MM[L + 1, i] = inner(W[L + 1], V[i])
            end
            MM[L + 1, L + 1] = inner(W[L + 1], V[L + 1])

            numops += 2
        else # shrink
            numiter == maxiter && break

            # Determine how many to keep
            keep = div(3 * krylovdim + 2 * converged, 5) # strictly smaller than krylovdim since converged < howmany <= krylovdim, at least equal to converged

            while (!iszero(H[keep + 1, keep]) || !iszero(K[keep + 1, keep]))
                # we are in the middle of a 2x2 block; this cannot happen if keep == converged, so we can decrease keep
                # however, we have to make sure that we do not end up with keep = 0
                if keep > 1
                    keep -= 1 # conservative choice
                else
                    keep += 1
                    if krylovdim == 2
                        alg.verbosity >= WARN_LEVEL &&
                            @warn "Arnoldi iteration got stuck in a 2x2 block, consider increasing the Krylov dimension"
                        break
                    end
                end
            end

            # Step 9 to 11 - Shrink Krylov factorization and restore Arnoldi form for both directions
            # In particular, we need to return to a Rayleigh quotient that is `V' * A * V` instead
            # of `W' * A * V`, and residuals that satisfy `V' * rV = 0` and `W' * rW = 0` instead of
            # `W' * rV = 0` and `V' * rW = 0`.

            # Step 10 and 11: update Rayleigh quotients and residuals
            # Ĥ = Sₖₖ + (V * Qₖ)' * ṽℓ₊₁ * h̃ₖ' (subscript k for `keep`)
            # and
            # (V * Qₖ)' * ṽℓ₊₁ = Qₖ' * V' * (vℓ₊₁ - V * M \ (W' * vℓ₊₁))= - Qₖ' * M \ (W' * vℓ₊₁)
            # so that (and analoguously for K)
            # Ĥ = Sₖₖ - Qₖ' * M⁻¹Wᴴv * h̃'ₖ
            # K̂ = Tₖₖ - Zₖ' * M⁻ᴴVᴴw * k̃'ₖ

            VQᴴv = -view(Q, :, 1:keep)' * M⁻¹Wᴴv
            WZᴴw = -view(Z, :, 1:keep)' * M⁻ᴴVᴴw

            H[1:keep, 1:keep] += VQᴴv * h[1:keep]' # Ĥ = Sₖₖ + (V * Qₖ)' * ṽℓ₊₁ * h̃ₖ'
            K[1:keep, 1:keep] += WZᴴw * k[1:keep]' # K̂ = Tₖₖ + (W * Zₖ)' * w̃ℓ₊₁ * k̃ₖ'

            # We similarly correct the residuals
            # v̂ = ṽℓ₊₁ - (V * Qₖ) * (V * Qₖ)' * ṽℓ₊₁
            #   = ṽℓ₊₁ + (V * Qₖ) * (V * Qₖ)' * V * M \ (W' * vℓ₊₁)
            #   = ṽℓ₊₁ + V * Qₖ * Qₖ' * M⁻¹Wᴴv
            #   = ṽℓ₊₁ - V * Qₖ * VQᴴv
            # Let's also recylce the Wᴴv and Vᴴw storage, which we don't need anymore
            QVQᴴv = mul!(Wᴴv, view(Q, :, 1:keep), VQᴴv)
            ZWZᴴw = mul!(Vᴴw, view(Z, :, 1:keep), WZᴴw)
            @inbounds for i in 1:L
                rV = add!!(rV, V[i], -QVQᴴv[i]) # v̂ = ṽℓ₊₁ - V * Qₖ * VQᴴv
                rW = add!!(rW, W[i], -ZWZᴴw[i]) # ŵ = w̃ℓ₊₁ - W * Zₖ * WZᴴw
            end

            # normalize the new residuals and absorb norm in h and k
            βrV = norm(rV)
            βrW = norm(rW)
            rV = scale!!(rV, 1 / βrV) # v̂ₖ₊₁
            rW = scale!!(rW, 1 / βrW) # ŵₖ₊₁
            h .*= βrV
            k .*= βrW

            # Restore Arnoldi form in the first keep columns before shrinking
            _restorearnoldiform!(Q, H, h, keep)
            _restorearnoldiform!(Z, K, k, keep)
            # Copy H and K back into compact Hessenberg form
            copy!.(rayleighquotient(fact), (H, K))
            # Update the basis
            basistransform!(V, view(Q, :, 1:keep))
            V[keep + 1] = rV
            basistransform!(W, view(Z, :, 1:keep))
            W[keep + 1] = rW

            # Step 9: update M; we can only do this now because by restoring the Arnoldi form where
            # the Rayleigh quotients have a Hessenberg form, we have further changed `Q` and `Z` and
            # thus the actual new Krylov bases `V` and `W`.
            MQ = view(MMQQ, 1:L, 1:keep)
            ZMQ = view(ZZMMQQ, 1:keep, 1:keep)
            MQ = mul!(MQ, M, view(Q, :, 1:keep))
            ZMQ = mul!(ZMQ, view(Z, :, 1:keep)', MQ)
            copy!(view(MM, 1:keep, 1:keep), ZMQ)

            # Shrink BiArnoldi factorization
            fact = shrink!(fact, keep; verbosity = alg.verbosity)
            numiter += 1
        end
    end

    # At the point where we return, `fact` is not in a valid state, as we have the
    # Krylov factorization or partial Schur decomposition in the form
    # A * V * Q = V * Q * S + rV * h'
    # A' * W * Z = W * Z * T + rW * k'
    # with W' * rV = 0 and V' * rW = 0, so this is the information we return.
    # We also return M = W' * V.
    return (S, T), (Q, Z), (V, W), (rV, rW), (h, k), M, converged, numiter, numops
end

function linsolve(operator, b, x₀, alg::GMRES, a₀::Number = 0, a₁::Number = 1; alg_rrule = alg)
    # Initial function operation and division defines number type
    y₀ = apply(operator, x₀)
    T = typeof(inner(b, y₀) / norm(b) * one(a₀) * one(a₁))
    α₀ = convert(T, a₀)::T
    α₁ = convert(T, a₁)::T
    # Continue computing r = b - a₀ * x₀ - a₁ * operator(x₀)
    r = scale(b, one(T))
    r = iszero(α₀) ? r : add!!(r, x₀, -α₀)
    r = add!!(r, y₀, -α₁)
    x = scale!!(zerovector(r), x₀, 1)
    β = norm(r)
    S = typeof(β)

    # Algorithm parameters
    maxiter = alg.maxiter
    krylovdim = alg.krylovdim
    tol::S = alg.tol

    # Check for early return
    if β < tol
        if alg.verbosity >= STARTSTOP_LEVEL
            @info """GMRES linsolve converged without any iterations:
            * norm of residual = $(normres2string(β))
            * number of operations = 1"""
        end
        return (x, ConvergenceInfo(1, r, β, 0, 1))
    elseif alg.verbosity >= STARTSTOP_LEVEL
        @info "GMRES linsolve starts with norm of residual = $(normres2string(β))"
    end

    # Initialize data structures
    y = Vector{T}(undef, krylovdim + 1)
    gs = Vector{Givens{T}}(undef, krylovdim)
    R = fill(zero(T), (krylovdim, krylovdim))
    numiter = 0
    numops = 1 # operator has been applied once to determine T and r

    iter = ArnoldiIterator(operator, r, alg.orth)
    fact = initialize(iter; verbosity = SILENT_LEVEL)
    sizehint!(fact, alg.krylovdim)
    numops += 1 # start applies operator once

    while true # restart loop
        numiter += 1
        y[1] = β
        k = 1
        H = rayleighquotient(fact)
        R[1, 1] = α₀ + α₁ * H[1, 1]
        gs[1], R[1, 1] = givens(R[1, 1], α₁ * normres(fact), 1, 2)
        y[2] = zero(T)
        lmul!(gs[1], y)
        β = convert(S, abs(y[2]))

        while (!iszero(R[k, k]) && β > tol && length(fact) < krylovdim) # inner arnoldi loop
            if alg.verbosity >= EACHITERATION_LEVEL
                @info "GMRES linsolve in iteration $numiter; step $k: normres = $(normres2string(β))"
            end
            fact = expand!(iter, fact; verbosity = SILENT_LEVEL)
            numops += 1 # expand! applies the operator once
            k = length(fact)
            H = rayleighquotient(fact)

            # copy Arnoldi Hessenberg matrix into R
            @inbounds begin
                for i in 1:(k - 1)
                    R[i, k] = α₁ * H[i, k]
                end
                R[k, k] = α₀ + α₁ * H[k, k]
            end

            # Apply old Givens rotations
            Rk = view(R, :, k)
            @inbounds for i in 1:(k - 1)
                lmul!(gs[i], Rk)
            end

            # Compute new Givens rotations for final row and also apply to right hand side
            if hypot(R[k, k], α₁ * normres(fact)) < tol
                if alg.verbosity >= WARN_LEVEL
                    @warn "GMRES linsolve in iteration $numiter; step $k: linear operator is singular in Krylov subspace"
                end
                # rotate all the weight into y[k + 1]
                gs[k], y[k + 1] = givens(zero(T), y[k], k + 1, k)
                y[k] = zero(T)
                R[k, k] = zero(T)
            else
                gs[k], R[k, k] = givens(R[k, k], α₁ * normres(fact), k, k + 1)
                y[k + 1] = zero(T)
                lmul!(gs[k], y)
            end

            # New error
            β = convert(S, abs(y[k + 1]))
        end

        # Solve upper triangular system
        if iszero(R[k, k]) && iszero(y[k])
            ldiv!(UpperTriangular(R), y, 1:(k - 1))
        else
            ldiv!(UpperTriangular(R), y, 1:k)
        end

        # Update x
        V = basis(fact)
        @inbounds for i in 1:k
            x = add!!(x, V[i], y[i])
        end

        if β > tol && numiter < maxiter
            # Recompute residual without reevaluating operator
            w = residual(fact)
            push!(V, scale!!(w, 1 / normres(fact)))
            for i in 1:k
                rmul!(V, gs[i]')
            end
            r = scale!!(r, V[k + 1], y[k + 1])
        else
            # Recompute residual and its norm explicitly, to ensure that no
            # numerical errors have accumulated
            r = scale!!(r, b, 1)
            r = add!!(r, apply(operator, x, α₀, α₁), -1)
            numops += 1
            β = norm(r)
            if β < tol
                if alg.verbosity >= STARTSTOP_LEVEL
                    @info """GMRES linsolve converged at iteration $numiter, step $k:
                    * norm of residual = $(normres2string(β))
                    * number of operations = $numops"""
                end
                return (x, ConvergenceInfo(1, r, β, numiter, numops))
            end
        end
        if numiter >= maxiter
            if alg.verbosity >= WARN_LEVEL
                @warn """GMRES linsolve stopped without converging after $numiter iterations:
                * norm of residual = $(normres2string(β))
                * number of operations = $numops"""
            end
            return (x, ConvergenceInfo(0, r, β, numiter, numops))
        end
        if alg.verbosity >= EACHITERATION_LEVEL
            @info "GMRES linsolve in iteration $numiter; step $k: normres = $(normres2string(β))"
        end

        # Restart Arnoldi factorization with new r
        iter = ArnoldiIterator(operator, r, alg.orth)
        fact = initialize!(iter, fact; verbosity = SILENT_LEVEL)
    end
    return
end

function eigsolve(
        A, x₀, howmany::Int, which::Selector, alg::Lanczos;
        alg_rrule = Arnoldi(;
            tol = alg.tol,
            krylovdim = alg.krylovdim,
            maxiter = alg.maxiter,
            eager = alg.eager,
            orth = alg.orth
        )
    )
    krylovdim = alg.krylovdim
    maxiter = alg.maxiter
    if howmany > krylovdim
        error("krylov dimension $(krylovdim) too small to compute $howmany eigenvalues")
    end

    ## FIRST ITERATION: setting up
    # Initialize Lanczos factorization
    iter = LanczosIterator(A, x₀, alg.orth)
    fact = initialize(iter; verbosity = alg.verbosity)
    numops = 1
    numiter = 1
    sizehint!(fact, krylovdim)
    β = normres(fact)
    tol::typeof(β) = alg.tol

    # allocate storage
    HH = fill(zero(eltype(fact)), krylovdim + 1, krylovdim)
    UU = fill(zero(eltype(fact)), krylovdim, krylovdim)

    converged = 0
    local D, U, f
    while true
        β = normres(fact)
        K = length(fact)

        # diagonalize Krylov factorization
        if β <= tol && K < howmany
            if alg.verbosity >= WARN_LEVEL
                msg = "Invariant subspace of dimension $K (up to requested tolerance `tol = $tol`), "
                msg *= "which is smaller than the number of requested eigenvalues (i.e. `howmany == $howmany`)."
                @warn msg
            end
        end
        if K == krylovdim || β <= tol || (alg.eager && K >= howmany)
            U = copyto!(view(UU, 1:K, 1:K), I)
            f = view(HH, K + 1, 1:K)
            T = rayleighquotient(fact) # symtridiagonal

            # compute eigenvalues
            if K == 1
                D = [T[1, 1]]
                f[1] = β
                converged = Int(β <= tol)
            else
                if K < krylovdim
                    T = deepcopy(T)
                end
                D, U = tridiageigh!(T, U)
                by, rev = eigsort(which)
                p = sortperm(D; by = by, rev = rev)
                D, U = permuteeig!(D, U, p)
                mul!(f, view(U, K, :), β)
                converged = 0
                while converged < K && abs(f[converged + 1]) <= tol
                    converged += 1
                end
            end

            if converged >= howmany || β <= tol
                break
            elseif alg.verbosity >= EACHITERATION_LEVEL
                @info "Lanczos eigsolve in iteration $numiter, step = $K: $converged values converged, normres = $(normres2string(abs.(f[1:howmany])))"
            end
        end

        if K < krylovdim # expand Krylov factorization
            fact = expand!(iter, fact; verbosity = alg.verbosity)
            numops += 1
        else ## shrink and restart
            if numiter == maxiter
                break
            end

            # Determine how many to keep
            keep = div(3 * krylovdim + 2 * converged, 5) # strictly smaller than krylovdim since converged < howmany <= krylovdim, at least equal to converged

            # Restore Lanczos form in the first keep columns
            H = fill!(view(HH, 1:(keep + 1), 1:keep), zero(eltype(HH)))
            @inbounds for j in 1:keep
                H[j, j] = D[j]
                H[keep + 1, j] = f[j]
            end
            @inbounds for j in keep:-1:1
                h, ν = householder(H, j + 1, 1:j, j)
                H[j + 1, j] = ν
                H[j + 1, 1:(j - 1)] .= zero(eltype(H))
                lmul!(h, H)
                rmul!(view(H, 1:j, :), h')
                rmul!(U, h')
            end
            @inbounds for j in 1:keep
                fact.αs[j] = H[j, j]
                fact.βs[j] = H[j + 1, j]
            end

            # Update B by applying U using Householder reflections
            B = basis(fact)
            B = basistransform!(B, view(U, :, 1:keep))
            r = residual(fact)
            B[keep + 1] = scale!!(r, 1 / β)

            # Shrink Lanczos factorization
            fact = shrink!(fact, keep; verbosity = alg.verbosity)
            numiter += 1
        end
    end

    howmany′ = howmany
    if converged > howmany
        howmany′ = converged
    elseif length(D) < howmany
        howmany′ = length(D)
    end
    values = D[1:howmany′]

    # Compute eigenvectors
    V = view(U, :, 1:howmany′)

    # Compute convergence information
    vectors = let B = basis(fact)
        [B * v for v in cols(V)]
    end
    residuals = let r = residual(fact)
        [scale(r, last(v)) for v in cols(V)]
    end
    normresiduals = let f = f
        map(i -> abs(f[i]), 1:howmany′)
    end

    if (converged < howmany) && alg.verbosity >= WARN_LEVEL
        @warn """Lanczos eigsolve stopped without convergence after $numiter iterations:
        * $converged eigenvalues converged
        * norm of residuals = $(normres2string(normresiduals))
        * number of operations = $numops"""
    elseif alg.verbosity >= STARTSTOP_LEVEL
        @info """Lanczos eigsolve finished after $numiter iterations:
        * $converged eigenvalues converged
        * norm of residuals = $(normres2string(normresiduals))
        * number of operations = $numops"""
    end

    return values, vectors,
        ConvergenceInfo(converged, residuals, normresiduals, numiter, numops)
end

function linsolve(operator, b, x₀, alg::CG, a₀::Real = 0, a₁::Real = 1; alg_rrule = alg)
    # Initial function operation and division defines number type
    y₀ = apply(operator, x₀)
    T = typeof(inner(b, y₀) / norm(b) * one(a₀) * one(a₁))
    α₀ = convert(T, a₀)
    α₁ = convert(T, a₁)
    # Continue computing r = b - a₀ * x₀ - a₁ * operator(x₀)
    r = scale(b, one(T))
    r = iszero(α₀) ? r : add!!(r, x₀, -α₀)
    r = add!!(r, y₀, -α₁)
    x = scale!!(zerovector(r), x₀, 1)
    normr = norm(r)
    S = typeof(normr)

    # Algorithm parameters
    maxiter = alg.maxiter
    tol::S = alg.tol
    numops = 1 # operator has been applied once to determine r
    numiter = 0

    # Check for early return
    if normr < tol
        if alg.verbosity >= STARTSTOP_LEVEL
            @info """CG linsolve converged without any iterations:
            * norm of residual = $(normres2string(normr))
            * number of operations = 1"""
        end
        return (x, ConvergenceInfo(1, r, normr, numiter, numops))
    elseif alg.verbosity >= STARTSTOP_LEVEL
        @info "CG linsolve starts with norm of residual = $(normres2string(normr))"
    end

    # First iteration
    ρ = normr^2
    p = scale!!(zerovector(r), r, 1)
    q = apply(operator, p, α₀, α₁)
    α = ρ / inner(p, q)
    x = add!!(x, p, +α)
    r = add!!(r, q, -α)
    normr = norm(r)
    ρold = ρ
    ρ = normr^2
    β = ρ / ρold
    numops += 1
    numiter += 1

    if normr < tol
        if alg.verbosity >= STARTSTOP_LEVEL
            @info """CG linsolve converged at iteration $numiter:
            * norm of residual = $(normres2string(normr))
            * number of operations = $numops"""
        end
        return (x, ConvergenceInfo(1, r, normr, numiter, numops))
    end
    if alg.verbosity >= EACHITERATION_LEVEL
        @info "CG linsolve in iteration $numiter: normres = $(normres2string(normr))"
    end

    # Check for early return
    normr < tol && return (x, ConvergenceInfo(1, r, normr, numiter, numops))

    while true
        p = add!!(p, r, 1, β)
        q = apply(operator, p, α₀, α₁)
        α = ρ / inner(p, q)
        x = add!!(x, p, α)
        r = add!!(r, q, -α)
        normr = norm(r)
        if normr < tol # recompute to account for buildup of floating point errors
            r = scale!!(r, b, 1)
            r = add!!(r, apply(operator, x, α₀, α₁), -1)
            normr = norm(r)
            ρ = normr^2
            β = zero(β) # restart CG
        else
            ρold = ρ
            ρ = normr^2
            β = ρ / ρold
        end
        numops += 1
        numiter += 1
        if normr < tol
            if alg.verbosity >= STARTSTOP_LEVEL
                @info """CG linsolve converged at iteration $numiter:
                * norm of residual = $(normres2string(normr))
                * number of operations = $numops"""
            end
            return (x, ConvergenceInfo(1, r, normr, numiter, numops))
        end
        if numiter >= maxiter
            if alg.verbosity >= WARN_LEVEL
                @warn """CG linsolve stopped without converging after $numiter iterations:
                * norm of residual = $(normres2string(normr))
                * number of operations = $numops"""
            end
            return (x, ConvergenceInfo(0, r, normr, numiter, numops))
        end
        if alg.verbosity >= EACHITERATION_LEVEL
            @info "CG linsolve in iteration $numiter: normres = $(normres2string(normr))"
        end
    end
    return
end

"""
    linsolve(A::AbstractMatrix, b::AbstractVector, [x₀, a₀::Number = 0, a₁::Number = 1]; kwargs...)
    linsolve(f, b, [x₀, a₀::Number = 0, a₁::Number = 1]; kwargs...)
    # expert version:
    linsolve(f, b, x₀, algorithm, [a₀::Number = 0, a₁::Number = 1]; alg_rrule=algorithm)

Compute a solution `x` to the linear system `(a₀ + a₁ * A)*x = b` or
`a₀ * x + a₁ * f(x) = b`, possibly using a starting guess `x₀`. Return the approximate
solution `x` and a `ConvergenceInfo` structure.

### Arguments:

The linear map can be an `AbstractMatrix` (dense or sparse) or a general function or
callable object. If no initial guess is specified, it is chosen as `(zero(a₀)*zero(a₁))*b`
which should generate an object similar to `b` but initialized with zeros. The numbers `a₀`
and `a₁` are optional arguments; they are applied implicitly, i.e. they do not contribute
the computation time of applying the linear map or to the number of operations on vectors of
type `x` and `b`.

### Return values:

The return value is always of the form `x, info = linsolve(...)` with

  - `x`: the approximate solution to the problem, similar type as the right hand side `b`
    but possibly with a different `scalartype`

  - `info`: an object of type [`ConvergenceInfo`], which has the following fields

      + `info.converged::Int`: takes value 0 or 1 depending on whether the solution was
        converged up to the requested tolerance
      + `info.residual`: residual `b - f(x)` of the approximate solution `x`
      + `info.normres::Real`: norm of the residual, i.e. `norm(info.residual)`
      + `info.numops::Int`: total number of times that the linear map was applied, i.e. the
        number of times that `f` was called, or a vector was multiplied with `A`
      + `info.numiter::Int`: number of times the Krylov subspace was restarted (see below)

!!! warning "Check for convergence"

    No warning is printed if no converged solution was found, so always check if
    `info.converged == 1`.

### Keyword arguments:

Keyword arguments are given by:

  - `verbosity::Int = SILENT_LEVEL`: verbosity level, i.e. 
    - SILENT_LEVEL (suppress all messages)
    - WARN_LEVEL (only warnings)
    - STARTSTOP_LEVEL (information at the beginning and end)
    - EACHITERATION_LEVEL (progress info after every iteration)
  - `atol::Real`: the requested accuracy, i.e. absolute tolerance, on the norm of the
    residual.
  - `rtol::Real`: the requested accuracy on the norm of the residual, relative to the norm
    of the right hand side `b`.
  - `tol::Real`: the requested accuracy on the norm of the residual that is actually used by
    the algorithm; it defaults to `max(atol, rtol*norm(b))`. So either use `atol` and `rtol`
    or directly use `tol` (in which case the value of `atol` and `rtol` will be ignored).
  - `krylovdim::Integer`: the maximum dimension of the Krylov subspace that will be
    constructed.
  - `maxiter::Integer`: the number of times the Krylov subspace can be rebuilt; see below for
    further details on the algorithms.
  - `orth::Orthogonalizer`: the orthogonalization method to be used, see
    [`Orthogonalizer`](@ref)
  - `issymmetric::Bool`: if the linear map is symmetric, only meaningful if `T<:Real`
  - `ishermitian::Bool`: if the linear map is hermitian
  - `isposdef::Bool`: if the linear map is positive definite

The default values are given by `atol = KrylovDefaults.tol[]`, `rtol = KrylovDefaults.tol[]`,
`tol = max(atol, rtol*norm(b))`, `krylovdim = KrylovDefaults.krylovdim[]`,
`maxiter = KrylovDefaults.maxiter[]`, `orth = KrylovDefaults.orth`;
see [`KrylovDefaults`](@ref) for details.

The default value for the last three parameters depends on the method. If an
`AbstractMatrix` is used, `issymmetric`, `ishermitian` and `isposdef` are checked for that
matrix, ortherwise the default values are `issymmetric = false`,
`ishermitian = T <: Real && issymmetric` and `isposdef = false`.

The final keyword argument `alg_rrule` is relevant only when `linsolve` is used in a setting
where reverse-mode automatic differentation will be used. A custom `ChainRulesCore.rrule` is
defined for `linsolve`, which can be evaluated using different algorithms that can be specified
via `alg_rrule`. As the pullback of `linsolve` involves solving a linear system with the
(Hermitian) adjoint of the linear map, the default value is to use the same algorithm. This
keyword argument should only be used when this default choice is failing or not performing
efficiently. Check the documentation for more information on the possible values for
`alg_rrule` and their implications on the algorithm being used.

### Algorithms

The final (expert) method, without default values and keyword arguments, is the one that is
finally called, and can also be used directly. Here, one specifies the algorithm explicitly.
Currently, only [`CG`](@ref), [`GMRES`](@ref), [`BiCGStab`](@ref) and [`LSMR`](@ref) are implemented, where
`CG` is chosen if `isposdef == true` and `GMRES` is chosen otherwise. Note that in standard
`GMRES` terminology, our parameter `krylovdim` is referred to as the *restart* parameter,
and our `maxiter` parameter counts the number of outer iterations, i.e. restart cycles. In
`CG`, the Krylov subspace is only implicit because short recurrence relations are being
used, and therefore no restarts are required. Therefore, we pass `krylovdim*maxiter` as the
maximal number of CG iterations that can be used by the `CG` algorithm.
"""
function linsolve end

function linsolve(
        A::AbstractMatrix, b::AbstractVector, a₀::Number = 0, a₁::Number = 1;
        kwargs...
    )
    return linsolve(A, b, (zero(a₀) * zero(a₁)) * b, a₀, a₁; kwargs...)
end

function linsolve(f, b, a₀::Number = 0, a₁::Number = 1; kwargs...)
    return linsolve(f, b, scale(b, zero(a₀) * zero(a₁)), a₀, a₁; kwargs...)
end

function linsolve(f, b, x₀, a₀::Number = 0, a₁::Number = 1; kwargs...)
    T = apply_scalartype(f, x₀, a₀, a₁)
    alg = linselector(f, b, T; kwargs...)
    if haskey(kwargs, :alg_rrule)
        alg_rrule = kwargs[:alg_rrule]
    else
        alg_rrule = alg
    end
    return linsolve(f, b, x₀, alg, a₀, a₁; alg_rrule = alg_rrule)
end

function linselector(
        f, b, T::Type;
        issymmetric::Bool = false,
        ishermitian::Bool = (T <: Real && issymmetric),
        isposdef::Bool = false,
        krylovdim::Int = KrylovDefaults.krylovdim[],
        maxiter::Int = KrylovDefaults.maxiter[],
        rtol::Real = KrylovDefaults.tol[],
        atol::Real = KrylovDefaults.tol[],
        tol::Real = max(atol, rtol * norm(b)),
        orth = KrylovDefaults.orth,
        verbosity::Int = KrylovDefaults.verbosity[]
    )
    if (T <: Real && issymmetric) || ishermitian
        if isposdef
            return CG(; maxiter = krylovdim * maxiter, tol = tol, verbosity = verbosity)
        else
            # TODO: implement MINRES for symmetric but not posdef; for now use GRMES
            # return MINRES(krylovdim*maxiter, tol=tol)
        end
    end
    return GMRES(;
        krylovdim = krylovdim,
        maxiter = maxiter,
        tol = tol,
        orth = orth,
        verbosity = verbosity
    )
end
function linselector(
        A::AbstractMatrix, b, T::Type;
        issymmetric::Bool = (T <: Real && LinearAlgebra.issymmetric(A)),
        ishermitian::Bool = issymmetric || LinearAlgebra.ishermitian(A),
        isposdef::Bool = ishermitian ? LinearAlgebra.isposdef(A) : false,
        krylovdim::Int = KrylovDefaults.krylovdim[],
        maxiter::Int = KrylovDefaults.maxiter[],
        rtol::Real = KrylovDefaults.tol[],
        atol::Real = KrylovDefaults.tol[],
        tol::Real = max(atol, rtol * norm(b)),
        orth = KrylovDefaults.orth,
        verbosity::Int = KrylovDefaults.verbosity[]
    )
    if (T <: Real && issymmetric) || ishermitian
        if isposdef
            return CG(; maxiter = krylovdim * maxiter, tol = tol, verbosity = verbosity)
        else
            # TODO: implement MINRES for symmetric but not posdef; for now use GRMES
            # return MINRES(krylovdim*maxiter, tol=tol)
        end
    end
    return GMRES(;
        krylovdim = krylovdim,
        maxiter = maxiter,
        tol = tol,
        orth = orth,
        verbosity = verbosity
    )
end

"""
    reallinsolve(f, b, x₀, algorithm, [a₀::Real = 0, a₁::Real = 1]; alg_rrule=algorithm)

Compute a solution `x` to the linear system `a₀ * x + a₁ * f(x) = b`, using a starting guess
`x₀`, where `f` represents a real linear map.
Return the approximate solution `x` and a `ConvergenceInfo` structure.

!!! note "Note about real linear maps"

    A function `f` is said to implement a real linear map if it satisfies 
    `f(add(x,y)) = add(f(x), f(y)` and `f(scale(x, α)) = scale(f(x), α)` for vectors `x`
    and `y` and scalars `α::Real`. Note that this is possible even when the vectors are
    represented using complex arithmetic. For example, the map `f=x-> x + conj(x)`
    represents a real linear map that is not (complex) linear, as it does not satisfy
    `f(scale(x, α)) = scale(f(x), α)` for complex scalars `α`. Note that complex linear
    maps are always real linear maps and thus can be used in this context, though in that
    case `linsolve` and `reallinsolve` target the same solution. However, they still compute
    that solution using different arithmetic, and in that case `linsolve` might be more
    efficient.

    To interpret the vectors `x` and `y` as elements from a real vector space, the standard
    inner product defined on them will be replaced with `real(inner(x,y))`. This has no
    effect if the vectors `x` and `y` were represented using real arithmetic to begin with,
    and allows to seemlessly use complex vectors as well.


### Arguments:

The linear map can be an `AbstractMatrix` (dense or sparse) or a general function or
callable object. The real numbers `a₀` and `a₁` are optional arguments; they are applied 
implicitly,  i.e. they do not contribute the computation time of applying the linear map or
to the  number of operations on vectors of type `x` and `b`.

### Return values:

The return value is always of the form `x, info = linsolve(...)` with

  - `x`: the approximate solution to the problem, similar type as the right hand side `b`
    but possibly with a different `scalartype`

  - `info`: an object of type [`ConvergenceInfo`], which has the following fields

      + `info.converged::Int`: takes value 0 or 1 depending on whether the solution was
        converged up to the requested tolerance
      + `info.residual`: residual `b - f(x)` of the approximate solution `x`
      + `info.normres::Real`: norm of the residual, i.e. `norm(info.residual)`
      + `info.numops::Int`: total number of times that the linear map was applied, i.e. the
        number of times that `f` was called, or a vector was multiplied with `A`
      + `info.numiter::Int`: number of times the Krylov subspace was restarted (see below)

!!! warning "Check for convergence"

    No warning is printed if no converged solution was found, so always check if
    `info.converged == 1`.


### Algorithms

The final (expert) method, without default values and keyword arguments, is the one that is
finally called, and can also be used directly. Here, one specifies the algorithm explicitly.
Currently, only [`CG`](@ref), [`GMRES`](@ref) and [`BiCGStab`](@ref) are implemented, where
`CG` is chosen if `isposdef == true` and `GMRES` is chosen otherwise. Note that in standard
`GMRES` terminology, our parameter `krylovdim` is referred to as the *restart* parameter,
and our `maxiter` parameter counts the number of outer iterations, i.e. restart cycles. In
`CG`, the Krylov subspace is only implicit because short recurrence relations are being
used, and therefore no restarts are required. Therefore, we pass `krylovdim*maxiter` as the
maximal number of CG iterations that can be used by the `CG` algorithm.
"""
function reallinsolve(f, b, x₀, alg, a₀::Real = 0, a₁::Real = 1)
    x, info = linsolve(f, RealVec(b), RealVec(x₀), alg, a₀, a₁)

    newinfo = ConvergenceInfo(
        info.converged, info.residual[], info.normres, info.numiter,
        info.numops
    )
    return x[], newinfo
end

"""
    svdsolve(A::AbstractMatrix, [x₀, howmany = 1, which = :LR, T = eltype(A)]; kwargs...)
    svdsolve(f, m::Int, [howmany = 1, which = :LR, T = Float64]; kwargs...)
    svdsolve(f, x₀, [howmany = 1, which = :LR]; kwargs...)
    # expert version:
    svdsolve(f, x₀, howmany, which, algorithm; alg_rrule=...)

Compute `howmany` singular values from the linear map encoded in the matrix `A` or by the
function `f`. Return singular values, left and right singular vectors and a
`ConvergenceInfo` structure.

### Arguments:

The linear map can be an `AbstractMatrix` (dense or sparse) or a general function or
callable object. Since both the action of the linear map and its adjoint are required in
order to compute singular values, `f` can either be a tuple of two callable objects (each
accepting a single argument), representing the linear map and its adjoint respectively, or,
`f` can be a single callable object that accepts two input arguments, where the second
argument is a flag of type `Val{true}` or `Val{false}` that indicates whether the adjoint or
the normal action of the linear map needs to be computed. The latter form still combines
well with the `do` block syntax of Julia, as in

```julia
vals, lvecs, rvecs, info = svdsolve(x₀, howmany, which; kwargs...) do x, flag
    if flag === Val(true)
        # y = compute action of adjoint map on x
    else
        # y = compute action of linear map on x
    end
    return y
end
```

For a general linear map encoded using either the tuple or the two-argument form, the best
approach is to provide a start vector `x₀` (in the codomain, i.e. column space, of the
linear map). Alternatively, one can specify the number `m` of rows of the linear map, in
which case `x₀ = rand(T, m)` is used, where the default value of `T` is `Float64`, unless
specified differently. If an `AbstractMatrix` is used, a starting vector `x₀` does not need
to be provided; it is chosen as `rand(T, size(A, 1))`.

The next arguments are optional, but should typically be specified. `howmany` specifies how
many singular values and vectors should be computed; `which` specifies which singular
values should be targeted. Valid specifications of `which` are

  - `LR`: largest singular values
  - `SR`: smallest singular values
    However, the largest singular values tend to converge more rapidly.

### Return values:

The return value is always of the form `vals, lvecs, rvecs, info = svdsolve(...)` with

  - `vals`: a `Vector{<:Real}` containing the singular values, of length at least `howmany`,
    but could be longer if more singular values were converged at the same cost.
  - `lvecs`: a `Vector` of corresponding left singular vectors, of the same length as
    `vals`.
  - `rvecs`: a `Vector` of corresponding right singular vectors, of the same length as
    `vals`. Note that singular vectors are not returned as a matrix, as the linear map
    could act on any custom Julia type with vector like behavior, i.e. the elements of the
  lists `lvecs`(`rvecs`) are objects that are typically similar to the starting guess `x₀`(`A' * x₀`), up to a possibly different `eltype`. When the linear map is a simple
    `AbstractMatrix`, `lvecs` and `rvecs` will be `Vector{Vector{<:Number}}`.
  - `info`: an object of type [`ConvergenceInfo`], which has the following fields

      + `info.converged::Int`: indicates how many singular values and vectors were actually
        converged to the specified tolerance `tol` (see below under keyword arguments)
      + `info.residual::Vector`: a list of the same length as `vals` containing the
        residuals
        `info.residual[i] = A * rvecs[i] - vals[i] * lvecs[i]`.
      + `info.normres::Vector{<:Real}`: list of the same length as `vals` containing the
        norm of the residual `info.normres[i] = norm(info.residual[i])`
      + `info.numops::Int`: number of times the linear map was applied, i.e. number of times
        `f` was called, or a vector was multiplied with `A` or `A'`.
      + `info.numiter::Int`: number of times the Krylov subspace was restarted (see below)

!!! warning "Check for convergence"

    No warning is printed if not all requested singular values were converged, so always
    check if `info.converged >= howmany`.

### Keyword arguments:

Keyword arguments and their default values are given by:

  - `verbosity::Int = SILENT_LEVEL`: verbosity level
    - SILENT_LEVEL (suppress all messages)
    - WARN_LEVEL (only warnings)
    - STARTSTOP_LEVEL (one message with convergence info at the end)
    - EACHITERATION_LEVEL (progress info after every iteration)
    - EACHITERATION_LEVEL+ (all of the above and additional information about the GKL iteration)
  - `krylovdim`: the maximum dimension of the Krylov subspace that will be constructed.
    Note that the dimension of the vector space is not known or checked, e.g. `x₀` should
    not necessarily support the `Base.length` function. If you know the actual problem
    dimension is smaller than the default value, it is useful to reduce the value of
    `krylovdim`, though in principle this should be detected.
  - `tol`: the requested accuracy according to `normres` as defined above. If you work in
    e.g. single precision (`Float32`), you should definitely change the default value.
  - `maxiter`: the number of times the Krylov subspace can be rebuilt; see below for further
    details on the algorithms.
  - `orth`: the orthogonalization method to be used, see [`Orthogonalizer`](@ref)
  - `eager::Bool = false`: if true, eagerly compute the SVD after every expansion of the
    Krylov subspace to test for convergence, otherwise wait until the Krylov subspace has
    dimension `krylovdim`

The final keyword argument `alg_rrule` is relevant only when `svdsolve` is used in a setting
where reverse-mode automatic differentation will be used. A custom `ChainRulesCore.rrule` is
defined for `svdsolve`, which can be evaluated using different algorithms that can be specified
via `alg_rrule`. A suitable default is chosen, so this keyword argument should only be used
when this default choice is failing or not performing efficiently. Check the documentation for
more information on the possible values for `alg_rrule` and their implications on the algorithm
being used.

### Algorithm

The last method, without default values and keyword arguments, is the one that is finally
called, and can also be used directly. Here the algorithm is specified, though currently
only [`GKL`](@ref) is available. `GKL` refers to the the partial Golub-Kahan-Lanczos
bidiagonalization which forms the basis for computing the approximation to the singular
values. This factorization is dynamically shrunk and expanded (i.e. thick restart) similar
to the Krylov-Schur factorization for eigenvalues.
"""
function svdsolve end

function svdsolve(
        A::AbstractMatrix, howmany::Int = 1, which::Selector = :LR, T::Type = eltype(A);
        kwargs...
    )
    x₀ = Random.rand!(similar(A, T, size(A, 1)))
    return svdsolve(A, x₀, howmany, which; kwargs...)
end
function svdsolve(
        f, n::Int, howmany::Int = 1, which::Selector = :LR, T::Type = Float64;
        kwargs...
    )
    return svdsolve(f, rand(T, n), howmany, which; kwargs...)
end

function svdsolve(f, x₀, howmany::Int = 1, which::Selector = :LR; kwargs...)
    which == :LR || which == :SR ||
        error("invalid specification of which singular values to target: which = $which")
    alg = GKL(; kwargs...)
    return svdsolve(f, x₀, howmany, which, alg)
end

function svdsolve(
        A, x₀, howmany::Int, which::Symbol, alg::GKL;
        alg_rrule = Arnoldi(;
            tol = alg.tol,
            krylovdim = alg.krylovdim,
            maxiter = alg.maxiter,
            eager = alg.eager,
            orth = alg.orth,
            verbosity = alg.verbosity
        )
    )
    krylovdim = alg.krylovdim
    maxiter = alg.maxiter
    howmany > krylovdim &&
        error("krylov dimension $(krylovdim) too small to compute $howmany singular values")

    ## FIRST ITERATION: setting up
    numiter = 1
    # initialize GKL factorization
    iter = GKLIterator(A, x₀, alg.orth)
    fact = initialize(iter; verbosity = alg.verbosity)
    numops = 2
    sizehint!(fact, krylovdim)
    β = normres(fact)
    tol::typeof(β) = alg.tol

    # allocate storage
    HH = fill(zero(eltype(fact)), krylovdim + 1, krylovdim)
    PP = fill(zero(eltype(fact)), krylovdim, krylovdim)
    QQ = fill(zero(eltype(fact)), krylovdim, krylovdim)

    # initialize storage
    local P, Q, f, S
    converged = 0
    while true
        β = normres(fact)
        K = length(fact)

        if β <= tol && K < howmany
            if alg.verbosity >= WARN_LEVEL
                msg = "Invariant subspace of dimension $K (up to requested tolerance `tol = $tol`), "
                msg *= "which is smaller than the number of requested eigenvalues (i.e. `howmany == $howmany`)."
                @warn msg
            end
        end
        if K == krylovdim || β <= tol || (alg.eager && K >= howmany)
            P = copyto!(view(PP, 1:K, 1:K), I)
            Q = copyto!(view(QQ, 1:K, 1:K), I)
            f = view(HH, K + 1, 1:K)
            B = rayleighquotient(fact) # Bidiagional (lower)

            if K < krylovdim
                B = deepcopy(B)
            end
            P, S, Q = bidiagsvd!(B, P, Q)
            if which == :SR
                reversecols!(P)
                reverserows!(S)
                reverserows!(Q)
            elseif which != :LR
                error("invalid specification of which singular values to target: which = $which")
            end
            mul!(f, view(Q', K, :), β)

            converged = 0
            while converged < K && abs(f[converged + 1]) < tol
                converged += 1
            end

            if converged >= howmany || β <= tol
                break
            elseif alg.verbosity >= EACHITERATION_LEVEL
                @info "GKL svdsolve in iteration $numiter, step $K: $converged values converged, normres = $(normres2string(abs.(f[1:howmany])))"
            end
        end

        if K < krylovdim # expand
            fact = expand!(iter, fact; verbosity = alg.verbosity)
            numops += 2
        else ## shrink and restart
            if numiter == maxiter
                break
            end

            # Determine how many to keep
            keep = div(3 * krylovdim + 2 * converged, 5) # strictly smaller than krylovdim since converged < howmany <= krylovdim, at least equal to converged

            # Update basis by applying P and Q using Householder reflections
            U = basis(fact, Val(:U))
            basistransform!(U, view(P, :, 1:keep))
            # for j = 1:m
            #     h, ν = householder(P, j:m, j)
            #     lmul!(h, view(P, :, j+1:krylovdim))
            #     rmul!(U, h')
            # end
            V = basis(fact, Val(:V))
            basistransform!(V, view(Q', :, 1:keep))
            # for j = 1:m
            #     h, ν = householder(Q, j, j:m)
            #     rmul!(view(Q, j+1:krylovdim, :), h)
            #     rmul!(V, h)
            # end

            # Shrink GKL factorization (no longer strictly GKL)
            r = residual(fact)
            U[keep + 1] = scale!!(r, 1 / normres(fact))
            H = fill!(view(HH, 1:(keep + 1), 1:keep), zero(eltype(HH)))
            @inbounds for j in 1:keep
                H[j, j] = S[j]
                H[keep + 1, j] = f[j]
            end

            # Restore bidiagonal form in the first keep columns
            @inbounds for j in keep:-1:1
                h, ν = householder(H, j + 1, 1:j, j)
                H[j + 1, j] = ν
                H[j + 1, 1:(j - 1)] .= zero(eltype(H))
                rmul!(view(H, 1:j, :), h')
                rmul!(V, h')
                h, ν = householder(H, 1:j, j, j)
                H[j, j] = ν
                @inbounds H[1:(j - 1), j] .= zero(eltype(H))
                lmul!(h, view(H, :, 1:(j - 1)))
                rmul!(U, h')
            end
            @inbounds for j in 1:keep
                fact.αs[j] = H[j, j]
                fact.βs[j] = H[j + 1, j]
            end
            # Shrink GKL factorization
            fact = shrink!(fact, keep; verbosity = alg.verbosity)
            numiter += 1
        end
    end
    if converged > howmany
        howmany = converged
    end
    values = S[1:howmany]

    # Compute schur vectors
    Pv = view(P, :, 1:howmany)
    Qv = view(Q, 1:howmany, :)

    # Compute convergence information
    leftvectors = let U = basis(fact, Val(:U))
        [U * v for v in cols(Pv)]
    end
    rightvectors = let V = basis(fact, Val(:V))
        [V * v for v in cols(Qv')]
    end
    residuals = let r = residual(fact)
        [scale(r, last(v)) for v in cols(Qv')]
    end
    normresiduals = let f = f
        map(i -> abs(f[i]), 1:howmany)
    end
    if (converged < howmany) && alg.verbosity >= WARN_LEVEL
        @warn """GKL svdsolve finished without convergence after $numiter iterations:
        * $converged singular values converged
        * norm of residuals = $(normres2string(normresiduals))
        * number of operations = $numops"""
    elseif alg.verbosity >= STARTSTOP_LEVEL
        @info """GKL svdsolve finished after $numiter iterations:
        * $converged singular values converged
        * norm of residuals = $(normres2string(normresiduals))
        * number of operations = $numops"""
    end

    return values, leftvectors, rightvectors,
        ConvergenceInfo(converged, residuals, normresiduals, numiter, numops)
end

"""
    KrylovKit

A Julia package collecting a number of Krylov-based algorithms for linear problems,
singular value and eigenvalue problems and the application of functions of linear maps or
operators to vectors.

KrylovKit accepts general functions or callable objects as linear maps, and general Julia
objects with vector like behavior as vectors.

The high level interface of KrylovKit is provided by the following functions:

  - [`linsolve`](@ref): solve linear systems
  - [`eigsolve`](@ref): find a few eigenvalues and corresponding eigenvectors
  - [`geneigsolve`](@ref): find a few generalized eigenvalues and corresponding vectors
  - [`svdsolve`](@ref): find a few singular values and corresponding left and right
    singular vectors
  - [`exponentiate`](@ref): apply the exponential of a linear map to a vector
  - [`expintegrator`](@ref): exponential integrator for a linear non-homogeneous ODE,
    computes a linear combination of the `ϕⱼ` functions which generalize `ϕ₀(z) = exp(z)`.
"""
module KrylovKit
using VectorInterface
using VectorInterface: add!!
using LinearAlgebra
using Printf
using Random
using PackageExtensionCompat
const IndexRange = AbstractRange{Int}

export linsolve, reallinsolve, lssolve, reallssolve
export eigsolve, geneigsolve, realeigsolve, schursolve, svdsolve, bieigsolve
export exponentiate, expintegrator
export orthogonalize, orthogonalize!!, orthonormalize, orthonormalize!!
export basis, rayleighquotient, residual, normres, rayleighextension
export initialize, initialize!, expand!, shrink!
export ClassicalGramSchmidt, ClassicalGramSchmidt2, ClassicalGramSchmidtIR
export ModifiedGramSchmidt, ModifiedGramSchmidt2, ModifiedGramSchmidtIR
export LanczosIterator, BlockLanczosIterator, ArnoldiIterator, GKLIterator, BiArnoldiIterator
export CG, GMRES, BiCGStab, Lanczos, BlockLanczos, Arnoldi, GKL, GolubYe, LSMR, BiArnoldi
export KrylovDefaults, EigSorter
export RecursiveVec, InnerProductVec, Block

# Multithreading
const _NTHREADS = Ref(1)
get_num_threads() = _NTHREADS[]

function set_num_threads(n::Int)
    N = Base.Threads.nthreads()
    if n > N
        n = N
        _set_num_threads_warn(n)
    end
    return _NTHREADS[] = n
end
@noinline function _set_num_threads_warn(n)
    return @warn "Maximal number of threads limited by number of Julia threads,
            setting number of threads equal to Threads.nthreads() = $n"
end

enable_threads() = set_num_threads(Base.Threads.nthreads())
disable_threads() = set_num_threads(1)

function __init__()
    @require_extensions
    set_num_threads(Base.Threads.nthreads())
    return nothing
end

struct SplitRange
    start::Int
    step::Int
    stop::Int
    innerlength::Int
    outerlength1::Int
    outerlength::Int
end
function splitrange(r::OrdinalRange, n::Integer)
    start = first(r)
    stp = step(r)
    stop = last(r)
    l = length(r)
    innerlength = div(l, n)
    outerlength1 = l - n * innerlength
    outerlength = n
    return SplitRange(start, stp, stop, innerlength, outerlength1, outerlength)
end
function Base.iterate(r::SplitRange, i = 1)
    step = r.step
    if i <= r.outerlength1
        offset = (i - 1) * (r.innerlength + 1) * step
        start = r.start + offset
        stop = start + step * r.innerlength
        return StepRange(start, step, stop), i + 1
    elseif i <= r.outerlength
        offset = (r.outerlength1 + (i - 1) * r.innerlength) * step
        start = r.start + offset
        stop = start + step * (r.innerlength - 1)
        return StepRange(start, step, stop), i + 1
    else
        return nothing
    end
end
Base.length(r::SplitRange) = r.outerlength

# Structures to store a list of basis vectors
"""
    abstract type Basis{T} end

An abstract type to collect specific types for representing a basis of vectors of type `T`.

Implementations of `Basis{T}` behave in many ways like `Vector{T}` and should have a
`length`, can be indexed (`getindex` and `setindex!`), iterated over (`iterate`), and
support resizing (`resize!`, `pop!`, `push!`, `empty!`, `sizehint!`).

The type `T` denotes the type of the elements stored in an `Basis{T}` and can be any custom
type that has vector like behavior (as defined in the docs of KrylovKit).

See [`OrthonormalBasis`](@ref) for a specific implementation.
"""
abstract type Basis{T} end

# Simple coordinate basis vector, i.e. a vector of all zeros and a single one on position `k`:
"""
    SimpleBasisVector(m, k)

Construct a simple struct `SimpleBasisVector <: AbstractVector{Bool}` representing a
coordinate basis vector of length `m` in the direction of `k`, i.e. for
`e_k = SimpleBasisVector(m, k)` we have `length(e_k) = m` and `e_k[i] = (i == k)`.
"""
struct SimpleBasisVector <: AbstractVector{Bool}
    m::Int
    k::Int
end
Base.axes(e::SimpleBasisVector) = (Base.OneTo(e.m),)
Base.size(e::SimpleBasisVector) = (e.m,)
@inline function Base.getindex(e::SimpleBasisVector, i)
    @boundscheck Base.checkbounds(e, i)
    return e.k == i
end

# some often used tools
function checkposdef(z)
    r = checkhermitian(z)
    r > 0 ||
        error("operator does not appear to be positive definite: diagonal element $z")
    return r
end
function checkhermitian(z, n = abs(z))
    imag(z) <= sqrt(max(eps(n), eps(one(n)))) ||
        error("operator does not appear to be hermitian: diagonal element $z")
    return real(z)
end

# apply operators
include("apply.jl")

# Verbosity levels
const SILENT_LEVEL = 0
const WARN_LEVEL = 1
const STARTSTOP_LEVEL = 2
const EACHITERATION_LEVEL = 3

# Algorithm types
include("algorithms.jl")

# OrthonormalBasis, orthogonalization and orthonormalization methods
include("orthonormal.jl")

# Dense linear algebra structures and functions used in the algorithms below
include("dense/givens.jl")
include("dense/linalg.jl")
include("dense/packedhessenberg.jl")
include("dense/reflector.jl")

# Krylov and related factorizations and their iterators
include("factorizations/krylov.jl")
include("factorizations/lanczos.jl")
include("factorizations/blocklanczos.jl")
include("factorizations/arnoldi.jl")
include("factorizations/biarnoldi.jl")
include("factorizations/gkl.jl")

# A general structure to pass on convergence information
"""
    struct ConvergenceInfo{S,T}
        converged::Int
        residual::T
        normres::S
        numiter::Int
        numops::Int
    end

Used to return information about the solution found by the iterative method.

  - `converged`: the number of solutions that have converged according to an appropriate
    error measure and requested tolerance for the problem. Its value can be zero or one for
    [`linsolve`](@ref), [`exponentiate`](@ref) and  [`expintegrator`](@ref), or any integer
    `>= 0` for [`eigsolve`](@ref), [`schursolve`](@ref) or [`svdsolve`](@ref).
  - `residual:` the (list of) residual(s) for the problem, or `nothing` for problems without
    the concept of a residual (i.e. `exponentiate`, `expintegrator`). This is a single
    vector (of the same type as the type of vectors used in the problem) for `linsolve`, or
    a `Vector` of such vectors for `eigsolve`, `schursolve` or `svdsolve`.
  - `normres`: the norm of the residual(s) (in the previous field) or the value of any other
    error measure that is appropriate for the problem. This is a `Real` for `linsolve` and
    `exponentiate`, and a `Vector{<:Real}` for `eigsolve`, `schursolve` and `svdsolve`. The
    number of values in `normres` that are smaller than a predefined tolerance corresponds
    to the number `converged` of solutions that have converged.
  - `numiter`: the number of iterations (sometimes called restarts) used by the algorithm.
  - `numops`: the number of times the linear map or operator was applied
"""
struct ConvergenceInfo{S, T}
    converged::Int # how many vectors have converged, 0 or 1 for linear systems, exponentiate, any integer for eigenvalue problems
    residual::T
    normres::S
    numiter::Int
    numops::Int
end

function Base.show(io::IO, info::ConvergenceInfo)
    print(io, "ConvergenceInfo: ")
    info.converged == 0 && print(io, "no converged values ")
    info.converged == 1 && print(io, "one converged value ")
    info.converged > 1 && print(io, "$(info.converged) converged values ")
    println(
        io, "after ", info.numiter, " iterations and ", info.numops, " applications of the linear map;"
    )
    return print(io, "norms of residuals are given by ", normres2string(info.normres), ".")
end

# Convert residual norms into strings for info and warning printing
normres2string(β::Number) = @sprintf("%.2e", β)
function normres2string(β)
    s = "("
    for i in 1:length(β)
        s *= normres2string(β[i])
        i < length(β) && (s *= ", ")
    end
    s *= ")"
    return s
end

# vectors with modified inner product
include("innerproductvec.jl")

# support for real
_realinner(v, w) = real(inner(v, w))
const RealVec{V} = InnerProductVec{typeof(_realinner), V}
RealVec(v) = InnerProductVec(v, _realinner)

apply(A, x::RealVec) = RealVec(apply(A, x[]))

apply_normal(f::Tuple{Any, Any}, x::RealVec) = RealVec(apply_normal(f, x[]))
apply_adjoint(f::Tuple{Any, Any}, x::RealVec) = RealVec(apply_adjoint(f, x[]))
apply_normal(f, x::RealVec) = RealVec(apply_normal(f, x[]))
apply_adjoint(f, x::RealVec) = RealVec(apply_adjoint(f, x[]))

# linsolve
include("linsolve/linsolve.jl")
include("linsolve/cg.jl")
include("linsolve/gmres.jl")
include("linsolve/bicgstab.jl")

# lssolve
include("lssolve/lssolve.jl")
include("lssolve/lsmr.jl")

# eigsolve and svdsolve
include("eigsolve/eigsolve.jl")
include("eigsolve/lanczos.jl")
include("eigsolve/blocklanczos.jl")
include("eigsolve/arnoldi.jl")
include("eigsolve/biarnoldi.jl")
include("eigsolve/geneigsolve.jl")
include("eigsolve/golubye.jl")
include("eigsolve/svdsolve.jl")

# exponentiate
include("matrixfun/exponentiate.jl")
include("matrixfun/expintegrator.jl")

# deprecations
include("deprecated.jl")
end

# In the various algorithms we store the tolerance as a generic Real in order to
# construct these objects using keyword arguments in a type-stable manner. At
# the beginning of the corresponding algorithm, the actual tolerance will be
# converted to the concrete numeric type appropriate for the problem at hand

# Orthogonalization and orthonormalization
"""
    abstract type Orthogonalizer

Supertype of a hierarchy for representing different orthogonalization strategies or
algorithms.

See also: [`ClassicalGramSchmidt`](@ref), [`ModifiedGramSchmidt`](@ref),
[`ClassicalGramSchmidt2`](@ref), [`ModifiedGramSchmidt2`](@ref),
[`ClassicalGramSchmidtIR`](@ref), [`ModifiedGramSchmidtIR`](@ref).
"""
abstract type Orthogonalizer end
abstract type Reorthogonalizer <: Orthogonalizer end

# Simple
"""
    ClassicalGramSchmidt()

Represents the classical Gram Schmidt algorithm for orthogonalizing different vectors,
typically not an optimal choice.
"""
struct ClassicalGramSchmidt <: Orthogonalizer end

"""
    ModifiedGramSchmidt()

Represents the modified Gram Schmidt algorithm for orthogonalizing different vectors,
typically a reasonable choice for linear systems but not for eigenvalue solvers with a
large Krylov dimension.
"""
struct ModifiedGramSchmidt <: Orthogonalizer end

# A single reorthogonalization always
"""
    ClassicalGramSchmidt2()

Represents the classical Gram Schmidt algorithm with a second reorthogonalization step
always taking place.
"""
struct ClassicalGramSchmidt2 <: Reorthogonalizer end

"""
    ModifiedGramSchmidt2()

Represents the modified Gram Schmidt algorithm with a second reorthogonalization step
always taking place.
"""
struct ModifiedGramSchmidt2 <: Reorthogonalizer end

# Iterative reorthogonalization
"""
    ClassicalGramSchmidtIR(η::Real = 1/sqrt(2))

Represents the classical Gram Schmidt algorithm with iterative (i.e. zero or more)
reorthogonalization until the norm of the vector after an orthogonalization step has not
decreased by a factor smaller than `η` with respect to the norm before the step. The
default value corresponds to the Daniel-Gragg-Kaufman-Stewart condition.
"""
struct ClassicalGramSchmidtIR{S <: Real} <: Reorthogonalizer
    η::S
end
ClassicalGramSchmidtIR() = ClassicalGramSchmidtIR(1 / sqrt(2)) # Daniel-Gragg-Kaufman-Stewart

"""
    ModifiedGramSchmidtIR(η::Real = 1/sqrt(2))

Represents the modified Gram Schmidt algorithm with iterative (i.e. zero or more)
reorthogonalization until the norm of the vector after an orthogonalization step has not
decreased by a factor smaller than `η` with respect to the norm before the step. The
default value corresponds to the Daniel-Gragg-Kaufman-Stewart condition.
"""
struct ModifiedGramSchmidtIR{S <: Real} <: Reorthogonalizer
    η::S
end
ModifiedGramSchmidtIR() = ModifiedGramSchmidtIR(1 / sqrt(2)) # Daniel-Gragg-Kaufman-Stewart

# Solving eigenvalue problems
abstract type KrylovAlgorithm end

# General purpose; good for linear systems, eigensystems and matrix functions
"""
    Lanczos(; krylovdim=KrylovDefaults.krylovdim[],
            maxiter=KrylovDefaults.maxiter[],
            tol=KrylovDefaults.tol[],
            orth=KrylovDefaults.orth,
            eager=false,
            verbosity=KrylovDefaults.verbosity[])

Represents the Lanczos algorithm for building the Krylov subspace; assumes the linear
operator is real symmetric or complex Hermitian. Can be used in `eigsolve` and
`exponentiate`. The corresponding algorithms will build a Krylov subspace of size at most
`krylovdim`, which will be repeated at most `maxiter` times and will stop when the norm of
the residual of the Lanczos factorization is smaller than `tol`. The orthogonalizer `orth`
will be used to orthogonalize the different Krylov vectors. Eager mode, as selected by
`eager=true`, means that the algorithm that uses this Lanczos process (e.g. `eigsolve`)
can try to finish its computation before the total Krylov subspace of dimension `krylovdim`
is constructed. The default verbosity level `verbosity` amounts to printing warnings upon
lack of convergence.


Use `Arnoldi` for non-symmetric or non-Hermitian linear operators.

See also: [Factorization types](@ref), [`eigsolve`](@ref), [`exponentiate`](@ref), [`Arnoldi`](@ref), [`Orthogonalizer`](@ref)
"""
struct Lanczos{O <: Orthogonalizer, S <: Real} <: KrylovAlgorithm
    orth::O
    krylovdim::Int
    maxiter::Int
    tol::S
    eager::Bool
    verbosity::Int
end
function Lanczos(;
        krylovdim::Int = KrylovDefaults.krylovdim[],
        maxiter::Int = KrylovDefaults.maxiter[],
        tol::Real = KrylovDefaults.tol[],
        orth::Orthogonalizer = KrylovDefaults.orth,
        eager::Bool = false,
        verbosity::Int = KrylovDefaults.verbosity[]
    )
    return Lanczos(orth, krylovdim, maxiter, tol, eager, verbosity)
end

"""
    BlockLanczos(; krylovdim=KrylovDefaults.blockkrylovdim[],
            maxiter=KrylovDefaults.maxiter[],
            tol=KrylovDefaults.tol[],
            orth=KrylovDefaults.orth,
            eager=false,
            verbosity=KrylovDefaults.verbosity[],
            qr_tol::Real=KrylovDefaults.tol[])

The block version of [`Lanczos`](@ref) is suited for solving eigenvalue problems with repeated extremal eigenvalues.
Its implementation is mainly based on *Golub, G. H., & Van Loan, C. F. (2013). Matrix Computations* (4th ed., pp. 566–569).
Arguments `krylovdim`, `maxiter`, `tol`, `orth`, `eager` and `verbosity` are the same as `Lanczos`.
`qr_tol` is the error tolerance for `block_qr!` - a subroutine used to orthorgonalize the vectors in the same block.
The initial size of the block is determined by the number of vectors that a user provides in the starting block;
the size of the block can shrink during iterations.
The initial block size determines the maximum multiplicity of the target eigenvalue can that be resolved.

The iteration stops when either the norm of the residual is below `tol` or a sufficient number of eigenvectors have converged. [Reference](https://www.netlib.org/utk/people/JackDongarra/etemplates/node250.html)

Use `Arnoldi` for non-symmetric or non-Hermitian linear operators. 

See also: [Factorization types](@ref), [`eigsolve`](@ref), [`Arnoldi`](@ref), [`Orthogonalizer`](@ref)
"""
struct BlockLanczos{O <: Orthogonalizer, S <: Real} <: KrylovAlgorithm
    orth::O
    krylovdim::Int
    maxiter::Int
    tol::S
    qr_tol::S
    eager::Bool
    verbosity::Int
end
function BlockLanczos(;
        krylovdim::Int = KrylovDefaults.blockkrylovdim[],
        maxiter::Int = KrylovDefaults.maxiter[],
        tol::Real = KrylovDefaults.tol[],
        qr_tol::Real = KrylovDefaults.tol[],
        orth::Orthogonalizer = KrylovDefaults.orth,
        eager::Bool = false,
        verbosity::Int = KrylovDefaults.verbosity[]
    )
    return BlockLanczos(orth, krylovdim, maxiter, promote(tol, qr_tol)..., eager, verbosity)
end

"""
    GKL(; krylovdim=KrylovDefaults.krylovdim[],
        maxiter=KrylovDefaults.maxiter[],
        tol=KrylovDefaults.tol[],
        orth=KrylovDefaults.orth,
        eager=false,
        verbosity=KrylovDefaults.verbosity[])

Represents the Golub-Kahan-Lanczos bidiagonalization algorithm for sequentially building a
Krylov-like factorization of a general matrix or linear operator with a bidiagonal reduced
matrix. Can be used in `svdsolve`. The corresponding algorithm builds a Krylov subspace of
size at most `krylovdim`, which will be repeated at most `maxiter` times and will stop when
the norm of the residual of the Arnoldi factorization is smaller than `tol`. The
orthogonalizer `orth` will be used to orthogonalize the different Krylov vectors. The default
verbosity level `verbosity` amounts to printing warnings upon lack of convergence.


See also: [`svdsolve`](@ref), [`Orthogonalizer`](@ref)
"""
struct GKL{O <: Orthogonalizer, S <: Real} <: KrylovAlgorithm
    orth::O
    krylovdim::Int
    maxiter::Int
    tol::S
    eager::Bool
    verbosity::Int
end
function GKL(;
        krylovdim::Int = KrylovDefaults.krylovdim[],
        maxiter::Int = KrylovDefaults.maxiter[],
        tol::Real = KrylovDefaults.tol[],
        orth::Orthogonalizer = KrylovDefaults.orth,
        eager::Bool = false,
        verbosity::Int = KrylovDefaults.verbosity[]
    )
    return GKL(orth, krylovdim, maxiter, tol, eager, verbosity)
end

"""
    Arnoldi(; krylovdim=KrylovDefaults.krylovdim[],
            maxiter=KrylovDefaults.maxiter[],
            tol=KrylovDefaults.tol[],
            orth=KrylovDefaults.orth,
            eager=false,
            verbosity=KrylovDefaults.verbosity[])

Represents the Arnoldi algorithm for building the Krylov subspace for a general matrix or
linear operator. Can be used in `eigsolve` and `exponentiate`. The corresponding algorithms
will build a Krylov subspace of size at most `krylovdim`, which will be repeated at most
`maxiter` times and will stop when the norm of the residual of the Arnoldi factorization is
smaller than `tol`. The orthogonalizer `orth` will be used to orthogonalize the different
Krylov vectors. Eager mode, as selected by `eager=true`, means that the algorithm that
uses this Arnoldi process (e.g. `eigsolve`) can try to finish its computation before the
total Krylov subspace of dimension `krylovdim` is constructed. The default verbosity level
`verbosity` amounts to printing warnings upon lack of convergence.


Use `Lanczos` for real symmetric or complex Hermitian linear operators.

See also: [`eigsolve`](@ref), [`exponentiate`](@ref), [`Lanczos`](@ref),
[`Orthogonalizer`](@ref)
"""
struct Arnoldi{O <: Orthogonalizer, S <: Real} <: KrylovAlgorithm
    orth::O
    krylovdim::Int
    maxiter::Int
    tol::S
    eager::Bool
    verbosity::Int
end
function Arnoldi(;
        krylovdim::Int = KrylovDefaults.krylovdim[],
        maxiter::Int = KrylovDefaults.maxiter[],
        tol::Real = KrylovDefaults.tol[],
        orth::Orthogonalizer = KrylovDefaults.orth,
        eager::Bool = false,
        verbosity::Int = KrylovDefaults.verbosity[]
    )
    return Arnoldi(orth, krylovdim, maxiter, tol, eager, verbosity)
end

"""
    BiArnoldi(; krylovdim=KrylovDefaults.krylovdim[],
              maxiter=KrylovDefaults.maxiter[],
              tol=KrylovDefaults.tol[],
              orth=KrylovDefaults.orth,
              eager=false,
              verbosity=KrylovDefaults.verbosity[])

Represents the BiArnoldi algorithm for building the Krylov subspace for a general matrix or
linear operator. Can be used in `bieigsolve`. The corresponding algorithm will build a Krylov subspace of size at most `krylovdim`, which will be repeated at most `maxiter` times and
will stop when the norm of the residual of the Arnoldi factorization is smaller than `tol`.
The orthogonalizer `orth` will be used to orthogonalize the different Krylov vectors.
Eager mode, as selected by `eager=true`, means that the algorithm that uses this BiArnoldi
process (i.e. `bieigsolve`) can try to finish its computation before the total Krylov
subspace of dimension `krylovdim` is constructed. The default verbosity level
`verbosity` amounts to printing warnings upon lack of convergence.


See also: [`bieigsolve`](@ref), [`Orthogonalizer`](@ref)
"""
struct BiArnoldi{O <: Orthogonalizer, S <: Real} <: KrylovAlgorithm
    orth::O
    krylovdim::Int
    maxiter::Int
    tol::S
    eager::Bool
    verbosity::Int
end
function BiArnoldi(;
        krylovdim::Int = KrylovDefaults.krylovdim[],
        maxiter::Int = KrylovDefaults.maxiter[],
        tol::Real = KrylovDefaults.tol[],
        orth::Orthogonalizer = KrylovDefaults.orth,
        eager::Bool = false,
        verbosity::Int = KrylovDefaults.verbosity[]
    )
    return BiArnoldi(orth, krylovdim, maxiter, tol, eager, verbosity)
end

"""
    GolubYe(; krylovdim=KrylovDefaults.krylovdim[],
            maxiter=KrylovDefaults.maxiter[],
            tol=KrylovDefaults.tol[],
            orth=KrylovDefaults.orth,
            eager=false,
            verbosity=KrylovDefaults.verbosity[])

Represents the Golub-Ye algorithm for solving hermitian (symmetric) generalized eigenvalue
problems `A x = λ B x` with positive definite `B`, without the need for inverting `B`.
Builds a Krylov subspace of size `krylovdim` starting from an estimate `x` by acting with
`(A - ρ(x) B)`, where `ρ(x) = dot(x, A*x)/dot(x, B*x)`, and employing the Lanczos
algorithm. This process is repeated at most `maxiter` times. In every iteration `k>1`, the
subspace will also be expanded to size `krylovdim+1` by adding ``x_k - x_{k-1}``, which is
known as the LOPCG correction and was suggested by Money and Ye. With `krylovdim=2`, this
algorithm becomes equivalent to `LOPCG`.
"""
struct GolubYe{O <: Orthogonalizer, S <: Real} <: KrylovAlgorithm
    orth::O
    krylovdim::Int
    maxiter::Int
    tol::S
    verbosity::Int
end
function GolubYe(;
        krylovdim::Int = KrylovDefaults.krylovdim[],
        maxiter::Int = KrylovDefaults.maxiter[],
        tol::Real = KrylovDefaults.tol[],
        orth::Orthogonalizer = KrylovDefaults.orth,
        verbosity::Int = KrylovDefaults.verbosity[]
    )
    return GolubYe(orth, krylovdim, maxiter, tol, verbosity)
end

# Solving linear systems specifically
abstract type LinearSolver <: KrylovAlgorithm end

"""
    CG(; maxiter=KrylovDefaults.maxiter[], tol=KrylovDefaults.tol[], verbosity=KrylovDefaults.verbosity[])

Construct an instance of the conjugate gradient algorithm with specified parameters, which
can be passed to `linsolve` in order to iteratively solve a linear system with a positive
definite (and thus symmetric or hermitian) coefficient matrix or operator. The `CG` method
will search for the optimal `x` in a Krylov subspace of maximal size `maxiter`, or stop when
`norm(A*x - b) < tol`. The default verbosity level `verbosity` amounts to printing warnings
upon lack of convergence.


See also: [`linsolve`](@ref), [`MINRES`](@ref), [`GMRES`](@ref), [`BiCG`](@ref), [`LSMR`](@ref),
[`BiCGStab`](@ref)
"""
struct CG{S <: Real} <: LinearSolver
    maxiter::Int
    tol::S
    verbosity::Int
end
function CG(;
        maxiter::Integer = KrylovDefaults.maxiter[],
        tol::Real = KrylovDefaults.tol[],
        verbosity::Int = KrylovDefaults.verbosity[]
    )
    return CG(maxiter, tol, verbosity)
end

"""
    GMRES(; krylovdim=KrylovDefaults.krylovdim[],
            maxiter=KrylovDefaults.maxiter[],
            tol=KrylovDefaults.tol[], 
            orth::Orthogonalizer=KrylovDefaults.orth,
            verbosity=KrylovDefaults.verbosity[])

Construct an instance of the GMRES algorithm with specified parameters, which can be passed
to `linsolve` in order to iteratively solve a linear system. The `GMRES` method will search
for the optimal `x` in a Krylov subspace of maximal size `krylovdim`, and repeat this
process for at most `maxiter` times, or stop when `norm(A*x - b) < tol`. In building the
Krylov subspace, `GMRES` will use the orthogonalizer `orth`. The default verbosity level
`verbosity` amounts to printing warnings upon lack of convergence.


Note that in the traditional nomenclature of `GMRES`, the parameter `krylovdim` is referred
to as the restart parameter, and `maxiter` is the number of outer iterations, i.e. restart
cycles. The total iteration count, i.e. the number of expansion steps, is roughly
`krylovdim` times the number of iterations.

See also: [`linsolve`](@ref), [`BiCG`](@ref), [`BiCGStab`](@ref), [`CG`](@ref), [`LSMR`](@ref),
[`MINRES`](@ref)
"""
struct GMRES{O <: Orthogonalizer, S <: Real} <: LinearSolver
    orth::O
    maxiter::Int
    krylovdim::Int
    tol::S
    verbosity::Int
end
function GMRES(;
        krylovdim::Integer = KrylovDefaults.krylovdim[],
        maxiter::Integer = KrylovDefaults.maxiter[],
        tol::Real = KrylovDefaults.tol[],
        orth::Orthogonalizer = KrylovDefaults.orth,
        verbosity::Int = KrylovDefaults.verbosity[]
    )
    return GMRES(orth, maxiter, krylovdim, tol, verbosity)
end

# TODO
"""
    MINRES(; maxiter=KrylovDefaults.maxiter[], tol=KrylovDefaults.tol[], verbosity=KrylovDefaults.verbosity[])

    !!! warning "Not implemented yet"

    Construct an instance of the conjugate gradient algorithm with specified parameters,
    which can be passed to `linsolve` in order to iteratively solve a linear system with a
    real symmetric or complex hermitian coefficient matrix or operator. The `MINRES` method
    will search for the optimal `x` in a Krylov subspace of maximal size `maxiter`, or stop
    when `norm(A*x - b) < tol`. In building the Krylov subspace, `MINRES` will use the
    orthogonalizer `orth`. The default verbosity level `verbosity` amounts to printing
    warnings upon lack of convergence.


See also: [`linsolve`](@ref), [`CG`](@ref), [`GMRES`](@ref), [`BiCG`](@ref), [`LSMR`](@ref),
[`BiCGStab`](@ref)
"""
struct MINRES{S <: Real} <: LinearSolver
    maxiter::Int
    tol::S
    verbosity::Int
end
function MINRES(;
        maxiter::Integer = KrylovDefaults.maxiter[],
        tol::Real = KrylovDefaults.tol[],
        verbosity::Int = KrylovDefaults.verbosity[]
    )
    return MINRES(maxiter, tol, verbosity)
end

"""
    BiCG(; maxiter=KrylovDefaults.maxiter[], tol=KrylovDefaults.tol[], verbosity=KrylovDefaults.verbosity[])

    !!! warning "Not implemented yet"

    Construct an instance of the Biconjugate gradient algorithm with specified parameters,
    which can be passed to `linsolve` in order to iteratively solve a linear system general
    linear map, of which the adjoint can also be applied. The `BiCG` method will search for
    the optimal `x` in a Krylov subspace of maximal size `maxiter`, or stop when `norm(A*x -
    b) < tol`. The default verbosity level `verbosity` amounts to printing warnings upon
    lack of convergence.


See also: [`linsolve`](@ref), [`GMRES`](@ref), [`CG`](@ref), [`BiCGStab`](@ref), [`LSMR`](@ref),
[`MINRES`](@ref)
"""
struct BiCG{S <: Real} <: LinearSolver
    maxiter::Int
    tol::S
    verbosity::Int
end
function BiCG(;
        maxiter::Integer = KrylovDefaults.maxiter[],
        tol::Real = KrylovDefaults.tol[],
        verbosity::Int = KrylovDefaults.verbosity[]
    )
    return BiCG(maxiter, tol, verbosity)
end

"""
    BiCGStab(; maxiter=KrylovDefaults.maxiter[], tol=KrylovDefaults.tol[], verbosity=KrylovDefaults.verbosity[])

    Construct an instance of the Biconjugate gradient algorithm with specified parameters,
    which can be passed to `linsolve` in order to iteratively solve a linear system general
    linear map. The `BiCGStab` method will search for the optimal `x` in a Krylov subspace
    of maximal size `maxiter`, or stop when `norm(A*x - b) < tol`. The default verbosity level 
    `verbosity` amounts to printing warnings upon lack of convergence.

See also: [`linsolve`](@ref), [`GMRES`](@ref), [`CG`](@ref), [`BiCG`](@ref), [`LSMR`](@ref),
[`MINRES`](@ref)
"""
struct BiCGStab{S <: Real} <: LinearSolver
    maxiter::Int
    tol::S
    verbosity::Int
end
function BiCGStab(;
        maxiter::Integer = KrylovDefaults.maxiter[],
        tol::Real = KrylovDefaults.tol[],
        verbosity::Int = KrylovDefaults.verbosity[]
    )
    return BiCGStab(maxiter, tol, verbosity)
end

# Solving least squares problems
abstract type LeastSquaresSolver <: KrylovAlgorithm end
"""
    LSMR(; krylovdim=1,
            maxiter=KrylovDefaults.maxiter[],
            tol=KrylovDefaults.tol[], 
            orth::Orthogonalizer=ModifiedGramSchmidt(),
            verbosity=KrylovDefaults.verbosity[])

Represents the LSMR algorithm, which minimizes ``\\|Ax - b\\|^2 + \\|λx\\|^2`` in the Euclidean norm.
If multiple solutions exists the minimum norm solution is returned.
The method is based on the Golub-Kahan bidiagonalization process. It is
algebraically equivalent to applying MINRES to the normal equations
``(A^*A + λ^2I)x = A^*b``, but has better numerical properties,
especially if ``A`` is ill-conditioned.

The `LSMR` method will search for the optimal ``x`` in a Krylov subspace of maximal size 
`maxiter`, or stop when ``norm(A'*(A*x - b) + λ^2 * x) < tol``. The parameter `krylovdim`
does in this case not indicate that a subspace of that size will be built, but represents the
number of most recent vectors that will be kept to which the next vector will be reorthogonalized.
The default verbosity level `verbosity` amounts to printing warnings upon lack of convergence.

See also: [`lssolve`](@ref)
"""
struct LSMR{O <: Orthogonalizer, S <: Real} <: LeastSquaresSolver
    orth::O
    maxiter::Int
    krylovdim::Int
    tol::S
    verbosity::Int
end
function LSMR(;
        krylovdim::Integer = KrylovDefaults.krylovdim[],
        maxiter::Integer = KrylovDefaults.maxiter[],
        tol::Real = KrylovDefaults.tol[],
        orth::Orthogonalizer = ModifiedGramSchmidt(),
        verbosity::Int = KrylovDefaults.verbosity[]
    )
    return LSMR(orth, maxiter, krylovdim, tol, verbosity)
end

# Solving eigenvalue systems specifically
abstract type EigenSolver <: KrylovAlgorithm end

struct JacobiDavidson <: EigenSolver end

# Default values
"""
    module KrylovDefaults
        const orth = KrylovKit.ModifiedGramSchmidt2()
        const krylovdim = Ref(30)
        const maxiter = Ref(100)
        const blockkrylovdim = Ref(100)
        const tol = Ref(1e-12)
        const verbosity = Ref(KrylovKit.WARN_LEVEL)
    end

A module listing the default values for the typical parameters in Krylov based algorithms:

  - `orth = ModifiedGramSchmidt2()`: the orthogonalization routine used to orthogonalize
    the Krylov basis in the `Lanczos` or `Arnoldi` iteration
  - `krylovdim = 30`: the maximal dimension of the Krylov subspace that will be constructed
  - `maxiter = 100`: the maximal number of outer iterations, i.e. the maximum number of
    times the Krylov subspace may be rebuilt
  - `blockkrylovdim = 100`: the maximal dimension of the Krylov subspace that will be constructed for `BlockLanczos`
  - `tol = 1e-12`: the tolerance to which the problem must be solved, based on a suitable
    error measure, e.g. the norm of some residual.

!!! warning

    The default value of `tol` is a `Float64` value, if you solve problems in `Float32` or
    `ComplexF32` arithmetic, you should always specify a new `tol` as the default value
    will not be attainable.
"""
module KrylovDefaults
    using ..KrylovKit
    const orth = KrylovKit.ModifiedGramSchmidt2() # conservative choice
    const krylovdim = Ref(30)
    const maxiter = Ref(100)
    const blockkrylovdim = Ref(100)
    const tol = Ref(1.0e-12)
    const verbosity = Ref(KrylovKit.WARN_LEVEL)
end

function ChainRulesCore.rrule(
        config::RuleConfig,
        ::typeof(linsolve),
        f,
        b,
        x₀,
        alg_primal,
        a₀,
        a₁; alg_rrule = alg_primal
    )
    (x, info) = linsolve(f, b, x₀, alg_primal, a₀, a₁)
    fᴴ, construct∂f = lin_preprocess(config, f, x)
    linsolve_pullback = make_linsolve_pullback(
        fᴴ, b, a₀, a₁, alg_primal, alg_rrule, construct∂f, x,
        info
    )
    return (x, info), linsolve_pullback
end

function make_linsolve_pullback(fᴴ, b, a₀, a₁, alg_primal, alg_rrule, construct∂f, x, info)
    return function linsolve_pullback(X̄)
        x̄ = unthunk(X̄[1])
        @assert X̄[2] isa AbstractZero "No cotangent of the `info` output is supported."
        ∂self = NoTangent()
        ∂x₀ = ZeroTangent()
        ∂algorithm = NoTangent()
        if x̄ isa AbstractZero
            ∂f = ZeroTangent()
            ∂b = ZeroTangent()
            ∂a₀ = ZeroTangent()
            ∂a₁ = ZeroTangent()
            return ∂self, ∂f, ∂b, ∂x₀, ∂algorithm, ∂a₀, ∂a₁
        end

        x̄₀ = zerovector(
            x̄,
            VectorInterface.promote_scale(
                scalartype(x̄),
                VectorInterface.promote_scale(a₀, a₁)
            )
        )
        ∂b, reverse_info = linsolve(
            fᴴ, x̄, x̄₀, alg_rrule, conj(a₀),
            conj(a₁)
        )
        if info.converged > 0 && reverse_info.converged == 0 &&
                alg_primal.verbosity >= WARN_LEVEL
            @warn "`linsolve` cotangent problem did not converge, whereas the primal linear problem did: normres = $(reverse_info.normres)"
        end
        x∂b = inner(x, ∂b)
        b∂b = inner(b, ∂b)
        ∂f = construct∂f(scale(∂b, -conj(a₁)))
        ∂a₀ = -x∂b
        ∂a₁ = (x∂b * conj(a₀) - b∂b) / conj(a₁)

        return ∂self, ∂f, ∂b, ∂x₀, ∂algorithm, ∂a₀, ∂a₁
    end
end

function lin_preprocess(config, f, x)
    config isa RuleConfig{>:HasReverseMode} ||
        throw(ArgumentError("`linsolve` reverse-mode AD requires AD engine that supports calling back into AD"))
    pb = rrule_via_ad(config, f, x)[2]
    fᴴ, construct∂f_lin = let pb = rrule_via_ad(config, f, x)[2]
        v -> unthunk(pb(v)[2]), w -> pb(w)[1]
    end
    return fᴴ, construct∂f_lin
end
function lin_preprocess(config, A::AbstractMatrix, x)
    fᴴ = adjoint(A)
    if A isa StridedMatrix
        construct∂f_lin = w -> InplaceableThunk(
            Ā -> _buildĀ_lin!(Ā, x, w),
            @thunk(_buildĀ_lin!(zero(A), x, w))
        )
    else
        construct∂f_lin = let project_A = ProjectTo(A)
            w -> @thunk(project_A(_buildĀ_lin!(zero(A), x, w)))
        end
    end
    return fᴴ, construct∂f_lin
end
function _buildĀ_lin!(Ā, v, w)
    if !(w isa AbstractZero)
        if eltype(Ā) <: Real && eltype(w) <: Complex
            mul!(Ā, _realview(w), _realview(v)', +1, +1)
            mul!(Ā, _imagview(w), _imagview(v)', +1, +1)
        else
            mul!(Ā, w, v', +1, 1)
        end
    end
    return Ā
end

# frule - currently untested - commented out while untested and unused

# function ChainRulesCore.frule((_, ΔA, Δb, Δx₀, _, Δa₀, Δa₁)::Tuple, ::typeof(linsolve),
#                               A::AbstractMatrix, b::AbstractVector, x₀, algorithm, a₀, a₁)
#     (x, info) = linsolve(A, b, x₀, algorithm, a₀, a₁)

#     if Δb isa ChainRulesCore.AbstractZero
#         rhs = zerovector(b)
#     else
#         rhs = scale(Δb, (1 - Δa₁))
#     end
#     if !iszero(Δa₀)
#         rhs = add!!(rhs, x, -Δa₀)
#     end
#     if !iszero(ΔA)
#         rhs = mul!(rhs, ΔA, x, -a₁, true)
#     end
#     (Δx, forward_info) = linsolve(A, rhs, zerovector(rhs), algorithm, a₀, a₁)
#     if info.converged > 0 && forward_info.converged == 0 && alg_rrule.verbosity >= SILENT_LEVEL
#         @warn "The tangent linear problem did not converge, whereas the primal linear problem did."
#     end
#     return (x, info), (Δx, NoTangent())
# end

# function ChainRulesCore.frule(config::RuleConfig{>:HasForwardsMode}, tangents,
#                               ::typeof(linsolve),
#                               A::AbstractMatrix, b::AbstractVector, x₀, algorithm, a₀, a₁)
#     return frule(tangents, linsolve, A, b, x₀, algorithm, a₀, a₁)
# end

# function ChainRulesCore.frule(config::RuleConfig{>:HasForwardsMode},
#                               (_, Δf, Δb, Δx₀, _, Δa₀, Δa₁),
#                               ::typeof(linsolve),
#                               f, b, x₀, algorithm, a₀, a₁)
#     (x, info) = linsolve(f, b, x₀, algorithm, a₀, a₁)

#     if Δb isa AbstractZero
#         rhs = zerovector(b)
#     else
#         rhs = scale(Δb, (1 - Δa₁))
#     end
#     if !iszero(Δa₀)
#         rhs = add!!(rhs, x, -Δa₀)
#     end
#     if !(Δf isa AbstractZero)
#         rhs = add!!(rhs, frule_via_ad(config, (Δf, ZeroTangent()), f, x), -a₀)
#     end
#     (Δx, forward_info) = linsolve(f, rhs, zerovector(rhs), algorithm, a₀, a₁)
#     if info.converged > 0 && forward_info.converged == 0 && alg_rrule.verbosity >= SILENT_LEVEL
#         @warn "The tangent linear problem did not converge, whereas the primal linear problem did."
#     end
#     return (x, info), (Δx, NoTangent())
# end

function ChainRulesCore.rrule(
        config::RuleConfig,
        ::typeof(eigsolve),
        f,
        x₀,
        howmany,
        which,
        alg_primal;
        alg_rrule = Arnoldi(;
            tol = alg_primal.tol,
            krylovdim = alg_primal.krylovdim,
            maxiter = alg_primal.maxiter,
            eager = alg_primal.eager,
            orth = alg_primal.orth,
            verbosity = alg_primal.verbosity
        )
    )
    (vals, vecs, info) = eigsolve(f, x₀, howmany, which, alg_primal)
    if alg_primal isa Lanczos
        fᴴ = f
    elseif f isa AbstractMatrix
        fᴴ = adjoint(f)
    else
        fᴴ = let pb = rrule_via_ad(config, f, zerovector(x₀, complex(scalartype(x₀))))[2]
            v -> unthunk(pb(v)[2])
        end
    end
    eigsolve_pullback = make_eigsolve_pullback(
        config, f, fᴴ, x₀, howmany, which,
        alg_primal, alg_rrule, vals, vecs, info
    )
    return (vals, vecs, info), eigsolve_pullback
end

function make_eigsolve_pullback(
        config, f, fᴴ, x₀, howmany, which, alg_primal, alg_rrule,
        vals, vecs, info
    )
    function eigsolve_pullback(ΔX)
        ∂self = NoTangent()
        ∂x₀ = ZeroTangent()
        ∂howmany = NoTangent()
        ∂which = NoTangent()
        ∂alg = NoTangent()

        # Prepare inputs:
        #----------------
        _Δvals = unthunk(ΔX[1])
        _Δvecs = unthunk(ΔX[2])
        # special case: propagate zero tangent
        if _Δvals isa AbstractZero && _Δvecs isa AbstractZero
            ∂f = ZeroTangent()
            return ∂self, ∂f, ∂x₀, ∂howmany, ∂which, ∂alg
        end
        # discard vals/vecs from n + 1 onwards if contribution is zero
        _n_vals = _Δvals isa AbstractZero ? nothing : findlast(!iszero, _Δvals)
        _n_vecs = _Δvecs isa AbstractZero ? nothing :
            findlast(!Base.Fix2(isa, AbstractZero), _Δvecs)
        n_vals = isnothing(_n_vals) ? 0 : _n_vals
        n_vecs = isnothing(_n_vecs) ? 0 : _n_vecs
        n = max(n_vals, n_vecs)
        # special case (can this happen?): try to maintain type stability
        if n == 0
            if howmany == 0
                T = (alg_primal isa Lanczos) ? scalartype(x₀) : complex(scalartype(x₀))
                _vecs = [zerovector(x₀, T)]
                ws = [_vecs[1]]
                ∂f = construct∂f_eig(config, f, _vecs, ws)
                return ∂self, ∂f, ∂x₀, ∂howmany, ∂which, ∂alg
            else
                ws = [zerovector(vecs[1])]
                ∂f = construct∂f_eig(config, f, vecs, ws)
                return ∂self, ∂f, ∂x₀, ∂howmany, ∂which, ∂alg
            end
        end
        Δvals = fill(zero(vals[1]), n)
        if n_vals > 0
            Δvals[1:n_vals] .= view(_Δvals, 1:n_vals)
        end
        if _Δvecs isa AbstractZero
            # case of no contribution of singular vectors
            Δvecs = fill(ZeroTangent(), n)
        else
            Δvecs = fill(zerovector(vecs[1]), n)
            if n_vecs > 0
                for i in 1:n_vecs
                    if !(_Δvecs[i] isa AbstractZero)
                        Δvecs[i] = _Δvecs[i]
                    end
                end
            end
        end

        # Compute actual pullback data:
        #------------------------------
        ws = compute_eigsolve_pullback_data(
            Δvals, Δvecs, view(vals, 1:n), view(vecs, 1:n),
            info, which, fᴴ, alg_primal, alg_rrule
        )

        # Return pullback in correct form:
        #---------------------------------
        ∂f = construct∂f_eig(config, f, vecs, ws)
        return ∂self, ∂f, ∂x₀, ∂howmany, ∂which, ∂alg
    end
    return eigsolve_pullback
end

function compute_eigsolve_pullback_data(
        Δvals, Δvecs, vals, vecs, info, which, fᴴ,
        alg_primal, alg_rrule::Union{GMRES, BiCGStab}
    )
    ws = similar(vecs, length(Δvecs))
    T = scalartype(vecs[1])
    @inbounds for i in 1:length(Δvecs)
        Δλ = Δvals[i]
        Δv = Δvecs[i]
        λ = vals[i]
        v = vecs[i]

        # First treat special cases
        if isa(Δv, AbstractZero) && iszero(Δλ) # no contribution
            ws[i] = zerovector(v)
            continue
        end
        if isa(Δv, AbstractZero) && isa(alg_primal, Lanczos) # simple contribution
            ws[i] = scale(v, Δλ)
            continue
        end

        # TODO: Is the following useful and correct?
        # (given that Δvecs might contain weird tangent types)
        # The following only holds if `f` represents a real linear operator, which we cannot
        # check explicitly, unless `f isa AbstractMatrix`.`
        # However, exact equality between conjugate pairs of eigenvalues and eigenvectors
        # seems sufficient to guarantee this
        # Also, we can only be sure to know how to apply complex conjugation when the
        # vectors are of type `AbstractArray{T}` with `T` the scalar type
        # if i > 1 && ws[i - 1] isa AbstractArray{T} &&
        #    vals[i] == conj(vals[i - 1]) && Δvals[i] == conj(Δvals[i - 1]) &&
        #    vecs[i] == conj(vecs[i - 1]) && Δvecs[i] == conj(Δvecs[i - 1])
        #     ws[i] = conj(ws[i - 1])
        #     continue
        # end

        if isa(Δv, AbstractZero)
            b = (zerovector(v), convert(T, Δλ))
        else
            vdΔv = inner(v, Δv)
            if alg_rrule.verbosity >= WARN_LEVEL
                gauge = abs(imag(vdΔv))
                gauge > alg_primal.tol &&
                    @warn "`eigsolve` cotangent for eigenvector $i is sensitive to gauge choice: (|gauge| = $gauge)"
            end
            Δv = add(Δv, v, -vdΔv)
            b = (Δv, convert(T, Δλ))
        end
        w, reverse_info = let λ = λ, v = v
            linsolve(b, zerovector(b), alg_rrule) do (x1, x2)
                y1 = VectorInterface.add!!(
                    VectorInterface.add!!(
                        KrylovKit.apply(fᴴ, x1), x1, conj(λ), -1
                    ),
                    v, x2
                )
                y2 = inner(v, x1)
                return (y1, y2)
            end
        end
        if info.converged >= i && reverse_info.converged == 0 &&
                alg_primal.verbosity >= WARN_LEVEL
            @warn "`eigsolve` cotangent linear problem ($i) did not converge, whereas the primal eigenvalue problem did: normres = $(reverse_info.normres)"
        elseif abs(w[2]) > (alg_rrule.tol * norm(w[1])) &&
                alg_primal.verbosity >= WARN_LEVEL
            @warn "`eigsolve` cotangent linear problem ($i) returns unexpected result: error = $(w[2])"
        end
        ws[i] = w[1]
    end
    return ws
end

function compute_eigsolve_pullback_data(
        Δvals, Δvecs, vals, vecs, info, which, fᴴ,
        alg_primal::Arnoldi, alg_rrule::Arnoldi
    )
    n = length(Δvecs)
    T = scalartype(vecs[1])
    G = zeros(T, n, n)
    VdΔV = zeros(T, n, n)
    for j in 1:n
        for i in 1:n
            if i < j
                G[i, j] = conj(G[j, i])
            elseif i == j
                G[i, i] = norm(vecs[i])^2
            else
                G[i, j] = inner(vecs[i], vecs[j])
            end
            if !(Δvecs[j] isa AbstractZero)
                VdΔV[i, j] = inner(vecs[i], Δvecs[j])
            end
        end
    end

    # components along subspace spanned by current eigenvectors
    tol = alg_primal.tol
    if alg_rrule.verbosity >= WARN_LEVEL
        mask = abs.(transpose(vals) .- vals) .< tol
        gaugepart = VdΔV[mask] - Diagonal(real(diag(VdΔV)))[mask]
        Δgauge = norm(gaugepart, Inf)
        Δgauge > tol &&
            @warn "`eigsolve` cotangents sensitive to gauge choice: (|Δgauge| = $Δgauge)"
    end
    VdΔV′ = VdΔV - G * Diagonal(diag(VdΔV) ./ diag(G))
    aVdΔV = VdΔV′ .* conj.(safe_inv.(transpose(vals) .- vals, tol))
    for i in 1:n
        aVdΔV[i, i] += Δvals[i]
    end
    Gc = cholesky!(G)
    iGaVdΔV = Gc \ aVdΔV
    iGVdΔV = Gc \ VdΔV

    zs = similar(vecs)
    for i in 1:n
        z = scale(vecs[1], iGaVdΔV[1, i])
        for j in 2:n
            z = VectorInterface.add!!(z, vecs[j], iGaVdΔV[j, i])
        end
        zs[i] = z
    end

    # components in orthogonal subspace:
    # solve Sylvester problem (A * (1-P) + shift * P) * W - W * Λ  = ΔV as eigenvalue problem
    # with ΔVᵢ = fᴴ(zᵢ) + (1 - P) * Δvᵢ
    # where we can recylce information in the computation of P * Δvᵢ
    sylvesterarg = similar(vecs)
    for i in 1:n
        y = KrylovKit.apply(fᴴ, zs[i])
        if !(Δvecs[i] isa AbstractZero)
            y = VectorInterface.add!!(y, Δvecs[i])
            for j in 1:n
                y = VectorInterface.add!!(y, vecs[j], -iGVdΔV[j, i])
            end
        end
        sylvesterarg[i] = y
    end

    # To solve Sylvester problem as eigenvalue problem, we potentially need to shift the
    # eigenvalues zero that originate from the projection onto the orthognal complement of
    # original subspace, namely whenever zero is more extremal than the actual eigenvalues.
    # Hereto, we shift the zero eigenvalues in the original subspace to the value 2 * vals[n],
    # where we expect that if `by(vals[n]) > by(0)`, then `by(2*vals[n]) > by(vals[n])`
    # (whenever `rev = false`, and with opposite inequality whenever `rev = true`)
    by, rev = KrylovKit.eigsort(which)
    if (rev ? (by(vals[n]) < by(zero(vals[n]))) : (by(vals[n]) > by(zero(vals[n]))))
        shift = 2 * conj(vals[n])
    else
        shift = zero(vals[n])
    end
    # The ith column wᵢ of the solution to the Sylvester equation is contained in the
    # the eigenvector (wᵢ, eᵢ) corresponding to eigenvalue λᵢ of the block matrix
    # [(A * (1-P) + shift * P)  -ΔV; 0 Λ], where eᵢ is the ith unit vector. We will need
    # to renormalise the eigenvectors to have exactly eᵢ as second component. We use
    # (0, e₁ + e₂ + ... + eₙ) as the initial guess for the eigenvalue problem.

    W₀ = (zerovector(vecs[1]), one.(vals))
    P = orthogonalprojector(vecs, n, Gc)
    # TODO: is `realeigsolve` every used here, as there is a separate `alg_primal::Lanczos` method below
    solver = (T <: Real) ? KrylovKit.realeigsolve : KrylovKit.eigsolve # for `eigsolve`, `T` will always be a Complex subtype`
    rvals, Ws, reverse_info = let P = P, ΔV = sylvesterarg, shift = shift,
            eigsort = EigSorter(v -> minimum(DistanceTo(conj(v)), vals))

        solver(W₀, n, eigsort, alg_rrule) do (w, x)
            w₀ = P(w)
            w′ = KrylovKit.apply(fᴴ, add(w, w₀, -1))
            if !iszero(shift)
                w′ = VectorInterface.add!!(w′, w₀, shift)
            end
            @inbounds for i in eachindex(x) # length(x) = n but let us not use outer variables
                w′ = VectorInterface.add!!(w′, ΔV[i], -x[i])
            end
            return (w′, conj.(vals) .* x)
        end
    end
    if info.converged >= n && reverse_info.converged < n &&
            alg_primal.verbosity >= WARN_LEVEL
        @warn "`eigsolve` cotangent problem did not converge, whereas the primal eigenvalue problem did"
    end

    # cleanup and construct final result
    tol = alg_rrule.tol
    Z = zeros(T, n, n)
    for i in 1:n
        copy!(view(Z, :, i), Ws[i][2])
    end
    Zinv = inv(Z)
    error = norm(Diagonal(view(vals, 1:n))' - Z * Diagonal(view(rvals, 1:n)) * Zinv, Inf)
    if error > 10 * tol && alg_primal.verbosity >= WARN_LEVEL
        @warn "`eigsolve` cotangent linear problem returns unexpected result: error = $error vs tol = $tol"
    end
    Q = orthogonalcomplementprojector(vecs, n, Gc)
    xs = Q.(getindex.(view(Ws, 1:n), 1))
    ws = zs
    for i in 1:n
        for j in 1:n
            ws[i] = VectorInterface.add!!(ws[i], xs[j], -Zinv[j, i])
        end
    end
    return ws
end

struct DistanceTo{T}
    x::T
end
(d::DistanceTo)(y) = norm(y - d.x)

# several simplications happen in the case of a Hermitian eigenvalue problem
function compute_eigsolve_pullback_data(
        Δvals, Δvecs, vals, vecs, info, which, fᴴ,
        alg_primal::Lanczos, alg_rrule::Arnoldi
    )
    n = length(Δvecs)
    T = scalartype(vecs[1])
    VdΔV = zeros(T, n, n)
    for j in 1:n
        for i in 1:n
            if !(Δvecs[j] isa AbstractZero)
                VdΔV[i, j] = inner(vecs[i], Δvecs[j])
            end
        end
    end

    # components along subspace spanned by current eigenvectors
    tol = alg_primal.tol
    aVdΔV = rmul!(VdΔV - VdΔV', 1 / 2)
    if alg_rrule.verbosity >= WARN_LEVEL
        mask = abs.(transpose(vals) .- vals) .< tol
        gaugepart = view(aVdΔV, mask)
        gauge = norm(gaugepart, Inf)
        gauge > tol &&
            @warn "`eigsolve` cotangents sensitive to gauge choice: (|gauge| = $gauge)"
    end
    aVdΔV .= aVdΔV .* safe_inv.(transpose(vals) .- vals, tol)
    for i in 1:n
        aVdΔV[i, i] += real(Δvals[i])
    end

    zs = similar(vecs)
    for i in 1:n
        z = scale(vecs[1], aVdΔV[1, i])
        for j in 2:n
            z = VectorInterface.add!!(z, vecs[j], aVdΔV[j, i])
        end
        zs[i] = z
    end

    # components in orthogonal subspace
    sylvesterarg = similar(vecs)
    for i in 1:n
        y = zerovector(vecs[1])
        if !(Δvecs[i] isa AbstractZero)
            y = VectorInterface.add!!(y, Δvecs[i], +1)
            for j in 1:n
                y = VectorInterface.add!!(y, vecs[j], -VdΔV[j, i])
            end
        end
        sylvesterarg[i] = y
    end

    by, rev = KrylovKit.eigsort(which)
    if (rev ? (by(vals[n]) < by(zero(vals[n]))) : (by(vals[n]) > by(zero(vals[n]))))
        shift = 2 * conj(vals[n])
    else
        shift = zero(vals[n])
    end
    W₀ = (zerovector(vecs[1]), one.(vals))
    P = orthogonalprojector(vecs, n)
    solver = (T <: Real) ? KrylovKit.realeigsolve : KrylovKit.eigsolve
    rvals, Ws, reverse_info = let P = P, ΔV = sylvesterarg, shift = shift,
            eigsort = EigSorter(v -> minimum(DistanceTo(conj(v)), vals))

        solver(W₀, n, eigsort, alg_rrule) do (w, x)
            w₀ = P(w)
            w′ = KrylovKit.apply(fᴴ, add(w, w₀, -1))
            if !iszero(shift)
                w′ = VectorInterface.add!!(w′, w₀, shift)
            end
            @inbounds for i in 1:length(x) # length(x) = n but let us not use outer variables
                w′ = VectorInterface.add!!(w′, ΔV[i], -x[i])
            end
            return (w′, vals .* x)
        end
    end
    if info.converged >= n && reverse_info.converged < n &&
            alg_primal.verbosity >= WARN_LEVEL
        @warn "`eigsolve` cotangent problem did not converge, whereas the primal eigenvalue problem did"
    end

    # cleanup and construct final result
    tol = alg_rrule.tol
    Z = zeros(T, n, n)
    for i in 1:n
        copy!(view(Z, :, i), Ws[i][2])
    end
    Zinv = inv(Z)
    error = norm(Diagonal(view(vals, 1:n))' - Z * Diagonal(view(rvals, 1:n)) * Zinv, Inf)
    if error > 10 * tol && alg_primal.verbosity >= WARN_LEVEL
        @warn "`eigsolve` cotangent linear problem returns unexpected result: error = $error vs tol = $tol"
    end
    Q = orthogonalcomplementprojector(vecs, n)
    xs = Q.(getindex.(view(Ws, 1:n), 1))
    ws = zs
    for i in 1:n
        for j in 1:n
            ws[i] = VectorInterface.add!!(ws[i], xs[j], -Zinv[j, i])
        end
    end
    return ws
end

function construct∂f_eig(config, f, vecs, ws)
    config isa RuleConfig{>:HasReverseMode} ||
        throw(ArgumentError("`eigsolve` reverse-mode AD requires AD engine that supports calling back into AD"))

    v = vecs[1]
    w = ws[1]
    ∂f = rrule_via_ad(config, f, v)[2](w)[1]
    for i in 2:length(ws)
        v = vecs[i]
        w = ws[i]
        ∂f = ChainRulesCore.add!!(∂f, rrule_via_ad(config, f, v)[2](w)[1])
    end
    return ∂f
end
function construct∂f_eig(config, A::AbstractMatrix, vecs, ws)
    if A isa StridedMatrix
        return InplaceableThunk(
            Ā -> _buildĀ_eig!(Ā, vecs, ws),
            @thunk(_buildĀ_eig!(zero(A), vecs, ws))
        )
    else
        return @thunk(ProjectTo(A)(_buildĀ_eig!(zero(A), vecs, ws)))
    end
end

function _buildĀ_eig!(Ā, vs, ws)
    for i in 1:length(ws)
        w = ws[i]
        v = vs[i]
        if !(w isa AbstractZero)
            if eltype(Ā) <: Real && eltype(w) <: Complex
                mul!(Ā, _realview(w), _realview(v)', +1, +1)
                mul!(Ā, _imagview(w), _imagview(v)', +1, +1)
            else
                mul!(Ā, w, v', +1, 1)
            end
        end
    end
    return Ā
end

function reverse_which(which)
    by, rev = KrylovKit.eigsort(which)
    return EigSorter(by ∘ conj, rev)
end

module TestSetup

export tolerance, ≊, MinimalVec, isinplace, stack
export wrapop, wrapvec, unwrapvec, buildrealmap
export relax_tol, mat_with_eigrepition

import VectorInterface as VI
using VectorInterface
using LinearAlgebra: LinearAlgebra

# Utility functions
# -----------------
"function for determining the precision of a type"
tolerance(T::Type{<:Number}) = eps(real(T))^(2 // 3)
relax_tol(T::Type{<:Number}) = eps(real(T))^(1 // 2)

"function for comparing sets of eigenvalues"
function ≊(list1::AbstractVector, list2::AbstractVector)
    length(list1) == length(list2) || return false
    n = length(list1)
    ind2 = collect(1:n)
    p = sizehint!(Int[], n)
    for i in 1:n
        j = argmin(abs.(view(list2, ind2) .- list1[i]))
        p = push!(p, ind2[j])
        ind2 = deleteat!(ind2, j)
    end
    return list1 ≈ view(list2, p)
end

function buildrealmap(A, B)
    function f(x)
        return A * x + B * conj(x)
    end
    function f(x, ::Val{C}) where {C}
        if C == false
            return A * x + B * conj(x)
        else
            return adjoint(A) * x + transpose(B) * conj(x)
        end
    end
    return f
end

"function for generating a matrix with repeated eigenvalues"
function mat_with_eigrepition(T, N, multiplicity)
    U = LinearAlgebra.qr(randn(T, (N, N))).Q # Haar random matrix
    D = sort(randn(real(T), N))
    i = 0
    while multiplicity >= 2 && (i + multiplicity) <= N ÷ 2
        D[i .+ (1:multiplicity)] .= D[i + 1]
        D[N + 1 - i .- (1:multiplicity)] .= D[N - i]
        i += multiplicity
        multiplicity -= 1
    end
    A = U * LinearAlgebra.Diagonal(D) * U'
    return (A + A') / 2
end

# Wrappers
# --------
using VectorInterface: MinimalSVec, MinimalMVec, MinimalVec
# dispatch on val is necessary for type stability

function wrapvec(v, ::Val{mode}) where {mode}
    return mode === :vector ? v :
        mode === :inplace ? MinimalMVec(v) :
        mode === :outplace ? MinimalSVec(v) :
        mode === :mixed ? MinimalSVec(v) :
        throw(ArgumentError("invalid mode ($mode)"))
end
function wrapvec2(v, ::Val{mode}) where {mode}
    return mode === :mixed ? MinimalMVec(v) : wrapvec(v, mode)
end

unwrapvec(v::MinimalVec) = v.vec
unwrapvec(v) = v

function wrapop(A, ::Val{mode}) where {mode}
    if mode === :vector
        return A
    elseif mode === :inplace || mode === :outplace
        return function (v, flag = Val(false))
            if flag === Val(true)
                return wrapvec(A' * unwrapvec(v), Val(mode))
            else
                return wrapvec(A * unwrapvec(v), Val(mode))
            end
        end
    elseif mode === :mixed
        return (
            x -> wrapvec(A * unwrapvec(x), Val(mode)),
            y -> wrapvec2(A' * unwrapvec(y), Val(mode)),
        )
    else
        throw(ArgumentError("invalid mode ($mode)"))
    end
end

if VERSION < v"1.9"
    stack(f, itr) = mapreduce(f, hcat, itr)
    stack(itr) = reduce(hcat, itr)
end

end

# Introduction

```@contents
Pages = ["man/intro.md", "man/linear.md", "man/eig.md", "man/svd.md", "man/matfun.md",
"man/algorithms.md", "man/implementation.md"]
Depth = 2
```

## Installing

Install KrylovKit.jl via the package manager:
```julia
using Pkg
Pkg.add("KrylovKit")
```

KrylovKit.jl is a pure Julia package; no dependencies (aside from the Julia standard
library) are required.

## Getting started

After installation, start by loading `KrylovKit`

```julia
using KrylovKit
```
The help entry of the `KrylovKit` module states
```@docs
KrylovKit
```

## Common interface

The for high-level function [`linsolve`](@ref), [`eigsolve`](@ref), [`geneigsolve`](@ref),
[`svdsolve`](@ref), [`exponentiate`](@ref) and [`expintegrator`](@ref) follow a common interface
```julia
results..., info = problemsolver(A, args...; kwargs...)
```
where `problemsolver` is one of the functions above. Here, `A` is the linear map in the
problem, which could be an instance of `AbstractMatrix`, or any function or callable object
that encodes the action of the linear map on a vector. In particular, one can write the
linear map using Julia's `do` block syntax as
```julia
results..., info = problemsolver(args...; kwargs...) do x
    y = # implement linear map on x
    return y
end
```
Read the documentation for problems that require both the linear map and its adjoint to be
implemented, e.g. [`svdsolve`](@ref), or that require two different linear maps, e.g.
[`geneigsolve`](@ref).

Furthermore, `args` is a set of additional arguments to specify the problem. The keyword
arguments `kwargs` contain information about the linear map (`issymmetric`, `ishermitian`,
`isposdef`) and about the solution strategy (`tol`, `krylovdim`, `maxiter`). Finally, there
is a keyword argument `verbosity` that determines how much information is printed to
`STDOUT`. The default value `verbosity = SILENT_LEVEL` means that no information will be printed. With
`verbosity = WARN_LEVEL`, a single message at the end of the algorithm will be displayed, which is a
warning if the algorithm did not succeed in finding the solution, or some information if it
did. For `verbosity = STARTSTOP_LEVEL`, information about the current state is displayed after every
iteration of the algorithm. Finally, for `verbosity > STARTSTOP_LEVEL`, information about the individual Krylov expansion steps is displayed.

The return value contains one or more entries that define the solution, and a final
entry `info` of type `ConvergeInfo` that encodes information about the solution, i.e.
whether it has converged, the residual(s) and the norm thereof, the number of operations
used:
```@docs
KrylovKit.ConvergenceInfo
```

There is also an expert interface where the user specifies the algorithm that should be used
explicitly, i.e.
```julia
results..., info = problemsolver(A, args..., algorithm(; kwargs...))
```
Most `algorithm` constructions take the same keyword arguments (`tol`, `krylovdim`,
`maxiter` and `verbosity`) discussed above.

While KrylovKit.jl does currently not provide a general interface for including
preconditioners, it is possible to e.g. use a modified inner product. KrylovKit.jl provides
a specific type for this purpose:
```@docs
InnerProductVec
```

# Real linear maps

A map $$f: V \to V$$ from some vector space $$V$$ to itself is said to be a real linear map if
it satisfies $$f(\alpha x + \beta y) = \alpha f(x) + \beta f(y)$$ for all $$x, y \in V$$ and
all $$\alpha, \beta \in \mathbb{R}$$. When $$V$$ is itself a real vector space, this is just
the natural concept of a linear map. However, this definition can be used even if $$x$$ and
$$y$$ are naturally represented using complex numbers and arithmetic and also admit complex linear
combinations, i.e. if $$V$$ is a complex vector space.

Such real linear maps arise whenever `f(x)` involves calling `conj(x)`, and are for example
obtained in the context of Jacobians (pullbacks) of complex valued functions that are not
holomorphic.

To deal with real linear maps, one should reinterpret $$V$$ as a real vector space, by
restricting the possible linear combinations to those with real scalar coefficients, and by
using the real part of the inner product. When the vectors are explictly represented as
some `AbstractVector{Complex{T}}`, this could be obtained by explicitly splitting
them in their real and imaginary parts and stacking those into `AbstractVector{T}` objects
with twice the original length.

However, KrylovKit.jl admits a different approach, where the original representation of
vectors is kept, and the inner product is simply replaced by its real part. KrylovKit.jl
offers specific methods for solving linear systems and eigenvalue systems in this way. For
linear problems and least square problems, this is implemented using `reallinsolve` and
`reallssolve`:

```@docs
reallinsolve
reallssolve
```

In the case of eigenvalue systems, a similar method `realeigsolve` is available. In this
context, only real eigenvalues are meaningful, as the corresponding eigenvectors should be
built from real linear combinations of the vectors that span the (real) Krylov subspace.
This approach can also be applied to linear maps on vectors that were naturally real to
begin with, if it is guaranteed that the targetted eigenvalues are real. In that case, also
the associated eigenvectors will be returned using only real arithmic. This is contrast
with `eigsolve`, which will always turn to complex arithmetic if the linear map is real but
not symmetric. An error will be thrown if complex eigenvalues are encountered within the
targetted set.

```@docs
realeigsolve
```

Note that `reallinsolve`, `reallssolve` and `realeigsolve` currently only exist with the
"expert" mode interface, where the user has to manually specify the underlying Krylov
algorithm and its parameters, i.e. `GMRES` or `BiCGStab` for `reallinsolve`, `LSMR` for
`reallssolve` and `Arnoldi` for `realeigsolve`.

# KrylovKit.jl

A Julia package collecting a number of Krylov-based algorithms for linear problems, singular
value and eigenvalue problems and the application of functions of linear maps or operators
to vectors.

## Overview
KrylovKit.jl accepts general functions or callable objects as linear maps, and general Julia
objects with vector like behavior (see below) as vectors.

The high level interface of KrylovKit is provided by the following functions:
*   [`linsolve`](@ref): solve linear systems `A*x = b`
*   [`lssolve`](@ref): solve least square problems `A*x ≈ b`
*   [`eigsolve`](@ref): find a few eigenvalues and corresponding eigenvectors of an
    eigenvalue problem `A*x = λ x`
*   [`geneigsolve`](@ref): find a few eigenvalues and corresponding vectors of a
    generalized eigenvalue problem `A*x = λ*B*x`
*   [`svdsolve`](@ref): find a few singular values and corresponding left and right
    singular vectors `A*x = σ * y` and `A'*y = σ*x`
*   [`exponentiate`](@ref): apply the exponential of a linear map to a vector `x=exp(t*A)*x₀`
*   [`expintegrator`](@ref): exponential integrator for a linear non-homogeneous ODE
    (generalization of `exponentiate`)

Furthermore, for specialised use cases, there are functions that can deal with so-called
"real linear maps", which arise e.g. in the context of differentiable programming:
*   [`reallinsolve`](@ref) and [`realeigsolve`](@ref)


## Package features and alternatives
This section could also be titled "Why did I create KrylovKit.jl"?

There are already a fair number of packages with Krylov-based or other iterative methods, such as
*   [IterativeSolvers.jl](https://github.com/JuliaMath/IterativeSolvers.jl): part of the
    [JuliaMath](https://github.com/JuliaMath) organisation, solves linear systems and least
    square problems, eigenvalue and singular value problems
*   [Krylov.jl](https://github.com/JuliaSmoothOptimizers/Krylov.jl): part of the
    [JuliaSmoothOptimizers](https://github.com/JuliaSmoothOptimizers) organisation, solves
    linear systems and least square problems on CPU or GPU for any data type that supports `mul!()`,
    including dense and sparse matrices, and abstract operators such as those defined from
    [LinearOperators.jl](https://github.com/JuliaSmoothOptimizers/LinearOperators.jl) or
    [LinearMaps.jl](https://github.com/JuliaLinearAlgebra/LinearMaps.jl).
*   [KrylovMethods.jl](https://github.com/lruthotto/KrylovMethods.jl): specific for sparse
    matrices
*   [Expokit.jl](https://github.com/acroy/Expokit.jl): application of the matrix
    exponential to a vector
*   [ArnoldiMethod.jl](https://github.com/haampie/ArnoldiMethod.jl): Implicitly restarted
    Arnoldi method for eigenvalues of a general matrix
*   [JacobiDavidson.jl](https://github.com/haampie/JacobiDavidson.jl): Jacobi-Davidson
    method for eigenvalues of a general matrix
*   [ExponentialUtilities.jl](https://github.com/JuliaDiffEq/ExponentialUtilities.jl): Krylov
    subspace methods for matrix exponentials and `phiv` exponential integrator products. It
    has specialized methods for subspace caching, time stepping, and error testing which are
    essential for use in high order exponential integrators.
*   [OrdinaryDiffEq.jl](https://github.com/JuliaDiffEq/OrdinaryDiffEq.jl):
    contains implementations of [high order exponential integrators](https://docs.juliadiffeq.org/latest/solvers/split_ode_solve/#OrdinaryDiffEq.jl-2)
    with adaptive Krylov-subspace calculations for solving semilinear and nonlinear ODEs.

Some of these packages have certainly inspired and influenced the development of KrylovKit.jl.
However, KrylovKit.jl distinguishes itself from the previous packages in the following ways:

1.  KrylovKit accepts general functions to represent the linear map or operator that defines
    the problem, without having to wrap them in a
    [`LinearMap`](https://github.com/Jutho/LinearMaps.jl) or
    [`LinearOperator`](https://github.com/JuliaSmoothOptimizers/LinearOperators.jl) type.
    Of course, subtypes of `AbstractMatrix` are also supported. If the linear map (always
    the first argument) is a subtype of `AbstractMatrix`, matrix vector multiplication is
    used, otherwise it is applied as a function call.

2.  KrylovKit does not assume that the vectors involved in the problem are actual subtypes
    of `AbstractVector`. Any Julia object that behaves as a vector is supported, so in
    particular higher-dimensional arrays or any custom user type that supports the
    interface as defined in [`VectorInterface.jl`](https://github.com/Jutho/VectorInterface.jl).
    Aside from arrays filled with scalar entries, this includes tuples, named tuples, and
    arbitrarily nested combinations of tuples and arrays. Furthermore, `CuArray` objects
    are fully supported as vectors, so that the application of the linear operator on the
    vector can be executed on a GPU. The computations performed within the Krylov subspace,
    such as diagonalising the projected matrix, are however always performed on the CPU.
    
3.  Since version 0.8, KrylovKit.jl supports reverse-mode AD by defining `ChainRulesCore.rrule` 
    definitions for the most common functionality (`linsolve`, `eigsolve`, `svdsolve`).
    Hence, reverse mode AD engines that are compatible with the [ChainRules](https://juliadiff.org/ChainRulesCore.jl/dev/)
    ecosystem will be able to benefit from an optimized implementation of the adjoint
    of these functions. The `rrule` definitions for the remaining functionality 
    (`geneigsolve` and `expintegrator`, of which `exponentiate` is a special case) will be
    added at a later stage. There is a dedicated documentation page on how to configure these
    `rrule`s, as they also require to solve large-scale linear or eigenvalue problems.

## Current functionality

The following algorithms are currently implemented
*   `linsolve`: [`CG`](@ref), [`GMRES`](@ref), [`BiCGStab`](@ref)
*   `eigsolve`: a Krylov-Schur algorithm (i.e. with tick restarts) for extremal eigenvalues
    of normal (i.e. not generalized) eigenvalue problems, corresponding to
    [`Lanczos`](@ref) and [`BlockLanczos`](@ref) for real symmetric or complex hermitian linear maps, and to
    [`Arnoldi`](@ref) for general linear maps.
*   `geneigsolve`: an customized implementation of the inverse-free algorithm of Golub and
    Ye for symmetric / hermitian generalized eigenvalue problems with positive definite
    matrix `B` in the right hand side of the generalized eigenvalue problem ``A v = B v λ``.
    The Matlab implementation was described by Money and Ye and is known as `EIGIFP`; in
    particular it extends the Krylov subspace with a vector corresponding to the step
    between the current and previous estimate, analogous to the locally optimal
    preconditioned conjugate gradient method (LOPCG). In particular, with Krylov dimension
    2, it becomes equivalent to the latter.
*   `svdsolve`: finding largest singular values based on Golub-Kahan-Lanczos
    bidiagonalization (see [`GKL`](@ref))
*   `exponentiate`: a [`Lanczos`](@ref) or [`Arnoldi`](@ref) based algorithm for the action
    of the exponential of linear map.
*   `expintegrator`: [exponential integrator](https://en.wikipedia.org/wiki/Exponential_integrator)
    for a linear non-homogeneous ODE, computes a linear combination of the `ϕⱼ` functions which generalize `ϕ₀(z) = exp(z)`.

## Future functionality?

Here follows a wish list / to-do list for the future. Any help is welcomed and appreciated.

*   More algorithms, including biorthogonal methods:
    -   for `linsolve`: L-GMRES, MINRES, BiCG, IDR(s), ...
    -   for `lssolve`: LSQR, ...
    -   for `eigsolve`: BiLanczos, Jacobi-Davidson JDQR/JDQZ, subspace iteration (?), ...
    -   for `geneigsolve`: trace minimization, ...
*   Support both in-place / mutating and out-of-place functions as linear maps
*   Reuse memory for storing vectors when restarting algorithms (related to previous)
*   Support non-BLAS scalar types using GeneralLinearAlgebra.jl and GeneralSchur.jl
*   Nonlinear eigenvalue problems
*   Preconditioners
*   Refined Ritz vectors, Harmonic Ritz values and vectors
*   Block versions of the algorithms
*   More relevant matrix functions

Partially done:
*   Improved efficiency for the specific case where `x` is `Vector` (i.e. BLAS level 2
    operations): any vector `v::AbstractArray` which has `IndexStyle(v) == IndexLinear()`
    now benefits from a multithreaded (use `export JULIA_NUM_THREADS = x` with `x` the
    number of threads you want to use) implementation that resembles BLAS level 2 style for
    the vector operations, provided `ClassicalGramSchmidt()`, `ClassicalGramSchmidt2()` or
    `ClassicalGramSchmidtIR()` is chosen as orthogonalization routine.

# Least squares problems

Least square problems take the form of finding `x` that minimises `norm(b - A*x)` where
`A` should be a linear map. As opposed to linear systems, the input and output of the linear
map do not need to be the same, so that `x` (input) and `b` (output) can live in different
vector spaces. Such problems can be solved using the function `lssolve`:

```@docs
lssolve
```

# Eigenvalue problems

## Eigenvalues and eigenvectors
Finding a selection of eigenvalues and corresponding (right) eigenvectors of a linear map
can be accomplished with the `eigsolve` routine:
```@docs
eigsolve
```

Which eigenvalues are targeted can be specified using one of the symbols `:LM`, `:LR`,
`:SR`, `:LI` and `:SI` for largest magnitude, largest and smallest real part, and largest
and smallest imaginary part respectively. Alternatively, one can just specify a general
sorting operation using `EigSorter`
```@docs
EigSorter
```

For a self-adjoint linear map (hermitian or, in the real case, symmetric), the eigenvalues are real 
and the eigenvectors satisfy both $$A \vec{v} = \lambda \vec{v}$$ and
$$A^\dagger \vec{v} = \lambda \vec{v}$$. For a general linear map, eigenvalues are in general 
complex, and so eigenvalues and eigenvectors obtained by `eigsolve` will always be returned with 
complex values for reasons of type stability. Furthermore, the eigenvectors only satisfy
$$A \vec{v} = \lambda \vec{v}$$, although there are associated "left" eigenvectors that satisfy
$$A^\dagger \vec{w} = \bar{\lambda} \vec{w}$$. These can be computed using the `bieigsolve` method
```@docs
bieigsolve
```

Even though eigenvalues and eigenvectors for a general linear map are returned with complex numbers,
if the linear map and initial guess are real, most of the computation is actually performed using 
real arithmetic, as in fact the first step is to compute an approximate partial Schur factorization.
If one is not interested in the eigenvectors, one can also just compute this partial Schur 
factorization using `schursolve`, for which only an 'expert' method call is available
```@docs
schursolve
```
Note that, for symmetric or hermitian linear maps, the eigenvalue and Schur factorization
are equivalent, and one should only use `eigsolve`. There is no `schursolve` using the `Lanczos` or `BlockLanczos` algorithm.

Another example of a possible use case of `schursolve` is if the linear map is known to have
a unique eigenvalue of, e.g. largest magnitude. Then, if the linear map is real valued, that
largest magnitude eigenvalue and its corresponding eigenvector are also real valued.
`eigsolve` will automatically return complex valued eigenvectors for reasons of type
stability. However, as the first Schur vector will coincide with the first eigenvector, one
can instead use
```julia
T, vecs, vals, info = schursolve(A, x⁠₀, 1, :LM, Arnoldi(...))
```
and use `vecs[1]` as the real valued eigenvector (after checking `info.converged`)
corresponding to the largest magnitude eigenvalue of `A`.

More generally, if you want to compute several eigenvalues of a real linear map, and you know
that all of them are real, so that also the associated eigenvectors will be real, then you
can use the [`realeigsolve`](@ref) method.

## Automatic differentation

The `eigsolve` (and `realeigsolve`) routine can be used in conjunction with reverse-mode automatic 
differentiation, using AD engines that are compatible with the [ChainRules](https://juliadiff.org/ChainRulesCore.jl/dev/)
ecosystem. The adjoint problem of an eigenvalue problem is a linear problem, although it can also
be formulated as an eigenvalue problem. Details about this approach will be published in a
forthcoming manuscript.

In either case, the adjoint problem requires the adjoint[^1] of the linear map. If the linear map is
an `AbstractMatrix` instance, its `adjoint` will be used in the `rrule`. If the linear map is implemented 
as a function `f`, then the AD engine itself is used to compute the corresponding adjoint via 
`ChainRulesCore.rrule_via_ad(config, f, x)`. The specific base point `x` at which this adjoint is
computed should not affect the result if `f` properly represents a linear map. Furthermore, the linear
map is the only argument that affects the `eigsolve` output (from a theoretical perspective, the
starting vector and algorithm parameters should have no effect), so that this is where the adjoint 
variables need to be propagated to and have a nonzero effect.

The adjoint problem (also referred to as cotangent problem) can thus be solved as a linear problem
or as an eigenvalue problem. Note that this eigenvalue problem is never symmetric or Hermitian,
even if the primal problem is. The different implementations of the `rrule` can be selected using
the `alg_rrule` keyword argument. If a linear solver such as `GMRES` or `BiCGStab` is specified,
the adjoint problem requires solving a number of linear problems equal to the number of requested
eigenvalues and eigenvectors. If an eigenvalue solver is specified, for which `Arnoldi` is essentially
the only option, then the adjoint problem is solved as a single (but larger) eigenvalue problem.

Note that the phase of an eigenvector is not uniquely determined. Hence, a well-defined cost function
constructed from eigenvectors should depend on these in such a way that its value is not affected
by changing the phase of those eigenvectors, i.e. the cost function should be 'gauge invariant'.
If this is not the case, the cost function is said to be 'gauge dependent', and this can be detected
in the resulting adjoint variables for those eigenvectors. The KrylovKit `rrule` for `eigsolve`
will print a warning if it detects from the incoming adjoint variables that the cost function is gauge
dependent. This warning can be suppressed by passing `alg_rrule` an algorithm with `verbosity=SILENT_LEVEL-1`.

## Generalized eigenvalue problems

Generalized eigenvalues `λ` and corresponding vectors `x` of the generalized eigenvalue
problem ``A x = λ B x`` can be obtained using the method `geneigsolve`. Currently, there is
only one algorithm, which does not require inverses of `A` or `B`, but is restricted to
symmetric or hermitian generalized eigenvalue problems where the matrix or linear map `B`
is positive definite. Note that this is not reflected in the default values for the keyword
arguments `issymmetric`, `ishermitian` and `isposdef`, so that these should be set
explicitly in order to comply with this restriction. If `A` and `B` are actual instances of
`AbstractMatrix`, the default value for the keyword arguments will try to check these
properties explicitly.

```@docs
geneigsolve
```

Currently, there is `rrule` and thus no automatic differentiation support for `geneigsolve`.

[^1]: For a linear map, the adjoint or pullback required in the reverse-order chain rule coincides
with its (conjugate) transpose, at least with respect to the standard Euclidean inner product.

# Implementation details

## Orthogonalization
To denote a basis of vectors, e.g. to represent a given Krylov subspace, there is an
abstract type `Basis{T}`
```@docs
KrylovKit.Basis
```

Many Krylov based algorithms use an orthogonal basis to parameterize the Krylov subspace. In
that case, the specific implementation `OrthonormalBasis{T}` can be used:
```@docs
KrylovKit.OrthonormalBasis
```

We can orthogonalize or orthonormalize a given vector to another vector (assumed normalized)
or to a given [`KrylovKit.OrthonormalBasis`](@ref) using
```@docs
KrylovKit.orthogonalize
KrylovKit.orthonormalize
```
or using the possibly in-place versions
```@docs
KrylovKit.orthogonalize!!
KrylovKit.orthonormalize!!
```

The expansion coefficients of a general vector in terms of a given orthonormal basis can be obtained as
```@docs
KrylovKit.project!!
```
whereas the inverse calculation is obtained as
```@docs
KrylovKit.unproject!!
```

An orthonormal basis can be transformed using a rank-1 update using
```@docs
KrylovKit.rank1update!
```

Note that this changes the subspace. A mere rotation of the basis, which does not change
the subspace spanned by it, can be computed using

```@docs
KrylovKit.basistransform!
```

## Block Krylov method
The block version of the Krylov subspace algorithm is an approach to extending Krylov subspace techniques from
a starting block. It is mainly used for solving eigenvalue problems with repeated eigenvalues.

In our implementation, a block of vectors is stored in a new data structure `Block`,
which implements the [`KrylovKit.block_qr!`](@ref) and [`KrylovKit.block_reorthogonalize!`](@ref) interfaces.

```@docs
KrylovKit.Block
```

A block of vectors can be orthonormalized using
```@docs
KrylovKit.block_qr!
```

Additional procedure applied to the block is as follows:
```@docs
KrylovKit.block_reorthogonalize!
```



## Dense linear algebra

KrylovKit relies on Julia's `LinearAlgebra` module from the standard library for most of its
dense linear algebra dependencies.

## Factorization types
The central ingredient in a Krylov based algorithm is a Krylov factorization or
decomposition of a linear map. Such partial factorizations are represented as a
`KrylovFactorization`, of which `LanczosFactorization`, `BlockLanczosFactorization` and `ArnoldiFactorization` are three
concrete implementations:

```@docs
KrylovKit.KrylovFactorization
KrylovKit.LanczosFactorization
KrylovKit.BlockLanczosFactorization
KrylovKit.ArnoldiFactorization
KrylovKit.GKLFactorization
```

A `KrylovFactorization` or `GKLFactorization` can be destructured into its defining
components using iteration, but these can also be accessed using the following functions
```@docs
basis
rayleighquotient
residual
normres
rayleighextension
```

As the `rayleighextension` is typically a simple basis vector, we have created a dedicated
type to represent this without having to allocate an actual vector, i.e.
```@docs
KrylovKit.SimpleBasisVector
```

Furthermore, to store the Rayleigh quotient of the Arnoldi factorization in a manner that
can easily be expanded, we have constructed a custom matrix type to store the Hessenberg
matrix in a packed format (without zeros):

```@docs
KrylovKit.PackedHessenberg
```

## Factorization iterators
Given a linear map ``A`` and a starting vector ``x₀``, a Krylov factorization is obtained
by sequentially building a Krylov subspace ``{x₀, A x₀, A² x₀, ...}``. Rather then using
this set of vectors as a basis, an orthonormal basis is generated by a process known as
Lanczos, BlockLanczos or Arnoldi iteration (for symmetric/hermitian and for general matrices,
respectively). These processes are represented as iterators in Julia:

```@docs
KrylovKit.KrylovIterator
KrylovKit.LanczosIterator
KrylovKit.BlockLanczosIterator
KrylovKit.ArnoldiIterator
```

Similarly, there is also an iterator for the Golub-Kahan-Lanczos bidiagonalization proces:

```@docs
KrylovKit.GKLIterator
```

As an alternative to the standard iteration interface from Julia Base (using `iterate`),
these iterative processes and the factorizations they produce can also be manipulated
using the following functions:

```@docs
expand!
shrink!
initialize
initialize!
```

# Singular value problems

## Singular values and singular vectors
It is possible to iteratively compute a few singular values and corresponding left and
right singular vectors using the function `svdsolve`:

```@docs
svdsolve
```

## Automatic differentation

The `svdsolve` routine can be used in conjunction with reverse-mode automatic differentiation, 
using AD engines that are compatible with the [ChainRules](https://juliadiff.org/ChainRulesCore.jl/dev/)
ecosystem. The adjoint problem of a singular value problem contains a linear problem, although it
can also be formulated as an eigenvalue problem. Details about this approach will be published in a
forthcoming manuscript.

Both `svdsolve` and the adjoint problem associated with it require the action of the linear map as
well as of its adjoint[^1]. Hence, no new information about the linear map is required for the adjoint
problem. However, the linear map is the only argument that affects the `svdsolve` output (from a
theoretical perspective, the starting vector and algorithm parameters should have no effect), so that
this is where the adjoint variables need to be propagated to.

The adjoint problem (also referred to as cotangent problem) can thus be solved as a linear problem
or as an eigenvalue problem. Note that this eigenvalue problem is never symmetric or Hermitian.
The different implementations of the `rrule` can be selected using the `alg_rrule` keyword argument. 
If a linear solver such as `GMRES` or `BiCGStab` is specified, the adjoint problem requires solving a]
number of linear problems equal to the number of requested singular values and vectors. If an 
eigenvalue solver is specified, for which `Arnoldi` is essentially the only option, then the adjoint
problem is solved as a single (but larger) eigenvalue problem.

Note that the common pair of left and right singular vectors has an arbitrary phase freedom.
Hence, a well-defined cost function constructed from singular should depend on these in such a way 
that its value is not affected by simultaneously changing the left and right singular vector with
a common phase factor, i.e. the cost function should be 'gauge invariant'. If this is not the case, 
the cost function is said to be 'gauge dependent', and this can be detected in the resulting adjoint
variables for those singular vectors. The KrylovKit `rrule` for `svdsolve` will print a warning if
it detects from the incoming adjoint variables that the cost function is gauge dependent. This
warning can be suppressed by passing `alg_rrule` an algorithm with `verbosity=SILENT_LEVEL-1`.

[^1]: For a linear map, the adjoint or pullback required in the reverse-order chain rule coincides
with its (conjugate) transpose, at least with respect to the standard Euclidean inner product.

# Functions of matrices and linear operators
Applying a function of a matrix or linear operator to a given vector can in some cases also be
computed using Krylov methods. One example is the inverse function, which exactly
corresponds to what `linsolve` computes: ``A^{-1} * b``. There are other functions ``f``
for which ``f(A) * b`` can be computed using Krylov techniques, i.e. where ``f(A) * b`` can
be well approximated in the Krylov subspace spanned by ``{b, A * b, A^2 * b, ...}``.

Currently, the only family of functions of a linear map for which such a method is
available are the `ϕⱼ(z)` functions which generalize the exponential function
`ϕ₀(z) = exp(z)` and arise in the context of linear non-homogeneous ODEs. The corresponding
Krylov method for computing is an exponential integrator, and is thus available under the
name `expintegrator`. For a linear homogeneous ODE, the solution is a pure exponential, and
the special wrapper `exponentiate` is available:

```@docs
exponentiate
expintegrator
```

# Linear problems

## Linear systems

Linear systems are of the form `A*x=b` where `A` should be a linear map that has the same
type of output as input, i.e. the solution `x` should be of the same type as the right hand
side `b`. They can be solved using the function `linsolve`:

```@docs
linsolve
```

## Automatic differentation

The `linsolve` routine can be used in conjunction with reverse-mode automatic differentiation,
using AD engines that are compatible with the [ChainRules](https://juliadiff.org/ChainRulesCore.jl/dev/)
ecosystem. The adjoint problem of a linear problem is again a linear problem, that requires the
adjoint[^1] of the linear map. If the linear map is an `AbstractMatrix` instance, its `adjoint`
will be used in the `rrule`. If the linear map is implemented as a function `f`, then the AD engine
itself is used to compute the corresponding adjoint via `ChainRulesCore.rrule_via_ad(config, f, x)`.
The specific base point `x` at which this adjoint is computed should not affect the result if `f`
properly represents a linear map. Furthermore, the `linsolve` output is only affected by the linear
map argument and the right hand side argument `b` (from a theoretical perspective, the starting vector
and algorithm parameters should have no effect), so that these two arguments are where the adjoint 
variables need to be propagated to and have a nonzero effect.

The adjoint linear problem (also referred to as cotangent problem) is by default solved using the
same algorithms as the primal problem. However, the `rrule` can be customized to use a different
Krylov algorithm, by specifying the `alg_rrule` keyword argument. Its value can take any of the values
as the `algorithm` argument in `linsolve`.

[^1]: For a linear map, the adjoint or pullback required in the reverse-order chain rule coincides
with its (conjugate) transpose, at least with respect to the standard Euclidean inner product.

# Available algorithms

## Orthogonalization algorithms
```@docs
KrylovKit.Orthogonalizer
ClassicalGramSchmidt
ModifiedGramSchmidt
ClassicalGramSchmidt2
ModifiedGramSchmidt2
ClassicalGramSchmidtIR
ModifiedGramSchmidtIR
```

## General Krylov algorithms
```@docs
Lanczos
BlockLanczos
Arnoldi
BiArnoldi
```

## Specific algorithms for linear systems
```@docs
CG
KrylovKit.MINRES
GMRES
KrylovKit.BiCG
BiCGStab
LSMR
```
## Specific algorithms for generalized eigenvalue problems
```@docs
GolubYe
```

## Specific algorithms for singular value problems
```@docs
GKL
```

## Default values
```@docs
KrylovDefaults
```
